#include "Globals.h"

#include "Palette_1_16.h"
#include "Registries/BlockStates.h"

namespace Palette_1_16
{
	UInt32 From(const BlockState Block)
	{
		using namespace Block;

		switch (Block.ID)
		{
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6442;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6443;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6444;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6445;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 6446;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 6447;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 6448;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 6449;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6450;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6451;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6452;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6453;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 6454;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 6455;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 6456;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 6457;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6458;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6459;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6460;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6461;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 6462;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 6463;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 6464;
			case AcaciaButton::AcaciaButton(AcaciaButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 6465;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, true).ID: return 8930;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, false).ID: return 8931;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, true).ID: return 8932;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, false).ID: return 8933;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, true).ID: return 8934;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, false).ID: return 8935;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, true).ID: return 8936;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, false).ID: return 8937;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, true).ID: return 8938;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, false).ID: return 8939;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, true).ID: return 8940;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, false).ID: return 8941;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, true).ID: return 8942;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, false).ID: return 8943;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, true).ID: return 8944;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, false).ID: return 8945;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, true).ID: return 8946;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, false).ID: return 8947;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, true).ID: return 8948;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, false).ID: return 8949;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, true).ID: return 8950;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, false).ID: return 8951;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, true).ID: return 8952;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, false).ID: return 8953;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, true).ID: return 8954;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, false).ID: return 8955;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, true).ID: return 8956;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, false).ID: return 8957;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, true).ID: return 8958;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, false).ID: return 8959;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, true).ID: return 8960;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_ZP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, false).ID: return 8961;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, true).ID: return 8962;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, false).ID: return 8963;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, true).ID: return 8964;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, false).ID: return 8965;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, true).ID: return 8966;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, false).ID: return 8967;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, true).ID: return 8968;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, false).ID: return 8969;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, true).ID: return 8970;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, false).ID: return 8971;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, true).ID: return 8972;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, false).ID: return 8973;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, true).ID: return 8974;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, false).ID: return 8975;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, true).ID: return 8976;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XM, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, false).ID: return 8977;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, true).ID: return 8978;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, true, false).ID: return 8979;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, true).ID: return 8980;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Left, false, false).ID: return 8981;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, true).ID: return 8982;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, true, false).ID: return 8983;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, true).ID: return 8984;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Upper, AcaciaDoor::Hinge::Right, false, false).ID: return 8985;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, true).ID: return 8986;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, true, false).ID: return 8987;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, true).ID: return 8988;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Left, false, false).ID: return 8989;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, true).ID: return 8990;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, true, false).ID: return 8991;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, true).ID: return 8992;
			case AcaciaDoor::AcaciaDoor(eBlockFace::BLOCK_FACE_XP, AcaciaDoor::Half::Lower, AcaciaDoor::Hinge::Right, false, false).ID: return 8993;
			case AcaciaFence::AcaciaFence(true, true, true, true).ID: return 8676;
			case AcaciaFence::AcaciaFence(true, true, true, false).ID: return 8677;
			case AcaciaFence::AcaciaFence(true, true, false, true).ID: return 8680;
			case AcaciaFence::AcaciaFence(true, true, false, false).ID: return 8681;
			case AcaciaFence::AcaciaFence(true, false, true, true).ID: return 8684;
			case AcaciaFence::AcaciaFence(true, false, true, false).ID: return 8685;
			case AcaciaFence::AcaciaFence(true, false, false, true).ID: return 8688;
			case AcaciaFence::AcaciaFence(true, false, false, false).ID: return 8689;
			case AcaciaFence::AcaciaFence(false, true, true, true).ID: return 8692;
			case AcaciaFence::AcaciaFence(false, true, true, false).ID: return 8693;
			case AcaciaFence::AcaciaFence(false, true, false, true).ID: return 8696;
			case AcaciaFence::AcaciaFence(false, true, false, false).ID: return 8697;
			case AcaciaFence::AcaciaFence(false, false, true, true).ID: return 8700;
			case AcaciaFence::AcaciaFence(false, false, true, false).ID: return 8701;
			case AcaciaFence::AcaciaFence(false, false, false, true).ID: return 8704;
			case AcaciaFence::AcaciaFence(false, false, false, false).ID: return 8705;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 8514;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 8515;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 8516;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 8517;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 8518;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 8519;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 8520;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 8521;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 8522;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 8523;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 8524;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 8525;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 8526;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 8527;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 8528;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 8529;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 8530;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 8531;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 8532;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 8533;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 8534;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 8535;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 8536;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 8537;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 8538;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 8539;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 8540;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 8541;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 8542;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 8543;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 8544;
			case AcaciaFenceGate::AcaciaFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 8545;
			case AcaciaLeaves::AcaciaLeaves(1, true).ID: return 201;
			case AcaciaLeaves::AcaciaLeaves(1, false).ID: return 202;
			case AcaciaLeaves::AcaciaLeaves(2, true).ID: return 203;
			case AcaciaLeaves::AcaciaLeaves(2, false).ID: return 204;
			case AcaciaLeaves::AcaciaLeaves(3, true).ID: return 205;
			case AcaciaLeaves::AcaciaLeaves(3, false).ID: return 206;
			case AcaciaLeaves::AcaciaLeaves(4, true).ID: return 207;
			case AcaciaLeaves::AcaciaLeaves(4, false).ID: return 208;
			case AcaciaLeaves::AcaciaLeaves(5, true).ID: return 209;
			case AcaciaLeaves::AcaciaLeaves(5, false).ID: return 210;
			case AcaciaLeaves::AcaciaLeaves(6, true).ID: return 211;
			case AcaciaLeaves::AcaciaLeaves(6, false).ID: return 212;
			case AcaciaLeaves::AcaciaLeaves(7, true).ID: return 213;
			case AcaciaLeaves::AcaciaLeaves(7, false).ID: return 214;
			case AcaciaLog::AcaciaLog(AcaciaLog::Axis::X).ID: return 85;
			case AcaciaLog::AcaciaLog(AcaciaLog::Axis::Y).ID: return 86;
			case AcaciaLog::AcaciaLog(AcaciaLog::Axis::Z).ID: return 87;
			case AcaciaPlanks::AcaciaPlanks().ID: return 19;
			case AcaciaPressurePlate::AcaciaPressurePlate(true).ID: return 3881;
			case AcaciaPressurePlate::AcaciaPressurePlate(false).ID: return 3882;
			case AcaciaSapling::AcaciaSapling(0).ID: return 29;
			case AcaciaSapling::AcaciaSapling(1).ID: return 30;
			case AcaciaSign::AcaciaSign(0).ID: return 3478;
			case AcaciaSign::AcaciaSign(1).ID: return 3480;
			case AcaciaSign::AcaciaSign(2).ID: return 3482;
			case AcaciaSign::AcaciaSign(3).ID: return 3484;
			case AcaciaSign::AcaciaSign(4).ID: return 3486;
			case AcaciaSign::AcaciaSign(5).ID: return 3488;
			case AcaciaSign::AcaciaSign(6).ID: return 3490;
			case AcaciaSign::AcaciaSign(7).ID: return 3492;
			case AcaciaSign::AcaciaSign(8).ID: return 3494;
			case AcaciaSign::AcaciaSign(9).ID: return 3496;
			case AcaciaSign::AcaciaSign(10).ID: return 3498;
			case AcaciaSign::AcaciaSign(11).ID: return 3500;
			case AcaciaSign::AcaciaSign(12).ID: return 3502;
			case AcaciaSign::AcaciaSign(13).ID: return 3504;
			case AcaciaSign::AcaciaSign(14).ID: return 3506;
			case AcaciaSign::AcaciaSign(15).ID: return 3508;
			case AcaciaSlab::AcaciaSlab(AcaciaSlab::Type::Top).ID: return 8325;
			case AcaciaSlab::AcaciaSlab(AcaciaSlab::Type::Bottom).ID: return 8327;
			case AcaciaSlab::AcaciaSlab(AcaciaSlab::Type::Double).ID: return 8329;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::Straight).ID: return 7376;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerLeft).ID: return 7378;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerRight).ID: return 7380;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterLeft).ID: return 7382;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterRight).ID: return 7384;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::Straight).ID: return 7386;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerLeft).ID: return 7388;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerRight).ID: return 7390;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterLeft).ID: return 7392;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterRight).ID: return 7394;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::Straight).ID: return 7396;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerLeft).ID: return 7398;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerRight).ID: return 7400;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterLeft).ID: return 7402;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterRight).ID: return 7404;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::Straight).ID: return 7406;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerLeft).ID: return 7408;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerRight).ID: return 7410;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterLeft).ID: return 7412;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_ZP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterRight).ID: return 7414;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::Straight).ID: return 7416;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerLeft).ID: return 7418;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerRight).ID: return 7420;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterLeft).ID: return 7422;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterRight).ID: return 7424;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::Straight).ID: return 7426;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerLeft).ID: return 7428;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerRight).ID: return 7430;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterLeft).ID: return 7432;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XM, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterRight).ID: return 7434;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::Straight).ID: return 7436;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerLeft).ID: return 7438;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::InnerRight).ID: return 7440;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterLeft).ID: return 7442;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Top, AcaciaStairs::Shape::OuterRight).ID: return 7444;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::Straight).ID: return 7446;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerLeft).ID: return 7448;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::InnerRight).ID: return 7450;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterLeft).ID: return 7452;
			case AcaciaStairs::AcaciaStairs(eBlockFace::BLOCK_FACE_XP, AcaciaStairs::Half::Bottom, AcaciaStairs::Shape::OuterRight).ID: return 7454;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Top, true, true).ID: return 4368;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Top, true, false).ID: return 4370;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Top, false, true).ID: return 4372;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Top, false, false).ID: return 4374;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Bottom, true, true).ID: return 4376;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Bottom, true, false).ID: return 4378;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Bottom, false, true).ID: return 4380;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZM, AcaciaTrapdoor::Half::Bottom, false, false).ID: return 4382;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Top, true, true).ID: return 4384;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Top, true, false).ID: return 4386;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Top, false, true).ID: return 4388;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Top, false, false).ID: return 4390;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Bottom, true, true).ID: return 4392;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Bottom, true, false).ID: return 4394;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Bottom, false, true).ID: return 4396;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_ZP, AcaciaTrapdoor::Half::Bottom, false, false).ID: return 4398;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Top, true, true).ID: return 4400;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Top, true, false).ID: return 4402;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Top, false, true).ID: return 4404;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Top, false, false).ID: return 4406;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Bottom, true, true).ID: return 4408;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Bottom, true, false).ID: return 4410;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Bottom, false, true).ID: return 4412;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XM, AcaciaTrapdoor::Half::Bottom, false, false).ID: return 4414;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Top, true, true).ID: return 4416;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Top, true, false).ID: return 4418;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Top, false, true).ID: return 4420;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Top, false, false).ID: return 4422;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Bottom, true, true).ID: return 4424;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Bottom, true, false).ID: return 4426;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Bottom, false, true).ID: return 4428;
			case AcaciaTrapdoor::AcaciaTrapdoor(eBlockFace::BLOCK_FACE_XP, AcaciaTrapdoor::Half::Bottom, false, false).ID: return 4430;
			case AcaciaWallSign::AcaciaWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 3760;
			case AcaciaWallSign::AcaciaWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 3762;
			case AcaciaWallSign::AcaciaWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 3764;
			case AcaciaWallSign::AcaciaWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 3766;
			case AcaciaWood::AcaciaWood(AcaciaWood::Axis::X).ID: return 121;
			case AcaciaWood::AcaciaWood(AcaciaWood::Axis::Y).ID: return 122;
			case AcaciaWood::AcaciaWood(AcaciaWood::Axis::Z).ID: return 123;
			case ActivatorRail::ActivatorRail(true, ActivatorRail::Shape::NorthSouth).ID: return 6823;
			case ActivatorRail::ActivatorRail(true, ActivatorRail::Shape::EastWest).ID: return 6824;
			case ActivatorRail::ActivatorRail(true, ActivatorRail::Shape::AscendingEast).ID: return 6825;
			case ActivatorRail::ActivatorRail(true, ActivatorRail::Shape::AscendingWest).ID: return 6826;
			case ActivatorRail::ActivatorRail(true, ActivatorRail::Shape::AscendingNorth).ID: return 6827;
			case ActivatorRail::ActivatorRail(true, ActivatorRail::Shape::AscendingSouth).ID: return 6828;
			case ActivatorRail::ActivatorRail(false, ActivatorRail::Shape::NorthSouth).ID: return 6829;
			case ActivatorRail::ActivatorRail(false, ActivatorRail::Shape::EastWest).ID: return 6830;
			case ActivatorRail::ActivatorRail(false, ActivatorRail::Shape::AscendingEast).ID: return 6831;
			case ActivatorRail::ActivatorRail(false, ActivatorRail::Shape::AscendingWest).ID: return 6832;
			case ActivatorRail::ActivatorRail(false, ActivatorRail::Shape::AscendingNorth).ID: return 6833;
			case ActivatorRail::ActivatorRail(false, ActivatorRail::Shape::AscendingSouth).ID: return 6834;
			case Air::Air().ID: return -0;
			case Allium::Allium().ID: return 1415;
			case AncientDebris::AncientDebris().ID: return 15827;
			case Andesite::Andesite().ID: return 6;
			case AndesiteSlab::AndesiteSlab(AndesiteSlab::Type::Top).ID: return 10844;
			case AndesiteSlab::AndesiteSlab(AndesiteSlab::Type::Bottom).ID: return 10846;
			case AndesiteSlab::AndesiteSlab(AndesiteSlab::Type::Double).ID: return 10848;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::Straight).ID: return 10470;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerLeft).ID: return 10472;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerRight).ID: return 10474;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterLeft).ID: return 10476;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterRight).ID: return 10478;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::Straight).ID: return 10480;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerLeft).ID: return 10482;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerRight).ID: return 10484;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterLeft).ID: return 10486;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterRight).ID: return 10488;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::Straight).ID: return 10490;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerLeft).ID: return 10492;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerRight).ID: return 10494;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterLeft).ID: return 10496;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterRight).ID: return 10498;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::Straight).ID: return 10500;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerLeft).ID: return 10502;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerRight).ID: return 10504;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterLeft).ID: return 10506;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_ZP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterRight).ID: return 10508;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::Straight).ID: return 10510;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerLeft).ID: return 10512;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerRight).ID: return 10514;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterLeft).ID: return 10516;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterRight).ID: return 10518;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::Straight).ID: return 10520;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerLeft).ID: return 10522;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerRight).ID: return 10524;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterLeft).ID: return 10526;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XM, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterRight).ID: return 10528;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::Straight).ID: return 10530;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerLeft).ID: return 10532;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::InnerRight).ID: return 10534;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterLeft).ID: return 10536;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Top, AndesiteStairs::Shape::OuterRight).ID: return 10538;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::Straight).ID: return 10540;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerLeft).ID: return 10542;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::InnerRight).ID: return 10544;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterLeft).ID: return 10546;
			case AndesiteStairs::AndesiteStairs(eBlockFace::BLOCK_FACE_XP, AndesiteStairs::Half::Bottom, AndesiteStairs::Shape::OuterRight).ID: return 10548;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13138;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13139;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13140;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13144;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13145;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13146;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13150;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13151;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13152;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13156;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13157;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13158;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13162;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13163;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13164;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13168;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13169;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13170;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13174;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13175;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13176;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13180;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13181;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13182;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13186;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13187;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13188;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13192;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13193;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13194;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13198;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13199;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13200;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13204;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13205;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13206;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13210;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13211;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13212;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13216;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13217;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13218;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13222;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13223;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13224;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13228;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13229;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13230;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13234;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13235;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13236;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13240;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13241;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::None, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13242;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13246;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13247;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13248;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13252;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13253;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13254;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13258;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13259;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13260;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13264;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13265;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13266;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13270;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13271;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13272;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13276;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13277;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13278;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13282;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13283;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13284;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13288;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13289;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13290;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13294;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13295;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13296;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13300;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13301;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13302;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13306;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13307;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13308;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13312;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13313;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13314;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13318;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13319;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13320;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13324;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13325;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13326;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13330;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13331;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13332;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13336;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13337;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13338;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13342;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13343;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13344;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13348;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13349;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Low, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13350;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13354;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13355;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13356;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13360;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13361;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13362;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13366;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13367;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13368;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13372;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13373;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13374;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13378;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13379;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13380;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13384;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13385;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::None, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13386;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13390;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13391;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13392;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13396;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13397;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13398;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13402;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13403;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13404;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13408;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13409;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13410;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13414;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13415;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13416;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13420;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13421;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Low, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13422;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::None).ID: return 13426;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::Low).ID: return 13427;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::None, true, AndesiteWall::West::Tall).ID: return 13428;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::None).ID: return 13432;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::Low).ID: return 13433;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::None, false, AndesiteWall::West::Tall).ID: return 13434;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::None).ID: return 13438;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::Low).ID: return 13439;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Low, true, AndesiteWall::West::Tall).ID: return 13440;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::None).ID: return 13444;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::Low).ID: return 13445;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Low, false, AndesiteWall::West::Tall).ID: return 13446;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::None).ID: return 13450;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::Low).ID: return 13451;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Tall, true, AndesiteWall::West::Tall).ID: return 13452;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::None).ID: return 13456;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::Low).ID: return 13457;
			case AndesiteWall::AndesiteWall(AndesiteWall::East::Tall, AndesiteWall::North::Tall, AndesiteWall::South::Tall, false, AndesiteWall::West::Tall).ID: return 13458;
			case Anvil::Anvil(eBlockFace::BLOCK_FACE_ZM).ID: return 6610;
			case Anvil::Anvil(eBlockFace::BLOCK_FACE_ZP).ID: return 6611;
			case Anvil::Anvil(eBlockFace::BLOCK_FACE_XM).ID: return 6612;
			case Anvil::Anvil(eBlockFace::BLOCK_FACE_XP).ID: return 6613;
			case AttachedMelonStem::AttachedMelonStem(eBlockFace::BLOCK_FACE_ZM).ID: return 4768;
			case AttachedMelonStem::AttachedMelonStem(eBlockFace::BLOCK_FACE_ZP).ID: return 4769;
			case AttachedMelonStem::AttachedMelonStem(eBlockFace::BLOCK_FACE_XM).ID: return 4770;
			case AttachedMelonStem::AttachedMelonStem(eBlockFace::BLOCK_FACE_XP).ID: return 4771;
			case AttachedPumpkinStem::AttachedPumpkinStem(eBlockFace::BLOCK_FACE_ZM).ID: return 4764;
			case AttachedPumpkinStem::AttachedPumpkinStem(eBlockFace::BLOCK_FACE_ZP).ID: return 4765;
			case AttachedPumpkinStem::AttachedPumpkinStem(eBlockFace::BLOCK_FACE_XM).ID: return 4766;
			case AttachedPumpkinStem::AttachedPumpkinStem(eBlockFace::BLOCK_FACE_XP).ID: return 4767;
			case AzureBluet::AzureBluet().ID: return 1416;
			case Bamboo::Bamboo(0, Bamboo::Leaves::None, 0).ID: return 9652;
			case Bamboo::Bamboo(0, Bamboo::Leaves::None, 1).ID: return 9653;
			case Bamboo::Bamboo(0, Bamboo::Leaves::Small, 0).ID: return 9654;
			case Bamboo::Bamboo(0, Bamboo::Leaves::Small, 1).ID: return 9655;
			case Bamboo::Bamboo(0, Bamboo::Leaves::Large, 0).ID: return 9656;
			case Bamboo::Bamboo(0, Bamboo::Leaves::Large, 1).ID: return 9657;
			case Bamboo::Bamboo(1, Bamboo::Leaves::None, 0).ID: return 9658;
			case Bamboo::Bamboo(1, Bamboo::Leaves::None, 1).ID: return 9659;
			case Bamboo::Bamboo(1, Bamboo::Leaves::Small, 0).ID: return 9660;
			case Bamboo::Bamboo(1, Bamboo::Leaves::Small, 1).ID: return 9661;
			case Bamboo::Bamboo(1, Bamboo::Leaves::Large, 0).ID: return 9662;
			case Bamboo::Bamboo(1, Bamboo::Leaves::Large, 1).ID: return 9663;
			case BambooSapling::BambooSapling().ID: return 9651;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_ZM, true).ID: return 14791;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_ZM, false).ID: return 14792;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_XP, true).ID: return 14793;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_XP, false).ID: return 14794;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_ZP, true).ID: return 14795;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_ZP, false).ID: return 14796;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_XM, true).ID: return 14797;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_XM, false).ID: return 14798;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_YP, true).ID: return 14799;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_YP, false).ID: return 14800;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_YM, true).ID: return 14801;
			case Barrel::Barrel(eBlockFace::BLOCK_FACE_YM, false).ID: return 14802;
			case Barrier::Barrier().ID: return 7536;
			case Basalt::Basalt(Basalt::Axis::X).ID: return 4002;
			case Basalt::Basalt(Basalt::Axis::Y).ID: return 4003;
			case Basalt::Basalt(Basalt::Axis::Z).ID: return 4004;
			case Beacon::Beacon().ID: return 5656;
			case Bedrock::Bedrock().ID: return 33;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZM, 0).ID: return 15776;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZM, 1).ID: return 15777;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZM, 2).ID: return 15778;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZM, 3).ID: return 15779;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZM, 4).ID: return 15780;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZM, 5).ID: return 15781;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZP, 0).ID: return 15782;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZP, 1).ID: return 15783;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZP, 2).ID: return 15784;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZP, 3).ID: return 15785;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZP, 4).ID: return 15786;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_ZP, 5).ID: return 15787;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XM, 0).ID: return 15788;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XM, 1).ID: return 15789;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XM, 2).ID: return 15790;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XM, 3).ID: return 15791;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XM, 4).ID: return 15792;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XM, 5).ID: return 15793;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XP, 0).ID: return 15794;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XP, 1).ID: return 15795;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XP, 2).ID: return 15796;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XP, 3).ID: return 15797;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XP, 4).ID: return 15798;
			case BeeNest::BeeNest(eBlockFace::BLOCK_FACE_XP, 5).ID: return 15799;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZM, 0).ID: return 15800;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZM, 1).ID: return 15801;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZM, 2).ID: return 15802;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZM, 3).ID: return 15803;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZM, 4).ID: return 15804;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZM, 5).ID: return 15805;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZP, 0).ID: return 15806;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZP, 1).ID: return 15807;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZP, 2).ID: return 15808;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZP, 3).ID: return 15809;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZP, 4).ID: return 15810;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_ZP, 5).ID: return 15811;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XM, 0).ID: return 15812;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XM, 1).ID: return 15813;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XM, 2).ID: return 15814;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XM, 3).ID: return 15815;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XM, 4).ID: return 15816;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XM, 5).ID: return 15817;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XP, 0).ID: return 15818;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XP, 1).ID: return 15819;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XP, 2).ID: return 15820;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XP, 3).ID: return 15821;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XP, 4).ID: return 15822;
			case Beehive::Beehive(eBlockFace::BLOCK_FACE_XP, 5).ID: return 15823;
			case Beetroots::Beetroots(0).ID: return 9219;
			case Beetroots::Beetroots(1).ID: return 9220;
			case Beetroots::Beetroots(2).ID: return 9221;
			case Beetroots::Beetroots(3).ID: return 9222;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 14854;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 14855;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 14856;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 14857;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 14858;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 14859;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 14860;
			case Bell::Bell(Bell::Attachment::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 14861;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 14862;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 14863;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 14864;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 14865;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 14866;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 14867;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 14868;
			case Bell::Bell(Bell::Attachment::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 14869;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 14870;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 14871;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 14872;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 14873;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_XM, true).ID: return 14874;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_XM, false).ID: return 14875;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_XP, true).ID: return 14876;
			case Bell::Bell(Bell::Attachment::SingleWall, eBlockFace::BLOCK_FACE_XP, false).ID: return 14877;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 14878;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 14879;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 14880;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 14881;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_XM, true).ID: return 14882;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_XM, false).ID: return 14883;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_XP, true).ID: return 14884;
			case Bell::Bell(Bell::Attachment::DoubleWall, eBlockFace::BLOCK_FACE_XP, false).ID: return 14885;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6394;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6395;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6396;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6397;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 6398;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 6399;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 6400;
			case BirchButton::BirchButton(BirchButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 6401;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6402;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6403;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6404;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6405;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 6406;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 6407;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 6408;
			case BirchButton::BirchButton(BirchButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 6409;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6410;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6411;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6412;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6413;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 6414;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 6415;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 6416;
			case BirchButton::BirchButton(BirchButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 6417;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, true).ID: return 8802;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, false).ID: return 8803;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, true).ID: return 8804;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, false).ID: return 8805;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, true).ID: return 8806;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, false).ID: return 8807;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, true).ID: return 8808;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, false).ID: return 8809;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, true).ID: return 8810;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, false).ID: return 8811;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, true).ID: return 8812;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, false).ID: return 8813;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, true).ID: return 8814;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, false).ID: return 8815;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, true).ID: return 8816;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, false).ID: return 8817;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, true).ID: return 8818;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, false).ID: return 8819;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, true).ID: return 8820;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, false).ID: return 8821;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, true).ID: return 8822;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, false).ID: return 8823;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, true).ID: return 8824;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, false).ID: return 8825;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, true).ID: return 8826;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, false).ID: return 8827;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, true).ID: return 8828;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, false).ID: return 8829;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, true).ID: return 8830;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, false).ID: return 8831;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, true).ID: return 8832;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_ZP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, false).ID: return 8833;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, true).ID: return 8834;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, false).ID: return 8835;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, true).ID: return 8836;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, false).ID: return 8837;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, true).ID: return 8838;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, false).ID: return 8839;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, true).ID: return 8840;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, false).ID: return 8841;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, true).ID: return 8842;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, false).ID: return 8843;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, true).ID: return 8844;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, false).ID: return 8845;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, true).ID: return 8846;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, false).ID: return 8847;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, true).ID: return 8848;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XM, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, false).ID: return 8849;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, true).ID: return 8850;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, true, false).ID: return 8851;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, true).ID: return 8852;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Left, false, false).ID: return 8853;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, true).ID: return 8854;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, true, false).ID: return 8855;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, true).ID: return 8856;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Upper, BirchDoor::Hinge::Right, false, false).ID: return 8857;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, true).ID: return 8858;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, true, false).ID: return 8859;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, true).ID: return 8860;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Left, false, false).ID: return 8861;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, true).ID: return 8862;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, true, false).ID: return 8863;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, true).ID: return 8864;
			case BirchDoor::BirchDoor(eBlockFace::BLOCK_FACE_XP, BirchDoor::Half::Lower, BirchDoor::Hinge::Right, false, false).ID: return 8865;
			case BirchFence::BirchFence(true, true, true, true).ID: return 8612;
			case BirchFence::BirchFence(true, true, true, false).ID: return 8613;
			case BirchFence::BirchFence(true, true, false, true).ID: return 8616;
			case BirchFence::BirchFence(true, true, false, false).ID: return 8617;
			case BirchFence::BirchFence(true, false, true, true).ID: return 8620;
			case BirchFence::BirchFence(true, false, true, false).ID: return 8621;
			case BirchFence::BirchFence(true, false, false, true).ID: return 8624;
			case BirchFence::BirchFence(true, false, false, false).ID: return 8625;
			case BirchFence::BirchFence(false, true, true, true).ID: return 8628;
			case BirchFence::BirchFence(false, true, true, false).ID: return 8629;
			case BirchFence::BirchFence(false, true, false, true).ID: return 8632;
			case BirchFence::BirchFence(false, true, false, false).ID: return 8633;
			case BirchFence::BirchFence(false, false, true, true).ID: return 8636;
			case BirchFence::BirchFence(false, false, true, false).ID: return 8637;
			case BirchFence::BirchFence(false, false, false, true).ID: return 8640;
			case BirchFence::BirchFence(false, false, false, false).ID: return 8641;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 8450;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 8451;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 8452;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 8453;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 8454;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 8455;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 8456;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 8457;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 8458;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 8459;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 8460;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 8461;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 8462;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 8463;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 8464;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 8465;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 8466;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 8467;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 8468;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 8469;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 8470;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 8471;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 8472;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 8473;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 8474;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 8475;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 8476;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 8477;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 8478;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 8479;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 8480;
			case BirchFenceGate::BirchFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 8481;
			case BirchLeaves::BirchLeaves(1, true).ID: return 173;
			case BirchLeaves::BirchLeaves(1, false).ID: return 174;
			case BirchLeaves::BirchLeaves(2, true).ID: return 175;
			case BirchLeaves::BirchLeaves(2, false).ID: return 176;
			case BirchLeaves::BirchLeaves(3, true).ID: return 177;
			case BirchLeaves::BirchLeaves(3, false).ID: return 178;
			case BirchLeaves::BirchLeaves(4, true).ID: return 179;
			case BirchLeaves::BirchLeaves(4, false).ID: return 180;
			case BirchLeaves::BirchLeaves(5, true).ID: return 181;
			case BirchLeaves::BirchLeaves(5, false).ID: return 182;
			case BirchLeaves::BirchLeaves(6, true).ID: return 183;
			case BirchLeaves::BirchLeaves(6, false).ID: return 184;
			case BirchLeaves::BirchLeaves(7, true).ID: return 185;
			case BirchLeaves::BirchLeaves(7, false).ID: return 186;
			case BirchLog::BirchLog(BirchLog::Axis::X).ID: return 79;
			case BirchLog::BirchLog(BirchLog::Axis::Y).ID: return 80;
			case BirchLog::BirchLog(BirchLog::Axis::Z).ID: return 81;
			case BirchPlanks::BirchPlanks().ID: return 17;
			case BirchPressurePlate::BirchPressurePlate(true).ID: return 3877;
			case BirchPressurePlate::BirchPressurePlate(false).ID: return 3878;
			case BirchSapling::BirchSapling(0).ID: return 25;
			case BirchSapling::BirchSapling(1).ID: return 26;
			case BirchSign::BirchSign(0).ID: return 3446;
			case BirchSign::BirchSign(1).ID: return 3448;
			case BirchSign::BirchSign(2).ID: return 3450;
			case BirchSign::BirchSign(3).ID: return 3452;
			case BirchSign::BirchSign(4).ID: return 3454;
			case BirchSign::BirchSign(5).ID: return 3456;
			case BirchSign::BirchSign(6).ID: return 3458;
			case BirchSign::BirchSign(7).ID: return 3460;
			case BirchSign::BirchSign(8).ID: return 3462;
			case BirchSign::BirchSign(9).ID: return 3464;
			case BirchSign::BirchSign(10).ID: return 3466;
			case BirchSign::BirchSign(11).ID: return 3468;
			case BirchSign::BirchSign(12).ID: return 3470;
			case BirchSign::BirchSign(13).ID: return 3472;
			case BirchSign::BirchSign(14).ID: return 3474;
			case BirchSign::BirchSign(15).ID: return 3476;
			case BirchSlab::BirchSlab(BirchSlab::Type::Top).ID: return 8313;
			case BirchSlab::BirchSlab(BirchSlab::Type::Bottom).ID: return 8315;
			case BirchSlab::BirchSlab(BirchSlab::Type::Double).ID: return 8317;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Top, BirchStairs::Shape::Straight).ID: return 5485;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Top, BirchStairs::Shape::InnerLeft).ID: return 5487;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Top, BirchStairs::Shape::InnerRight).ID: return 5489;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Top, BirchStairs::Shape::OuterLeft).ID: return 5491;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Top, BirchStairs::Shape::OuterRight).ID: return 5493;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Bottom, BirchStairs::Shape::Straight).ID: return 5495;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerLeft).ID: return 5497;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerRight).ID: return 5499;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterLeft).ID: return 5501;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZM, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterRight).ID: return 5503;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Top, BirchStairs::Shape::Straight).ID: return 5505;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Top, BirchStairs::Shape::InnerLeft).ID: return 5507;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Top, BirchStairs::Shape::InnerRight).ID: return 5509;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Top, BirchStairs::Shape::OuterLeft).ID: return 5511;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Top, BirchStairs::Shape::OuterRight).ID: return 5513;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Bottom, BirchStairs::Shape::Straight).ID: return 5515;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerLeft).ID: return 5517;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerRight).ID: return 5519;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterLeft).ID: return 5521;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_ZP, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterRight).ID: return 5523;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Top, BirchStairs::Shape::Straight).ID: return 5525;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Top, BirchStairs::Shape::InnerLeft).ID: return 5527;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Top, BirchStairs::Shape::InnerRight).ID: return 5529;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Top, BirchStairs::Shape::OuterLeft).ID: return 5531;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Top, BirchStairs::Shape::OuterRight).ID: return 5533;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Bottom, BirchStairs::Shape::Straight).ID: return 5535;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerLeft).ID: return 5537;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerRight).ID: return 5539;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterLeft).ID: return 5541;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XM, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterRight).ID: return 5543;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Top, BirchStairs::Shape::Straight).ID: return 5545;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Top, BirchStairs::Shape::InnerLeft).ID: return 5547;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Top, BirchStairs::Shape::InnerRight).ID: return 5549;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Top, BirchStairs::Shape::OuterLeft).ID: return 5551;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Top, BirchStairs::Shape::OuterRight).ID: return 5553;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Bottom, BirchStairs::Shape::Straight).ID: return 5555;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerLeft).ID: return 5557;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Bottom, BirchStairs::Shape::InnerRight).ID: return 5559;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterLeft).ID: return 5561;
			case BirchStairs::BirchStairs(eBlockFace::BLOCK_FACE_XP, BirchStairs::Half::Bottom, BirchStairs::Shape::OuterRight).ID: return 5563;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Top, true, true).ID: return 4240;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Top, true, false).ID: return 4242;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Top, false, true).ID: return 4244;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Top, false, false).ID: return 4246;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Bottom, true, true).ID: return 4248;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Bottom, true, false).ID: return 4250;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Bottom, false, true).ID: return 4252;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZM, BirchTrapdoor::Half::Bottom, false, false).ID: return 4254;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Top, true, true).ID: return 4256;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Top, true, false).ID: return 4258;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Top, false, true).ID: return 4260;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Top, false, false).ID: return 4262;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Bottom, true, true).ID: return 4264;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Bottom, true, false).ID: return 4266;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Bottom, false, true).ID: return 4268;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_ZP, BirchTrapdoor::Half::Bottom, false, false).ID: return 4270;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Top, true, true).ID: return 4272;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Top, true, false).ID: return 4274;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Top, false, true).ID: return 4276;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Top, false, false).ID: return 4278;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Bottom, true, true).ID: return 4280;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Bottom, true, false).ID: return 4282;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Bottom, false, true).ID: return 4284;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XM, BirchTrapdoor::Half::Bottom, false, false).ID: return 4286;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Top, true, true).ID: return 4288;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Top, true, false).ID: return 4290;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Top, false, true).ID: return 4292;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Top, false, false).ID: return 4294;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Bottom, true, true).ID: return 4296;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Bottom, true, false).ID: return 4298;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Bottom, false, true).ID: return 4300;
			case BirchTrapdoor::BirchTrapdoor(eBlockFace::BLOCK_FACE_XP, BirchTrapdoor::Half::Bottom, false, false).ID: return 4302;
			case BirchWallSign::BirchWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 3752;
			case BirchWallSign::BirchWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 3754;
			case BirchWallSign::BirchWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 3756;
			case BirchWallSign::BirchWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 3758;
			case BirchWood::BirchWood(BirchWood::Axis::X).ID: return 115;
			case BirchWood::BirchWood(BirchWood::Axis::Y).ID: return 116;
			case BirchWood::BirchWood(BirchWood::Axis::Z).ID: return 117;
			case BlackBanner::BlackBanner(0).ID: return 8137;
			case BlackBanner::BlackBanner(1).ID: return 8138;
			case BlackBanner::BlackBanner(2).ID: return 8139;
			case BlackBanner::BlackBanner(3).ID: return 8140;
			case BlackBanner::BlackBanner(4).ID: return 8141;
			case BlackBanner::BlackBanner(5).ID: return 8142;
			case BlackBanner::BlackBanner(6).ID: return 8143;
			case BlackBanner::BlackBanner(7).ID: return 8144;
			case BlackBanner::BlackBanner(8).ID: return 8145;
			case BlackBanner::BlackBanner(9).ID: return 8146;
			case BlackBanner::BlackBanner(10).ID: return 8147;
			case BlackBanner::BlackBanner(11).ID: return 8148;
			case BlackBanner::BlackBanner(12).ID: return 8149;
			case BlackBanner::BlackBanner(13).ID: return 8150;
			case BlackBanner::BlackBanner(14).ID: return 8151;
			case BlackBanner::BlackBanner(15).ID: return 8152;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZM, true, BlackBed::Part::Head).ID: return 1289;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZM, true, BlackBed::Part::Foot).ID: return 1290;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZM, false, BlackBed::Part::Head).ID: return 1291;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZM, false, BlackBed::Part::Foot).ID: return 1292;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZP, true, BlackBed::Part::Head).ID: return 1293;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZP, true, BlackBed::Part::Foot).ID: return 1294;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZP, false, BlackBed::Part::Head).ID: return 1295;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_ZP, false, BlackBed::Part::Foot).ID: return 1296;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XM, true, BlackBed::Part::Head).ID: return 1297;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XM, true, BlackBed::Part::Foot).ID: return 1298;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XM, false, BlackBed::Part::Head).ID: return 1299;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XM, false, BlackBed::Part::Foot).ID: return 1300;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XP, true, BlackBed::Part::Head).ID: return 1301;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XP, true, BlackBed::Part::Foot).ID: return 1302;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XP, false, BlackBed::Part::Head).ID: return 1303;
			case BlackBed::BlackBed(eBlockFace::BLOCK_FACE_XP, false, BlackBed::Part::Foot).ID: return 1304;
			case BlackCarpet::BlackCarpet().ID: return 7881;
			case BlackConcrete::BlackConcrete().ID: return 9453;
			case BlackConcretePowder::BlackConcretePowder().ID: return 9469;
			case BlackGlazedTerracotta::BlackGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9434;
			case BlackGlazedTerracotta::BlackGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9435;
			case BlackGlazedTerracotta::BlackGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9436;
			case BlackGlazedTerracotta::BlackGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9437;
			case BlackShulkerBox::BlackShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9368;
			case BlackShulkerBox::BlackShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9369;
			case BlackShulkerBox::BlackShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9370;
			case BlackShulkerBox::BlackShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9371;
			case BlackShulkerBox::BlackShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9372;
			case BlackShulkerBox::BlackShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9373;
			case BlackStainedGlass::BlackStainedGlass().ID: return 4110;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, true, true, true).ID: return 7345;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, true, true, false).ID: return 7346;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, true, false, true).ID: return 7349;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, true, false, false).ID: return 7350;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, false, true, true).ID: return 7353;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, false, true, false).ID: return 7354;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, false, false, true).ID: return 7357;
			case BlackStainedGlassPane::BlackStainedGlassPane(true, false, false, false).ID: return 7358;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, true, true, true).ID: return 7361;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, true, true, false).ID: return 7362;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, true, false, true).ID: return 7365;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, true, false, false).ID: return 7366;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, false, true, true).ID: return 7369;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, false, true, false).ID: return 7370;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, false, false, true).ID: return 7373;
			case BlackStainedGlassPane::BlackStainedGlassPane(false, false, false, false).ID: return 7374;
			case BlackTerracotta::BlackTerracotta().ID: return 6862;
			case BlackWallBanner::BlackWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8213;
			case BlackWallBanner::BlackWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8214;
			case BlackWallBanner::BlackWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8215;
			case BlackWallBanner::BlackWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8216;
			case BlackWool::BlackWool().ID: return 1399;
			case Blackstone::Blackstone().ID: return 15839;
			case BlackstoneSlab::BlackstoneSlab(BlackstoneSlab::Type::Top).ID: return 16245;
			case BlackstoneSlab::BlackstoneSlab(BlackstoneSlab::Type::Bottom).ID: return 16247;
			case BlackstoneSlab::BlackstoneSlab(BlackstoneSlab::Type::Double).ID: return 16249;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::Straight).ID: return 15841;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerLeft).ID: return 15843;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerRight).ID: return 15845;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterLeft).ID: return 15847;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterRight).ID: return 15849;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::Straight).ID: return 15851;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerLeft).ID: return 15853;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerRight).ID: return 15855;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterLeft).ID: return 15857;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterRight).ID: return 15859;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::Straight).ID: return 15861;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerLeft).ID: return 15863;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerRight).ID: return 15865;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterLeft).ID: return 15867;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterRight).ID: return 15869;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::Straight).ID: return 15871;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerLeft).ID: return 15873;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerRight).ID: return 15875;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterLeft).ID: return 15877;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterRight).ID: return 15879;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::Straight).ID: return 15881;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerLeft).ID: return 15883;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerRight).ID: return 15885;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterLeft).ID: return 15887;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterRight).ID: return 15889;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::Straight).ID: return 15891;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerLeft).ID: return 15893;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerRight).ID: return 15895;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterLeft).ID: return 15897;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XM, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterRight).ID: return 15899;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::Straight).ID: return 15901;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerLeft).ID: return 15903;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::InnerRight).ID: return 15905;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterLeft).ID: return 15907;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Top, BlackstoneStairs::Shape::OuterRight).ID: return 15909;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::Straight).ID: return 15911;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerLeft).ID: return 15913;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::InnerRight).ID: return 15915;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterLeft).ID: return 15917;
			case BlackstoneStairs::BlackstoneStairs(eBlockFace::BLOCK_FACE_XP, BlackstoneStairs::Half::Bottom, BlackstoneStairs::Shape::OuterRight).ID: return 15919;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 15923;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 15924;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 15925;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 15929;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 15930;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 15931;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 15935;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 15936;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 15937;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 15941;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 15942;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 15943;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 15947;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 15948;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 15949;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 15953;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 15954;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 15955;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 15959;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 15960;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 15961;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 15965;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 15966;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 15967;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 15971;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 15972;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 15973;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 15977;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 15978;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 15979;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 15983;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 15984;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 15985;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 15989;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 15990;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 15991;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 15995;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 15996;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 15997;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16001;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16002;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16003;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16007;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16008;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16009;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16013;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16014;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16015;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16019;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16020;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16021;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16025;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16026;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::None, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16027;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 16031;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 16032;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 16033;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16037;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16038;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16039;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16043;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16044;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16045;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16049;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16050;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16051;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16055;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16056;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16057;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16061;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16062;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16063;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 16067;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 16068;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 16069;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16073;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16074;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16075;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16079;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16080;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16081;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16085;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16086;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16087;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16091;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16092;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16093;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16097;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16098;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16099;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 16103;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 16104;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 16105;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16109;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16110;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16111;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16115;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16116;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16117;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16121;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16122;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16123;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16127;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16128;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16129;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16133;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16134;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Low, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16135;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 16139;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 16140;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 16141;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16145;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16146;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16147;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16151;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16152;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16153;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16157;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16158;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16159;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16163;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16164;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16165;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16169;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16170;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::None, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16171;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 16175;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 16176;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 16177;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16181;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16182;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16183;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16187;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16188;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16189;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16193;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16194;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16195;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16199;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16200;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16201;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16205;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16206;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Low, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16207;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::None).ID: return 16211;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::Low).ID: return 16212;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::None, true, BlackstoneWall::West::Tall).ID: return 16213;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::None).ID: return 16217;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::Low).ID: return 16218;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::None, false, BlackstoneWall::West::Tall).ID: return 16219;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::None).ID: return 16223;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::Low).ID: return 16224;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, true, BlackstoneWall::West::Tall).ID: return 16225;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::None).ID: return 16229;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::Low).ID: return 16230;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Low, false, BlackstoneWall::West::Tall).ID: return 16231;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::None).ID: return 16235;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Low).ID: return 16236;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, true, BlackstoneWall::West::Tall).ID: return 16237;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::None).ID: return 16241;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Low).ID: return 16242;
			case BlackstoneWall::BlackstoneWall(BlackstoneWall::East::Tall, BlackstoneWall::North::Tall, BlackstoneWall::South::Tall, false, BlackstoneWall::West::Tall).ID: return 16243;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_ZM, true).ID: return 14811;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_ZM, false).ID: return 14812;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_ZP, true).ID: return 14813;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_ZP, false).ID: return 14814;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_XM, true).ID: return 14815;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_XM, false).ID: return 14816;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_XP, true).ID: return 14817;
			case BlastFurnace::BlastFurnace(eBlockFace::BLOCK_FACE_XP, false).ID: return 14818;
			case BlueBanner::BlueBanner(0).ID: return 8073;
			case BlueBanner::BlueBanner(1).ID: return 8074;
			case BlueBanner::BlueBanner(2).ID: return 8075;
			case BlueBanner::BlueBanner(3).ID: return 8076;
			case BlueBanner::BlueBanner(4).ID: return 8077;
			case BlueBanner::BlueBanner(5).ID: return 8078;
			case BlueBanner::BlueBanner(6).ID: return 8079;
			case BlueBanner::BlueBanner(7).ID: return 8080;
			case BlueBanner::BlueBanner(8).ID: return 8081;
			case BlueBanner::BlueBanner(9).ID: return 8082;
			case BlueBanner::BlueBanner(10).ID: return 8083;
			case BlueBanner::BlueBanner(11).ID: return 8084;
			case BlueBanner::BlueBanner(12).ID: return 8085;
			case BlueBanner::BlueBanner(13).ID: return 8086;
			case BlueBanner::BlueBanner(14).ID: return 8087;
			case BlueBanner::BlueBanner(15).ID: return 8088;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZM, true, BlueBed::Part::Head).ID: return 1225;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZM, true, BlueBed::Part::Foot).ID: return 1226;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZM, false, BlueBed::Part::Head).ID: return 1227;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZM, false, BlueBed::Part::Foot).ID: return 1228;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZP, true, BlueBed::Part::Head).ID: return 1229;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZP, true, BlueBed::Part::Foot).ID: return 1230;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZP, false, BlueBed::Part::Head).ID: return 1231;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_ZP, false, BlueBed::Part::Foot).ID: return 1232;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XM, true, BlueBed::Part::Head).ID: return 1233;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XM, true, BlueBed::Part::Foot).ID: return 1234;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XM, false, BlueBed::Part::Head).ID: return 1235;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XM, false, BlueBed::Part::Foot).ID: return 1236;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XP, true, BlueBed::Part::Head).ID: return 1237;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XP, true, BlueBed::Part::Foot).ID: return 1238;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XP, false, BlueBed::Part::Head).ID: return 1239;
			case BlueBed::BlueBed(eBlockFace::BLOCK_FACE_XP, false, BlueBed::Part::Foot).ID: return 1240;
			case BlueCarpet::BlueCarpet().ID: return 7877;
			case BlueConcrete::BlueConcrete().ID: return 9449;
			case BlueConcretePowder::BlueConcretePowder().ID: return 9465;
			case BlueGlazedTerracotta::BlueGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9418;
			case BlueGlazedTerracotta::BlueGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9419;
			case BlueGlazedTerracotta::BlueGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9420;
			case BlueGlazedTerracotta::BlueGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9421;
			case BlueIce::BlueIce().ID: return 9648;
			case BlueOrchid::BlueOrchid().ID: return 1414;
			case BlueShulkerBox::BlueShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9344;
			case BlueShulkerBox::BlueShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9345;
			case BlueShulkerBox::BlueShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9346;
			case BlueShulkerBox::BlueShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9347;
			case BlueShulkerBox::BlueShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9348;
			case BlueShulkerBox::BlueShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9349;
			case BlueStainedGlass::BlueStainedGlass().ID: return 4106;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, true, true, true).ID: return 7217;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, true, true, false).ID: return 7218;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, true, false, true).ID: return 7221;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, true, false, false).ID: return 7222;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, false, true, true).ID: return 7225;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, false, true, false).ID: return 7226;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, false, false, true).ID: return 7229;
			case BlueStainedGlassPane::BlueStainedGlassPane(true, false, false, false).ID: return 7230;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, true, true, true).ID: return 7233;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, true, true, false).ID: return 7234;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, true, false, true).ID: return 7237;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, true, false, false).ID: return 7238;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, false, true, true).ID: return 7241;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, false, true, false).ID: return 7242;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, false, false, true).ID: return 7245;
			case BlueStainedGlassPane::BlueStainedGlassPane(false, false, false, false).ID: return 7246;
			case BlueTerracotta::BlueTerracotta().ID: return 6858;
			case BlueWallBanner::BlueWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8197;
			case BlueWallBanner::BlueWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8198;
			case BlueWallBanner::BlueWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8199;
			case BlueWallBanner::BlueWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8200;
			case BlueWool::BlueWool().ID: return 1395;
			case BoneBlock::BoneBlock(BoneBlock::Axis::X).ID: return 9256;
			case BoneBlock::BoneBlock(BoneBlock::Axis::Y).ID: return 9257;
			case BoneBlock::BoneBlock(BoneBlock::Axis::Z).ID: return 9258;
			case Bookshelf::Bookshelf().ID: return 1432;
			case BrainCoral::BrainCoral().ID: return 9533;
			case BrainCoralBlock::BrainCoralBlock().ID: return 9516;
			case BrainCoralFan::BrainCoralFan().ID: return 9553;
			case BrainCoralWallFan::BrainCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9609;
			case BrainCoralWallFan::BrainCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9611;
			case BrainCoralWallFan::BrainCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9613;
			case BrainCoralWallFan::BrainCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9615;
			case BrewingStand::BrewingStand(true, true, true).ID: return 5133;
			case BrewingStand::BrewingStand(true, true, false).ID: return 5134;
			case BrewingStand::BrewingStand(true, false, true).ID: return 5135;
			case BrewingStand::BrewingStand(true, false, false).ID: return 5136;
			case BrewingStand::BrewingStand(false, true, true).ID: return 5137;
			case BrewingStand::BrewingStand(false, true, false).ID: return 5138;
			case BrewingStand::BrewingStand(false, false, true).ID: return 5139;
			case BrewingStand::BrewingStand(false, false, false).ID: return 5140;
			case BrickSlab::BrickSlab(BrickSlab::Type::Top).ID: return 8373;
			case BrickSlab::BrickSlab(BrickSlab::Type::Bottom).ID: return 8375;
			case BrickSlab::BrickSlab(BrickSlab::Type::Double).ID: return 8377;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Top, BrickStairs::Shape::Straight).ID: return 4853;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Top, BrickStairs::Shape::InnerLeft).ID: return 4855;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Top, BrickStairs::Shape::InnerRight).ID: return 4857;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Top, BrickStairs::Shape::OuterLeft).ID: return 4859;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Top, BrickStairs::Shape::OuterRight).ID: return 4861;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Bottom, BrickStairs::Shape::Straight).ID: return 4863;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerLeft).ID: return 4865;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerRight).ID: return 4867;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterLeft).ID: return 4869;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZM, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterRight).ID: return 4871;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Top, BrickStairs::Shape::Straight).ID: return 4873;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Top, BrickStairs::Shape::InnerLeft).ID: return 4875;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Top, BrickStairs::Shape::InnerRight).ID: return 4877;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Top, BrickStairs::Shape::OuterLeft).ID: return 4879;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Top, BrickStairs::Shape::OuterRight).ID: return 4881;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Bottom, BrickStairs::Shape::Straight).ID: return 4883;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerLeft).ID: return 4885;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerRight).ID: return 4887;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterLeft).ID: return 4889;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_ZP, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterRight).ID: return 4891;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Top, BrickStairs::Shape::Straight).ID: return 4893;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Top, BrickStairs::Shape::InnerLeft).ID: return 4895;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Top, BrickStairs::Shape::InnerRight).ID: return 4897;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Top, BrickStairs::Shape::OuterLeft).ID: return 4899;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Top, BrickStairs::Shape::OuterRight).ID: return 4901;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Bottom, BrickStairs::Shape::Straight).ID: return 4903;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerLeft).ID: return 4905;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerRight).ID: return 4907;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterLeft).ID: return 4909;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XM, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterRight).ID: return 4911;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Top, BrickStairs::Shape::Straight).ID: return 4913;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Top, BrickStairs::Shape::InnerLeft).ID: return 4915;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Top, BrickStairs::Shape::InnerRight).ID: return 4917;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Top, BrickStairs::Shape::OuterLeft).ID: return 4919;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Top, BrickStairs::Shape::OuterRight).ID: return 4921;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Bottom, BrickStairs::Shape::Straight).ID: return 4923;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerLeft).ID: return 4925;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Bottom, BrickStairs::Shape::InnerRight).ID: return 4927;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterLeft).ID: return 4929;
			case BrickStairs::BrickStairs(eBlockFace::BLOCK_FACE_XP, BrickStairs::Half::Bottom, BrickStairs::Shape::OuterRight).ID: return 4931;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::None).ID: return 10870;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::Low).ID: return 10871;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 10872;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::None).ID: return 10876;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::Low).ID: return 10877;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 10878;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::None).ID: return 10882;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 10883;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 10884;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::None).ID: return 10888;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 10889;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 10890;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 10894;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 10895;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 10896;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 10900;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 10901;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 10902;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::None).ID: return 10906;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::Low).ID: return 10907;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 10908;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::None).ID: return 10912;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::Low).ID: return 10913;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 10914;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::None).ID: return 10918;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 10919;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 10920;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::None).ID: return 10924;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 10925;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 10926;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 10930;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 10931;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 10932;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 10936;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 10937;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 10938;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::None).ID: return 10942;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::Low).ID: return 10943;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 10944;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::None).ID: return 10948;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::Low).ID: return 10949;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 10950;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::None).ID: return 10954;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 10955;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 10956;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::None).ID: return 10960;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 10961;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 10962;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 10966;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 10967;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 10968;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 10972;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 10973;
			case BrickWall::BrickWall(BrickWall::East::None, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 10974;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::None).ID: return 10978;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::Low).ID: return 10979;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 10980;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::None).ID: return 10984;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::Low).ID: return 10985;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 10986;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::None).ID: return 10990;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 10991;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 10992;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::None).ID: return 10996;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 10997;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 10998;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 11002;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 11003;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 11004;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 11008;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 11009;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 11010;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::None).ID: return 11014;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::Low).ID: return 11015;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 11016;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::None).ID: return 11020;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::Low).ID: return 11021;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 11022;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::None).ID: return 11026;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 11027;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 11028;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::None).ID: return 11032;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 11033;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 11034;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 11038;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 11039;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 11040;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 11044;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 11045;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 11046;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::None).ID: return 11050;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::Low).ID: return 11051;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 11052;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::None).ID: return 11056;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::Low).ID: return 11057;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 11058;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::None).ID: return 11062;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 11063;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 11064;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::None).ID: return 11068;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 11069;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 11070;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 11074;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 11075;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 11076;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 11080;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 11081;
			case BrickWall::BrickWall(BrickWall::East::Low, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 11082;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::None).ID: return 11086;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::Low).ID: return 11087;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 11088;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::None).ID: return 11092;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::Low).ID: return 11093;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 11094;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::None).ID: return 11098;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 11099;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 11100;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::None).ID: return 11104;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 11105;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 11106;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 11110;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 11111;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 11112;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 11116;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 11117;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::None, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 11118;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::None).ID: return 11122;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::Low).ID: return 11123;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 11124;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::None).ID: return 11128;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::Low).ID: return 11129;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 11130;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::None).ID: return 11134;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 11135;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 11136;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::None).ID: return 11140;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 11141;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 11142;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 11146;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 11147;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 11148;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 11152;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 11153;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Low, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 11154;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::None).ID: return 11158;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::Low).ID: return 11159;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::None, true, BrickWall::West::Tall).ID: return 11160;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::None).ID: return 11164;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::Low).ID: return 11165;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::None, false, BrickWall::West::Tall).ID: return 11166;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::None).ID: return 11170;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::Low).ID: return 11171;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Low, true, BrickWall::West::Tall).ID: return 11172;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::None).ID: return 11176;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::Low).ID: return 11177;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Low, false, BrickWall::West::Tall).ID: return 11178;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::None).ID: return 11182;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::Low).ID: return 11183;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Tall, true, BrickWall::West::Tall).ID: return 11184;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::None).ID: return 11188;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::Low).ID: return 11189;
			case BrickWall::BrickWall(BrickWall::East::Tall, BrickWall::North::Tall, BrickWall::South::Tall, false, BrickWall::West::Tall).ID: return 11190;
			case Bricks::Bricks().ID: return 1429;
			case BrownBanner::BrownBanner(0).ID: return 8089;
			case BrownBanner::BrownBanner(1).ID: return 8090;
			case BrownBanner::BrownBanner(2).ID: return 8091;
			case BrownBanner::BrownBanner(3).ID: return 8092;
			case BrownBanner::BrownBanner(4).ID: return 8093;
			case BrownBanner::BrownBanner(5).ID: return 8094;
			case BrownBanner::BrownBanner(6).ID: return 8095;
			case BrownBanner::BrownBanner(7).ID: return 8096;
			case BrownBanner::BrownBanner(8).ID: return 8097;
			case BrownBanner::BrownBanner(9).ID: return 8098;
			case BrownBanner::BrownBanner(10).ID: return 8099;
			case BrownBanner::BrownBanner(11).ID: return 8100;
			case BrownBanner::BrownBanner(12).ID: return 8101;
			case BrownBanner::BrownBanner(13).ID: return 8102;
			case BrownBanner::BrownBanner(14).ID: return 8103;
			case BrownBanner::BrownBanner(15).ID: return 8104;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZM, true, BrownBed::Part::Head).ID: return 1241;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZM, true, BrownBed::Part::Foot).ID: return 1242;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZM, false, BrownBed::Part::Head).ID: return 1243;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZM, false, BrownBed::Part::Foot).ID: return 1244;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZP, true, BrownBed::Part::Head).ID: return 1245;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZP, true, BrownBed::Part::Foot).ID: return 1246;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZP, false, BrownBed::Part::Head).ID: return 1247;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_ZP, false, BrownBed::Part::Foot).ID: return 1248;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XM, true, BrownBed::Part::Head).ID: return 1249;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XM, true, BrownBed::Part::Foot).ID: return 1250;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XM, false, BrownBed::Part::Head).ID: return 1251;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XM, false, BrownBed::Part::Foot).ID: return 1252;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XP, true, BrownBed::Part::Head).ID: return 1253;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XP, true, BrownBed::Part::Foot).ID: return 1254;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XP, false, BrownBed::Part::Head).ID: return 1255;
			case BrownBed::BrownBed(eBlockFace::BLOCK_FACE_XP, false, BrownBed::Part::Foot).ID: return 1256;
			case BrownCarpet::BrownCarpet().ID: return 7878;
			case BrownConcrete::BrownConcrete().ID: return 9450;
			case BrownConcretePowder::BrownConcretePowder().ID: return 9466;
			case BrownGlazedTerracotta::BrownGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9422;
			case BrownGlazedTerracotta::BrownGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9423;
			case BrownGlazedTerracotta::BrownGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9424;
			case BrownGlazedTerracotta::BrownGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9425;
			case BrownMushroom::BrownMushroom().ID: return 1425;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, true, true, true).ID: return 4505;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, true, true, false).ID: return 4506;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, true, false, true).ID: return 4507;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, true, false, false).ID: return 4508;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, false, true, true).ID: return 4509;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, false, true, false).ID: return 4510;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, false, false, true).ID: return 4511;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, true, false, false, false).ID: return 4512;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, true, true, true).ID: return 4513;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, true, true, false).ID: return 4514;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, true, false, true).ID: return 4515;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, true, false, false).ID: return 4516;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, false, true, true).ID: return 4517;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, false, true, false).ID: return 4518;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, false, false, true).ID: return 4519;
			case BrownMushroomBlock::BrownMushroomBlock(true, true, false, false, false, false).ID: return 4520;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, true, true, true).ID: return 4521;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, true, true, false).ID: return 4522;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, true, false, true).ID: return 4523;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, true, false, false).ID: return 4524;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, false, true, true).ID: return 4525;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, false, true, false).ID: return 4526;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, false, false, true).ID: return 4527;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, true, false, false, false).ID: return 4528;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, true, true, true).ID: return 4529;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, true, true, false).ID: return 4530;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, true, false, true).ID: return 4531;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, true, false, false).ID: return 4532;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, false, true, true).ID: return 4533;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, false, true, false).ID: return 4534;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, false, false, true).ID: return 4535;
			case BrownMushroomBlock::BrownMushroomBlock(true, false, false, false, false, false).ID: return 4536;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, true, true, true).ID: return 4537;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, true, true, false).ID: return 4538;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, true, false, true).ID: return 4539;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, true, false, false).ID: return 4540;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, false, true, true).ID: return 4541;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, false, true, false).ID: return 4542;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, false, false, true).ID: return 4543;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, true, false, false, false).ID: return 4544;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, true, true, true).ID: return 4545;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, true, true, false).ID: return 4546;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, true, false, true).ID: return 4547;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, true, false, false).ID: return 4548;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, false, true, true).ID: return 4549;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, false, true, false).ID: return 4550;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, false, false, true).ID: return 4551;
			case BrownMushroomBlock::BrownMushroomBlock(false, true, false, false, false, false).ID: return 4552;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, true, true, true).ID: return 4553;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, true, true, false).ID: return 4554;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, true, false, true).ID: return 4555;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, true, false, false).ID: return 4556;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, false, true, true).ID: return 4557;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, false, true, false).ID: return 4558;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, false, false, true).ID: return 4559;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, true, false, false, false).ID: return 4560;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, true, true, true).ID: return 4561;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, true, true, false).ID: return 4562;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, true, false, true).ID: return 4563;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, true, false, false).ID: return 4564;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, false, true, true).ID: return 4565;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, false, true, false).ID: return 4566;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, false, false, true).ID: return 4567;
			case BrownMushroomBlock::BrownMushroomBlock(false, false, false, false, false, false).ID: return 4568;
			case BrownShulkerBox::BrownShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9350;
			case BrownShulkerBox::BrownShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9351;
			case BrownShulkerBox::BrownShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9352;
			case BrownShulkerBox::BrownShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9353;
			case BrownShulkerBox::BrownShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9354;
			case BrownShulkerBox::BrownShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9355;
			case BrownStainedGlass::BrownStainedGlass().ID: return 4107;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, true, true, true).ID: return 7249;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, true, true, false).ID: return 7250;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, true, false, true).ID: return 7253;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, true, false, false).ID: return 7254;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, false, true, true).ID: return 7257;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, false, true, false).ID: return 7258;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, false, false, true).ID: return 7261;
			case BrownStainedGlassPane::BrownStainedGlassPane(true, false, false, false).ID: return 7262;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, true, true, true).ID: return 7265;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, true, true, false).ID: return 7266;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, true, false, true).ID: return 7269;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, true, false, false).ID: return 7270;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, false, true, true).ID: return 7273;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, false, true, false).ID: return 7274;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, false, false, true).ID: return 7277;
			case BrownStainedGlassPane::BrownStainedGlassPane(false, false, false, false).ID: return 7278;
			case BrownTerracotta::BrownTerracotta().ID: return 6859;
			case BrownWallBanner::BrownWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8201;
			case BrownWallBanner::BrownWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8202;
			case BrownWallBanner::BrownWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8203;
			case BrownWallBanner::BrownWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8204;
			case BrownWool::BrownWool().ID: return 1396;
			case BubbleColumn::BubbleColumn(true).ID: return 9667;
			case BubbleColumn::BubbleColumn(false).ID: return 9668;
			case BubbleCoral::BubbleCoral().ID: return 9535;
			case BubbleCoralBlock::BubbleCoralBlock().ID: return 9517;
			case BubbleCoralFan::BubbleCoralFan().ID: return 9555;
			case BubbleCoralWallFan::BubbleCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9617;
			case BubbleCoralWallFan::BubbleCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9619;
			case BubbleCoralWallFan::BubbleCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9621;
			case BubbleCoralWallFan::BubbleCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9623;
			case Cactus::Cactus(0).ID: return 3931;
			case Cactus::Cactus(1).ID: return 3932;
			case Cactus::Cactus(2).ID: return 3933;
			case Cactus::Cactus(3).ID: return 3934;
			case Cactus::Cactus(4).ID: return 3935;
			case Cactus::Cactus(5).ID: return 3936;
			case Cactus::Cactus(6).ID: return 3937;
			case Cactus::Cactus(7).ID: return 3938;
			case Cactus::Cactus(8).ID: return 3939;
			case Cactus::Cactus(9).ID: return 3940;
			case Cactus::Cactus(10).ID: return 3941;
			case Cactus::Cactus(11).ID: return 3942;
			case Cactus::Cactus(12).ID: return 3943;
			case Cactus::Cactus(13).ID: return 3944;
			case Cactus::Cactus(14).ID: return 3945;
			case Cactus::Cactus(15).ID: return 3946;
			case Cake::Cake(0).ID: return 4024;
			case Cake::Cake(1).ID: return 4025;
			case Cake::Cake(2).ID: return 4026;
			case Cake::Cake(3).ID: return 4027;
			case Cake::Cake(4).ID: return 4028;
			case Cake::Cake(5).ID: return 4029;
			case Cake::Cake(6).ID: return 4030;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 14891;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 14893;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 14895;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 14897;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 14899;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 14901;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 14903;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 14905;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XM, true, true).ID: return 14907;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XM, true, false).ID: return 14909;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XM, false, true).ID: return 14911;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XM, false, false).ID: return 14913;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XP, true, true).ID: return 14915;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XP, true, false).ID: return 14917;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XP, false, true).ID: return 14919;
			case Campfire::Campfire(eBlockFace::BLOCK_FACE_XP, false, false).ID: return 14921;
			case Carrots::Carrots(0).ID: return 6330;
			case Carrots::Carrots(1).ID: return 6331;
			case Carrots::Carrots(2).ID: return 6332;
			case Carrots::Carrots(3).ID: return 6333;
			case Carrots::Carrots(4).ID: return 6334;
			case Carrots::Carrots(5).ID: return 6335;
			case Carrots::Carrots(6).ID: return 6336;
			case Carrots::Carrots(7).ID: return 6337;
			case CartographyTable::CartographyTable().ID: return 14819;
			case CarvedPumpkin::CarvedPumpkin(eBlockFace::BLOCK_FACE_ZM).ID: return 4016;
			case CarvedPumpkin::CarvedPumpkin(eBlockFace::BLOCK_FACE_ZP).ID: return 4017;
			case CarvedPumpkin::CarvedPumpkin(eBlockFace::BLOCK_FACE_XM).ID: return 4018;
			case CarvedPumpkin::CarvedPumpkin(eBlockFace::BLOCK_FACE_XP).ID: return 4019;
			case Cauldron::Cauldron(0).ID: return 5141;
			case Cauldron::Cauldron(1).ID: return 5142;
			case Cauldron::Cauldron(2).ID: return 5143;
			case Cauldron::Cauldron(3).ID: return 5144;
			case CaveAir::CaveAir().ID: return 9666;
			case Chain::Chain().ID: return 4730;
			case ChainCommandBlock::ChainCommandBlock(true, eBlockFace::BLOCK_FACE_ZM).ID: return 9237;
			case ChainCommandBlock::ChainCommandBlock(true, eBlockFace::BLOCK_FACE_XP).ID: return 9238;
			case ChainCommandBlock::ChainCommandBlock(true, eBlockFace::BLOCK_FACE_ZP).ID: return 9239;
			case ChainCommandBlock::ChainCommandBlock(true, eBlockFace::BLOCK_FACE_XM).ID: return 9240;
			case ChainCommandBlock::ChainCommandBlock(true, eBlockFace::BLOCK_FACE_YP).ID: return 9241;
			case ChainCommandBlock::ChainCommandBlock(true, eBlockFace::BLOCK_FACE_YM).ID: return 9242;
			case ChainCommandBlock::ChainCommandBlock(false, eBlockFace::BLOCK_FACE_ZM).ID: return 9243;
			case ChainCommandBlock::ChainCommandBlock(false, eBlockFace::BLOCK_FACE_XP).ID: return 9244;
			case ChainCommandBlock::ChainCommandBlock(false, eBlockFace::BLOCK_FACE_ZP).ID: return 9245;
			case ChainCommandBlock::ChainCommandBlock(false, eBlockFace::BLOCK_FACE_XM).ID: return 9246;
			case ChainCommandBlock::ChainCommandBlock(false, eBlockFace::BLOCK_FACE_YP).ID: return 9247;
			case ChainCommandBlock::ChainCommandBlock(false, eBlockFace::BLOCK_FACE_YM).ID: return 9248;
			case Chest::Chest(eBlockFace::BLOCK_FACE_ZM, Chest::Type::Single).ID: return 2035;
			case Chest::Chest(eBlockFace::BLOCK_FACE_ZM, Chest::Type::Left).ID: return 2037;
			case Chest::Chest(eBlockFace::BLOCK_FACE_ZM, Chest::Type::Right).ID: return 2039;
			case Chest::Chest(eBlockFace::BLOCK_FACE_ZP, Chest::Type::Single).ID: return 2041;
			case Chest::Chest(eBlockFace::BLOCK_FACE_ZP, Chest::Type::Left).ID: return 2043;
			case Chest::Chest(eBlockFace::BLOCK_FACE_ZP, Chest::Type::Right).ID: return 2045;
			case Chest::Chest(eBlockFace::BLOCK_FACE_XM, Chest::Type::Single).ID: return 2047;
			case Chest::Chest(eBlockFace::BLOCK_FACE_XM, Chest::Type::Left).ID: return 2049;
			case Chest::Chest(eBlockFace::BLOCK_FACE_XM, Chest::Type::Right).ID: return 2051;
			case Chest::Chest(eBlockFace::BLOCK_FACE_XP, Chest::Type::Single).ID: return 2053;
			case Chest::Chest(eBlockFace::BLOCK_FACE_XP, Chest::Type::Left).ID: return 2055;
			case Chest::Chest(eBlockFace::BLOCK_FACE_XP, Chest::Type::Right).ID: return 2057;
			case ChippedAnvil::ChippedAnvil(eBlockFace::BLOCK_FACE_ZM).ID: return 6614;
			case ChippedAnvil::ChippedAnvil(eBlockFace::BLOCK_FACE_ZP).ID: return 6615;
			case ChippedAnvil::ChippedAnvil(eBlockFace::BLOCK_FACE_XM).ID: return 6616;
			case ChippedAnvil::ChippedAnvil(eBlockFace::BLOCK_FACE_XP).ID: return 6617;
			case ChiseledNetherBricks::ChiseledNetherBricks().ID: return 17101;
			case ChiseledPolishedBlackstone::ChiseledPolishedBlackstone().ID: return 16253;
			case ChiseledQuartzBlock::ChiseledQuartzBlock().ID: return 6739;
			case ChiseledRedSandstone::ChiseledRedSandstone().ID: return 8218;
			case ChiseledSandstone::ChiseledSandstone().ID: return 247;
			case ChiseledStoneBricks::ChiseledStoneBricks().ID: return 4498;
			case ChorusFlower::ChorusFlower(0).ID: return 9128;
			case ChorusFlower::ChorusFlower(1).ID: return 9129;
			case ChorusFlower::ChorusFlower(2).ID: return 9130;
			case ChorusFlower::ChorusFlower(3).ID: return 9131;
			case ChorusFlower::ChorusFlower(4).ID: return 9132;
			case ChorusFlower::ChorusFlower(5).ID: return 9133;
			case ChorusPlant::ChorusPlant(true, true, true, true, true, true).ID: return 9064;
			case ChorusPlant::ChorusPlant(true, true, true, true, true, false).ID: return 9065;
			case ChorusPlant::ChorusPlant(true, true, true, true, false, true).ID: return 9066;
			case ChorusPlant::ChorusPlant(true, true, true, true, false, false).ID: return 9067;
			case ChorusPlant::ChorusPlant(true, true, true, false, true, true).ID: return 9068;
			case ChorusPlant::ChorusPlant(true, true, true, false, true, false).ID: return 9069;
			case ChorusPlant::ChorusPlant(true, true, true, false, false, true).ID: return 9070;
			case ChorusPlant::ChorusPlant(true, true, true, false, false, false).ID: return 9071;
			case ChorusPlant::ChorusPlant(true, true, false, true, true, true).ID: return 9072;
			case ChorusPlant::ChorusPlant(true, true, false, true, true, false).ID: return 9073;
			case ChorusPlant::ChorusPlant(true, true, false, true, false, true).ID: return 9074;
			case ChorusPlant::ChorusPlant(true, true, false, true, false, false).ID: return 9075;
			case ChorusPlant::ChorusPlant(true, true, false, false, true, true).ID: return 9076;
			case ChorusPlant::ChorusPlant(true, true, false, false, true, false).ID: return 9077;
			case ChorusPlant::ChorusPlant(true, true, false, false, false, true).ID: return 9078;
			case ChorusPlant::ChorusPlant(true, true, false, false, false, false).ID: return 9079;
			case ChorusPlant::ChorusPlant(true, false, true, true, true, true).ID: return 9080;
			case ChorusPlant::ChorusPlant(true, false, true, true, true, false).ID: return 9081;
			case ChorusPlant::ChorusPlant(true, false, true, true, false, true).ID: return 9082;
			case ChorusPlant::ChorusPlant(true, false, true, true, false, false).ID: return 9083;
			case ChorusPlant::ChorusPlant(true, false, true, false, true, true).ID: return 9084;
			case ChorusPlant::ChorusPlant(true, false, true, false, true, false).ID: return 9085;
			case ChorusPlant::ChorusPlant(true, false, true, false, false, true).ID: return 9086;
			case ChorusPlant::ChorusPlant(true, false, true, false, false, false).ID: return 9087;
			case ChorusPlant::ChorusPlant(true, false, false, true, true, true).ID: return 9088;
			case ChorusPlant::ChorusPlant(true, false, false, true, true, false).ID: return 9089;
			case ChorusPlant::ChorusPlant(true, false, false, true, false, true).ID: return 9090;
			case ChorusPlant::ChorusPlant(true, false, false, true, false, false).ID: return 9091;
			case ChorusPlant::ChorusPlant(true, false, false, false, true, true).ID: return 9092;
			case ChorusPlant::ChorusPlant(true, false, false, false, true, false).ID: return 9093;
			case ChorusPlant::ChorusPlant(true, false, false, false, false, true).ID: return 9094;
			case ChorusPlant::ChorusPlant(true, false, false, false, false, false).ID: return 9095;
			case ChorusPlant::ChorusPlant(false, true, true, true, true, true).ID: return 9096;
			case ChorusPlant::ChorusPlant(false, true, true, true, true, false).ID: return 9097;
			case ChorusPlant::ChorusPlant(false, true, true, true, false, true).ID: return 9098;
			case ChorusPlant::ChorusPlant(false, true, true, true, false, false).ID: return 9099;
			case ChorusPlant::ChorusPlant(false, true, true, false, true, true).ID: return 9100;
			case ChorusPlant::ChorusPlant(false, true, true, false, true, false).ID: return 9101;
			case ChorusPlant::ChorusPlant(false, true, true, false, false, true).ID: return 9102;
			case ChorusPlant::ChorusPlant(false, true, true, false, false, false).ID: return 9103;
			case ChorusPlant::ChorusPlant(false, true, false, true, true, true).ID: return 9104;
			case ChorusPlant::ChorusPlant(false, true, false, true, true, false).ID: return 9105;
			case ChorusPlant::ChorusPlant(false, true, false, true, false, true).ID: return 9106;
			case ChorusPlant::ChorusPlant(false, true, false, true, false, false).ID: return 9107;
			case ChorusPlant::ChorusPlant(false, true, false, false, true, true).ID: return 9108;
			case ChorusPlant::ChorusPlant(false, true, false, false, true, false).ID: return 9109;
			case ChorusPlant::ChorusPlant(false, true, false, false, false, true).ID: return 9110;
			case ChorusPlant::ChorusPlant(false, true, false, false, false, false).ID: return 9111;
			case ChorusPlant::ChorusPlant(false, false, true, true, true, true).ID: return 9112;
			case ChorusPlant::ChorusPlant(false, false, true, true, true, false).ID: return 9113;
			case ChorusPlant::ChorusPlant(false, false, true, true, false, true).ID: return 9114;
			case ChorusPlant::ChorusPlant(false, false, true, true, false, false).ID: return 9115;
			case ChorusPlant::ChorusPlant(false, false, true, false, true, true).ID: return 9116;
			case ChorusPlant::ChorusPlant(false, false, true, false, true, false).ID: return 9117;
			case ChorusPlant::ChorusPlant(false, false, true, false, false, true).ID: return 9118;
			case ChorusPlant::ChorusPlant(false, false, true, false, false, false).ID: return 9119;
			case ChorusPlant::ChorusPlant(false, false, false, true, true, true).ID: return 9120;
			case ChorusPlant::ChorusPlant(false, false, false, true, true, false).ID: return 9121;
			case ChorusPlant::ChorusPlant(false, false, false, true, false, true).ID: return 9122;
			case ChorusPlant::ChorusPlant(false, false, false, true, false, false).ID: return 9123;
			case ChorusPlant::ChorusPlant(false, false, false, false, true, true).ID: return 9124;
			case ChorusPlant::ChorusPlant(false, false, false, false, true, false).ID: return 9125;
			case ChorusPlant::ChorusPlant(false, false, false, false, false, true).ID: return 9126;
			case ChorusPlant::ChorusPlant(false, false, false, false, false, false).ID: return 9127;
			case Clay::Clay().ID: return 3947;
			case CoalBlock::CoalBlock().ID: return 7883;
			case CoalOre::CoalOre().ID: return 71;
			case CoarseDirt::CoarseDirt().ID: return 11;
			case Cobblestone::Cobblestone().ID: return 14;
			case CobblestoneSlab::CobblestoneSlab(CobblestoneSlab::Type::Top).ID: return 8367;
			case CobblestoneSlab::CobblestoneSlab(CobblestoneSlab::Type::Bottom).ID: return 8369;
			case CobblestoneSlab::CobblestoneSlab(CobblestoneSlab::Type::Double).ID: return 8371;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::Straight).ID: return 3656;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerLeft).ID: return 3658;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerRight).ID: return 3660;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterLeft).ID: return 3662;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterRight).ID: return 3664;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::Straight).ID: return 3666;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerLeft).ID: return 3668;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerRight).ID: return 3670;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterLeft).ID: return 3672;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterRight).ID: return 3674;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::Straight).ID: return 3676;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerLeft).ID: return 3678;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerRight).ID: return 3680;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterLeft).ID: return 3682;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterRight).ID: return 3684;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::Straight).ID: return 3686;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerLeft).ID: return 3688;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerRight).ID: return 3690;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterLeft).ID: return 3692;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterRight).ID: return 3694;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::Straight).ID: return 3696;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerLeft).ID: return 3698;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerRight).ID: return 3700;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterLeft).ID: return 3702;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterRight).ID: return 3704;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::Straight).ID: return 3706;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerLeft).ID: return 3708;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerRight).ID: return 3710;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterLeft).ID: return 3712;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XM, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterRight).ID: return 3714;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::Straight).ID: return 3716;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerLeft).ID: return 3718;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::InnerRight).ID: return 3720;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterLeft).ID: return 3722;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Top, CobblestoneStairs::Shape::OuterRight).ID: return 3724;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::Straight).ID: return 3726;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerLeft).ID: return 3728;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::InnerRight).ID: return 3730;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterLeft).ID: return 3732;
			case CobblestoneStairs::CobblestoneStairs(eBlockFace::BLOCK_FACE_XP, CobblestoneStairs::Half::Bottom, CobblestoneStairs::Shape::OuterRight).ID: return 3734;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5660;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5661;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5662;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5666;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5667;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5668;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5672;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5673;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5674;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5678;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5679;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5680;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5684;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5685;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5686;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5690;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5691;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5692;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5696;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5697;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5698;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5702;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5703;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5704;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5708;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5709;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5710;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5714;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5715;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5716;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5720;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5721;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5722;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5726;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5727;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5728;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5732;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5733;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5734;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5738;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5739;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5740;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5744;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5745;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5746;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5750;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5751;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5752;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5756;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5757;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5758;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5762;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5763;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::None, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5764;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5768;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5769;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5770;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5774;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5775;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5776;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5780;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5781;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5782;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5786;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5787;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5788;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5792;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5793;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5794;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5798;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5799;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5800;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5804;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5805;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5806;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5810;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5811;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5812;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5816;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5817;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5818;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5822;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5823;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5824;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5828;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5829;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5830;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5834;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5835;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5836;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5840;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5841;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5842;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5846;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5847;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5848;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5852;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5853;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5854;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5858;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5859;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5860;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5864;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5865;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5866;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5870;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5871;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Low, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5872;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5876;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5877;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5878;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5882;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5883;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5884;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5888;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5889;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5890;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5894;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5895;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5896;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5900;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5901;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5902;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5906;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5907;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::None, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5908;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5912;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5913;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5914;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5918;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5919;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5920;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5924;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5925;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5926;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5930;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5931;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5932;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5936;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5937;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5938;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5942;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5943;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Low, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5944;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::None).ID: return 5948;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::Low).ID: return 5949;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::None, true, CobblestoneWall::West::Tall).ID: return 5950;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::None).ID: return 5954;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::Low).ID: return 5955;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::None, false, CobblestoneWall::West::Tall).ID: return 5956;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::None).ID: return 5960;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::Low).ID: return 5961;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, true, CobblestoneWall::West::Tall).ID: return 5962;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::None).ID: return 5966;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::Low).ID: return 5967;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Low, false, CobblestoneWall::West::Tall).ID: return 5968;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::None).ID: return 5972;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Low).ID: return 5973;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, true, CobblestoneWall::West::Tall).ID: return 5974;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::None).ID: return 5978;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Low).ID: return 5979;
			case CobblestoneWall::CobblestoneWall(CobblestoneWall::East::Tall, CobblestoneWall::North::Tall, CobblestoneWall::South::Tall, false, CobblestoneWall::West::Tall).ID: return 5980;
			case Cobweb::Cobweb().ID: return 1341;
			case Cocoa::Cocoa(0, eBlockFace::BLOCK_FACE_ZM).ID: return 5158;
			case Cocoa::Cocoa(0, eBlockFace::BLOCK_FACE_ZP).ID: return 5159;
			case Cocoa::Cocoa(0, eBlockFace::BLOCK_FACE_XM).ID: return 5160;
			case Cocoa::Cocoa(0, eBlockFace::BLOCK_FACE_XP).ID: return 5161;
			case Cocoa::Cocoa(1, eBlockFace::BLOCK_FACE_ZM).ID: return 5162;
			case Cocoa::Cocoa(1, eBlockFace::BLOCK_FACE_ZP).ID: return 5163;
			case Cocoa::Cocoa(1, eBlockFace::BLOCK_FACE_XM).ID: return 5164;
			case Cocoa::Cocoa(1, eBlockFace::BLOCK_FACE_XP).ID: return 5165;
			case Cocoa::Cocoa(2, eBlockFace::BLOCK_FACE_ZM).ID: return 5166;
			case Cocoa::Cocoa(2, eBlockFace::BLOCK_FACE_ZP).ID: return 5167;
			case Cocoa::Cocoa(2, eBlockFace::BLOCK_FACE_XM).ID: return 5168;
			case Cocoa::Cocoa(2, eBlockFace::BLOCK_FACE_XP).ID: return 5169;
			case CommandBlock::CommandBlock(true, eBlockFace::BLOCK_FACE_ZM).ID: return 5644;
			case CommandBlock::CommandBlock(true, eBlockFace::BLOCK_FACE_XP).ID: return 5645;
			case CommandBlock::CommandBlock(true, eBlockFace::BLOCK_FACE_ZP).ID: return 5646;
			case CommandBlock::CommandBlock(true, eBlockFace::BLOCK_FACE_XM).ID: return 5647;
			case CommandBlock::CommandBlock(true, eBlockFace::BLOCK_FACE_YP).ID: return 5648;
			case CommandBlock::CommandBlock(true, eBlockFace::BLOCK_FACE_YM).ID: return 5649;
			case CommandBlock::CommandBlock(false, eBlockFace::BLOCK_FACE_ZM).ID: return 5650;
			case CommandBlock::CommandBlock(false, eBlockFace::BLOCK_FACE_XP).ID: return 5651;
			case CommandBlock::CommandBlock(false, eBlockFace::BLOCK_FACE_ZP).ID: return 5652;
			case CommandBlock::CommandBlock(false, eBlockFace::BLOCK_FACE_XM).ID: return 5653;
			case CommandBlock::CommandBlock(false, eBlockFace::BLOCK_FACE_YP).ID: return 5654;
			case CommandBlock::CommandBlock(false, eBlockFace::BLOCK_FACE_YM).ID: return 5655;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZM, Comparator::Mode::Compare, true).ID: return 6678;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZM, Comparator::Mode::Compare, false).ID: return 6679;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZM, Comparator::Mode::Subtract, true).ID: return 6680;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZM, Comparator::Mode::Subtract, false).ID: return 6681;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZP, Comparator::Mode::Compare, true).ID: return 6682;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZP, Comparator::Mode::Compare, false).ID: return 6683;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZP, Comparator::Mode::Subtract, true).ID: return 6684;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_ZP, Comparator::Mode::Subtract, false).ID: return 6685;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XM, Comparator::Mode::Compare, true).ID: return 6686;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XM, Comparator::Mode::Compare, false).ID: return 6687;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XM, Comparator::Mode::Subtract, true).ID: return 6688;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XM, Comparator::Mode::Subtract, false).ID: return 6689;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XP, Comparator::Mode::Compare, true).ID: return 6690;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XP, Comparator::Mode::Compare, false).ID: return 6691;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XP, Comparator::Mode::Subtract, true).ID: return 6692;
			case Comparator::Comparator(eBlockFace::BLOCK_FACE_XP, Comparator::Mode::Subtract, false).ID: return 6693;
			case Composter::Composter(0).ID: return 15751;
			case Composter::Composter(1).ID: return 15752;
			case Composter::Composter(2).ID: return 15753;
			case Composter::Composter(3).ID: return 15754;
			case Composter::Composter(4).ID: return 15755;
			case Composter::Composter(5).ID: return 15756;
			case Composter::Composter(6).ID: return 15757;
			case Composter::Composter(7).ID: return 15758;
			case Composter::Composter(8).ID: return 15759;
			case Conduit::Conduit().ID: return 9650;
			case Cornflower::Cornflower().ID: return 1422;
			case CrackedNetherBricks::CrackedNetherBricks().ID: return 17102;
			case CrackedPolishedBlackstoneBricks::CrackedPolishedBlackstoneBricks().ID: return 16252;
			case CrackedStoneBricks::CrackedStoneBricks().ID: return 4497;
			case CraftingTable::CraftingTable().ID: return 3356;
			case CreeperHead::CreeperHead(0).ID: return 6570;
			case CreeperHead::CreeperHead(1).ID: return 6571;
			case CreeperHead::CreeperHead(2).ID: return 6572;
			case CreeperHead::CreeperHead(3).ID: return 6573;
			case CreeperHead::CreeperHead(4).ID: return 6574;
			case CreeperHead::CreeperHead(5).ID: return 6575;
			case CreeperHead::CreeperHead(6).ID: return 6576;
			case CreeperHead::CreeperHead(7).ID: return 6577;
			case CreeperHead::CreeperHead(8).ID: return 6578;
			case CreeperHead::CreeperHead(9).ID: return 6579;
			case CreeperHead::CreeperHead(10).ID: return 6580;
			case CreeperHead::CreeperHead(11).ID: return 6581;
			case CreeperHead::CreeperHead(12).ID: return 6582;
			case CreeperHead::CreeperHead(13).ID: return 6583;
			case CreeperHead::CreeperHead(14).ID: return 6584;
			case CreeperHead::CreeperHead(15).ID: return 6585;
			case CreeperWallHead::CreeperWallHead(eBlockFace::BLOCK_FACE_ZM).ID: return 6586;
			case CreeperWallHead::CreeperWallHead(eBlockFace::BLOCK_FACE_ZP).ID: return 6587;
			case CreeperWallHead::CreeperWallHead(eBlockFace::BLOCK_FACE_XM).ID: return 6588;
			case CreeperWallHead::CreeperWallHead(eBlockFace::BLOCK_FACE_XP).ID: return 6589;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 15479;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 15480;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 15481;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 15482;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 15483;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 15484;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 15485;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 15486;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 15487;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 15488;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 15489;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 15490;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 15491;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 15492;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 15493;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 15494;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 15495;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 15496;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 15497;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 15498;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 15499;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 15500;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 15501;
			case CrimsonButton::CrimsonButton(CrimsonButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 15502;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, true).ID: return 15527;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, false).ID: return 15528;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, true).ID: return 15529;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, false).ID: return 15530;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, true).ID: return 15531;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, false).ID: return 15532;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, true).ID: return 15533;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, false).ID: return 15534;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, true).ID: return 15535;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, false).ID: return 15536;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, true).ID: return 15537;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, false).ID: return 15538;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, true).ID: return 15539;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, false).ID: return 15540;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, true).ID: return 15541;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, false).ID: return 15542;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, true).ID: return 15543;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, false).ID: return 15544;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, true).ID: return 15545;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, false).ID: return 15546;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, true).ID: return 15547;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, false).ID: return 15548;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, true).ID: return 15549;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, false).ID: return 15550;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, true).ID: return 15551;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, false).ID: return 15552;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, true).ID: return 15553;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, false).ID: return 15554;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, true).ID: return 15555;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, false).ID: return 15556;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, true).ID: return 15557;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_ZP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, false).ID: return 15558;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, true).ID: return 15559;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, false).ID: return 15560;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, true).ID: return 15561;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, false).ID: return 15562;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, true).ID: return 15563;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, false).ID: return 15564;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, true).ID: return 15565;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, false).ID: return 15566;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, true).ID: return 15567;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, false).ID: return 15568;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, true).ID: return 15569;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, false).ID: return 15570;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, true).ID: return 15571;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, false).ID: return 15572;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, true).ID: return 15573;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XM, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, false).ID: return 15574;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, true).ID: return 15575;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, true, false).ID: return 15576;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, true).ID: return 15577;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Left, false, false).ID: return 15578;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, true).ID: return 15579;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, true, false).ID: return 15580;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, true).ID: return 15581;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Upper, CrimsonDoor::Hinge::Right, false, false).ID: return 15582;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, true).ID: return 15583;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, true, false).ID: return 15584;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, true).ID: return 15585;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Left, false, false).ID: return 15586;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, true).ID: return 15587;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, true, false).ID: return 15588;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, true).ID: return 15589;
			case CrimsonDoor::CrimsonDoor(eBlockFace::BLOCK_FACE_XP, CrimsonDoor::Half::Lower, CrimsonDoor::Hinge::Right, false, false).ID: return 15590;
			case CrimsonFence::CrimsonFence(true, true, true, true).ID: return 15065;
			case CrimsonFence::CrimsonFence(true, true, true, false).ID: return 15066;
			case CrimsonFence::CrimsonFence(true, true, false, true).ID: return 15069;
			case CrimsonFence::CrimsonFence(true, true, false, false).ID: return 15070;
			case CrimsonFence::CrimsonFence(true, false, true, true).ID: return 15073;
			case CrimsonFence::CrimsonFence(true, false, true, false).ID: return 15074;
			case CrimsonFence::CrimsonFence(true, false, false, true).ID: return 15077;
			case CrimsonFence::CrimsonFence(true, false, false, false).ID: return 15078;
			case CrimsonFence::CrimsonFence(false, true, true, true).ID: return 15081;
			case CrimsonFence::CrimsonFence(false, true, true, false).ID: return 15082;
			case CrimsonFence::CrimsonFence(false, true, false, true).ID: return 15085;
			case CrimsonFence::CrimsonFence(false, true, false, false).ID: return 15086;
			case CrimsonFence::CrimsonFence(false, false, true, true).ID: return 15089;
			case CrimsonFence::CrimsonFence(false, false, true, false).ID: return 15090;
			case CrimsonFence::CrimsonFence(false, false, false, true).ID: return 15093;
			case CrimsonFence::CrimsonFence(false, false, false, false).ID: return 15094;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 15255;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 15256;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 15257;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 15258;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 15259;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 15260;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 15261;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 15262;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 15263;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 15264;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 15265;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 15266;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 15267;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 15268;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 15269;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 15270;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 15271;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 15272;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 15273;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 15274;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 15275;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 15276;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 15277;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 15278;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 15279;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 15280;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 15281;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 15282;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 15283;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 15284;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 15285;
			case CrimsonFenceGate::CrimsonFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 15286;
			case CrimsonFungus::CrimsonFungus().ID: return 14988;
			case CrimsonHyphae::CrimsonHyphae(CrimsonHyphae::Axis::X).ID: return 14981;
			case CrimsonHyphae::CrimsonHyphae(CrimsonHyphae::Axis::Y).ID: return 14982;
			case CrimsonHyphae::CrimsonHyphae(CrimsonHyphae::Axis::Z).ID: return 14983;
			case CrimsonNylium::CrimsonNylium().ID: return 14987;
			case CrimsonPlanks::CrimsonPlanks().ID: return 15045;
			case CrimsonPressurePlate::CrimsonPressurePlate(true).ID: return 15059;
			case CrimsonPressurePlate::CrimsonPressurePlate(false).ID: return 15060;
			case CrimsonRoots::CrimsonRoots().ID: return 15044;
			case CrimsonSign::CrimsonSign(0).ID: return 15656;
			case CrimsonSign::CrimsonSign(1).ID: return 15658;
			case CrimsonSign::CrimsonSign(2).ID: return 15660;
			case CrimsonSign::CrimsonSign(3).ID: return 15662;
			case CrimsonSign::CrimsonSign(4).ID: return 15664;
			case CrimsonSign::CrimsonSign(5).ID: return 15666;
			case CrimsonSign::CrimsonSign(6).ID: return 15668;
			case CrimsonSign::CrimsonSign(7).ID: return 15670;
			case CrimsonSign::CrimsonSign(8).ID: return 15672;
			case CrimsonSign::CrimsonSign(9).ID: return 15674;
			case CrimsonSign::CrimsonSign(10).ID: return 15676;
			case CrimsonSign::CrimsonSign(11).ID: return 15678;
			case CrimsonSign::CrimsonSign(12).ID: return 15680;
			case CrimsonSign::CrimsonSign(13).ID: return 15682;
			case CrimsonSign::CrimsonSign(14).ID: return 15684;
			case CrimsonSign::CrimsonSign(15).ID: return 15686;
			case CrimsonSlab::CrimsonSlab(CrimsonSlab::Type::Top).ID: return 15048;
			case CrimsonSlab::CrimsonSlab(CrimsonSlab::Type::Bottom).ID: return 15050;
			case CrimsonSlab::CrimsonSlab(CrimsonSlab::Type::Double).ID: return 15052;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::Straight).ID: return 15320;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerLeft).ID: return 15322;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerRight).ID: return 15324;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterLeft).ID: return 15326;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterRight).ID: return 15328;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::Straight).ID: return 15330;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerLeft).ID: return 15332;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerRight).ID: return 15334;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterLeft).ID: return 15336;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterRight).ID: return 15338;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::Straight).ID: return 15340;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerLeft).ID: return 15342;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerRight).ID: return 15344;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterLeft).ID: return 15346;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterRight).ID: return 15348;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::Straight).ID: return 15350;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerLeft).ID: return 15352;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerRight).ID: return 15354;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterLeft).ID: return 15356;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_ZP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterRight).ID: return 15358;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::Straight).ID: return 15360;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerLeft).ID: return 15362;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerRight).ID: return 15364;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterLeft).ID: return 15366;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterRight).ID: return 15368;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::Straight).ID: return 15370;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerLeft).ID: return 15372;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerRight).ID: return 15374;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterLeft).ID: return 15376;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XM, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterRight).ID: return 15378;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::Straight).ID: return 15380;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerLeft).ID: return 15382;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::InnerRight).ID: return 15384;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterLeft).ID: return 15386;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Top, CrimsonStairs::Shape::OuterRight).ID: return 15388;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::Straight).ID: return 15390;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerLeft).ID: return 15392;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::InnerRight).ID: return 15394;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterLeft).ID: return 15396;
			case CrimsonStairs::CrimsonStairs(eBlockFace::BLOCK_FACE_XP, CrimsonStairs::Half::Bottom, CrimsonStairs::Shape::OuterRight).ID: return 15398;
			case CrimsonStem::CrimsonStem(CrimsonStem::Axis::X).ID: return 14975;
			case CrimsonStem::CrimsonStem(CrimsonStem::Axis::Y).ID: return 14976;
			case CrimsonStem::CrimsonStem(CrimsonStem::Axis::Z).ID: return 14977;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Top, true, true).ID: return 15128;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Top, true, false).ID: return 15130;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Top, false, true).ID: return 15132;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Top, false, false).ID: return 15134;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Bottom, true, true).ID: return 15136;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Bottom, true, false).ID: return 15138;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Bottom, false, true).ID: return 15140;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZM, CrimsonTrapdoor::Half::Bottom, false, false).ID: return 15142;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Top, true, true).ID: return 15144;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Top, true, false).ID: return 15146;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Top, false, true).ID: return 15148;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Top, false, false).ID: return 15150;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Bottom, true, true).ID: return 15152;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Bottom, true, false).ID: return 15154;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Bottom, false, true).ID: return 15156;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_ZP, CrimsonTrapdoor::Half::Bottom, false, false).ID: return 15158;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Top, true, true).ID: return 15160;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Top, true, false).ID: return 15162;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Top, false, true).ID: return 15164;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Top, false, false).ID: return 15166;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Bottom, true, true).ID: return 15168;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Bottom, true, false).ID: return 15170;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Bottom, false, true).ID: return 15172;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XM, CrimsonTrapdoor::Half::Bottom, false, false).ID: return 15174;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Top, true, true).ID: return 15176;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Top, true, false).ID: return 15178;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Top, false, true).ID: return 15180;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Top, false, false).ID: return 15182;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Bottom, true, true).ID: return 15184;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Bottom, true, false).ID: return 15186;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Bottom, false, true).ID: return 15188;
			case CrimsonTrapdoor::CrimsonTrapdoor(eBlockFace::BLOCK_FACE_XP, CrimsonTrapdoor::Half::Bottom, false, false).ID: return 15190;
			case CrimsonWallSign::CrimsonWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 15720;
			case CrimsonWallSign::CrimsonWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 15722;
			case CrimsonWallSign::CrimsonWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 15724;
			case CrimsonWallSign::CrimsonWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 15726;
			case CryingObsidian::CryingObsidian().ID: return 15828;
			case CutRedSandstone::CutRedSandstone().ID: return 8219;
			case CutRedSandstoneSlab::CutRedSandstoneSlab(CutRedSandstoneSlab::Type::Top).ID: return 8403;
			case CutRedSandstoneSlab::CutRedSandstoneSlab(CutRedSandstoneSlab::Type::Bottom).ID: return 8405;
			case CutRedSandstoneSlab::CutRedSandstoneSlab(CutRedSandstoneSlab::Type::Double).ID: return 8407;
			case CutSandstone::CutSandstone().ID: return 248;
			case CutSandstoneSlab::CutSandstoneSlab(CutSandstoneSlab::Type::Top).ID: return 8355;
			case CutSandstoneSlab::CutSandstoneSlab(CutSandstoneSlab::Type::Bottom).ID: return 8357;
			case CutSandstoneSlab::CutSandstoneSlab(CutSandstoneSlab::Type::Double).ID: return 8359;
			case CyanBanner::CyanBanner(0).ID: return 8041;
			case CyanBanner::CyanBanner(1).ID: return 8042;
			case CyanBanner::CyanBanner(2).ID: return 8043;
			case CyanBanner::CyanBanner(3).ID: return 8044;
			case CyanBanner::CyanBanner(4).ID: return 8045;
			case CyanBanner::CyanBanner(5).ID: return 8046;
			case CyanBanner::CyanBanner(6).ID: return 8047;
			case CyanBanner::CyanBanner(7).ID: return 8048;
			case CyanBanner::CyanBanner(8).ID: return 8049;
			case CyanBanner::CyanBanner(9).ID: return 8050;
			case CyanBanner::CyanBanner(10).ID: return 8051;
			case CyanBanner::CyanBanner(11).ID: return 8052;
			case CyanBanner::CyanBanner(12).ID: return 8053;
			case CyanBanner::CyanBanner(13).ID: return 8054;
			case CyanBanner::CyanBanner(14).ID: return 8055;
			case CyanBanner::CyanBanner(15).ID: return 8056;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZM, true, CyanBed::Part::Head).ID: return 1193;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZM, true, CyanBed::Part::Foot).ID: return 1194;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZM, false, CyanBed::Part::Head).ID: return 1195;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZM, false, CyanBed::Part::Foot).ID: return 1196;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZP, true, CyanBed::Part::Head).ID: return 1197;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZP, true, CyanBed::Part::Foot).ID: return 1198;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZP, false, CyanBed::Part::Head).ID: return 1199;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_ZP, false, CyanBed::Part::Foot).ID: return 1200;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XM, true, CyanBed::Part::Head).ID: return 1201;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XM, true, CyanBed::Part::Foot).ID: return 1202;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XM, false, CyanBed::Part::Head).ID: return 1203;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XM, false, CyanBed::Part::Foot).ID: return 1204;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XP, true, CyanBed::Part::Head).ID: return 1205;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XP, true, CyanBed::Part::Foot).ID: return 1206;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XP, false, CyanBed::Part::Head).ID: return 1207;
			case CyanBed::CyanBed(eBlockFace::BLOCK_FACE_XP, false, CyanBed::Part::Foot).ID: return 1208;
			case CyanCarpet::CyanCarpet().ID: return 7875;
			case CyanConcrete::CyanConcrete().ID: return 9447;
			case CyanConcretePowder::CyanConcretePowder().ID: return 9463;
			case CyanGlazedTerracotta::CyanGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9410;
			case CyanGlazedTerracotta::CyanGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9411;
			case CyanGlazedTerracotta::CyanGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9412;
			case CyanGlazedTerracotta::CyanGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9413;
			case CyanShulkerBox::CyanShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9332;
			case CyanShulkerBox::CyanShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9333;
			case CyanShulkerBox::CyanShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9334;
			case CyanShulkerBox::CyanShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9335;
			case CyanShulkerBox::CyanShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9336;
			case CyanShulkerBox::CyanShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9337;
			case CyanStainedGlass::CyanStainedGlass().ID: return 4104;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, true, true, true).ID: return 7153;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, true, true, false).ID: return 7154;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, true, false, true).ID: return 7157;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, true, false, false).ID: return 7158;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, false, true, true).ID: return 7161;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, false, true, false).ID: return 7162;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, false, false, true).ID: return 7165;
			case CyanStainedGlassPane::CyanStainedGlassPane(true, false, false, false).ID: return 7166;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, true, true, true).ID: return 7169;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, true, true, false).ID: return 7170;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, true, false, true).ID: return 7173;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, true, false, false).ID: return 7174;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, false, true, true).ID: return 7177;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, false, true, false).ID: return 7178;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, false, false, true).ID: return 7181;
			case CyanStainedGlassPane::CyanStainedGlassPane(false, false, false, false).ID: return 7182;
			case CyanTerracotta::CyanTerracotta().ID: return 6856;
			case CyanWallBanner::CyanWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8189;
			case CyanWallBanner::CyanWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8190;
			case CyanWallBanner::CyanWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8191;
			case CyanWallBanner::CyanWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8192;
			case CyanWool::CyanWool().ID: return 1393;
			case DamagedAnvil::DamagedAnvil(eBlockFace::BLOCK_FACE_ZM).ID: return 6618;
			case DamagedAnvil::DamagedAnvil(eBlockFace::BLOCK_FACE_ZP).ID: return 6619;
			case DamagedAnvil::DamagedAnvil(eBlockFace::BLOCK_FACE_XM).ID: return 6620;
			case DamagedAnvil::DamagedAnvil(eBlockFace::BLOCK_FACE_XP).ID: return 6621;
			case Dandelion::Dandelion().ID: return 1412;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6466;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6467;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6468;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6469;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 6470;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 6471;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 6472;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 6473;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6474;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6475;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6476;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6477;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 6478;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 6479;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 6480;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 6481;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6482;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6483;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6484;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6485;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 6486;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 6487;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 6488;
			case DarkOakButton::DarkOakButton(DarkOakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 6489;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, true).ID: return 8994;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, false).ID: return 8995;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, true).ID: return 8996;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, false).ID: return 8997;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, true).ID: return 8998;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, false).ID: return 8999;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, true).ID: return 9000;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, false).ID: return 9001;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, true).ID: return 9002;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, false).ID: return 9003;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, true).ID: return 9004;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, false).ID: return 9005;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, true).ID: return 9006;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, false).ID: return 9007;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, true).ID: return 9008;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, false).ID: return 9009;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, true).ID: return 9010;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, false).ID: return 9011;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, true).ID: return 9012;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, false).ID: return 9013;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, true).ID: return 9014;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, false).ID: return 9015;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, true).ID: return 9016;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, false).ID: return 9017;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, true).ID: return 9018;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, false).ID: return 9019;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, true).ID: return 9020;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, false).ID: return 9021;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, true).ID: return 9022;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, false).ID: return 9023;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, true).ID: return 9024;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_ZP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, false).ID: return 9025;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, true).ID: return 9026;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, false).ID: return 9027;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, true).ID: return 9028;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, false).ID: return 9029;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, true).ID: return 9030;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, false).ID: return 9031;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, true).ID: return 9032;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, false).ID: return 9033;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, true).ID: return 9034;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, false).ID: return 9035;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, true).ID: return 9036;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, false).ID: return 9037;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, true).ID: return 9038;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, false).ID: return 9039;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, true).ID: return 9040;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XM, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, false).ID: return 9041;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, true).ID: return 9042;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, true, false).ID: return 9043;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, true).ID: return 9044;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Left, false, false).ID: return 9045;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, true).ID: return 9046;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, true, false).ID: return 9047;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, true).ID: return 9048;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Upper, DarkOakDoor::Hinge::Right, false, false).ID: return 9049;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, true).ID: return 9050;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, true, false).ID: return 9051;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, true).ID: return 9052;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Left, false, false).ID: return 9053;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, true).ID: return 9054;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, true, false).ID: return 9055;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, true).ID: return 9056;
			case DarkOakDoor::DarkOakDoor(eBlockFace::BLOCK_FACE_XP, DarkOakDoor::Half::Lower, DarkOakDoor::Hinge::Right, false, false).ID: return 9057;
			case DarkOakFence::DarkOakFence(true, true, true, true).ID: return 8708;
			case DarkOakFence::DarkOakFence(true, true, true, false).ID: return 8709;
			case DarkOakFence::DarkOakFence(true, true, false, true).ID: return 8712;
			case DarkOakFence::DarkOakFence(true, true, false, false).ID: return 8713;
			case DarkOakFence::DarkOakFence(true, false, true, true).ID: return 8716;
			case DarkOakFence::DarkOakFence(true, false, true, false).ID: return 8717;
			case DarkOakFence::DarkOakFence(true, false, false, true).ID: return 8720;
			case DarkOakFence::DarkOakFence(true, false, false, false).ID: return 8721;
			case DarkOakFence::DarkOakFence(false, true, true, true).ID: return 8724;
			case DarkOakFence::DarkOakFence(false, true, true, false).ID: return 8725;
			case DarkOakFence::DarkOakFence(false, true, false, true).ID: return 8728;
			case DarkOakFence::DarkOakFence(false, true, false, false).ID: return 8729;
			case DarkOakFence::DarkOakFence(false, false, true, true).ID: return 8732;
			case DarkOakFence::DarkOakFence(false, false, true, false).ID: return 8733;
			case DarkOakFence::DarkOakFence(false, false, false, true).ID: return 8736;
			case DarkOakFence::DarkOakFence(false, false, false, false).ID: return 8737;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 8546;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 8547;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 8548;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 8549;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 8550;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 8551;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 8552;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 8553;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 8554;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 8555;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 8556;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 8557;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 8558;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 8559;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 8560;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 8561;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 8562;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 8563;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 8564;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 8565;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 8566;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 8567;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 8568;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 8569;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 8570;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 8571;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 8572;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 8573;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 8574;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 8575;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 8576;
			case DarkOakFenceGate::DarkOakFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 8577;
			case DarkOakLeaves::DarkOakLeaves(1, true).ID: return 215;
			case DarkOakLeaves::DarkOakLeaves(1, false).ID: return 216;
			case DarkOakLeaves::DarkOakLeaves(2, true).ID: return 217;
			case DarkOakLeaves::DarkOakLeaves(2, false).ID: return 218;
			case DarkOakLeaves::DarkOakLeaves(3, true).ID: return 219;
			case DarkOakLeaves::DarkOakLeaves(3, false).ID: return 220;
			case DarkOakLeaves::DarkOakLeaves(4, true).ID: return 221;
			case DarkOakLeaves::DarkOakLeaves(4, false).ID: return 222;
			case DarkOakLeaves::DarkOakLeaves(5, true).ID: return 223;
			case DarkOakLeaves::DarkOakLeaves(5, false).ID: return 224;
			case DarkOakLeaves::DarkOakLeaves(6, true).ID: return 225;
			case DarkOakLeaves::DarkOakLeaves(6, false).ID: return 226;
			case DarkOakLeaves::DarkOakLeaves(7, true).ID: return 227;
			case DarkOakLeaves::DarkOakLeaves(7, false).ID: return 228;
			case DarkOakLog::DarkOakLog(DarkOakLog::Axis::X).ID: return 88;
			case DarkOakLog::DarkOakLog(DarkOakLog::Axis::Y).ID: return 89;
			case DarkOakLog::DarkOakLog(DarkOakLog::Axis::Z).ID: return 90;
			case DarkOakPlanks::DarkOakPlanks().ID: return 20;
			case DarkOakPressurePlate::DarkOakPressurePlate(true).ID: return 3883;
			case DarkOakPressurePlate::DarkOakPressurePlate(false).ID: return 3884;
			case DarkOakSapling::DarkOakSapling(0).ID: return 31;
			case DarkOakSapling::DarkOakSapling(1).ID: return 32;
			case DarkOakSign::DarkOakSign(0).ID: return 3542;
			case DarkOakSign::DarkOakSign(1).ID: return 3544;
			case DarkOakSign::DarkOakSign(2).ID: return 3546;
			case DarkOakSign::DarkOakSign(3).ID: return 3548;
			case DarkOakSign::DarkOakSign(4).ID: return 3550;
			case DarkOakSign::DarkOakSign(5).ID: return 3552;
			case DarkOakSign::DarkOakSign(6).ID: return 3554;
			case DarkOakSign::DarkOakSign(7).ID: return 3556;
			case DarkOakSign::DarkOakSign(8).ID: return 3558;
			case DarkOakSign::DarkOakSign(9).ID: return 3560;
			case DarkOakSign::DarkOakSign(10).ID: return 3562;
			case DarkOakSign::DarkOakSign(11).ID: return 3564;
			case DarkOakSign::DarkOakSign(12).ID: return 3566;
			case DarkOakSign::DarkOakSign(13).ID: return 3568;
			case DarkOakSign::DarkOakSign(14).ID: return 3570;
			case DarkOakSign::DarkOakSign(15).ID: return 3572;
			case DarkOakSlab::DarkOakSlab(DarkOakSlab::Type::Top).ID: return 8331;
			case DarkOakSlab::DarkOakSlab(DarkOakSlab::Type::Bottom).ID: return 8333;
			case DarkOakSlab::DarkOakSlab(DarkOakSlab::Type::Double).ID: return 8335;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::Straight).ID: return 7456;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerLeft).ID: return 7458;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerRight).ID: return 7460;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterLeft).ID: return 7462;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterRight).ID: return 7464;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::Straight).ID: return 7466;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerLeft).ID: return 7468;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerRight).ID: return 7470;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterLeft).ID: return 7472;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterRight).ID: return 7474;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::Straight).ID: return 7476;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerLeft).ID: return 7478;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerRight).ID: return 7480;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterLeft).ID: return 7482;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterRight).ID: return 7484;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::Straight).ID: return 7486;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerLeft).ID: return 7488;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerRight).ID: return 7490;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterLeft).ID: return 7492;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_ZP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterRight).ID: return 7494;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::Straight).ID: return 7496;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerLeft).ID: return 7498;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerRight).ID: return 7500;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterLeft).ID: return 7502;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterRight).ID: return 7504;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::Straight).ID: return 7506;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerLeft).ID: return 7508;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerRight).ID: return 7510;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterLeft).ID: return 7512;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XM, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterRight).ID: return 7514;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::Straight).ID: return 7516;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerLeft).ID: return 7518;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::InnerRight).ID: return 7520;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterLeft).ID: return 7522;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Top, DarkOakStairs::Shape::OuterRight).ID: return 7524;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::Straight).ID: return 7526;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerLeft).ID: return 7528;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::InnerRight).ID: return 7530;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterLeft).ID: return 7532;
			case DarkOakStairs::DarkOakStairs(eBlockFace::BLOCK_FACE_XP, DarkOakStairs::Half::Bottom, DarkOakStairs::Shape::OuterRight).ID: return 7534;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Top, true, true).ID: return 4432;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Top, true, false).ID: return 4434;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Top, false, true).ID: return 4436;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Top, false, false).ID: return 4438;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Bottom, true, true).ID: return 4440;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Bottom, true, false).ID: return 4442;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Bottom, false, true).ID: return 4444;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZM, DarkOakTrapdoor::Half::Bottom, false, false).ID: return 4446;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Top, true, true).ID: return 4448;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Top, true, false).ID: return 4450;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Top, false, true).ID: return 4452;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Top, false, false).ID: return 4454;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Bottom, true, true).ID: return 4456;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Bottom, true, false).ID: return 4458;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Bottom, false, true).ID: return 4460;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_ZP, DarkOakTrapdoor::Half::Bottom, false, false).ID: return 4462;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Top, true, true).ID: return 4464;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Top, true, false).ID: return 4466;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Top, false, true).ID: return 4468;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Top, false, false).ID: return 4470;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Bottom, true, true).ID: return 4472;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Bottom, true, false).ID: return 4474;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Bottom, false, true).ID: return 4476;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XM, DarkOakTrapdoor::Half::Bottom, false, false).ID: return 4478;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Top, true, true).ID: return 4480;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Top, true, false).ID: return 4482;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Top, false, true).ID: return 4484;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Top, false, false).ID: return 4486;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Bottom, true, true).ID: return 4488;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Bottom, true, false).ID: return 4490;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Bottom, false, true).ID: return 4492;
			case DarkOakTrapdoor::DarkOakTrapdoor(eBlockFace::BLOCK_FACE_XP, DarkOakTrapdoor::Half::Bottom, false, false).ID: return 4494;
			case DarkOakWallSign::DarkOakWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 3776;
			case DarkOakWallSign::DarkOakWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 3778;
			case DarkOakWallSign::DarkOakWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 3780;
			case DarkOakWallSign::DarkOakWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 3782;
			case DarkOakWood::DarkOakWood(DarkOakWood::Axis::X).ID: return 124;
			case DarkOakWood::DarkOakWood(DarkOakWood::Axis::Y).ID: return 125;
			case DarkOakWood::DarkOakWood(DarkOakWood::Axis::Z).ID: return 126;
			case DarkPrismarine::DarkPrismarine().ID: return 7603;
			case DarkPrismarineSlab::DarkPrismarineSlab(DarkPrismarineSlab::Type::Top).ID: return 7857;
			case DarkPrismarineSlab::DarkPrismarineSlab(DarkPrismarineSlab::Type::Bottom).ID: return 7859;
			case DarkPrismarineSlab::DarkPrismarineSlab(DarkPrismarineSlab::Type::Double).ID: return 7861;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::Straight).ID: return 7765;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7767;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerRight).ID: return 7769;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7771;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterRight).ID: return 7773;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::Straight).ID: return 7775;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7777;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerRight).ID: return 7779;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7781;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterRight).ID: return 7783;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::Straight).ID: return 7785;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7787;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerRight).ID: return 7789;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7791;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterRight).ID: return 7793;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::Straight).ID: return 7795;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7797;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerRight).ID: return 7799;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7801;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_ZP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterRight).ID: return 7803;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::Straight).ID: return 7805;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7807;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerRight).ID: return 7809;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7811;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterRight).ID: return 7813;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::Straight).ID: return 7815;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7817;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerRight).ID: return 7819;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7821;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XM, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterRight).ID: return 7823;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::Straight).ID: return 7825;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7827;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::InnerRight).ID: return 7829;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7831;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Top, DarkPrismarineStairs::Shape::OuterRight).ID: return 7833;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::Straight).ID: return 7835;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerLeft).ID: return 7837;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::InnerRight).ID: return 7839;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterLeft).ID: return 7841;
			case DarkPrismarineStairs::DarkPrismarineStairs(eBlockFace::BLOCK_FACE_XP, DarkPrismarineStairs::Half::Bottom, DarkPrismarineStairs::Shape::OuterRight).ID: return 7843;
			case DaylightDetector::DaylightDetector(true, 0).ID: return 6694;
			case DaylightDetector::DaylightDetector(true, 1).ID: return 6695;
			case DaylightDetector::DaylightDetector(true, 2).ID: return 6696;
			case DaylightDetector::DaylightDetector(true, 3).ID: return 6697;
			case DaylightDetector::DaylightDetector(true, 4).ID: return 6698;
			case DaylightDetector::DaylightDetector(true, 5).ID: return 6699;
			case DaylightDetector::DaylightDetector(true, 6).ID: return 6700;
			case DaylightDetector::DaylightDetector(true, 7).ID: return 6701;
			case DaylightDetector::DaylightDetector(true, 8).ID: return 6702;
			case DaylightDetector::DaylightDetector(true, 9).ID: return 6703;
			case DaylightDetector::DaylightDetector(true, 10).ID: return 6704;
			case DaylightDetector::DaylightDetector(true, 11).ID: return 6705;
			case DaylightDetector::DaylightDetector(true, 12).ID: return 6706;
			case DaylightDetector::DaylightDetector(true, 13).ID: return 6707;
			case DaylightDetector::DaylightDetector(true, 14).ID: return 6708;
			case DaylightDetector::DaylightDetector(true, 15).ID: return 6709;
			case DaylightDetector::DaylightDetector(false, 0).ID: return 6710;
			case DaylightDetector::DaylightDetector(false, 1).ID: return 6711;
			case DaylightDetector::DaylightDetector(false, 2).ID: return 6712;
			case DaylightDetector::DaylightDetector(false, 3).ID: return 6713;
			case DaylightDetector::DaylightDetector(false, 4).ID: return 6714;
			case DaylightDetector::DaylightDetector(false, 5).ID: return 6715;
			case DaylightDetector::DaylightDetector(false, 6).ID: return 6716;
			case DaylightDetector::DaylightDetector(false, 7).ID: return 6717;
			case DaylightDetector::DaylightDetector(false, 8).ID: return 6718;
			case DaylightDetector::DaylightDetector(false, 9).ID: return 6719;
			case DaylightDetector::DaylightDetector(false, 10).ID: return 6720;
			case DaylightDetector::DaylightDetector(false, 11).ID: return 6721;
			case DaylightDetector::DaylightDetector(false, 12).ID: return 6722;
			case DaylightDetector::DaylightDetector(false, 13).ID: return 6723;
			case DaylightDetector::DaylightDetector(false, 14).ID: return 6724;
			case DaylightDetector::DaylightDetector(false, 15).ID: return 6725;
			case DeadBrainCoral::DeadBrainCoral().ID: return 9523;
			case DeadBrainCoralBlock::DeadBrainCoralBlock().ID: return 9511;
			case DeadBrainCoralFan::DeadBrainCoralFan().ID: return 9543;
			case DeadBrainCoralWallFan::DeadBrainCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9569;
			case DeadBrainCoralWallFan::DeadBrainCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9571;
			case DeadBrainCoralWallFan::DeadBrainCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9573;
			case DeadBrainCoralWallFan::DeadBrainCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9575;
			case DeadBubbleCoral::DeadBubbleCoral().ID: return 9525;
			case DeadBubbleCoralBlock::DeadBubbleCoralBlock().ID: return 9512;
			case DeadBubbleCoralFan::DeadBubbleCoralFan().ID: return 9545;
			case DeadBubbleCoralWallFan::DeadBubbleCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9577;
			case DeadBubbleCoralWallFan::DeadBubbleCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9579;
			case DeadBubbleCoralWallFan::DeadBubbleCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9581;
			case DeadBubbleCoralWallFan::DeadBubbleCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9583;
			case DeadBush::DeadBush().ID: return 1344;
			case DeadFireCoral::DeadFireCoral().ID: return 9527;
			case DeadFireCoralBlock::DeadFireCoralBlock().ID: return 9513;
			case DeadFireCoralFan::DeadFireCoralFan().ID: return 9547;
			case DeadFireCoralWallFan::DeadFireCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9585;
			case DeadFireCoralWallFan::DeadFireCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9587;
			case DeadFireCoralWallFan::DeadFireCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9589;
			case DeadFireCoralWallFan::DeadFireCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9591;
			case DeadHornCoral::DeadHornCoral().ID: return 9529;
			case DeadHornCoralBlock::DeadHornCoralBlock().ID: return 9514;
			case DeadHornCoralFan::DeadHornCoralFan().ID: return 9549;
			case DeadHornCoralWallFan::DeadHornCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9593;
			case DeadHornCoralWallFan::DeadHornCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9595;
			case DeadHornCoralWallFan::DeadHornCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9597;
			case DeadHornCoralWallFan::DeadHornCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9599;
			case DeadTubeCoral::DeadTubeCoral().ID: return 9521;
			case DeadTubeCoralBlock::DeadTubeCoralBlock().ID: return 9510;
			case DeadTubeCoralFan::DeadTubeCoralFan().ID: return 9541;
			case DeadTubeCoralWallFan::DeadTubeCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9561;
			case DeadTubeCoralWallFan::DeadTubeCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9563;
			case DeadTubeCoralWallFan::DeadTubeCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9565;
			case DeadTubeCoralWallFan::DeadTubeCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9567;
			case DetectorRail::DetectorRail(true, DetectorRail::Shape::NorthSouth).ID: return 1317;
			case DetectorRail::DetectorRail(true, DetectorRail::Shape::EastWest).ID: return 1318;
			case DetectorRail::DetectorRail(true, DetectorRail::Shape::AscendingEast).ID: return 1319;
			case DetectorRail::DetectorRail(true, DetectorRail::Shape::AscendingWest).ID: return 1320;
			case DetectorRail::DetectorRail(true, DetectorRail::Shape::AscendingNorth).ID: return 1321;
			case DetectorRail::DetectorRail(true, DetectorRail::Shape::AscendingSouth).ID: return 1322;
			case DetectorRail::DetectorRail(false, DetectorRail::Shape::NorthSouth).ID: return 1323;
			case DetectorRail::DetectorRail(false, DetectorRail::Shape::EastWest).ID: return 1324;
			case DetectorRail::DetectorRail(false, DetectorRail::Shape::AscendingEast).ID: return 1325;
			case DetectorRail::DetectorRail(false, DetectorRail::Shape::AscendingWest).ID: return 1326;
			case DetectorRail::DetectorRail(false, DetectorRail::Shape::AscendingNorth).ID: return 1327;
			case DetectorRail::DetectorRail(false, DetectorRail::Shape::AscendingSouth).ID: return 1328;
			case DiamondBlock::DiamondBlock().ID: return 3355;
			case DiamondOre::DiamondOre().ID: return 3354;
			case Diorite::Diorite().ID: return 4;
			case DioriteSlab::DioriteSlab(DioriteSlab::Type::Top).ID: return 10862;
			case DioriteSlab::DioriteSlab(DioriteSlab::Type::Bottom).ID: return 10864;
			case DioriteSlab::DioriteSlab(DioriteSlab::Type::Double).ID: return 10866;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Top, DioriteStairs::Shape::Straight).ID: return 10710;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerLeft).ID: return 10712;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerRight).ID: return 10714;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterLeft).ID: return 10716;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterRight).ID: return 10718;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::Straight).ID: return 10720;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerLeft).ID: return 10722;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerRight).ID: return 10724;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterLeft).ID: return 10726;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterRight).ID: return 10728;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Top, DioriteStairs::Shape::Straight).ID: return 10730;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerLeft).ID: return 10732;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerRight).ID: return 10734;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterLeft).ID: return 10736;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterRight).ID: return 10738;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::Straight).ID: return 10740;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerLeft).ID: return 10742;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerRight).ID: return 10744;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterLeft).ID: return 10746;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_ZP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterRight).ID: return 10748;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Top, DioriteStairs::Shape::Straight).ID: return 10750;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerLeft).ID: return 10752;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerRight).ID: return 10754;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterLeft).ID: return 10756;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterRight).ID: return 10758;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::Straight).ID: return 10760;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerLeft).ID: return 10762;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerRight).ID: return 10764;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterLeft).ID: return 10766;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XM, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterRight).ID: return 10768;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Top, DioriteStairs::Shape::Straight).ID: return 10770;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerLeft).ID: return 10772;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Top, DioriteStairs::Shape::InnerRight).ID: return 10774;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterLeft).ID: return 10776;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Top, DioriteStairs::Shape::OuterRight).ID: return 10778;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::Straight).ID: return 10780;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerLeft).ID: return 10782;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::InnerRight).ID: return 10784;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterLeft).ID: return 10786;
			case DioriteStairs::DioriteStairs(eBlockFace::BLOCK_FACE_XP, DioriteStairs::Half::Bottom, DioriteStairs::Shape::OuterRight).ID: return 10788;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14434;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14435;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14436;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14440;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14441;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14442;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14446;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14447;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14448;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14452;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14453;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14454;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14458;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14459;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14460;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14464;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14465;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14466;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14470;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14471;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14472;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14476;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14477;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14478;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14482;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14483;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14484;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14488;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14489;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14490;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14494;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14495;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14496;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14500;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14501;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14502;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14506;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14507;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14508;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14512;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14513;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14514;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14518;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14519;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14520;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14524;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14525;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14526;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14530;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14531;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14532;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14536;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14537;
			case DioriteWall::DioriteWall(DioriteWall::East::None, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14538;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14542;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14543;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14544;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14548;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14549;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14550;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14554;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14555;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14556;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14560;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14561;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14562;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14566;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14567;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14568;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14572;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14573;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14574;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14578;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14579;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14580;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14584;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14585;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14586;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14590;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14591;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14592;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14596;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14597;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14598;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14602;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14603;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14604;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14608;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14609;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14610;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14614;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14615;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14616;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14620;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14621;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14622;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14626;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14627;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14628;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14632;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14633;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14634;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14638;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14639;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14640;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14644;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14645;
			case DioriteWall::DioriteWall(DioriteWall::East::Low, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14646;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14650;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14651;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14652;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14656;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14657;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14658;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14662;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14663;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14664;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14668;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14669;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14670;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14674;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14675;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14676;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14680;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14681;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::None, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14682;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14686;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14687;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14688;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14692;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14693;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14694;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14698;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14699;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14700;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14704;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14705;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14706;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14710;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14711;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14712;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14716;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14717;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Low, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14718;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::None).ID: return 14722;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::Low).ID: return 14723;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::None, true, DioriteWall::West::Tall).ID: return 14724;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::None).ID: return 14728;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::Low).ID: return 14729;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::None, false, DioriteWall::West::Tall).ID: return 14730;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::None).ID: return 14734;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::Low).ID: return 14735;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Low, true, DioriteWall::West::Tall).ID: return 14736;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::None).ID: return 14740;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::Low).ID: return 14741;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Low, false, DioriteWall::West::Tall).ID: return 14742;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::None).ID: return 14746;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::Low).ID: return 14747;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Tall, true, DioriteWall::West::Tall).ID: return 14748;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::None).ID: return 14752;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::Low).ID: return 14753;
			case DioriteWall::DioriteWall(DioriteWall::East::Tall, DioriteWall::North::Tall, DioriteWall::South::Tall, false, DioriteWall::West::Tall).ID: return 14754;
			case Dirt::Dirt().ID: return 10;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_ZM, true).ID: return 234;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_ZM, false).ID: return 235;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_XP, true).ID: return 236;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_XP, false).ID: return 237;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_ZP, true).ID: return 238;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_ZP, false).ID: return 239;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_XM, true).ID: return 240;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_XM, false).ID: return 241;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_YP, true).ID: return 242;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_YP, false).ID: return 243;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_YM, true).ID: return 244;
			case Dispenser::Dispenser(eBlockFace::BLOCK_FACE_YM, false).ID: return 245;
			case DragonEgg::DragonEgg().ID: return 5155;
			case DragonHead::DragonHead(0).ID: return 6590;
			case DragonHead::DragonHead(1).ID: return 6591;
			case DragonHead::DragonHead(2).ID: return 6592;
			case DragonHead::DragonHead(3).ID: return 6593;
			case DragonHead::DragonHead(4).ID: return 6594;
			case DragonHead::DragonHead(5).ID: return 6595;
			case DragonHead::DragonHead(6).ID: return 6596;
			case DragonHead::DragonHead(7).ID: return 6597;
			case DragonHead::DragonHead(8).ID: return 6598;
			case DragonHead::DragonHead(9).ID: return 6599;
			case DragonHead::DragonHead(10).ID: return 6600;
			case DragonHead::DragonHead(11).ID: return 6601;
			case DragonHead::DragonHead(12).ID: return 6602;
			case DragonHead::DragonHead(13).ID: return 6603;
			case DragonHead::DragonHead(14).ID: return 6604;
			case DragonHead::DragonHead(15).ID: return 6605;
			case DragonWallHead::DragonWallHead(eBlockFace::BLOCK_FACE_ZM).ID: return 6606;
			case DragonWallHead::DragonWallHead(eBlockFace::BLOCK_FACE_ZP).ID: return 6607;
			case DragonWallHead::DragonWallHead(eBlockFace::BLOCK_FACE_XM).ID: return 6608;
			case DragonWallHead::DragonWallHead(eBlockFace::BLOCK_FACE_XP).ID: return 6609;
			case DriedKelpBlock::DriedKelpBlock().ID: return 9497;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_ZM, true).ID: return 6835;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_ZM, false).ID: return 6836;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_XP, true).ID: return 6837;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_XP, false).ID: return 6838;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_ZP, true).ID: return 6839;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_ZP, false).ID: return 6840;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_XM, true).ID: return 6841;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_XM, false).ID: return 6842;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_YP, true).ID: return 6843;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_YP, false).ID: return 6844;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_YM, true).ID: return 6845;
			case Dropper::Dropper(eBlockFace::BLOCK_FACE_YM, false).ID: return 6846;
			case EmeraldBlock::EmeraldBlock().ID: return 5403;
			case EmeraldOre::EmeraldOre().ID: return 5250;
			case EnchantingTable::EnchantingTable().ID: return 5132;
			case EndGateway::EndGateway().ID: return 9224;
			case EndPortal::EndPortal().ID: return 5145;
			case EndPortalFrame::EndPortalFrame(true, eBlockFace::BLOCK_FACE_ZM).ID: return 5146;
			case EndPortalFrame::EndPortalFrame(true, eBlockFace::BLOCK_FACE_ZP).ID: return 5147;
			case EndPortalFrame::EndPortalFrame(true, eBlockFace::BLOCK_FACE_XM).ID: return 5148;
			case EndPortalFrame::EndPortalFrame(true, eBlockFace::BLOCK_FACE_XP).ID: return 5149;
			case EndPortalFrame::EndPortalFrame(false, eBlockFace::BLOCK_FACE_ZM).ID: return 5150;
			case EndPortalFrame::EndPortalFrame(false, eBlockFace::BLOCK_FACE_ZP).ID: return 5151;
			case EndPortalFrame::EndPortalFrame(false, eBlockFace::BLOCK_FACE_XM).ID: return 5152;
			case EndPortalFrame::EndPortalFrame(false, eBlockFace::BLOCK_FACE_XP).ID: return 5153;
			case EndRod::EndRod(eBlockFace::BLOCK_FACE_ZM).ID: return 9058;
			case EndRod::EndRod(eBlockFace::BLOCK_FACE_XP).ID: return 9059;
			case EndRod::EndRod(eBlockFace::BLOCK_FACE_ZP).ID: return 9060;
			case EndRod::EndRod(eBlockFace::BLOCK_FACE_XM).ID: return 9061;
			case EndRod::EndRod(eBlockFace::BLOCK_FACE_YP).ID: return 9062;
			case EndRod::EndRod(eBlockFace::BLOCK_FACE_YM).ID: return 9063;
			case EndStone::EndStone().ID: return 5154;
			case EndStoneBrickSlab::EndStoneBrickSlab(EndStoneBrickSlab::Type::Top).ID: return 10820;
			case EndStoneBrickSlab::EndStoneBrickSlab(EndStoneBrickSlab::Type::Bottom).ID: return 10822;
			case EndStoneBrickSlab::EndStoneBrickSlab(EndStoneBrickSlab::Type::Double).ID: return 10824;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::Straight).ID: return 10070;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10072;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerRight).ID: return 10074;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10076;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterRight).ID: return 10078;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::Straight).ID: return 10080;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10082;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerRight).ID: return 10084;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10086;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterRight).ID: return 10088;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::Straight).ID: return 10090;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10092;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerRight).ID: return 10094;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10096;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterRight).ID: return 10098;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::Straight).ID: return 10100;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10102;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerRight).ID: return 10104;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10106;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterRight).ID: return 10108;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::Straight).ID: return 10110;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10112;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerRight).ID: return 10114;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10116;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterRight).ID: return 10118;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::Straight).ID: return 10120;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10122;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerRight).ID: return 10124;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10126;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterRight).ID: return 10128;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::Straight).ID: return 10130;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10132;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::InnerRight).ID: return 10134;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10136;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Top, EndStoneBrickStairs::Shape::OuterRight).ID: return 10138;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::Straight).ID: return 10140;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerLeft).ID: return 10142;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::InnerRight).ID: return 10144;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterLeft).ID: return 10146;
			case EndStoneBrickStairs::EndStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, EndStoneBrickStairs::Half::Bottom, EndStoneBrickStairs::Shape::OuterRight).ID: return 10148;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14110;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14111;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14112;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14116;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14117;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14118;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14122;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14123;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14124;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14128;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14129;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14130;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14134;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14135;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14136;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14140;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14141;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14142;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14146;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14147;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14148;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14152;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14153;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14154;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14158;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14159;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14160;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14164;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14165;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14166;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14170;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14171;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14172;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14176;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14177;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14178;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14182;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14183;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14184;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14188;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14189;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14190;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14194;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14195;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14196;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14200;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14201;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14202;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14206;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14207;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14208;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14212;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14213;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::None, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14214;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14218;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14219;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14220;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14224;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14225;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14226;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14230;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14231;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14232;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14236;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14237;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14238;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14242;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14243;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14244;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14248;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14249;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14250;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14254;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14255;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14256;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14260;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14261;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14262;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14266;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14267;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14268;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14272;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14273;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14274;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14278;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14279;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14280;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14284;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14285;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14286;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14290;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14291;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14292;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14296;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14297;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14298;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14302;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14303;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14304;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14308;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14309;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14310;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14314;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14315;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14316;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14320;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14321;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Low, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14322;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14326;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14327;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14328;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14332;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14333;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14334;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14338;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14339;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14340;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14344;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14345;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14346;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14350;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14351;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14352;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14356;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14357;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::None, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14358;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14362;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14363;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14364;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14368;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14369;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14370;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14374;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14375;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14376;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14380;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14381;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14382;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14386;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14387;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14388;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14392;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14393;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Low, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14394;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::None).ID: return 14398;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Low).ID: return 14399;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, true, EndStoneBrickWall::West::Tall).ID: return 14400;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::None).ID: return 14404;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Low).ID: return 14405;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::None, false, EndStoneBrickWall::West::Tall).ID: return 14406;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::None).ID: return 14410;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Low).ID: return 14411;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, true, EndStoneBrickWall::West::Tall).ID: return 14412;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::None).ID: return 14416;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Low).ID: return 14417;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Low, false, EndStoneBrickWall::West::Tall).ID: return 14418;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::None).ID: return 14422;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Low).ID: return 14423;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, true, EndStoneBrickWall::West::Tall).ID: return 14424;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::None).ID: return 14428;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Low).ID: return 14429;
			case EndStoneBrickWall::EndStoneBrickWall(EndStoneBrickWall::East::Tall, EndStoneBrickWall::North::Tall, EndStoneBrickWall::South::Tall, false, EndStoneBrickWall::West::Tall).ID: return 14430;
			case EndStoneBricks::EndStoneBricks().ID: return 9218;
			case EnderChest::EnderChest(eBlockFace::BLOCK_FACE_ZM).ID: return 5252;
			case EnderChest::EnderChest(eBlockFace::BLOCK_FACE_ZP).ID: return 5254;
			case EnderChest::EnderChest(eBlockFace::BLOCK_FACE_XM).ID: return 5256;
			case EnderChest::EnderChest(eBlockFace::BLOCK_FACE_XP).ID: return 5258;
			case Farmland::Farmland(0).ID: return 3365;
			case Farmland::Farmland(1).ID: return 3366;
			case Farmland::Farmland(2).ID: return 3367;
			case Farmland::Farmland(3).ID: return 3368;
			case Farmland::Farmland(4).ID: return 3369;
			case Farmland::Farmland(5).ID: return 3370;
			case Farmland::Farmland(6).ID: return 3371;
			case Farmland::Farmland(7).ID: return 3372;
			case Fern::Fern().ID: return 1343;
			case Fire::Fire(0, true, true, true, true, true).ID: return 1440;
			case Fire::Fire(0, true, true, true, true, false).ID: return 1441;
			case Fire::Fire(0, true, true, true, false, true).ID: return 1442;
			case Fire::Fire(0, true, true, true, false, false).ID: return 1443;
			case Fire::Fire(0, true, true, false, true, true).ID: return 1444;
			case Fire::Fire(0, true, true, false, true, false).ID: return 1445;
			case Fire::Fire(0, true, true, false, false, true).ID: return 1446;
			case Fire::Fire(0, true, true, false, false, false).ID: return 1447;
			case Fire::Fire(0, true, false, true, true, true).ID: return 1448;
			case Fire::Fire(0, true, false, true, true, false).ID: return 1449;
			case Fire::Fire(0, true, false, true, false, true).ID: return 1450;
			case Fire::Fire(0, true, false, true, false, false).ID: return 1451;
			case Fire::Fire(0, true, false, false, true, true).ID: return 1452;
			case Fire::Fire(0, true, false, false, true, false).ID: return 1453;
			case Fire::Fire(0, true, false, false, false, true).ID: return 1454;
			case Fire::Fire(0, true, false, false, false, false).ID: return 1455;
			case Fire::Fire(0, false, true, true, true, true).ID: return 1456;
			case Fire::Fire(0, false, true, true, true, false).ID: return 1457;
			case Fire::Fire(0, false, true, true, false, true).ID: return 1458;
			case Fire::Fire(0, false, true, true, false, false).ID: return 1459;
			case Fire::Fire(0, false, true, false, true, true).ID: return 1460;
			case Fire::Fire(0, false, true, false, true, false).ID: return 1461;
			case Fire::Fire(0, false, true, false, false, true).ID: return 1462;
			case Fire::Fire(0, false, true, false, false, false).ID: return 1463;
			case Fire::Fire(0, false, false, true, true, true).ID: return 1464;
			case Fire::Fire(0, false, false, true, true, false).ID: return 1465;
			case Fire::Fire(0, false, false, true, false, true).ID: return 1466;
			case Fire::Fire(0, false, false, true, false, false).ID: return 1467;
			case Fire::Fire(0, false, false, false, true, true).ID: return 1468;
			case Fire::Fire(0, false, false, false, true, false).ID: return 1469;
			case Fire::Fire(0, false, false, false, false, true).ID: return 1470;
			case Fire::Fire(0, false, false, false, false, false).ID: return 1471;
			case Fire::Fire(1, true, true, true, true, true).ID: return 1472;
			case Fire::Fire(1, true, true, true, true, false).ID: return 1473;
			case Fire::Fire(1, true, true, true, false, true).ID: return 1474;
			case Fire::Fire(1, true, true, true, false, false).ID: return 1475;
			case Fire::Fire(1, true, true, false, true, true).ID: return 1476;
			case Fire::Fire(1, true, true, false, true, false).ID: return 1477;
			case Fire::Fire(1, true, true, false, false, true).ID: return 1478;
			case Fire::Fire(1, true, true, false, false, false).ID: return 1479;
			case Fire::Fire(1, true, false, true, true, true).ID: return 1480;
			case Fire::Fire(1, true, false, true, true, false).ID: return 1481;
			case Fire::Fire(1, true, false, true, false, true).ID: return 1482;
			case Fire::Fire(1, true, false, true, false, false).ID: return 1483;
			case Fire::Fire(1, true, false, false, true, true).ID: return 1484;
			case Fire::Fire(1, true, false, false, true, false).ID: return 1485;
			case Fire::Fire(1, true, false, false, false, true).ID: return 1486;
			case Fire::Fire(1, true, false, false, false, false).ID: return 1487;
			case Fire::Fire(1, false, true, true, true, true).ID: return 1488;
			case Fire::Fire(1, false, true, true, true, false).ID: return 1489;
			case Fire::Fire(1, false, true, true, false, true).ID: return 1490;
			case Fire::Fire(1, false, true, true, false, false).ID: return 1491;
			case Fire::Fire(1, false, true, false, true, true).ID: return 1492;
			case Fire::Fire(1, false, true, false, true, false).ID: return 1493;
			case Fire::Fire(1, false, true, false, false, true).ID: return 1494;
			case Fire::Fire(1, false, true, false, false, false).ID: return 1495;
			case Fire::Fire(1, false, false, true, true, true).ID: return 1496;
			case Fire::Fire(1, false, false, true, true, false).ID: return 1497;
			case Fire::Fire(1, false, false, true, false, true).ID: return 1498;
			case Fire::Fire(1, false, false, true, false, false).ID: return 1499;
			case Fire::Fire(1, false, false, false, true, true).ID: return 1500;
			case Fire::Fire(1, false, false, false, true, false).ID: return 1501;
			case Fire::Fire(1, false, false, false, false, true).ID: return 1502;
			case Fire::Fire(1, false, false, false, false, false).ID: return 1503;
			case Fire::Fire(2, true, true, true, true, true).ID: return 1504;
			case Fire::Fire(2, true, true, true, true, false).ID: return 1505;
			case Fire::Fire(2, true, true, true, false, true).ID: return 1506;
			case Fire::Fire(2, true, true, true, false, false).ID: return 1507;
			case Fire::Fire(2, true, true, false, true, true).ID: return 1508;
			case Fire::Fire(2, true, true, false, true, false).ID: return 1509;
			case Fire::Fire(2, true, true, false, false, true).ID: return 1510;
			case Fire::Fire(2, true, true, false, false, false).ID: return 1511;
			case Fire::Fire(2, true, false, true, true, true).ID: return 1512;
			case Fire::Fire(2, true, false, true, true, false).ID: return 1513;
			case Fire::Fire(2, true, false, true, false, true).ID: return 1514;
			case Fire::Fire(2, true, false, true, false, false).ID: return 1515;
			case Fire::Fire(2, true, false, false, true, true).ID: return 1516;
			case Fire::Fire(2, true, false, false, true, false).ID: return 1517;
			case Fire::Fire(2, true, false, false, false, true).ID: return 1518;
			case Fire::Fire(2, true, false, false, false, false).ID: return 1519;
			case Fire::Fire(2, false, true, true, true, true).ID: return 1520;
			case Fire::Fire(2, false, true, true, true, false).ID: return 1521;
			case Fire::Fire(2, false, true, true, false, true).ID: return 1522;
			case Fire::Fire(2, false, true, true, false, false).ID: return 1523;
			case Fire::Fire(2, false, true, false, true, true).ID: return 1524;
			case Fire::Fire(2, false, true, false, true, false).ID: return 1525;
			case Fire::Fire(2, false, true, false, false, true).ID: return 1526;
			case Fire::Fire(2, false, true, false, false, false).ID: return 1527;
			case Fire::Fire(2, false, false, true, true, true).ID: return 1528;
			case Fire::Fire(2, false, false, true, true, false).ID: return 1529;
			case Fire::Fire(2, false, false, true, false, true).ID: return 1530;
			case Fire::Fire(2, false, false, true, false, false).ID: return 1531;
			case Fire::Fire(2, false, false, false, true, true).ID: return 1532;
			case Fire::Fire(2, false, false, false, true, false).ID: return 1533;
			case Fire::Fire(2, false, false, false, false, true).ID: return 1534;
			case Fire::Fire(2, false, false, false, false, false).ID: return 1535;
			case Fire::Fire(3, true, true, true, true, true).ID: return 1536;
			case Fire::Fire(3, true, true, true, true, false).ID: return 1537;
			case Fire::Fire(3, true, true, true, false, true).ID: return 1538;
			case Fire::Fire(3, true, true, true, false, false).ID: return 1539;
			case Fire::Fire(3, true, true, false, true, true).ID: return 1540;
			case Fire::Fire(3, true, true, false, true, false).ID: return 1541;
			case Fire::Fire(3, true, true, false, false, true).ID: return 1542;
			case Fire::Fire(3, true, true, false, false, false).ID: return 1543;
			case Fire::Fire(3, true, false, true, true, true).ID: return 1544;
			case Fire::Fire(3, true, false, true, true, false).ID: return 1545;
			case Fire::Fire(3, true, false, true, false, true).ID: return 1546;
			case Fire::Fire(3, true, false, true, false, false).ID: return 1547;
			case Fire::Fire(3, true, false, false, true, true).ID: return 1548;
			case Fire::Fire(3, true, false, false, true, false).ID: return 1549;
			case Fire::Fire(3, true, false, false, false, true).ID: return 1550;
			case Fire::Fire(3, true, false, false, false, false).ID: return 1551;
			case Fire::Fire(3, false, true, true, true, true).ID: return 1552;
			case Fire::Fire(3, false, true, true, true, false).ID: return 1553;
			case Fire::Fire(3, false, true, true, false, true).ID: return 1554;
			case Fire::Fire(3, false, true, true, false, false).ID: return 1555;
			case Fire::Fire(3, false, true, false, true, true).ID: return 1556;
			case Fire::Fire(3, false, true, false, true, false).ID: return 1557;
			case Fire::Fire(3, false, true, false, false, true).ID: return 1558;
			case Fire::Fire(3, false, true, false, false, false).ID: return 1559;
			case Fire::Fire(3, false, false, true, true, true).ID: return 1560;
			case Fire::Fire(3, false, false, true, true, false).ID: return 1561;
			case Fire::Fire(3, false, false, true, false, true).ID: return 1562;
			case Fire::Fire(3, false, false, true, false, false).ID: return 1563;
			case Fire::Fire(3, false, false, false, true, true).ID: return 1564;
			case Fire::Fire(3, false, false, false, true, false).ID: return 1565;
			case Fire::Fire(3, false, false, false, false, true).ID: return 1566;
			case Fire::Fire(3, false, false, false, false, false).ID: return 1567;
			case Fire::Fire(4, true, true, true, true, true).ID: return 1568;
			case Fire::Fire(4, true, true, true, true, false).ID: return 1569;
			case Fire::Fire(4, true, true, true, false, true).ID: return 1570;
			case Fire::Fire(4, true, true, true, false, false).ID: return 1571;
			case Fire::Fire(4, true, true, false, true, true).ID: return 1572;
			case Fire::Fire(4, true, true, false, true, false).ID: return 1573;
			case Fire::Fire(4, true, true, false, false, true).ID: return 1574;
			case Fire::Fire(4, true, true, false, false, false).ID: return 1575;
			case Fire::Fire(4, true, false, true, true, true).ID: return 1576;
			case Fire::Fire(4, true, false, true, true, false).ID: return 1577;
			case Fire::Fire(4, true, false, true, false, true).ID: return 1578;
			case Fire::Fire(4, true, false, true, false, false).ID: return 1579;
			case Fire::Fire(4, true, false, false, true, true).ID: return 1580;
			case Fire::Fire(4, true, false, false, true, false).ID: return 1581;
			case Fire::Fire(4, true, false, false, false, true).ID: return 1582;
			case Fire::Fire(4, true, false, false, false, false).ID: return 1583;
			case Fire::Fire(4, false, true, true, true, true).ID: return 1584;
			case Fire::Fire(4, false, true, true, true, false).ID: return 1585;
			case Fire::Fire(4, false, true, true, false, true).ID: return 1586;
			case Fire::Fire(4, false, true, true, false, false).ID: return 1587;
			case Fire::Fire(4, false, true, false, true, true).ID: return 1588;
			case Fire::Fire(4, false, true, false, true, false).ID: return 1589;
			case Fire::Fire(4, false, true, false, false, true).ID: return 1590;
			case Fire::Fire(4, false, true, false, false, false).ID: return 1591;
			case Fire::Fire(4, false, false, true, true, true).ID: return 1592;
			case Fire::Fire(4, false, false, true, true, false).ID: return 1593;
			case Fire::Fire(4, false, false, true, false, true).ID: return 1594;
			case Fire::Fire(4, false, false, true, false, false).ID: return 1595;
			case Fire::Fire(4, false, false, false, true, true).ID: return 1596;
			case Fire::Fire(4, false, false, false, true, false).ID: return 1597;
			case Fire::Fire(4, false, false, false, false, true).ID: return 1598;
			case Fire::Fire(4, false, false, false, false, false).ID: return 1599;
			case Fire::Fire(5, true, true, true, true, true).ID: return 1600;
			case Fire::Fire(5, true, true, true, true, false).ID: return 1601;
			case Fire::Fire(5, true, true, true, false, true).ID: return 1602;
			case Fire::Fire(5, true, true, true, false, false).ID: return 1603;
			case Fire::Fire(5, true, true, false, true, true).ID: return 1604;
			case Fire::Fire(5, true, true, false, true, false).ID: return 1605;
			case Fire::Fire(5, true, true, false, false, true).ID: return 1606;
			case Fire::Fire(5, true, true, false, false, false).ID: return 1607;
			case Fire::Fire(5, true, false, true, true, true).ID: return 1608;
			case Fire::Fire(5, true, false, true, true, false).ID: return 1609;
			case Fire::Fire(5, true, false, true, false, true).ID: return 1610;
			case Fire::Fire(5, true, false, true, false, false).ID: return 1611;
			case Fire::Fire(5, true, false, false, true, true).ID: return 1612;
			case Fire::Fire(5, true, false, false, true, false).ID: return 1613;
			case Fire::Fire(5, true, false, false, false, true).ID: return 1614;
			case Fire::Fire(5, true, false, false, false, false).ID: return 1615;
			case Fire::Fire(5, false, true, true, true, true).ID: return 1616;
			case Fire::Fire(5, false, true, true, true, false).ID: return 1617;
			case Fire::Fire(5, false, true, true, false, true).ID: return 1618;
			case Fire::Fire(5, false, true, true, false, false).ID: return 1619;
			case Fire::Fire(5, false, true, false, true, true).ID: return 1620;
			case Fire::Fire(5, false, true, false, true, false).ID: return 1621;
			case Fire::Fire(5, false, true, false, false, true).ID: return 1622;
			case Fire::Fire(5, false, true, false, false, false).ID: return 1623;
			case Fire::Fire(5, false, false, true, true, true).ID: return 1624;
			case Fire::Fire(5, false, false, true, true, false).ID: return 1625;
			case Fire::Fire(5, false, false, true, false, true).ID: return 1626;
			case Fire::Fire(5, false, false, true, false, false).ID: return 1627;
			case Fire::Fire(5, false, false, false, true, true).ID: return 1628;
			case Fire::Fire(5, false, false, false, true, false).ID: return 1629;
			case Fire::Fire(5, false, false, false, false, true).ID: return 1630;
			case Fire::Fire(5, false, false, false, false, false).ID: return 1631;
			case Fire::Fire(6, true, true, true, true, true).ID: return 1632;
			case Fire::Fire(6, true, true, true, true, false).ID: return 1633;
			case Fire::Fire(6, true, true, true, false, true).ID: return 1634;
			case Fire::Fire(6, true, true, true, false, false).ID: return 1635;
			case Fire::Fire(6, true, true, false, true, true).ID: return 1636;
			case Fire::Fire(6, true, true, false, true, false).ID: return 1637;
			case Fire::Fire(6, true, true, false, false, true).ID: return 1638;
			case Fire::Fire(6, true, true, false, false, false).ID: return 1639;
			case Fire::Fire(6, true, false, true, true, true).ID: return 1640;
			case Fire::Fire(6, true, false, true, true, false).ID: return 1641;
			case Fire::Fire(6, true, false, true, false, true).ID: return 1642;
			case Fire::Fire(6, true, false, true, false, false).ID: return 1643;
			case Fire::Fire(6, true, false, false, true, true).ID: return 1644;
			case Fire::Fire(6, true, false, false, true, false).ID: return 1645;
			case Fire::Fire(6, true, false, false, false, true).ID: return 1646;
			case Fire::Fire(6, true, false, false, false, false).ID: return 1647;
			case Fire::Fire(6, false, true, true, true, true).ID: return 1648;
			case Fire::Fire(6, false, true, true, true, false).ID: return 1649;
			case Fire::Fire(6, false, true, true, false, true).ID: return 1650;
			case Fire::Fire(6, false, true, true, false, false).ID: return 1651;
			case Fire::Fire(6, false, true, false, true, true).ID: return 1652;
			case Fire::Fire(6, false, true, false, true, false).ID: return 1653;
			case Fire::Fire(6, false, true, false, false, true).ID: return 1654;
			case Fire::Fire(6, false, true, false, false, false).ID: return 1655;
			case Fire::Fire(6, false, false, true, true, true).ID: return 1656;
			case Fire::Fire(6, false, false, true, true, false).ID: return 1657;
			case Fire::Fire(6, false, false, true, false, true).ID: return 1658;
			case Fire::Fire(6, false, false, true, false, false).ID: return 1659;
			case Fire::Fire(6, false, false, false, true, true).ID: return 1660;
			case Fire::Fire(6, false, false, false, true, false).ID: return 1661;
			case Fire::Fire(6, false, false, false, false, true).ID: return 1662;
			case Fire::Fire(6, false, false, false, false, false).ID: return 1663;
			case Fire::Fire(7, true, true, true, true, true).ID: return 1664;
			case Fire::Fire(7, true, true, true, true, false).ID: return 1665;
			case Fire::Fire(7, true, true, true, false, true).ID: return 1666;
			case Fire::Fire(7, true, true, true, false, false).ID: return 1667;
			case Fire::Fire(7, true, true, false, true, true).ID: return 1668;
			case Fire::Fire(7, true, true, false, true, false).ID: return 1669;
			case Fire::Fire(7, true, true, false, false, true).ID: return 1670;
			case Fire::Fire(7, true, true, false, false, false).ID: return 1671;
			case Fire::Fire(7, true, false, true, true, true).ID: return 1672;
			case Fire::Fire(7, true, false, true, true, false).ID: return 1673;
			case Fire::Fire(7, true, false, true, false, true).ID: return 1674;
			case Fire::Fire(7, true, false, true, false, false).ID: return 1675;
			case Fire::Fire(7, true, false, false, true, true).ID: return 1676;
			case Fire::Fire(7, true, false, false, true, false).ID: return 1677;
			case Fire::Fire(7, true, false, false, false, true).ID: return 1678;
			case Fire::Fire(7, true, false, false, false, false).ID: return 1679;
			case Fire::Fire(7, false, true, true, true, true).ID: return 1680;
			case Fire::Fire(7, false, true, true, true, false).ID: return 1681;
			case Fire::Fire(7, false, true, true, false, true).ID: return 1682;
			case Fire::Fire(7, false, true, true, false, false).ID: return 1683;
			case Fire::Fire(7, false, true, false, true, true).ID: return 1684;
			case Fire::Fire(7, false, true, false, true, false).ID: return 1685;
			case Fire::Fire(7, false, true, false, false, true).ID: return 1686;
			case Fire::Fire(7, false, true, false, false, false).ID: return 1687;
			case Fire::Fire(7, false, false, true, true, true).ID: return 1688;
			case Fire::Fire(7, false, false, true, true, false).ID: return 1689;
			case Fire::Fire(7, false, false, true, false, true).ID: return 1690;
			case Fire::Fire(7, false, false, true, false, false).ID: return 1691;
			case Fire::Fire(7, false, false, false, true, true).ID: return 1692;
			case Fire::Fire(7, false, false, false, true, false).ID: return 1693;
			case Fire::Fire(7, false, false, false, false, true).ID: return 1694;
			case Fire::Fire(7, false, false, false, false, false).ID: return 1695;
			case Fire::Fire(8, true, true, true, true, true).ID: return 1696;
			case Fire::Fire(8, true, true, true, true, false).ID: return 1697;
			case Fire::Fire(8, true, true, true, false, true).ID: return 1698;
			case Fire::Fire(8, true, true, true, false, false).ID: return 1699;
			case Fire::Fire(8, true, true, false, true, true).ID: return 1700;
			case Fire::Fire(8, true, true, false, true, false).ID: return 1701;
			case Fire::Fire(8, true, true, false, false, true).ID: return 1702;
			case Fire::Fire(8, true, true, false, false, false).ID: return 1703;
			case Fire::Fire(8, true, false, true, true, true).ID: return 1704;
			case Fire::Fire(8, true, false, true, true, false).ID: return 1705;
			case Fire::Fire(8, true, false, true, false, true).ID: return 1706;
			case Fire::Fire(8, true, false, true, false, false).ID: return 1707;
			case Fire::Fire(8, true, false, false, true, true).ID: return 1708;
			case Fire::Fire(8, true, false, false, true, false).ID: return 1709;
			case Fire::Fire(8, true, false, false, false, true).ID: return 1710;
			case Fire::Fire(8, true, false, false, false, false).ID: return 1711;
			case Fire::Fire(8, false, true, true, true, true).ID: return 1712;
			case Fire::Fire(8, false, true, true, true, false).ID: return 1713;
			case Fire::Fire(8, false, true, true, false, true).ID: return 1714;
			case Fire::Fire(8, false, true, true, false, false).ID: return 1715;
			case Fire::Fire(8, false, true, false, true, true).ID: return 1716;
			case Fire::Fire(8, false, true, false, true, false).ID: return 1717;
			case Fire::Fire(8, false, true, false, false, true).ID: return 1718;
			case Fire::Fire(8, false, true, false, false, false).ID: return 1719;
			case Fire::Fire(8, false, false, true, true, true).ID: return 1720;
			case Fire::Fire(8, false, false, true, true, false).ID: return 1721;
			case Fire::Fire(8, false, false, true, false, true).ID: return 1722;
			case Fire::Fire(8, false, false, true, false, false).ID: return 1723;
			case Fire::Fire(8, false, false, false, true, true).ID: return 1724;
			case Fire::Fire(8, false, false, false, true, false).ID: return 1725;
			case Fire::Fire(8, false, false, false, false, true).ID: return 1726;
			case Fire::Fire(8, false, false, false, false, false).ID: return 1727;
			case Fire::Fire(9, true, true, true, true, true).ID: return 1728;
			case Fire::Fire(9, true, true, true, true, false).ID: return 1729;
			case Fire::Fire(9, true, true, true, false, true).ID: return 1730;
			case Fire::Fire(9, true, true, true, false, false).ID: return 1731;
			case Fire::Fire(9, true, true, false, true, true).ID: return 1732;
			case Fire::Fire(9, true, true, false, true, false).ID: return 1733;
			case Fire::Fire(9, true, true, false, false, true).ID: return 1734;
			case Fire::Fire(9, true, true, false, false, false).ID: return 1735;
			case Fire::Fire(9, true, false, true, true, true).ID: return 1736;
			case Fire::Fire(9, true, false, true, true, false).ID: return 1737;
			case Fire::Fire(9, true, false, true, false, true).ID: return 1738;
			case Fire::Fire(9, true, false, true, false, false).ID: return 1739;
			case Fire::Fire(9, true, false, false, true, true).ID: return 1740;
			case Fire::Fire(9, true, false, false, true, false).ID: return 1741;
			case Fire::Fire(9, true, false, false, false, true).ID: return 1742;
			case Fire::Fire(9, true, false, false, false, false).ID: return 1743;
			case Fire::Fire(9, false, true, true, true, true).ID: return 1744;
			case Fire::Fire(9, false, true, true, true, false).ID: return 1745;
			case Fire::Fire(9, false, true, true, false, true).ID: return 1746;
			case Fire::Fire(9, false, true, true, false, false).ID: return 1747;
			case Fire::Fire(9, false, true, false, true, true).ID: return 1748;
			case Fire::Fire(9, false, true, false, true, false).ID: return 1749;
			case Fire::Fire(9, false, true, false, false, true).ID: return 1750;
			case Fire::Fire(9, false, true, false, false, false).ID: return 1751;
			case Fire::Fire(9, false, false, true, true, true).ID: return 1752;
			case Fire::Fire(9, false, false, true, true, false).ID: return 1753;
			case Fire::Fire(9, false, false, true, false, true).ID: return 1754;
			case Fire::Fire(9, false, false, true, false, false).ID: return 1755;
			case Fire::Fire(9, false, false, false, true, true).ID: return 1756;
			case Fire::Fire(9, false, false, false, true, false).ID: return 1757;
			case Fire::Fire(9, false, false, false, false, true).ID: return 1758;
			case Fire::Fire(9, false, false, false, false, false).ID: return 1759;
			case Fire::Fire(10, true, true, true, true, true).ID: return 1760;
			case Fire::Fire(10, true, true, true, true, false).ID: return 1761;
			case Fire::Fire(10, true, true, true, false, true).ID: return 1762;
			case Fire::Fire(10, true, true, true, false, false).ID: return 1763;
			case Fire::Fire(10, true, true, false, true, true).ID: return 1764;
			case Fire::Fire(10, true, true, false, true, false).ID: return 1765;
			case Fire::Fire(10, true, true, false, false, true).ID: return 1766;
			case Fire::Fire(10, true, true, false, false, false).ID: return 1767;
			case Fire::Fire(10, true, false, true, true, true).ID: return 1768;
			case Fire::Fire(10, true, false, true, true, false).ID: return 1769;
			case Fire::Fire(10, true, false, true, false, true).ID: return 1770;
			case Fire::Fire(10, true, false, true, false, false).ID: return 1771;
			case Fire::Fire(10, true, false, false, true, true).ID: return 1772;
			case Fire::Fire(10, true, false, false, true, false).ID: return 1773;
			case Fire::Fire(10, true, false, false, false, true).ID: return 1774;
			case Fire::Fire(10, true, false, false, false, false).ID: return 1775;
			case Fire::Fire(10, false, true, true, true, true).ID: return 1776;
			case Fire::Fire(10, false, true, true, true, false).ID: return 1777;
			case Fire::Fire(10, false, true, true, false, true).ID: return 1778;
			case Fire::Fire(10, false, true, true, false, false).ID: return 1779;
			case Fire::Fire(10, false, true, false, true, true).ID: return 1780;
			case Fire::Fire(10, false, true, false, true, false).ID: return 1781;
			case Fire::Fire(10, false, true, false, false, true).ID: return 1782;
			case Fire::Fire(10, false, true, false, false, false).ID: return 1783;
			case Fire::Fire(10, false, false, true, true, true).ID: return 1784;
			case Fire::Fire(10, false, false, true, true, false).ID: return 1785;
			case Fire::Fire(10, false, false, true, false, true).ID: return 1786;
			case Fire::Fire(10, false, false, true, false, false).ID: return 1787;
			case Fire::Fire(10, false, false, false, true, true).ID: return 1788;
			case Fire::Fire(10, false, false, false, true, false).ID: return 1789;
			case Fire::Fire(10, false, false, false, false, true).ID: return 1790;
			case Fire::Fire(10, false, false, false, false, false).ID: return 1791;
			case Fire::Fire(11, true, true, true, true, true).ID: return 1792;
			case Fire::Fire(11, true, true, true, true, false).ID: return 1793;
			case Fire::Fire(11, true, true, true, false, true).ID: return 1794;
			case Fire::Fire(11, true, true, true, false, false).ID: return 1795;
			case Fire::Fire(11, true, true, false, true, true).ID: return 1796;
			case Fire::Fire(11, true, true, false, true, false).ID: return 1797;
			case Fire::Fire(11, true, true, false, false, true).ID: return 1798;
			case Fire::Fire(11, true, true, false, false, false).ID: return 1799;
			case Fire::Fire(11, true, false, true, true, true).ID: return 1800;
			case Fire::Fire(11, true, false, true, true, false).ID: return 1801;
			case Fire::Fire(11, true, false, true, false, true).ID: return 1802;
			case Fire::Fire(11, true, false, true, false, false).ID: return 1803;
			case Fire::Fire(11, true, false, false, true, true).ID: return 1804;
			case Fire::Fire(11, true, false, false, true, false).ID: return 1805;
			case Fire::Fire(11, true, false, false, false, true).ID: return 1806;
			case Fire::Fire(11, true, false, false, false, false).ID: return 1807;
			case Fire::Fire(11, false, true, true, true, true).ID: return 1808;
			case Fire::Fire(11, false, true, true, true, false).ID: return 1809;
			case Fire::Fire(11, false, true, true, false, true).ID: return 1810;
			case Fire::Fire(11, false, true, true, false, false).ID: return 1811;
			case Fire::Fire(11, false, true, false, true, true).ID: return 1812;
			case Fire::Fire(11, false, true, false, true, false).ID: return 1813;
			case Fire::Fire(11, false, true, false, false, true).ID: return 1814;
			case Fire::Fire(11, false, true, false, false, false).ID: return 1815;
			case Fire::Fire(11, false, false, true, true, true).ID: return 1816;
			case Fire::Fire(11, false, false, true, true, false).ID: return 1817;
			case Fire::Fire(11, false, false, true, false, true).ID: return 1818;
			case Fire::Fire(11, false, false, true, false, false).ID: return 1819;
			case Fire::Fire(11, false, false, false, true, true).ID: return 1820;
			case Fire::Fire(11, false, false, false, true, false).ID: return 1821;
			case Fire::Fire(11, false, false, false, false, true).ID: return 1822;
			case Fire::Fire(11, false, false, false, false, false).ID: return 1823;
			case Fire::Fire(12, true, true, true, true, true).ID: return 1824;
			case Fire::Fire(12, true, true, true, true, false).ID: return 1825;
			case Fire::Fire(12, true, true, true, false, true).ID: return 1826;
			case Fire::Fire(12, true, true, true, false, false).ID: return 1827;
			case Fire::Fire(12, true, true, false, true, true).ID: return 1828;
			case Fire::Fire(12, true, true, false, true, false).ID: return 1829;
			case Fire::Fire(12, true, true, false, false, true).ID: return 1830;
			case Fire::Fire(12, true, true, false, false, false).ID: return 1831;
			case Fire::Fire(12, true, false, true, true, true).ID: return 1832;
			case Fire::Fire(12, true, false, true, true, false).ID: return 1833;
			case Fire::Fire(12, true, false, true, false, true).ID: return 1834;
			case Fire::Fire(12, true, false, true, false, false).ID: return 1835;
			case Fire::Fire(12, true, false, false, true, true).ID: return 1836;
			case Fire::Fire(12, true, false, false, true, false).ID: return 1837;
			case Fire::Fire(12, true, false, false, false, true).ID: return 1838;
			case Fire::Fire(12, true, false, false, false, false).ID: return 1839;
			case Fire::Fire(12, false, true, true, true, true).ID: return 1840;
			case Fire::Fire(12, false, true, true, true, false).ID: return 1841;
			case Fire::Fire(12, false, true, true, false, true).ID: return 1842;
			case Fire::Fire(12, false, true, true, false, false).ID: return 1843;
			case Fire::Fire(12, false, true, false, true, true).ID: return 1844;
			case Fire::Fire(12, false, true, false, true, false).ID: return 1845;
			case Fire::Fire(12, false, true, false, false, true).ID: return 1846;
			case Fire::Fire(12, false, true, false, false, false).ID: return 1847;
			case Fire::Fire(12, false, false, true, true, true).ID: return 1848;
			case Fire::Fire(12, false, false, true, true, false).ID: return 1849;
			case Fire::Fire(12, false, false, true, false, true).ID: return 1850;
			case Fire::Fire(12, false, false, true, false, false).ID: return 1851;
			case Fire::Fire(12, false, false, false, true, true).ID: return 1852;
			case Fire::Fire(12, false, false, false, true, false).ID: return 1853;
			case Fire::Fire(12, false, false, false, false, true).ID: return 1854;
			case Fire::Fire(12, false, false, false, false, false).ID: return 1855;
			case Fire::Fire(13, true, true, true, true, true).ID: return 1856;
			case Fire::Fire(13, true, true, true, true, false).ID: return 1857;
			case Fire::Fire(13, true, true, true, false, true).ID: return 1858;
			case Fire::Fire(13, true, true, true, false, false).ID: return 1859;
			case Fire::Fire(13, true, true, false, true, true).ID: return 1860;
			case Fire::Fire(13, true, true, false, true, false).ID: return 1861;
			case Fire::Fire(13, true, true, false, false, true).ID: return 1862;
			case Fire::Fire(13, true, true, false, false, false).ID: return 1863;
			case Fire::Fire(13, true, false, true, true, true).ID: return 1864;
			case Fire::Fire(13, true, false, true, true, false).ID: return 1865;
			case Fire::Fire(13, true, false, true, false, true).ID: return 1866;
			case Fire::Fire(13, true, false, true, false, false).ID: return 1867;
			case Fire::Fire(13, true, false, false, true, true).ID: return 1868;
			case Fire::Fire(13, true, false, false, true, false).ID: return 1869;
			case Fire::Fire(13, true, false, false, false, true).ID: return 1870;
			case Fire::Fire(13, true, false, false, false, false).ID: return 1871;
			case Fire::Fire(13, false, true, true, true, true).ID: return 1872;
			case Fire::Fire(13, false, true, true, true, false).ID: return 1873;
			case Fire::Fire(13, false, true, true, false, true).ID: return 1874;
			case Fire::Fire(13, false, true, true, false, false).ID: return 1875;
			case Fire::Fire(13, false, true, false, true, true).ID: return 1876;
			case Fire::Fire(13, false, true, false, true, false).ID: return 1877;
			case Fire::Fire(13, false, true, false, false, true).ID: return 1878;
			case Fire::Fire(13, false, true, false, false, false).ID: return 1879;
			case Fire::Fire(13, false, false, true, true, true).ID: return 1880;
			case Fire::Fire(13, false, false, true, true, false).ID: return 1881;
			case Fire::Fire(13, false, false, true, false, true).ID: return 1882;
			case Fire::Fire(13, false, false, true, false, false).ID: return 1883;
			case Fire::Fire(13, false, false, false, true, true).ID: return 1884;
			case Fire::Fire(13, false, false, false, true, false).ID: return 1885;
			case Fire::Fire(13, false, false, false, false, true).ID: return 1886;
			case Fire::Fire(13, false, false, false, false, false).ID: return 1887;
			case Fire::Fire(14, true, true, true, true, true).ID: return 1888;
			case Fire::Fire(14, true, true, true, true, false).ID: return 1889;
			case Fire::Fire(14, true, true, true, false, true).ID: return 1890;
			case Fire::Fire(14, true, true, true, false, false).ID: return 1891;
			case Fire::Fire(14, true, true, false, true, true).ID: return 1892;
			case Fire::Fire(14, true, true, false, true, false).ID: return 1893;
			case Fire::Fire(14, true, true, false, false, true).ID: return 1894;
			case Fire::Fire(14, true, true, false, false, false).ID: return 1895;
			case Fire::Fire(14, true, false, true, true, true).ID: return 1896;
			case Fire::Fire(14, true, false, true, true, false).ID: return 1897;
			case Fire::Fire(14, true, false, true, false, true).ID: return 1898;
			case Fire::Fire(14, true, false, true, false, false).ID: return 1899;
			case Fire::Fire(14, true, false, false, true, true).ID: return 1900;
			case Fire::Fire(14, true, false, false, true, false).ID: return 1901;
			case Fire::Fire(14, true, false, false, false, true).ID: return 1902;
			case Fire::Fire(14, true, false, false, false, false).ID: return 1903;
			case Fire::Fire(14, false, true, true, true, true).ID: return 1904;
			case Fire::Fire(14, false, true, true, true, false).ID: return 1905;
			case Fire::Fire(14, false, true, true, false, true).ID: return 1906;
			case Fire::Fire(14, false, true, true, false, false).ID: return 1907;
			case Fire::Fire(14, false, true, false, true, true).ID: return 1908;
			case Fire::Fire(14, false, true, false, true, false).ID: return 1909;
			case Fire::Fire(14, false, true, false, false, true).ID: return 1910;
			case Fire::Fire(14, false, true, false, false, false).ID: return 1911;
			case Fire::Fire(14, false, false, true, true, true).ID: return 1912;
			case Fire::Fire(14, false, false, true, true, false).ID: return 1913;
			case Fire::Fire(14, false, false, true, false, true).ID: return 1914;
			case Fire::Fire(14, false, false, true, false, false).ID: return 1915;
			case Fire::Fire(14, false, false, false, true, true).ID: return 1916;
			case Fire::Fire(14, false, false, false, true, false).ID: return 1917;
			case Fire::Fire(14, false, false, false, false, true).ID: return 1918;
			case Fire::Fire(14, false, false, false, false, false).ID: return 1919;
			case Fire::Fire(15, true, true, true, true, true).ID: return 1920;
			case Fire::Fire(15, true, true, true, true, false).ID: return 1921;
			case Fire::Fire(15, true, true, true, false, true).ID: return 1922;
			case Fire::Fire(15, true, true, true, false, false).ID: return 1923;
			case Fire::Fire(15, true, true, false, true, true).ID: return 1924;
			case Fire::Fire(15, true, true, false, true, false).ID: return 1925;
			case Fire::Fire(15, true, true, false, false, true).ID: return 1926;
			case Fire::Fire(15, true, true, false, false, false).ID: return 1927;
			case Fire::Fire(15, true, false, true, true, true).ID: return 1928;
			case Fire::Fire(15, true, false, true, true, false).ID: return 1929;
			case Fire::Fire(15, true, false, true, false, true).ID: return 1930;
			case Fire::Fire(15, true, false, true, false, false).ID: return 1931;
			case Fire::Fire(15, true, false, false, true, true).ID: return 1932;
			case Fire::Fire(15, true, false, false, true, false).ID: return 1933;
			case Fire::Fire(15, true, false, false, false, true).ID: return 1934;
			case Fire::Fire(15, true, false, false, false, false).ID: return 1935;
			case Fire::Fire(15, false, true, true, true, true).ID: return 1936;
			case Fire::Fire(15, false, true, true, true, false).ID: return 1937;
			case Fire::Fire(15, false, true, true, false, true).ID: return 1938;
			case Fire::Fire(15, false, true, true, false, false).ID: return 1939;
			case Fire::Fire(15, false, true, false, true, true).ID: return 1940;
			case Fire::Fire(15, false, true, false, true, false).ID: return 1941;
			case Fire::Fire(15, false, true, false, false, true).ID: return 1942;
			case Fire::Fire(15, false, true, false, false, false).ID: return 1943;
			case Fire::Fire(15, false, false, true, true, true).ID: return 1944;
			case Fire::Fire(15, false, false, true, true, false).ID: return 1945;
			case Fire::Fire(15, false, false, true, false, true).ID: return 1946;
			case Fire::Fire(15, false, false, true, false, false).ID: return 1947;
			case Fire::Fire(15, false, false, false, true, true).ID: return 1948;
			case Fire::Fire(15, false, false, false, true, false).ID: return 1949;
			case Fire::Fire(15, false, false, false, false, true).ID: return 1950;
			case Fire::Fire(15, false, false, false, false, false).ID: return 1951;
			case FireCoral::FireCoral().ID: return 9537;
			case FireCoralBlock::FireCoralBlock().ID: return 9518;
			case FireCoralFan::FireCoralFan().ID: return 9557;
			case FireCoralWallFan::FireCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9625;
			case FireCoralWallFan::FireCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9627;
			case FireCoralWallFan::FireCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9629;
			case FireCoralWallFan::FireCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9631;
			case FletchingTable::FletchingTable().ID: return 14820;
			case FlowerPot::FlowerPot().ID: return 6305;
			case FrostedIce::FrostedIce(0).ID: return 9249;
			case FrostedIce::FrostedIce(1).ID: return 9250;
			case FrostedIce::FrostedIce(2).ID: return 9251;
			case FrostedIce::FrostedIce(3).ID: return 9252;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_ZM, true).ID: return 3373;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_ZM, false).ID: return 3374;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_ZP, true).ID: return 3375;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_ZP, false).ID: return 3376;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_XM, true).ID: return 3377;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_XM, false).ID: return 3378;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_XP, true).ID: return 3379;
			case Furnace::Furnace(eBlockFace::BLOCK_FACE_XP, false).ID: return 3380;
			case GildedBlackstone::GildedBlackstone().ID: return 16664;
			case Glass::Glass().ID: return 231;
			case GlassPane::GlassPane(true, true, true, true).ID: return 4733;
			case GlassPane::GlassPane(true, true, true, false).ID: return 4734;
			case GlassPane::GlassPane(true, true, false, true).ID: return 4737;
			case GlassPane::GlassPane(true, true, false, false).ID: return 4738;
			case GlassPane::GlassPane(true, false, true, true).ID: return 4741;
			case GlassPane::GlassPane(true, false, true, false).ID: return 4742;
			case GlassPane::GlassPane(true, false, false, true).ID: return 4745;
			case GlassPane::GlassPane(true, false, false, false).ID: return 4746;
			case GlassPane::GlassPane(false, true, true, true).ID: return 4749;
			case GlassPane::GlassPane(false, true, true, false).ID: return 4750;
			case GlassPane::GlassPane(false, true, false, true).ID: return 4753;
			case GlassPane::GlassPane(false, true, false, false).ID: return 4754;
			case GlassPane::GlassPane(false, false, true, true).ID: return 4757;
			case GlassPane::GlassPane(false, false, true, false).ID: return 4758;
			case GlassPane::GlassPane(false, false, false, true).ID: return 4761;
			case GlassPane::GlassPane(false, false, false, false).ID: return 4762;
			case Glowstone::Glowstone().ID: return 4013;
			case GoldBlock::GoldBlock().ID: return 1427;
			case GoldOre::GoldOre().ID: return 69;
			case Granite::Granite().ID: return 2;
			case GraniteSlab::GraniteSlab(GraniteSlab::Type::Top).ID: return 10838;
			case GraniteSlab::GraniteSlab(GraniteSlab::Type::Bottom).ID: return 10840;
			case GraniteSlab::GraniteSlab(GraniteSlab::Type::Double).ID: return 10842;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Top, GraniteStairs::Shape::Straight).ID: return 10390;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerLeft).ID: return 10392;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerRight).ID: return 10394;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterLeft).ID: return 10396;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterRight).ID: return 10398;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::Straight).ID: return 10400;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerLeft).ID: return 10402;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerRight).ID: return 10404;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterLeft).ID: return 10406;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterRight).ID: return 10408;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Top, GraniteStairs::Shape::Straight).ID: return 10410;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerLeft).ID: return 10412;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerRight).ID: return 10414;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterLeft).ID: return 10416;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterRight).ID: return 10418;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::Straight).ID: return 10420;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerLeft).ID: return 10422;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerRight).ID: return 10424;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterLeft).ID: return 10426;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_ZP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterRight).ID: return 10428;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Top, GraniteStairs::Shape::Straight).ID: return 10430;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerLeft).ID: return 10432;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerRight).ID: return 10434;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterLeft).ID: return 10436;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterRight).ID: return 10438;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::Straight).ID: return 10440;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerLeft).ID: return 10442;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerRight).ID: return 10444;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterLeft).ID: return 10446;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XM, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterRight).ID: return 10448;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Top, GraniteStairs::Shape::Straight).ID: return 10450;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerLeft).ID: return 10452;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Top, GraniteStairs::Shape::InnerRight).ID: return 10454;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterLeft).ID: return 10456;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Top, GraniteStairs::Shape::OuterRight).ID: return 10458;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::Straight).ID: return 10460;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerLeft).ID: return 10462;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::InnerRight).ID: return 10464;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterLeft).ID: return 10466;
			case GraniteStairs::GraniteStairs(eBlockFace::BLOCK_FACE_XP, GraniteStairs::Half::Bottom, GraniteStairs::Shape::OuterRight).ID: return 10468;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12166;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12167;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12168;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12172;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12173;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12174;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12178;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12179;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12180;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12184;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12185;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12186;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12190;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12191;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12192;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12196;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12197;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12198;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12202;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12203;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12204;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12208;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12209;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12210;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12214;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12215;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12216;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12220;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12221;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12222;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12226;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12227;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12228;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12232;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12233;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12234;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12238;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12239;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12240;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12244;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12245;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12246;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12250;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12251;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12252;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12256;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12257;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12258;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12262;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12263;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12264;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12268;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12269;
			case GraniteWall::GraniteWall(GraniteWall::East::None, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12270;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12274;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12275;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12276;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12280;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12281;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12282;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12286;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12287;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12288;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12292;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12293;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12294;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12298;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12299;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12300;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12304;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12305;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12306;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12310;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12311;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12312;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12316;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12317;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12318;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12322;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12323;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12324;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12328;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12329;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12330;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12334;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12335;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12336;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12340;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12341;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12342;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12346;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12347;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12348;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12352;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12353;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12354;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12358;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12359;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12360;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12364;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12365;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12366;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12370;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12371;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12372;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12376;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12377;
			case GraniteWall::GraniteWall(GraniteWall::East::Low, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12378;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12382;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12383;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12384;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12388;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12389;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12390;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12394;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12395;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12396;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12400;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12401;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12402;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12406;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12407;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12408;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12412;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12413;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::None, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12414;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12418;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12419;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12420;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12424;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12425;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12426;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12430;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12431;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12432;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12436;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12437;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12438;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12442;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12443;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12444;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12448;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12449;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Low, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12450;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::None).ID: return 12454;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::Low).ID: return 12455;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::None, true, GraniteWall::West::Tall).ID: return 12456;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::None).ID: return 12460;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::Low).ID: return 12461;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::None, false, GraniteWall::West::Tall).ID: return 12462;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::None).ID: return 12466;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::Low).ID: return 12467;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Low, true, GraniteWall::West::Tall).ID: return 12468;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::None).ID: return 12472;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::Low).ID: return 12473;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Low, false, GraniteWall::West::Tall).ID: return 12474;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::None).ID: return 12478;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::Low).ID: return 12479;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Tall, true, GraniteWall::West::Tall).ID: return 12480;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::None).ID: return 12484;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::Low).ID: return 12485;
			case GraniteWall::GraniteWall(GraniteWall::East::Tall, GraniteWall::North::Tall, GraniteWall::South::Tall, false, GraniteWall::West::Tall).ID: return 12486;
			case Grass::Grass().ID: return 1342;
			case GrassBlock::GrassBlock(true).ID: return 8;
			case GrassBlock::GrassBlock(false).ID: return 9;
			case GrassPath::GrassPath().ID: return 9223;
			case Gravel::Gravel().ID: return 68;
			case GrayBanner::GrayBanner(0).ID: return 8009;
			case GrayBanner::GrayBanner(1).ID: return 8010;
			case GrayBanner::GrayBanner(2).ID: return 8011;
			case GrayBanner::GrayBanner(3).ID: return 8012;
			case GrayBanner::GrayBanner(4).ID: return 8013;
			case GrayBanner::GrayBanner(5).ID: return 8014;
			case GrayBanner::GrayBanner(6).ID: return 8015;
			case GrayBanner::GrayBanner(7).ID: return 8016;
			case GrayBanner::GrayBanner(8).ID: return 8017;
			case GrayBanner::GrayBanner(9).ID: return 8018;
			case GrayBanner::GrayBanner(10).ID: return 8019;
			case GrayBanner::GrayBanner(11).ID: return 8020;
			case GrayBanner::GrayBanner(12).ID: return 8021;
			case GrayBanner::GrayBanner(13).ID: return 8022;
			case GrayBanner::GrayBanner(14).ID: return 8023;
			case GrayBanner::GrayBanner(15).ID: return 8024;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZM, true, GrayBed::Part::Head).ID: return 1161;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZM, true, GrayBed::Part::Foot).ID: return 1162;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZM, false, GrayBed::Part::Head).ID: return 1163;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZM, false, GrayBed::Part::Foot).ID: return 1164;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZP, true, GrayBed::Part::Head).ID: return 1165;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZP, true, GrayBed::Part::Foot).ID: return 1166;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZP, false, GrayBed::Part::Head).ID: return 1167;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_ZP, false, GrayBed::Part::Foot).ID: return 1168;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XM, true, GrayBed::Part::Head).ID: return 1169;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XM, true, GrayBed::Part::Foot).ID: return 1170;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XM, false, GrayBed::Part::Head).ID: return 1171;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XM, false, GrayBed::Part::Foot).ID: return 1172;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XP, true, GrayBed::Part::Head).ID: return 1173;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XP, true, GrayBed::Part::Foot).ID: return 1174;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XP, false, GrayBed::Part::Head).ID: return 1175;
			case GrayBed::GrayBed(eBlockFace::BLOCK_FACE_XP, false, GrayBed::Part::Foot).ID: return 1176;
			case GrayCarpet::GrayCarpet().ID: return 7873;
			case GrayConcrete::GrayConcrete().ID: return 9445;
			case GrayConcretePowder::GrayConcretePowder().ID: return 9461;
			case GrayGlazedTerracotta::GrayGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9402;
			case GrayGlazedTerracotta::GrayGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9403;
			case GrayGlazedTerracotta::GrayGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9404;
			case GrayGlazedTerracotta::GrayGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9405;
			case GrayShulkerBox::GrayShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9320;
			case GrayShulkerBox::GrayShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9321;
			case GrayShulkerBox::GrayShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9322;
			case GrayShulkerBox::GrayShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9323;
			case GrayShulkerBox::GrayShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9324;
			case GrayShulkerBox::GrayShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9325;
			case GrayStainedGlass::GrayStainedGlass().ID: return 4102;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, true, true, true).ID: return 7089;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, true, true, false).ID: return 7090;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, true, false, true).ID: return 7093;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, true, false, false).ID: return 7094;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, false, true, true).ID: return 7097;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, false, true, false).ID: return 7098;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, false, false, true).ID: return 7101;
			case GrayStainedGlassPane::GrayStainedGlassPane(true, false, false, false).ID: return 7102;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, true, true, true).ID: return 7105;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, true, true, false).ID: return 7106;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, true, false, true).ID: return 7109;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, true, false, false).ID: return 7110;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, false, true, true).ID: return 7113;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, false, true, false).ID: return 7114;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, false, false, true).ID: return 7117;
			case GrayStainedGlassPane::GrayStainedGlassPane(false, false, false, false).ID: return 7118;
			case GrayTerracotta::GrayTerracotta().ID: return 6854;
			case GrayWallBanner::GrayWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8181;
			case GrayWallBanner::GrayWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8182;
			case GrayWallBanner::GrayWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8183;
			case GrayWallBanner::GrayWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8184;
			case GrayWool::GrayWool().ID: return 1391;
			case GreenBanner::GreenBanner(0).ID: return 8105;
			case GreenBanner::GreenBanner(1).ID: return 8106;
			case GreenBanner::GreenBanner(2).ID: return 8107;
			case GreenBanner::GreenBanner(3).ID: return 8108;
			case GreenBanner::GreenBanner(4).ID: return 8109;
			case GreenBanner::GreenBanner(5).ID: return 8110;
			case GreenBanner::GreenBanner(6).ID: return 8111;
			case GreenBanner::GreenBanner(7).ID: return 8112;
			case GreenBanner::GreenBanner(8).ID: return 8113;
			case GreenBanner::GreenBanner(9).ID: return 8114;
			case GreenBanner::GreenBanner(10).ID: return 8115;
			case GreenBanner::GreenBanner(11).ID: return 8116;
			case GreenBanner::GreenBanner(12).ID: return 8117;
			case GreenBanner::GreenBanner(13).ID: return 8118;
			case GreenBanner::GreenBanner(14).ID: return 8119;
			case GreenBanner::GreenBanner(15).ID: return 8120;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZM, true, GreenBed::Part::Head).ID: return 1257;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZM, true, GreenBed::Part::Foot).ID: return 1258;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZM, false, GreenBed::Part::Head).ID: return 1259;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZM, false, GreenBed::Part::Foot).ID: return 1260;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZP, true, GreenBed::Part::Head).ID: return 1261;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZP, true, GreenBed::Part::Foot).ID: return 1262;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZP, false, GreenBed::Part::Head).ID: return 1263;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_ZP, false, GreenBed::Part::Foot).ID: return 1264;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XM, true, GreenBed::Part::Head).ID: return 1265;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XM, true, GreenBed::Part::Foot).ID: return 1266;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XM, false, GreenBed::Part::Head).ID: return 1267;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XM, false, GreenBed::Part::Foot).ID: return 1268;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XP, true, GreenBed::Part::Head).ID: return 1269;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XP, true, GreenBed::Part::Foot).ID: return 1270;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XP, false, GreenBed::Part::Head).ID: return 1271;
			case GreenBed::GreenBed(eBlockFace::BLOCK_FACE_XP, false, GreenBed::Part::Foot).ID: return 1272;
			case GreenCarpet::GreenCarpet().ID: return 7879;
			case GreenConcrete::GreenConcrete().ID: return 9451;
			case GreenConcretePowder::GreenConcretePowder().ID: return 9467;
			case GreenGlazedTerracotta::GreenGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9426;
			case GreenGlazedTerracotta::GreenGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9427;
			case GreenGlazedTerracotta::GreenGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9428;
			case GreenGlazedTerracotta::GreenGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9429;
			case GreenShulkerBox::GreenShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9356;
			case GreenShulkerBox::GreenShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9357;
			case GreenShulkerBox::GreenShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9358;
			case GreenShulkerBox::GreenShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9359;
			case GreenShulkerBox::GreenShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9360;
			case GreenShulkerBox::GreenShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9361;
			case GreenStainedGlass::GreenStainedGlass().ID: return 4108;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, true, true, true).ID: return 7281;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, true, true, false).ID: return 7282;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, true, false, true).ID: return 7285;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, true, false, false).ID: return 7286;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, false, true, true).ID: return 7289;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, false, true, false).ID: return 7290;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, false, false, true).ID: return 7293;
			case GreenStainedGlassPane::GreenStainedGlassPane(true, false, false, false).ID: return 7294;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, true, true, true).ID: return 7297;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, true, true, false).ID: return 7298;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, true, false, true).ID: return 7301;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, true, false, false).ID: return 7302;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, false, true, true).ID: return 7305;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, false, true, false).ID: return 7306;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, false, false, true).ID: return 7309;
			case GreenStainedGlassPane::GreenStainedGlassPane(false, false, false, false).ID: return 7310;
			case GreenTerracotta::GreenTerracotta().ID: return 6860;
			case GreenWallBanner::GreenWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8205;
			case GreenWallBanner::GreenWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8206;
			case GreenWallBanner::GreenWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8207;
			case GreenWallBanner::GreenWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8208;
			case GreenWool::GreenWool().ID: return 1397;
			case Grindstone::Grindstone(Grindstone::Face::Floor, eBlockFace::BLOCK_FACE_ZM).ID: return 14821;
			case Grindstone::Grindstone(Grindstone::Face::Floor, eBlockFace::BLOCK_FACE_ZP).ID: return 14822;
			case Grindstone::Grindstone(Grindstone::Face::Floor, eBlockFace::BLOCK_FACE_XM).ID: return 14823;
			case Grindstone::Grindstone(Grindstone::Face::Floor, eBlockFace::BLOCK_FACE_XP).ID: return 14824;
			case Grindstone::Grindstone(Grindstone::Face::Wall, eBlockFace::BLOCK_FACE_ZM).ID: return 14825;
			case Grindstone::Grindstone(Grindstone::Face::Wall, eBlockFace::BLOCK_FACE_ZP).ID: return 14826;
			case Grindstone::Grindstone(Grindstone::Face::Wall, eBlockFace::BLOCK_FACE_XM).ID: return 14827;
			case Grindstone::Grindstone(Grindstone::Face::Wall, eBlockFace::BLOCK_FACE_XP).ID: return 14828;
			case Grindstone::Grindstone(Grindstone::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM).ID: return 14829;
			case Grindstone::Grindstone(Grindstone::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP).ID: return 14830;
			case Grindstone::Grindstone(Grindstone::Face::Ceiling, eBlockFace::BLOCK_FACE_XM).ID: return 14831;
			case Grindstone::Grindstone(Grindstone::Face::Ceiling, eBlockFace::BLOCK_FACE_XP).ID: return 14832;
			case HayBale::HayBale(HayBale::Axis::X).ID: return 7863;
			case HayBale::HayBale(HayBale::Axis::Y).ID: return 7864;
			case HayBale::HayBale(HayBale::Axis::Z).ID: return 7865;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(0).ID: return 6662;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(1).ID: return 6663;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(2).ID: return 6664;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(3).ID: return 6665;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(4).ID: return 6666;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(5).ID: return 6667;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(6).ID: return 6668;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(7).ID: return 6669;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(8).ID: return 6670;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(9).ID: return 6671;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(10).ID: return 6672;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(11).ID: return 6673;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(12).ID: return 6674;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(13).ID: return 6675;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(14).ID: return 6676;
			case HeavyWeightedPressurePlate::HeavyWeightedPressurePlate(15).ID: return 6677;
			case HoneyBlock::HoneyBlock().ID: return 15824;
			case HoneycombBlock::HoneycombBlock().ID: return 15825;
			case Hopper::Hopper(true, eBlockFace::BLOCK_FACE_YM).ID: return 6728;
			case Hopper::Hopper(true, eBlockFace::BLOCK_FACE_ZM).ID: return 6729;
			case Hopper::Hopper(true, eBlockFace::BLOCK_FACE_ZP).ID: return 6730;
			case Hopper::Hopper(true, eBlockFace::BLOCK_FACE_XM).ID: return 6731;
			case Hopper::Hopper(true, eBlockFace::BLOCK_FACE_XP).ID: return 6732;
			case Hopper::Hopper(false, eBlockFace::BLOCK_FACE_YM).ID: return 6733;
			case Hopper::Hopper(false, eBlockFace::BLOCK_FACE_ZM).ID: return 6734;
			case Hopper::Hopper(false, eBlockFace::BLOCK_FACE_ZP).ID: return 6735;
			case Hopper::Hopper(false, eBlockFace::BLOCK_FACE_XM).ID: return 6736;
			case Hopper::Hopper(false, eBlockFace::BLOCK_FACE_XP).ID: return 6737;
			case HornCoral::HornCoral().ID: return 9539;
			case HornCoralBlock::HornCoralBlock().ID: return 9519;
			case HornCoralFan::HornCoralFan().ID: return 9559;
			case HornCoralWallFan::HornCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9633;
			case HornCoralWallFan::HornCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9635;
			case HornCoralWallFan::HornCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9637;
			case HornCoralWallFan::HornCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9639;
			case Ice::Ice().ID: return 3929;
			case InfestedChiseledStoneBricks::InfestedChiseledStoneBricks().ID: return 4504;
			case InfestedCobblestone::InfestedCobblestone().ID: return 4500;
			case InfestedCrackedStoneBricks::InfestedCrackedStoneBricks().ID: return 4503;
			case InfestedMossyStoneBricks::InfestedMossyStoneBricks().ID: return 4502;
			case InfestedStone::InfestedStone().ID: return 4499;
			case InfestedStoneBricks::InfestedStoneBricks().ID: return 4501;
			case IronBars::IronBars(true, true, true, true).ID: return 4699;
			case IronBars::IronBars(true, true, true, false).ID: return 4700;
			case IronBars::IronBars(true, true, false, true).ID: return 4703;
			case IronBars::IronBars(true, true, false, false).ID: return 4704;
			case IronBars::IronBars(true, false, true, true).ID: return 4707;
			case IronBars::IronBars(true, false, true, false).ID: return 4708;
			case IronBars::IronBars(true, false, false, true).ID: return 4711;
			case IronBars::IronBars(true, false, false, false).ID: return 4712;
			case IronBars::IronBars(false, true, true, true).ID: return 4715;
			case IronBars::IronBars(false, true, true, false).ID: return 4716;
			case IronBars::IronBars(false, true, false, true).ID: return 4719;
			case IronBars::IronBars(false, true, false, false).ID: return 4720;
			case IronBars::IronBars(false, false, true, true).ID: return 4723;
			case IronBars::IronBars(false, false, true, false).ID: return 4724;
			case IronBars::IronBars(false, false, false, true).ID: return 4727;
			case IronBars::IronBars(false, false, false, false).ID: return 4728;
			case IronBlock::IronBlock().ID: return 1428;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, true).ID: return 3809;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, false).ID: return 3810;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, true).ID: return 3811;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, false).ID: return 3812;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, true).ID: return 3813;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, false).ID: return 3814;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, true).ID: return 3815;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, false).ID: return 3816;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, true).ID: return 3817;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, false).ID: return 3818;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, true).ID: return 3819;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, false).ID: return 3820;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, true).ID: return 3821;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, false).ID: return 3822;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, true).ID: return 3823;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZM, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, false).ID: return 3824;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, true).ID: return 3825;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, false).ID: return 3826;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, true).ID: return 3827;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, false).ID: return 3828;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, true).ID: return 3829;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, false).ID: return 3830;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, true).ID: return 3831;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, false).ID: return 3832;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, true).ID: return 3833;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, false).ID: return 3834;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, true).ID: return 3835;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, false).ID: return 3836;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, true).ID: return 3837;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, false).ID: return 3838;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, true).ID: return 3839;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_ZP, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, false).ID: return 3840;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, true).ID: return 3841;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, false).ID: return 3842;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, true).ID: return 3843;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, false).ID: return 3844;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, true).ID: return 3845;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, false).ID: return 3846;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, true).ID: return 3847;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, false).ID: return 3848;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, true).ID: return 3849;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, false).ID: return 3850;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, true).ID: return 3851;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, false).ID: return 3852;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, true).ID: return 3853;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, false).ID: return 3854;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, true).ID: return 3855;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XM, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, false).ID: return 3856;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, true).ID: return 3857;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Left, true, false).ID: return 3858;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, true).ID: return 3859;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Left, false, false).ID: return 3860;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, true).ID: return 3861;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Right, true, false).ID: return 3862;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, true).ID: return 3863;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Upper, IronDoor::Hinge::Right, false, false).ID: return 3864;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, true).ID: return 3865;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Left, true, false).ID: return 3866;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, true).ID: return 3867;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Left, false, false).ID: return 3868;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, true).ID: return 3869;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Right, true, false).ID: return 3870;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, true).ID: return 3871;
			case IronDoor::IronDoor(eBlockFace::BLOCK_FACE_XP, IronDoor::Half::Lower, IronDoor::Hinge::Right, false, false).ID: return 3872;
			case IronOre::IronOre().ID: return 70;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Top, true, true).ID: return 7538;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Top, true, false).ID: return 7540;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Top, false, true).ID: return 7542;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Top, false, false).ID: return 7544;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Bottom, true, true).ID: return 7546;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Bottom, true, false).ID: return 7548;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Bottom, false, true).ID: return 7550;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZM, IronTrapdoor::Half::Bottom, false, false).ID: return 7552;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Top, true, true).ID: return 7554;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Top, true, false).ID: return 7556;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Top, false, true).ID: return 7558;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Top, false, false).ID: return 7560;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Bottom, true, true).ID: return 7562;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Bottom, true, false).ID: return 7564;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Bottom, false, true).ID: return 7566;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_ZP, IronTrapdoor::Half::Bottom, false, false).ID: return 7568;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Top, true, true).ID: return 7570;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Top, true, false).ID: return 7572;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Top, false, true).ID: return 7574;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Top, false, false).ID: return 7576;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Bottom, true, true).ID: return 7578;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Bottom, true, false).ID: return 7580;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Bottom, false, true).ID: return 7582;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XM, IronTrapdoor::Half::Bottom, false, false).ID: return 7584;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Top, true, true).ID: return 7586;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Top, true, false).ID: return 7588;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Top, false, true).ID: return 7590;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Top, false, false).ID: return 7592;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Bottom, true, true).ID: return 7594;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Bottom, true, false).ID: return 7596;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Bottom, false, true).ID: return 7598;
			case IronTrapdoor::IronTrapdoor(eBlockFace::BLOCK_FACE_XP, IronTrapdoor::Half::Bottom, false, false).ID: return 7600;
			case JackOLantern::JackOLantern(eBlockFace::BLOCK_FACE_ZM).ID: return 4020;
			case JackOLantern::JackOLantern(eBlockFace::BLOCK_FACE_ZP).ID: return 4021;
			case JackOLantern::JackOLantern(eBlockFace::BLOCK_FACE_XM).ID: return 4022;
			case JackOLantern::JackOLantern(eBlockFace::BLOCK_FACE_XP).ID: return 4023;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::DownEast).ID: return 15739;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::DownNorth).ID: return 15740;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::DownSouth).ID: return 15741;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::DownWest).ID: return 15742;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::UpEast).ID: return 15743;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::UpNorth).ID: return 15744;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::UpSouth).ID: return 15745;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::UpWest).ID: return 15746;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::WestUp).ID: return 15747;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::EastUp).ID: return 15748;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::NorthUp).ID: return 15749;
			case Jigsaw::Jigsaw(Jigsaw::Orientation::SouthUp).ID: return 15750;
			case Jukebox::Jukebox(true).ID: return 3964;
			case Jukebox::Jukebox(false).ID: return 3965;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6418;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6419;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6420;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6421;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 6422;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 6423;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 6424;
			case JungleButton::JungleButton(JungleButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 6425;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6426;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6427;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6428;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6429;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 6430;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 6431;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 6432;
			case JungleButton::JungleButton(JungleButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 6433;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6434;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6435;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6436;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6437;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 6438;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 6439;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 6440;
			case JungleButton::JungleButton(JungleButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 6441;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, true).ID: return 8866;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, false).ID: return 8867;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, true).ID: return 8868;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, false).ID: return 8869;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, true).ID: return 8870;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, false).ID: return 8871;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, true).ID: return 8872;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, false).ID: return 8873;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, true).ID: return 8874;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, false).ID: return 8875;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, true).ID: return 8876;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, false).ID: return 8877;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, true).ID: return 8878;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, false).ID: return 8879;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, true).ID: return 8880;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, false).ID: return 8881;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, true).ID: return 8882;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, false).ID: return 8883;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, true).ID: return 8884;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, false).ID: return 8885;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, true).ID: return 8886;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, false).ID: return 8887;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, true).ID: return 8888;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, false).ID: return 8889;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, true).ID: return 8890;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, false).ID: return 8891;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, true).ID: return 8892;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, false).ID: return 8893;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, true).ID: return 8894;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, false).ID: return 8895;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, true).ID: return 8896;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_ZP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, false).ID: return 8897;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, true).ID: return 8898;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, false).ID: return 8899;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, true).ID: return 8900;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, false).ID: return 8901;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, true).ID: return 8902;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, false).ID: return 8903;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, true).ID: return 8904;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, false).ID: return 8905;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, true).ID: return 8906;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, false).ID: return 8907;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, true).ID: return 8908;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, false).ID: return 8909;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, true).ID: return 8910;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, false).ID: return 8911;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, true).ID: return 8912;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XM, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, false).ID: return 8913;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, true).ID: return 8914;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, true, false).ID: return 8915;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, true).ID: return 8916;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Left, false, false).ID: return 8917;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, true).ID: return 8918;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, true, false).ID: return 8919;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, true).ID: return 8920;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Upper, JungleDoor::Hinge::Right, false, false).ID: return 8921;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, true).ID: return 8922;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, true, false).ID: return 8923;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, true).ID: return 8924;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Left, false, false).ID: return 8925;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, true).ID: return 8926;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, true, false).ID: return 8927;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, true).ID: return 8928;
			case JungleDoor::JungleDoor(eBlockFace::BLOCK_FACE_XP, JungleDoor::Half::Lower, JungleDoor::Hinge::Right, false, false).ID: return 8929;
			case JungleFence::JungleFence(true, true, true, true).ID: return 8644;
			case JungleFence::JungleFence(true, true, true, false).ID: return 8645;
			case JungleFence::JungleFence(true, true, false, true).ID: return 8648;
			case JungleFence::JungleFence(true, true, false, false).ID: return 8649;
			case JungleFence::JungleFence(true, false, true, true).ID: return 8652;
			case JungleFence::JungleFence(true, false, true, false).ID: return 8653;
			case JungleFence::JungleFence(true, false, false, true).ID: return 8656;
			case JungleFence::JungleFence(true, false, false, false).ID: return 8657;
			case JungleFence::JungleFence(false, true, true, true).ID: return 8660;
			case JungleFence::JungleFence(false, true, true, false).ID: return 8661;
			case JungleFence::JungleFence(false, true, false, true).ID: return 8664;
			case JungleFence::JungleFence(false, true, false, false).ID: return 8665;
			case JungleFence::JungleFence(false, false, true, true).ID: return 8668;
			case JungleFence::JungleFence(false, false, true, false).ID: return 8669;
			case JungleFence::JungleFence(false, false, false, true).ID: return 8672;
			case JungleFence::JungleFence(false, false, false, false).ID: return 8673;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 8482;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 8483;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 8484;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 8485;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 8486;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 8487;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 8488;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 8489;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 8490;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 8491;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 8492;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 8493;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 8494;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 8495;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 8496;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 8497;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 8498;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 8499;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 8500;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 8501;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 8502;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 8503;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 8504;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 8505;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 8506;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 8507;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 8508;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 8509;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 8510;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 8511;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 8512;
			case JungleFenceGate::JungleFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 8513;
			case JungleLeaves::JungleLeaves(1, true).ID: return 187;
			case JungleLeaves::JungleLeaves(1, false).ID: return 188;
			case JungleLeaves::JungleLeaves(2, true).ID: return 189;
			case JungleLeaves::JungleLeaves(2, false).ID: return 190;
			case JungleLeaves::JungleLeaves(3, true).ID: return 191;
			case JungleLeaves::JungleLeaves(3, false).ID: return 192;
			case JungleLeaves::JungleLeaves(4, true).ID: return 193;
			case JungleLeaves::JungleLeaves(4, false).ID: return 194;
			case JungleLeaves::JungleLeaves(5, true).ID: return 195;
			case JungleLeaves::JungleLeaves(5, false).ID: return 196;
			case JungleLeaves::JungleLeaves(6, true).ID: return 197;
			case JungleLeaves::JungleLeaves(6, false).ID: return 198;
			case JungleLeaves::JungleLeaves(7, true).ID: return 199;
			case JungleLeaves::JungleLeaves(7, false).ID: return 200;
			case JungleLog::JungleLog(JungleLog::Axis::X).ID: return 82;
			case JungleLog::JungleLog(JungleLog::Axis::Y).ID: return 83;
			case JungleLog::JungleLog(JungleLog::Axis::Z).ID: return 84;
			case JunglePlanks::JunglePlanks().ID: return 18;
			case JunglePressurePlate::JunglePressurePlate(true).ID: return 3879;
			case JunglePressurePlate::JunglePressurePlate(false).ID: return 3880;
			case JungleSapling::JungleSapling(0).ID: return 27;
			case JungleSapling::JungleSapling(1).ID: return 28;
			case JungleSign::JungleSign(0).ID: return 3510;
			case JungleSign::JungleSign(1).ID: return 3512;
			case JungleSign::JungleSign(2).ID: return 3514;
			case JungleSign::JungleSign(3).ID: return 3516;
			case JungleSign::JungleSign(4).ID: return 3518;
			case JungleSign::JungleSign(5).ID: return 3520;
			case JungleSign::JungleSign(6).ID: return 3522;
			case JungleSign::JungleSign(7).ID: return 3524;
			case JungleSign::JungleSign(8).ID: return 3526;
			case JungleSign::JungleSign(9).ID: return 3528;
			case JungleSign::JungleSign(10).ID: return 3530;
			case JungleSign::JungleSign(11).ID: return 3532;
			case JungleSign::JungleSign(12).ID: return 3534;
			case JungleSign::JungleSign(13).ID: return 3536;
			case JungleSign::JungleSign(14).ID: return 3538;
			case JungleSign::JungleSign(15).ID: return 3540;
			case JungleSlab::JungleSlab(JungleSlab::Type::Top).ID: return 8319;
			case JungleSlab::JungleSlab(JungleSlab::Type::Bottom).ID: return 8321;
			case JungleSlab::JungleSlab(JungleSlab::Type::Double).ID: return 8323;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Top, JungleStairs::Shape::Straight).ID: return 5565;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Top, JungleStairs::Shape::InnerLeft).ID: return 5567;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Top, JungleStairs::Shape::InnerRight).ID: return 5569;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Top, JungleStairs::Shape::OuterLeft).ID: return 5571;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Top, JungleStairs::Shape::OuterRight).ID: return 5573;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Bottom, JungleStairs::Shape::Straight).ID: return 5575;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerLeft).ID: return 5577;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerRight).ID: return 5579;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterLeft).ID: return 5581;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZM, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterRight).ID: return 5583;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Top, JungleStairs::Shape::Straight).ID: return 5585;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Top, JungleStairs::Shape::InnerLeft).ID: return 5587;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Top, JungleStairs::Shape::InnerRight).ID: return 5589;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Top, JungleStairs::Shape::OuterLeft).ID: return 5591;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Top, JungleStairs::Shape::OuterRight).ID: return 5593;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Bottom, JungleStairs::Shape::Straight).ID: return 5595;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerLeft).ID: return 5597;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerRight).ID: return 5599;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterLeft).ID: return 5601;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_ZP, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterRight).ID: return 5603;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Top, JungleStairs::Shape::Straight).ID: return 5605;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Top, JungleStairs::Shape::InnerLeft).ID: return 5607;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Top, JungleStairs::Shape::InnerRight).ID: return 5609;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Top, JungleStairs::Shape::OuterLeft).ID: return 5611;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Top, JungleStairs::Shape::OuterRight).ID: return 5613;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Bottom, JungleStairs::Shape::Straight).ID: return 5615;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerLeft).ID: return 5617;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerRight).ID: return 5619;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterLeft).ID: return 5621;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XM, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterRight).ID: return 5623;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Top, JungleStairs::Shape::Straight).ID: return 5625;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Top, JungleStairs::Shape::InnerLeft).ID: return 5627;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Top, JungleStairs::Shape::InnerRight).ID: return 5629;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Top, JungleStairs::Shape::OuterLeft).ID: return 5631;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Top, JungleStairs::Shape::OuterRight).ID: return 5633;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Bottom, JungleStairs::Shape::Straight).ID: return 5635;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerLeft).ID: return 5637;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Bottom, JungleStairs::Shape::InnerRight).ID: return 5639;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterLeft).ID: return 5641;
			case JungleStairs::JungleStairs(eBlockFace::BLOCK_FACE_XP, JungleStairs::Half::Bottom, JungleStairs::Shape::OuterRight).ID: return 5643;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Top, true, true).ID: return 4304;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Top, true, false).ID: return 4306;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Top, false, true).ID: return 4308;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Top, false, false).ID: return 4310;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Bottom, true, true).ID: return 4312;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Bottom, true, false).ID: return 4314;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Bottom, false, true).ID: return 4316;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZM, JungleTrapdoor::Half::Bottom, false, false).ID: return 4318;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Top, true, true).ID: return 4320;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Top, true, false).ID: return 4322;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Top, false, true).ID: return 4324;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Top, false, false).ID: return 4326;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Bottom, true, true).ID: return 4328;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Bottom, true, false).ID: return 4330;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Bottom, false, true).ID: return 4332;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_ZP, JungleTrapdoor::Half::Bottom, false, false).ID: return 4334;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Top, true, true).ID: return 4336;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Top, true, false).ID: return 4338;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Top, false, true).ID: return 4340;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Top, false, false).ID: return 4342;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Bottom, true, true).ID: return 4344;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Bottom, true, false).ID: return 4346;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Bottom, false, true).ID: return 4348;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XM, JungleTrapdoor::Half::Bottom, false, false).ID: return 4350;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Top, true, true).ID: return 4352;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Top, true, false).ID: return 4354;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Top, false, true).ID: return 4356;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Top, false, false).ID: return 4358;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Bottom, true, true).ID: return 4360;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Bottom, true, false).ID: return 4362;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Bottom, false, true).ID: return 4364;
			case JungleTrapdoor::JungleTrapdoor(eBlockFace::BLOCK_FACE_XP, JungleTrapdoor::Half::Bottom, false, false).ID: return 4366;
			case JungleWallSign::JungleWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 3768;
			case JungleWallSign::JungleWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 3770;
			case JungleWallSign::JungleWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 3772;
			case JungleWallSign::JungleWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 3774;
			case JungleWood::JungleWood(JungleWood::Axis::X).ID: return 118;
			case JungleWood::JungleWood(JungleWood::Axis::Y).ID: return 119;
			case JungleWood::JungleWood(JungleWood::Axis::Z).ID: return 120;
			case Kelp::Kelp(0).ID: return 9470;
			case Kelp::Kelp(1).ID: return 9471;
			case Kelp::Kelp(2).ID: return 9472;
			case Kelp::Kelp(3).ID: return 9473;
			case Kelp::Kelp(4).ID: return 9474;
			case Kelp::Kelp(5).ID: return 9475;
			case Kelp::Kelp(6).ID: return 9476;
			case Kelp::Kelp(7).ID: return 9477;
			case Kelp::Kelp(8).ID: return 9478;
			case Kelp::Kelp(9).ID: return 9479;
			case Kelp::Kelp(10).ID: return 9480;
			case Kelp::Kelp(11).ID: return 9481;
			case Kelp::Kelp(12).ID: return 9482;
			case Kelp::Kelp(13).ID: return 9483;
			case Kelp::Kelp(14).ID: return 9484;
			case Kelp::Kelp(15).ID: return 9485;
			case Kelp::Kelp(16).ID: return 9486;
			case Kelp::Kelp(17).ID: return 9487;
			case Kelp::Kelp(18).ID: return 9488;
			case Kelp::Kelp(19).ID: return 9489;
			case Kelp::Kelp(20).ID: return 9490;
			case Kelp::Kelp(21).ID: return 9491;
			case Kelp::Kelp(22).ID: return 9492;
			case Kelp::Kelp(23).ID: return 9493;
			case Kelp::Kelp(24).ID: return 9494;
			case Kelp::Kelp(25).ID: return 9495;
			case KelpPlant::KelpPlant().ID: return 9496;
			case Ladder::Ladder(eBlockFace::BLOCK_FACE_ZM).ID: return 3638;
			case Ladder::Ladder(eBlockFace::BLOCK_FACE_ZP).ID: return 3640;
			case Ladder::Ladder(eBlockFace::BLOCK_FACE_XM).ID: return 3642;
			case Ladder::Ladder(eBlockFace::BLOCK_FACE_XP).ID: return 3644;
			case Lantern::Lantern(true).ID: return 14886;
			case Lantern::Lantern(false).ID: return 14887;
			case LapisBlock::LapisBlock().ID: return 233;
			case LapisOre::LapisOre().ID: return 232;
			case LargeFern::LargeFern(LargeFern::Half::Upper).ID: return 7895;
			case LargeFern::LargeFern(LargeFern::Half::Lower).ID: return 7896;
			case Lava::Lava(0).ID: return 50;
			case Lava::Lava(1).ID: return 51;
			case Lava::Lava(2).ID: return 52;
			case Lava::Lava(3).ID: return 53;
			case Lava::Lava(4).ID: return 54;
			case Lava::Lava(5).ID: return 55;
			case Lava::Lava(6).ID: return 56;
			case Lava::Lava(7).ID: return 57;
			case Lava::Lava(8).ID: return 58;
			case Lava::Lava(9).ID: return 59;
			case Lava::Lava(10).ID: return 60;
			case Lava::Lava(11).ID: return 61;
			case Lava::Lava(12).ID: return 62;
			case Lava::Lava(13).ID: return 63;
			case Lava::Lava(14).ID: return 64;
			case Lava::Lava(15).ID: return 65;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 14833;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 14834;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 14835;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 14836;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 14837;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 14838;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 14839;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 14840;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XM, true, true).ID: return 14841;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XM, true, false).ID: return 14842;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XM, false, true).ID: return 14843;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XM, false, false).ID: return 14844;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XP, true, true).ID: return 14845;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XP, true, false).ID: return 14846;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XP, false, true).ID: return 14847;
			case Lectern::Lectern(eBlockFace::BLOCK_FACE_XP, false, false).ID: return 14848;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 3783;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 3784;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 3785;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 3786;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 3787;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 3788;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 3789;
			case Lever::Lever(Lever::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 3790;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 3791;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 3792;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 3793;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 3794;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 3795;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 3796;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 3797;
			case Lever::Lever(Lever::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 3798;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 3799;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 3800;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 3801;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 3802;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 3803;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 3804;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 3805;
			case Lever::Lever(Lever::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 3806;
			case LightBlueBanner::LightBlueBanner(0).ID: return 7945;
			case LightBlueBanner::LightBlueBanner(1).ID: return 7946;
			case LightBlueBanner::LightBlueBanner(2).ID: return 7947;
			case LightBlueBanner::LightBlueBanner(3).ID: return 7948;
			case LightBlueBanner::LightBlueBanner(4).ID: return 7949;
			case LightBlueBanner::LightBlueBanner(5).ID: return 7950;
			case LightBlueBanner::LightBlueBanner(6).ID: return 7951;
			case LightBlueBanner::LightBlueBanner(7).ID: return 7952;
			case LightBlueBanner::LightBlueBanner(8).ID: return 7953;
			case LightBlueBanner::LightBlueBanner(9).ID: return 7954;
			case LightBlueBanner::LightBlueBanner(10).ID: return 7955;
			case LightBlueBanner::LightBlueBanner(11).ID: return 7956;
			case LightBlueBanner::LightBlueBanner(12).ID: return 7957;
			case LightBlueBanner::LightBlueBanner(13).ID: return 7958;
			case LightBlueBanner::LightBlueBanner(14).ID: return 7959;
			case LightBlueBanner::LightBlueBanner(15).ID: return 7960;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZM, true, LightBlueBed::Part::Head).ID: return 1097;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZM, true, LightBlueBed::Part::Foot).ID: return 1098;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZM, false, LightBlueBed::Part::Head).ID: return 1099;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZM, false, LightBlueBed::Part::Foot).ID: return 1100;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZP, true, LightBlueBed::Part::Head).ID: return 1101;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZP, true, LightBlueBed::Part::Foot).ID: return 1102;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZP, false, LightBlueBed::Part::Head).ID: return 1103;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_ZP, false, LightBlueBed::Part::Foot).ID: return 1104;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XM, true, LightBlueBed::Part::Head).ID: return 1105;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XM, true, LightBlueBed::Part::Foot).ID: return 1106;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XM, false, LightBlueBed::Part::Head).ID: return 1107;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XM, false, LightBlueBed::Part::Foot).ID: return 1108;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XP, true, LightBlueBed::Part::Head).ID: return 1109;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XP, true, LightBlueBed::Part::Foot).ID: return 1110;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XP, false, LightBlueBed::Part::Head).ID: return 1111;
			case LightBlueBed::LightBlueBed(eBlockFace::BLOCK_FACE_XP, false, LightBlueBed::Part::Foot).ID: return 1112;
			case LightBlueCarpet::LightBlueCarpet().ID: return 7869;
			case LightBlueConcrete::LightBlueConcrete().ID: return 9441;
			case LightBlueConcretePowder::LightBlueConcretePowder().ID: return 9457;
			case LightBlueGlazedTerracotta::LightBlueGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9386;
			case LightBlueGlazedTerracotta::LightBlueGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9387;
			case LightBlueGlazedTerracotta::LightBlueGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9388;
			case LightBlueGlazedTerracotta::LightBlueGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9389;
			case LightBlueShulkerBox::LightBlueShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9296;
			case LightBlueShulkerBox::LightBlueShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9297;
			case LightBlueShulkerBox::LightBlueShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9298;
			case LightBlueShulkerBox::LightBlueShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9299;
			case LightBlueShulkerBox::LightBlueShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9300;
			case LightBlueShulkerBox::LightBlueShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9301;
			case LightBlueStainedGlass::LightBlueStainedGlass().ID: return 4098;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, true, true, true).ID: return 6961;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, true, true, false).ID: return 6962;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, true, false, true).ID: return 6965;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, true, false, false).ID: return 6966;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, false, true, true).ID: return 6969;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, false, true, false).ID: return 6970;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, false, false, true).ID: return 6973;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(true, false, false, false).ID: return 6974;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, true, true, true).ID: return 6977;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, true, true, false).ID: return 6978;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, true, false, true).ID: return 6981;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, true, false, false).ID: return 6982;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, false, true, true).ID: return 6985;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, false, true, false).ID: return 6986;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, false, false, true).ID: return 6989;
			case LightBlueStainedGlassPane::LightBlueStainedGlassPane(false, false, false, false).ID: return 6990;
			case LightBlueTerracotta::LightBlueTerracotta().ID: return 6850;
			case LightBlueWallBanner::LightBlueWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8165;
			case LightBlueWallBanner::LightBlueWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8166;
			case LightBlueWallBanner::LightBlueWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8167;
			case LightBlueWallBanner::LightBlueWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8168;
			case LightBlueWool::LightBlueWool().ID: return 1387;
			case LightGrayBanner::LightGrayBanner(0).ID: return 8025;
			case LightGrayBanner::LightGrayBanner(1).ID: return 8026;
			case LightGrayBanner::LightGrayBanner(2).ID: return 8027;
			case LightGrayBanner::LightGrayBanner(3).ID: return 8028;
			case LightGrayBanner::LightGrayBanner(4).ID: return 8029;
			case LightGrayBanner::LightGrayBanner(5).ID: return 8030;
			case LightGrayBanner::LightGrayBanner(6).ID: return 8031;
			case LightGrayBanner::LightGrayBanner(7).ID: return 8032;
			case LightGrayBanner::LightGrayBanner(8).ID: return 8033;
			case LightGrayBanner::LightGrayBanner(9).ID: return 8034;
			case LightGrayBanner::LightGrayBanner(10).ID: return 8035;
			case LightGrayBanner::LightGrayBanner(11).ID: return 8036;
			case LightGrayBanner::LightGrayBanner(12).ID: return 8037;
			case LightGrayBanner::LightGrayBanner(13).ID: return 8038;
			case LightGrayBanner::LightGrayBanner(14).ID: return 8039;
			case LightGrayBanner::LightGrayBanner(15).ID: return 8040;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZM, true, LightGrayBed::Part::Head).ID: return 1177;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZM, true, LightGrayBed::Part::Foot).ID: return 1178;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZM, false, LightGrayBed::Part::Head).ID: return 1179;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZM, false, LightGrayBed::Part::Foot).ID: return 1180;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZP, true, LightGrayBed::Part::Head).ID: return 1181;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZP, true, LightGrayBed::Part::Foot).ID: return 1182;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZP, false, LightGrayBed::Part::Head).ID: return 1183;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_ZP, false, LightGrayBed::Part::Foot).ID: return 1184;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XM, true, LightGrayBed::Part::Head).ID: return 1185;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XM, true, LightGrayBed::Part::Foot).ID: return 1186;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XM, false, LightGrayBed::Part::Head).ID: return 1187;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XM, false, LightGrayBed::Part::Foot).ID: return 1188;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XP, true, LightGrayBed::Part::Head).ID: return 1189;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XP, true, LightGrayBed::Part::Foot).ID: return 1190;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XP, false, LightGrayBed::Part::Head).ID: return 1191;
			case LightGrayBed::LightGrayBed(eBlockFace::BLOCK_FACE_XP, false, LightGrayBed::Part::Foot).ID: return 1192;
			case LightGrayCarpet::LightGrayCarpet().ID: return 7874;
			case LightGrayConcrete::LightGrayConcrete().ID: return 9446;
			case LightGrayConcretePowder::LightGrayConcretePowder().ID: return 9462;
			case LightGrayGlazedTerracotta::LightGrayGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9406;
			case LightGrayGlazedTerracotta::LightGrayGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9407;
			case LightGrayGlazedTerracotta::LightGrayGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9408;
			case LightGrayGlazedTerracotta::LightGrayGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9409;
			case LightGrayShulkerBox::LightGrayShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9326;
			case LightGrayShulkerBox::LightGrayShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9327;
			case LightGrayShulkerBox::LightGrayShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9328;
			case LightGrayShulkerBox::LightGrayShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9329;
			case LightGrayShulkerBox::LightGrayShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9330;
			case LightGrayShulkerBox::LightGrayShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9331;
			case LightGrayStainedGlass::LightGrayStainedGlass().ID: return 4103;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, true, true, true).ID: return 7121;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, true, true, false).ID: return 7122;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, true, false, true).ID: return 7125;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, true, false, false).ID: return 7126;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, false, true, true).ID: return 7129;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, false, true, false).ID: return 7130;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, false, false, true).ID: return 7133;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(true, false, false, false).ID: return 7134;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, true, true, true).ID: return 7137;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, true, true, false).ID: return 7138;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, true, false, true).ID: return 7141;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, true, false, false).ID: return 7142;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, false, true, true).ID: return 7145;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, false, true, false).ID: return 7146;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, false, false, true).ID: return 7149;
			case LightGrayStainedGlassPane::LightGrayStainedGlassPane(false, false, false, false).ID: return 7150;
			case LightGrayTerracotta::LightGrayTerracotta().ID: return 6855;
			case LightGrayWallBanner::LightGrayWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8185;
			case LightGrayWallBanner::LightGrayWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8186;
			case LightGrayWallBanner::LightGrayWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8187;
			case LightGrayWallBanner::LightGrayWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8188;
			case LightGrayWool::LightGrayWool().ID: return 1392;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(0).ID: return 6646;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(1).ID: return 6647;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(2).ID: return 6648;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(3).ID: return 6649;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(4).ID: return 6650;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(5).ID: return 6651;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(6).ID: return 6652;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(7).ID: return 6653;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(8).ID: return 6654;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(9).ID: return 6655;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(10).ID: return 6656;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(11).ID: return 6657;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(12).ID: return 6658;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(13).ID: return 6659;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(14).ID: return 6660;
			case LightWeightedPressurePlate::LightWeightedPressurePlate(15).ID: return 6661;
			case Lilac::Lilac(Lilac::Half::Upper).ID: return 7887;
			case Lilac::Lilac(Lilac::Half::Lower).ID: return 7888;
			case LilyOfTheValley::LilyOfTheValley().ID: return 1424;
			case LilyPad::LilyPad().ID: return 5014;
			case LimeBanner::LimeBanner(0).ID: return 7977;
			case LimeBanner::LimeBanner(1).ID: return 7978;
			case LimeBanner::LimeBanner(2).ID: return 7979;
			case LimeBanner::LimeBanner(3).ID: return 7980;
			case LimeBanner::LimeBanner(4).ID: return 7981;
			case LimeBanner::LimeBanner(5).ID: return 7982;
			case LimeBanner::LimeBanner(6).ID: return 7983;
			case LimeBanner::LimeBanner(7).ID: return 7984;
			case LimeBanner::LimeBanner(8).ID: return 7985;
			case LimeBanner::LimeBanner(9).ID: return 7986;
			case LimeBanner::LimeBanner(10).ID: return 7987;
			case LimeBanner::LimeBanner(11).ID: return 7988;
			case LimeBanner::LimeBanner(12).ID: return 7989;
			case LimeBanner::LimeBanner(13).ID: return 7990;
			case LimeBanner::LimeBanner(14).ID: return 7991;
			case LimeBanner::LimeBanner(15).ID: return 7992;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZM, true, LimeBed::Part::Head).ID: return 1129;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZM, true, LimeBed::Part::Foot).ID: return 1130;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZM, false, LimeBed::Part::Head).ID: return 1131;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZM, false, LimeBed::Part::Foot).ID: return 1132;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZP, true, LimeBed::Part::Head).ID: return 1133;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZP, true, LimeBed::Part::Foot).ID: return 1134;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZP, false, LimeBed::Part::Head).ID: return 1135;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_ZP, false, LimeBed::Part::Foot).ID: return 1136;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XM, true, LimeBed::Part::Head).ID: return 1137;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XM, true, LimeBed::Part::Foot).ID: return 1138;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XM, false, LimeBed::Part::Head).ID: return 1139;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XM, false, LimeBed::Part::Foot).ID: return 1140;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XP, true, LimeBed::Part::Head).ID: return 1141;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XP, true, LimeBed::Part::Foot).ID: return 1142;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XP, false, LimeBed::Part::Head).ID: return 1143;
			case LimeBed::LimeBed(eBlockFace::BLOCK_FACE_XP, false, LimeBed::Part::Foot).ID: return 1144;
			case LimeCarpet::LimeCarpet().ID: return 7871;
			case LimeConcrete::LimeConcrete().ID: return 9443;
			case LimeConcretePowder::LimeConcretePowder().ID: return 9459;
			case LimeGlazedTerracotta::LimeGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9394;
			case LimeGlazedTerracotta::LimeGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9395;
			case LimeGlazedTerracotta::LimeGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9396;
			case LimeGlazedTerracotta::LimeGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9397;
			case LimeShulkerBox::LimeShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9308;
			case LimeShulkerBox::LimeShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9309;
			case LimeShulkerBox::LimeShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9310;
			case LimeShulkerBox::LimeShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9311;
			case LimeShulkerBox::LimeShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9312;
			case LimeShulkerBox::LimeShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9313;
			case LimeStainedGlass::LimeStainedGlass().ID: return 4100;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, true, true, true).ID: return 7025;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, true, true, false).ID: return 7026;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, true, false, true).ID: return 7029;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, true, false, false).ID: return 7030;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, false, true, true).ID: return 7033;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, false, true, false).ID: return 7034;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, false, false, true).ID: return 7037;
			case LimeStainedGlassPane::LimeStainedGlassPane(true, false, false, false).ID: return 7038;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, true, true, true).ID: return 7041;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, true, true, false).ID: return 7042;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, true, false, true).ID: return 7045;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, true, false, false).ID: return 7046;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, false, true, true).ID: return 7049;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, false, true, false).ID: return 7050;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, false, false, true).ID: return 7053;
			case LimeStainedGlassPane::LimeStainedGlassPane(false, false, false, false).ID: return 7054;
			case LimeTerracotta::LimeTerracotta().ID: return 6852;
			case LimeWallBanner::LimeWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8173;
			case LimeWallBanner::LimeWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8174;
			case LimeWallBanner::LimeWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8175;
			case LimeWallBanner::LimeWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8176;
			case LimeWool::LimeWool().ID: return 1389;
			case Lodestone::Lodestone().ID: return 15838;
			case Loom::Loom(eBlockFace::BLOCK_FACE_ZM).ID: return 14787;
			case Loom::Loom(eBlockFace::BLOCK_FACE_ZP).ID: return 14788;
			case Loom::Loom(eBlockFace::BLOCK_FACE_XM).ID: return 14789;
			case Loom::Loom(eBlockFace::BLOCK_FACE_XP).ID: return 14790;
			case MagentaBanner::MagentaBanner(0).ID: return 7929;
			case MagentaBanner::MagentaBanner(1).ID: return 7930;
			case MagentaBanner::MagentaBanner(2).ID: return 7931;
			case MagentaBanner::MagentaBanner(3).ID: return 7932;
			case MagentaBanner::MagentaBanner(4).ID: return 7933;
			case MagentaBanner::MagentaBanner(5).ID: return 7934;
			case MagentaBanner::MagentaBanner(6).ID: return 7935;
			case MagentaBanner::MagentaBanner(7).ID: return 7936;
			case MagentaBanner::MagentaBanner(8).ID: return 7937;
			case MagentaBanner::MagentaBanner(9).ID: return 7938;
			case MagentaBanner::MagentaBanner(10).ID: return 7939;
			case MagentaBanner::MagentaBanner(11).ID: return 7940;
			case MagentaBanner::MagentaBanner(12).ID: return 7941;
			case MagentaBanner::MagentaBanner(13).ID: return 7942;
			case MagentaBanner::MagentaBanner(14).ID: return 7943;
			case MagentaBanner::MagentaBanner(15).ID: return 7944;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZM, true, MagentaBed::Part::Head).ID: return 1081;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZM, true, MagentaBed::Part::Foot).ID: return 1082;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZM, false, MagentaBed::Part::Head).ID: return 1083;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZM, false, MagentaBed::Part::Foot).ID: return 1084;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZP, true, MagentaBed::Part::Head).ID: return 1085;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZP, true, MagentaBed::Part::Foot).ID: return 1086;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZP, false, MagentaBed::Part::Head).ID: return 1087;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_ZP, false, MagentaBed::Part::Foot).ID: return 1088;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XM, true, MagentaBed::Part::Head).ID: return 1089;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XM, true, MagentaBed::Part::Foot).ID: return 1090;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XM, false, MagentaBed::Part::Head).ID: return 1091;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XM, false, MagentaBed::Part::Foot).ID: return 1092;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XP, true, MagentaBed::Part::Head).ID: return 1093;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XP, true, MagentaBed::Part::Foot).ID: return 1094;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XP, false, MagentaBed::Part::Head).ID: return 1095;
			case MagentaBed::MagentaBed(eBlockFace::BLOCK_FACE_XP, false, MagentaBed::Part::Foot).ID: return 1096;
			case MagentaCarpet::MagentaCarpet().ID: return 7868;
			case MagentaConcrete::MagentaConcrete().ID: return 9440;
			case MagentaConcretePowder::MagentaConcretePowder().ID: return 9456;
			case MagentaGlazedTerracotta::MagentaGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9382;
			case MagentaGlazedTerracotta::MagentaGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9383;
			case MagentaGlazedTerracotta::MagentaGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9384;
			case MagentaGlazedTerracotta::MagentaGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9385;
			case MagentaShulkerBox::MagentaShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9290;
			case MagentaShulkerBox::MagentaShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9291;
			case MagentaShulkerBox::MagentaShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9292;
			case MagentaShulkerBox::MagentaShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9293;
			case MagentaShulkerBox::MagentaShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9294;
			case MagentaShulkerBox::MagentaShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9295;
			case MagentaStainedGlass::MagentaStainedGlass().ID: return 4097;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, true, true, true).ID: return 6929;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, true, true, false).ID: return 6930;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, true, false, true).ID: return 6933;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, true, false, false).ID: return 6934;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, false, true, true).ID: return 6937;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, false, true, false).ID: return 6938;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, false, false, true).ID: return 6941;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(true, false, false, false).ID: return 6942;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, true, true, true).ID: return 6945;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, true, true, false).ID: return 6946;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, true, false, true).ID: return 6949;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, true, false, false).ID: return 6950;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, false, true, true).ID: return 6953;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, false, true, false).ID: return 6954;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, false, false, true).ID: return 6957;
			case MagentaStainedGlassPane::MagentaStainedGlassPane(false, false, false, false).ID: return 6958;
			case MagentaTerracotta::MagentaTerracotta().ID: return 6849;
			case MagentaWallBanner::MagentaWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8161;
			case MagentaWallBanner::MagentaWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8162;
			case MagentaWallBanner::MagentaWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8163;
			case MagentaWallBanner::MagentaWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8164;
			case MagentaWool::MagentaWool().ID: return 1386;
			case MagmaBlock::MagmaBlock().ID: return 9253;
			case Melon::Melon().ID: return 4763;
			case MelonStem::MelonStem(0).ID: return 4780;
			case MelonStem::MelonStem(1).ID: return 4781;
			case MelonStem::MelonStem(2).ID: return 4782;
			case MelonStem::MelonStem(3).ID: return 4783;
			case MelonStem::MelonStem(4).ID: return 4784;
			case MelonStem::MelonStem(5).ID: return 4785;
			case MelonStem::MelonStem(6).ID: return 4786;
			case MelonStem::MelonStem(7).ID: return 4787;
			case MossyCobblestone::MossyCobblestone().ID: return 1433;
			case MossyCobblestoneSlab::MossyCobblestoneSlab(MossyCobblestoneSlab::Type::Top).ID: return 10814;
			case MossyCobblestoneSlab::MossyCobblestoneSlab(MossyCobblestoneSlab::Type::Bottom).ID: return 10816;
			case MossyCobblestoneSlab::MossyCobblestoneSlab(MossyCobblestoneSlab::Type::Double).ID: return 10818;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::Straight).ID: return 9990;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 9992;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerRight).ID: return 9994;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 9996;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterRight).ID: return 9998;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::Straight).ID: return 10000;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10002;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10004;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10006;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10008;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::Straight).ID: return 10010;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10012;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10014;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10016;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10018;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::Straight).ID: return 10020;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10022;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10024;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10026;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_ZP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10028;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::Straight).ID: return 10030;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10032;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10034;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10036;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10038;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::Straight).ID: return 10040;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10042;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10044;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10046;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XM, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10048;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::Straight).ID: return 10050;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10052;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10054;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10056;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Top, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10058;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::Straight).ID: return 10060;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerLeft).ID: return 10062;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::InnerRight).ID: return 10064;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterLeft).ID: return 10066;
			case MossyCobblestoneStairs::MossyCobblestoneStairs(eBlockFace::BLOCK_FACE_XP, MossyCobblestoneStairs::Half::Bottom, MossyCobblestoneStairs::Shape::OuterRight).ID: return 10068;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 5984;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 5985;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 5986;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 5990;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 5991;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 5992;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 5996;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 5997;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 5998;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6002;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6003;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6004;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6008;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6009;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6010;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6014;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6015;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6016;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6020;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6021;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6022;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6026;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6027;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6028;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6032;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6033;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6034;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6038;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6039;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6040;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6044;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6045;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6046;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6050;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6051;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6052;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6056;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6057;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6058;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6062;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6063;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6064;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6068;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6069;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6070;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6074;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6075;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6076;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6080;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6081;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6082;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6086;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6087;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::None, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6088;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6092;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6093;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6094;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6098;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6099;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6100;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6104;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6105;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6106;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6110;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6111;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6112;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6116;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6117;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6118;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6122;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6123;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6124;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6128;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6129;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6130;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6134;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6135;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6136;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6140;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6141;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6142;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6146;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6147;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6148;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6152;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6153;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6154;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6158;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6159;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6160;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6164;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6165;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6166;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6170;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6171;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6172;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6176;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6177;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6178;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6182;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6183;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6184;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6188;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6189;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6190;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6194;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6195;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Low, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6196;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6200;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6201;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6202;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6206;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6207;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6208;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6212;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6213;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6214;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6218;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6219;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6220;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6224;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6225;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6226;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6230;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6231;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::None, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6232;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6236;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6237;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6238;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6242;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6243;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6244;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6248;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6249;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6250;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6254;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6255;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6256;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6260;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6261;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6262;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6266;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6267;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Low, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6268;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::None).ID: return 6272;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Low).ID: return 6273;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, true, MossyCobblestoneWall::West::Tall).ID: return 6274;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::None).ID: return 6278;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Low).ID: return 6279;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::None, false, MossyCobblestoneWall::West::Tall).ID: return 6280;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::None).ID: return 6284;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Low).ID: return 6285;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, true, MossyCobblestoneWall::West::Tall).ID: return 6286;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::None).ID: return 6290;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Low).ID: return 6291;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Low, false, MossyCobblestoneWall::West::Tall).ID: return 6292;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::None).ID: return 6296;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Low).ID: return 6297;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, true, MossyCobblestoneWall::West::Tall).ID: return 6298;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::None).ID: return 6302;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Low).ID: return 6303;
			case MossyCobblestoneWall::MossyCobblestoneWall(MossyCobblestoneWall::East::Tall, MossyCobblestoneWall::North::Tall, MossyCobblestoneWall::South::Tall, false, MossyCobblestoneWall::West::Tall).ID: return 6304;
			case MossyStoneBrickSlab::MossyStoneBrickSlab(MossyStoneBrickSlab::Type::Top).ID: return 10802;
			case MossyStoneBrickSlab::MossyStoneBrickSlab(MossyStoneBrickSlab::Type::Bottom).ID: return 10804;
			case MossyStoneBrickSlab::MossyStoneBrickSlab(MossyStoneBrickSlab::Type::Double).ID: return 10806;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::Straight).ID: return 9830;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9832;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9834;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9836;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9838;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::Straight).ID: return 9840;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9842;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9844;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9846;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9848;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::Straight).ID: return 9850;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9852;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9854;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9856;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9858;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::Straight).ID: return 9860;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9862;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9864;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9866;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9868;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::Straight).ID: return 9870;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9872;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9874;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9876;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9878;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::Straight).ID: return 9880;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9882;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9884;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9886;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XM, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9888;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::Straight).ID: return 9890;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9892;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9894;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9896;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Top, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9898;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::Straight).ID: return 9900;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerLeft).ID: return 9902;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::InnerRight).ID: return 9904;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterLeft).ID: return 9906;
			case MossyStoneBrickStairs::MossyStoneBrickStairs(eBlockFace::BLOCK_FACE_XP, MossyStoneBrickStairs::Half::Bottom, MossyStoneBrickStairs::Shape::OuterRight).ID: return 9908;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 11842;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 11843;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 11844;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 11848;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 11849;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 11850;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 11854;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 11855;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 11856;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 11860;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 11861;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 11862;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 11866;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 11867;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 11868;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 11872;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 11873;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 11874;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 11878;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 11879;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 11880;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 11884;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 11885;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 11886;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 11890;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 11891;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 11892;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 11896;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 11897;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 11898;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 11902;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 11903;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 11904;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 11908;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 11909;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 11910;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 11914;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 11915;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 11916;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 11920;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 11921;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 11922;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 11926;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 11927;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 11928;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 11932;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 11933;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 11934;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 11938;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 11939;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 11940;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 11944;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 11945;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::None, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 11946;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 11950;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 11951;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 11952;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 11956;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 11957;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 11958;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 11962;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 11963;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 11964;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 11968;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 11969;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 11970;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 11974;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 11975;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 11976;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 11980;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 11981;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 11982;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 11986;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 11987;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 11988;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 11992;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 11993;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 11994;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 11998;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 11999;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 12000;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 12004;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 12005;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 12006;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 12010;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 12011;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 12012;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 12016;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 12017;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 12018;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 12022;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 12023;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 12024;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 12028;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 12029;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 12030;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 12034;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 12035;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 12036;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 12040;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 12041;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 12042;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 12046;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 12047;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 12048;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 12052;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 12053;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Low, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 12054;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 12058;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 12059;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 12060;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 12064;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 12065;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 12066;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 12070;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 12071;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 12072;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 12076;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 12077;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 12078;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 12082;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 12083;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 12084;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 12088;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 12089;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::None, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 12090;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 12094;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 12095;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 12096;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 12100;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 12101;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 12102;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 12106;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 12107;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 12108;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 12112;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 12113;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 12114;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 12118;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 12119;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 12120;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 12124;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 12125;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Low, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 12126;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::None).ID: return 12130;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Low).ID: return 12131;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, true, MossyStoneBrickWall::West::Tall).ID: return 12132;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::None).ID: return 12136;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Low).ID: return 12137;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::None, false, MossyStoneBrickWall::West::Tall).ID: return 12138;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::None).ID: return 12142;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Low).ID: return 12143;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, true, MossyStoneBrickWall::West::Tall).ID: return 12144;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::None).ID: return 12148;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Low).ID: return 12149;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Low, false, MossyStoneBrickWall::West::Tall).ID: return 12150;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::None).ID: return 12154;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Low).ID: return 12155;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, true, MossyStoneBrickWall::West::Tall).ID: return 12156;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::None).ID: return 12160;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Low).ID: return 12161;
			case MossyStoneBrickWall::MossyStoneBrickWall(MossyStoneBrickWall::East::Tall, MossyStoneBrickWall::North::Tall, MossyStoneBrickWall::South::Tall, false, MossyStoneBrickWall::West::Tall).ID: return 12162;
			case MossyStoneBricks::MossyStoneBricks().ID: return 4496;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_ZM, MovingPiston::Type::Normal).ID: return 1400;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_ZM, MovingPiston::Type::Sticky).ID: return 1401;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_XP, MovingPiston::Type::Normal).ID: return 1402;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_XP, MovingPiston::Type::Sticky).ID: return 1403;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_ZP, MovingPiston::Type::Normal).ID: return 1404;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_ZP, MovingPiston::Type::Sticky).ID: return 1405;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_XM, MovingPiston::Type::Normal).ID: return 1406;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_XM, MovingPiston::Type::Sticky).ID: return 1407;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_YP, MovingPiston::Type::Normal).ID: return 1408;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_YP, MovingPiston::Type::Sticky).ID: return 1409;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_YM, MovingPiston::Type::Normal).ID: return 1410;
			case MovingPiston::MovingPiston(eBlockFace::BLOCK_FACE_YM, MovingPiston::Type::Sticky).ID: return 1411;
			case MushroomStem::MushroomStem(true, true, true, true, true, true).ID: return 4633;
			case MushroomStem::MushroomStem(true, true, true, true, true, false).ID: return 4634;
			case MushroomStem::MushroomStem(true, true, true, true, false, true).ID: return 4635;
			case MushroomStem::MushroomStem(true, true, true, true, false, false).ID: return 4636;
			case MushroomStem::MushroomStem(true, true, true, false, true, true).ID: return 4637;
			case MushroomStem::MushroomStem(true, true, true, false, true, false).ID: return 4638;
			case MushroomStem::MushroomStem(true, true, true, false, false, true).ID: return 4639;
			case MushroomStem::MushroomStem(true, true, true, false, false, false).ID: return 4640;
			case MushroomStem::MushroomStem(true, true, false, true, true, true).ID: return 4641;
			case MushroomStem::MushroomStem(true, true, false, true, true, false).ID: return 4642;
			case MushroomStem::MushroomStem(true, true, false, true, false, true).ID: return 4643;
			case MushroomStem::MushroomStem(true, true, false, true, false, false).ID: return 4644;
			case MushroomStem::MushroomStem(true, true, false, false, true, true).ID: return 4645;
			case MushroomStem::MushroomStem(true, true, false, false, true, false).ID: return 4646;
			case MushroomStem::MushroomStem(true, true, false, false, false, true).ID: return 4647;
			case MushroomStem::MushroomStem(true, true, false, false, false, false).ID: return 4648;
			case MushroomStem::MushroomStem(true, false, true, true, true, true).ID: return 4649;
			case MushroomStem::MushroomStem(true, false, true, true, true, false).ID: return 4650;
			case MushroomStem::MushroomStem(true, false, true, true, false, true).ID: return 4651;
			case MushroomStem::MushroomStem(true, false, true, true, false, false).ID: return 4652;
			case MushroomStem::MushroomStem(true, false, true, false, true, true).ID: return 4653;
			case MushroomStem::MushroomStem(true, false, true, false, true, false).ID: return 4654;
			case MushroomStem::MushroomStem(true, false, true, false, false, true).ID: return 4655;
			case MushroomStem::MushroomStem(true, false, true, false, false, false).ID: return 4656;
			case MushroomStem::MushroomStem(true, false, false, true, true, true).ID: return 4657;
			case MushroomStem::MushroomStem(true, false, false, true, true, false).ID: return 4658;
			case MushroomStem::MushroomStem(true, false, false, true, false, true).ID: return 4659;
			case MushroomStem::MushroomStem(true, false, false, true, false, false).ID: return 4660;
			case MushroomStem::MushroomStem(true, false, false, false, true, true).ID: return 4661;
			case MushroomStem::MushroomStem(true, false, false, false, true, false).ID: return 4662;
			case MushroomStem::MushroomStem(true, false, false, false, false, true).ID: return 4663;
			case MushroomStem::MushroomStem(true, false, false, false, false, false).ID: return 4664;
			case MushroomStem::MushroomStem(false, true, true, true, true, true).ID: return 4665;
			case MushroomStem::MushroomStem(false, true, true, true, true, false).ID: return 4666;
			case MushroomStem::MushroomStem(false, true, true, true, false, true).ID: return 4667;
			case MushroomStem::MushroomStem(false, true, true, true, false, false).ID: return 4668;
			case MushroomStem::MushroomStem(false, true, true, false, true, true).ID: return 4669;
			case MushroomStem::MushroomStem(false, true, true, false, true, false).ID: return 4670;
			case MushroomStem::MushroomStem(false, true, true, false, false, true).ID: return 4671;
			case MushroomStem::MushroomStem(false, true, true, false, false, false).ID: return 4672;
			case MushroomStem::MushroomStem(false, true, false, true, true, true).ID: return 4673;
			case MushroomStem::MushroomStem(false, true, false, true, true, false).ID: return 4674;
			case MushroomStem::MushroomStem(false, true, false, true, false, true).ID: return 4675;
			case MushroomStem::MushroomStem(false, true, false, true, false, false).ID: return 4676;
			case MushroomStem::MushroomStem(false, true, false, false, true, true).ID: return 4677;
			case MushroomStem::MushroomStem(false, true, false, false, true, false).ID: return 4678;
			case MushroomStem::MushroomStem(false, true, false, false, false, true).ID: return 4679;
			case MushroomStem::MushroomStem(false, true, false, false, false, false).ID: return 4680;
			case MushroomStem::MushroomStem(false, false, true, true, true, true).ID: return 4681;
			case MushroomStem::MushroomStem(false, false, true, true, true, false).ID: return 4682;
			case MushroomStem::MushroomStem(false, false, true, true, false, true).ID: return 4683;
			case MushroomStem::MushroomStem(false, false, true, true, false, false).ID: return 4684;
			case MushroomStem::MushroomStem(false, false, true, false, true, true).ID: return 4685;
			case MushroomStem::MushroomStem(false, false, true, false, true, false).ID: return 4686;
			case MushroomStem::MushroomStem(false, false, true, false, false, true).ID: return 4687;
			case MushroomStem::MushroomStem(false, false, true, false, false, false).ID: return 4688;
			case MushroomStem::MushroomStem(false, false, false, true, true, true).ID: return 4689;
			case MushroomStem::MushroomStem(false, false, false, true, true, false).ID: return 4690;
			case MushroomStem::MushroomStem(false, false, false, true, false, true).ID: return 4691;
			case MushroomStem::MushroomStem(false, false, false, true, false, false).ID: return 4692;
			case MushroomStem::MushroomStem(false, false, false, false, true, true).ID: return 4693;
			case MushroomStem::MushroomStem(false, false, false, false, true, false).ID: return 4694;
			case MushroomStem::MushroomStem(false, false, false, false, false, true).ID: return 4695;
			case MushroomStem::MushroomStem(false, false, false, false, false, false).ID: return 4696;
			case Mycelium::Mycelium(true).ID: return 5012;
			case Mycelium::Mycelium(false).ID: return 5013;
			case NetherBrickFence::NetherBrickFence(true, true, true, true).ID: return 5018;
			case NetherBrickFence::NetherBrickFence(true, true, true, false).ID: return 5019;
			case NetherBrickFence::NetherBrickFence(true, true, false, true).ID: return 5022;
			case NetherBrickFence::NetherBrickFence(true, true, false, false).ID: return 5023;
			case NetherBrickFence::NetherBrickFence(true, false, true, true).ID: return 5026;
			case NetherBrickFence::NetherBrickFence(true, false, true, false).ID: return 5027;
			case NetherBrickFence::NetherBrickFence(true, false, false, true).ID: return 5030;
			case NetherBrickFence::NetherBrickFence(true, false, false, false).ID: return 5031;
			case NetherBrickFence::NetherBrickFence(false, true, true, true).ID: return 5034;
			case NetherBrickFence::NetherBrickFence(false, true, true, false).ID: return 5035;
			case NetherBrickFence::NetherBrickFence(false, true, false, true).ID: return 5038;
			case NetherBrickFence::NetherBrickFence(false, true, false, false).ID: return 5039;
			case NetherBrickFence::NetherBrickFence(false, false, true, true).ID: return 5042;
			case NetherBrickFence::NetherBrickFence(false, false, true, false).ID: return 5043;
			case NetherBrickFence::NetherBrickFence(false, false, false, true).ID: return 5046;
			case NetherBrickFence::NetherBrickFence(false, false, false, false).ID: return 5047;
			case NetherBrickSlab::NetherBrickSlab(NetherBrickSlab::Type::Top).ID: return 8385;
			case NetherBrickSlab::NetherBrickSlab(NetherBrickSlab::Type::Bottom).ID: return 8387;
			case NetherBrickSlab::NetherBrickSlab(NetherBrickSlab::Type::Double).ID: return 8389;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::Straight).ID: return 5049;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerLeft).ID: return 5051;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerRight).ID: return 5053;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterLeft).ID: return 5055;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterRight).ID: return 5057;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::Straight).ID: return 5059;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerLeft).ID: return 5061;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerRight).ID: return 5063;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterLeft).ID: return 5065;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterRight).ID: return 5067;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::Straight).ID: return 5069;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerLeft).ID: return 5071;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerRight).ID: return 5073;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterLeft).ID: return 5075;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterRight).ID: return 5077;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::Straight).ID: return 5079;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerLeft).ID: return 5081;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerRight).ID: return 5083;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterLeft).ID: return 5085;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterRight).ID: return 5087;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::Straight).ID: return 5089;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerLeft).ID: return 5091;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerRight).ID: return 5093;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterLeft).ID: return 5095;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterRight).ID: return 5097;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::Straight).ID: return 5099;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerLeft).ID: return 5101;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerRight).ID: return 5103;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterLeft).ID: return 5105;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XM, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterRight).ID: return 5107;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::Straight).ID: return 5109;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerLeft).ID: return 5111;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::InnerRight).ID: return 5113;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterLeft).ID: return 5115;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Top, NetherBrickStairs::Shape::OuterRight).ID: return 5117;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::Straight).ID: return 5119;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerLeft).ID: return 5121;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::InnerRight).ID: return 5123;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterLeft).ID: return 5125;
			case NetherBrickStairs::NetherBrickStairs(eBlockFace::BLOCK_FACE_XP, NetherBrickStairs::Half::Bottom, NetherBrickStairs::Shape::OuterRight).ID: return 5127;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 12814;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 12815;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 12816;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 12820;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 12821;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 12822;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 12826;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 12827;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 12828;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 12832;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 12833;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 12834;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 12838;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 12839;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 12840;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 12844;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 12845;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 12846;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 12850;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 12851;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 12852;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 12856;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 12857;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 12858;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 12862;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 12863;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 12864;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 12868;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 12869;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 12870;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 12874;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 12875;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 12876;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 12880;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 12881;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 12882;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 12886;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 12887;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 12888;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 12892;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 12893;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 12894;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 12898;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 12899;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 12900;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 12904;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 12905;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 12906;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 12910;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 12911;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 12912;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 12916;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 12917;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::None, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 12918;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 12922;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 12923;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 12924;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 12928;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 12929;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 12930;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 12934;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 12935;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 12936;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 12940;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 12941;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 12942;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 12946;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 12947;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 12948;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 12952;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 12953;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 12954;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 12958;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 12959;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 12960;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 12964;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 12965;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 12966;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 12970;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 12971;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 12972;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 12976;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 12977;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 12978;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 12982;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 12983;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 12984;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 12988;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 12989;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 12990;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 12994;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 12995;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 12996;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 13000;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 13001;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 13002;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 13006;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 13007;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 13008;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 13012;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 13013;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 13014;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 13018;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 13019;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 13020;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 13024;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 13025;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Low, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 13026;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 13030;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 13031;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 13032;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 13036;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 13037;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 13038;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 13042;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 13043;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 13044;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 13048;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 13049;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 13050;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 13054;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 13055;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 13056;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 13060;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 13061;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::None, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 13062;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 13066;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 13067;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 13068;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 13072;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 13073;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 13074;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 13078;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 13079;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 13080;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 13084;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 13085;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 13086;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 13090;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 13091;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 13092;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 13096;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 13097;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Low, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 13098;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::None).ID: return 13102;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::Low).ID: return 13103;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::None, true, NetherBrickWall::West::Tall).ID: return 13104;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::None).ID: return 13108;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::Low).ID: return 13109;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::None, false, NetherBrickWall::West::Tall).ID: return 13110;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::None).ID: return 13114;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::Low).ID: return 13115;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, true, NetherBrickWall::West::Tall).ID: return 13116;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::None).ID: return 13120;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::Low).ID: return 13121;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Low, false, NetherBrickWall::West::Tall).ID: return 13122;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::None).ID: return 13126;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Low).ID: return 13127;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, true, NetherBrickWall::West::Tall).ID: return 13128;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::None).ID: return 13132;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Low).ID: return 13133;
			case NetherBrickWall::NetherBrickWall(NetherBrickWall::East::Tall, NetherBrickWall::North::Tall, NetherBrickWall::South::Tall, false, NetherBrickWall::West::Tall).ID: return 13134;
			case NetherBricks::NetherBricks().ID: return 5015;
			case NetherGoldOre::NetherGoldOre().ID: return 72;
			case NetherPortal::NetherPortal(NetherPortal::Axis::X).ID: return 4014;
			case NetherPortal::NetherPortal(NetherPortal::Axis::Z).ID: return 4015;
			case NetherQuartzOre::NetherQuartzOre().ID: return 6727;
			case NetherSprouts::NetherSprouts().ID: return 14974;
			case NetherWart::NetherWart(0).ID: return 5128;
			case NetherWart::NetherWart(1).ID: return 5129;
			case NetherWart::NetherWart(2).ID: return 5130;
			case NetherWart::NetherWart(3).ID: return 5131;
			case NetherWartBlock::NetherWartBlock().ID: return 9254;
			case NetheriteBlock::NetheriteBlock().ID: return 15826;
			case Netherrack::Netherrack().ID: return 3999;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 0, true).ID: return 249;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 0, false).ID: return 250;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 1, true).ID: return 251;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 1, false).ID: return 252;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 2, true).ID: return 253;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 2, false).ID: return 254;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 3, true).ID: return 255;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 3, false).ID: return 256;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 4, true).ID: return 257;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 4, false).ID: return 258;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 5, true).ID: return 259;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 5, false).ID: return 260;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 6, true).ID: return 261;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 6, false).ID: return 262;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 7, true).ID: return 263;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 7, false).ID: return 264;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 8, true).ID: return 265;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 8, false).ID: return 266;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 9, true).ID: return 267;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 9, false).ID: return 268;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 10, true).ID: return 269;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 10, false).ID: return 270;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 11, true).ID: return 271;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 11, false).ID: return 272;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 12, true).ID: return 273;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 12, false).ID: return 274;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 13, true).ID: return 275;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 13, false).ID: return 276;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 14, true).ID: return 277;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 14, false).ID: return 278;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 15, true).ID: return 279;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 15, false).ID: return 280;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 16, true).ID: return 281;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 16, false).ID: return 282;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 17, true).ID: return 283;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 17, false).ID: return 284;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 18, true).ID: return 285;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 18, false).ID: return 286;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 19, true).ID: return 287;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 19, false).ID: return 288;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 20, true).ID: return 289;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 20, false).ID: return 290;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 21, true).ID: return 291;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 21, false).ID: return 292;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 22, true).ID: return 293;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 22, false).ID: return 294;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 23, true).ID: return 295;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 23, false).ID: return 296;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 24, true).ID: return 297;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Harp, 24, false).ID: return 298;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 0, true).ID: return 299;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 0, false).ID: return 300;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 1, true).ID: return 301;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 1, false).ID: return 302;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 2, true).ID: return 303;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 2, false).ID: return 304;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 3, true).ID: return 305;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 3, false).ID: return 306;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 4, true).ID: return 307;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 4, false).ID: return 308;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 5, true).ID: return 309;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 5, false).ID: return 310;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 6, true).ID: return 311;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 6, false).ID: return 312;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 7, true).ID: return 313;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 7, false).ID: return 314;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 8, true).ID: return 315;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 8, false).ID: return 316;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 9, true).ID: return 317;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 9, false).ID: return 318;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 10, true).ID: return 319;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 10, false).ID: return 320;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 11, true).ID: return 321;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 11, false).ID: return 322;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 12, true).ID: return 323;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 12, false).ID: return 324;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 13, true).ID: return 325;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 13, false).ID: return 326;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 14, true).ID: return 327;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 14, false).ID: return 328;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 15, true).ID: return 329;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 15, false).ID: return 330;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 16, true).ID: return 331;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 16, false).ID: return 332;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 17, true).ID: return 333;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 17, false).ID: return 334;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 18, true).ID: return 335;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 18, false).ID: return 336;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 19, true).ID: return 337;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 19, false).ID: return 338;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 20, true).ID: return 339;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 20, false).ID: return 340;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 21, true).ID: return 341;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 21, false).ID: return 342;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 22, true).ID: return 343;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 22, false).ID: return 344;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 23, true).ID: return 345;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 23, false).ID: return 346;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 24, true).ID: return 347;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Basedrum, 24, false).ID: return 348;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 0, true).ID: return 349;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 0, false).ID: return 350;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 1, true).ID: return 351;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 1, false).ID: return 352;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 2, true).ID: return 353;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 2, false).ID: return 354;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 3, true).ID: return 355;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 3, false).ID: return 356;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 4, true).ID: return 357;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 4, false).ID: return 358;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 5, true).ID: return 359;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 5, false).ID: return 360;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 6, true).ID: return 361;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 6, false).ID: return 362;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 7, true).ID: return 363;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 7, false).ID: return 364;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 8, true).ID: return 365;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 8, false).ID: return 366;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 9, true).ID: return 367;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 9, false).ID: return 368;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 10, true).ID: return 369;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 10, false).ID: return 370;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 11, true).ID: return 371;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 11, false).ID: return 372;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 12, true).ID: return 373;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 12, false).ID: return 374;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 13, true).ID: return 375;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 13, false).ID: return 376;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 14, true).ID: return 377;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 14, false).ID: return 378;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 15, true).ID: return 379;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 15, false).ID: return 380;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 16, true).ID: return 381;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 16, false).ID: return 382;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 17, true).ID: return 383;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 17, false).ID: return 384;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 18, true).ID: return 385;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 18, false).ID: return 386;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 19, true).ID: return 387;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 19, false).ID: return 388;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 20, true).ID: return 389;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 20, false).ID: return 390;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 21, true).ID: return 391;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 21, false).ID: return 392;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 22, true).ID: return 393;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 22, false).ID: return 394;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 23, true).ID: return 395;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 23, false).ID: return 396;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 24, true).ID: return 397;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Snare, 24, false).ID: return 398;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 0, true).ID: return 399;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 0, false).ID: return 400;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 1, true).ID: return 401;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 1, false).ID: return 402;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 2, true).ID: return 403;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 2, false).ID: return 404;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 3, true).ID: return 405;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 3, false).ID: return 406;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 4, true).ID: return 407;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 4, false).ID: return 408;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 5, true).ID: return 409;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 5, false).ID: return 410;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 6, true).ID: return 411;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 6, false).ID: return 412;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 7, true).ID: return 413;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 7, false).ID: return 414;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 8, true).ID: return 415;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 8, false).ID: return 416;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 9, true).ID: return 417;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 9, false).ID: return 418;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 10, true).ID: return 419;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 10, false).ID: return 420;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 11, true).ID: return 421;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 11, false).ID: return 422;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 12, true).ID: return 423;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 12, false).ID: return 424;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 13, true).ID: return 425;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 13, false).ID: return 426;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 14, true).ID: return 427;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 14, false).ID: return 428;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 15, true).ID: return 429;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 15, false).ID: return 430;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 16, true).ID: return 431;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 16, false).ID: return 432;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 17, true).ID: return 433;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 17, false).ID: return 434;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 18, true).ID: return 435;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 18, false).ID: return 436;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 19, true).ID: return 437;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 19, false).ID: return 438;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 20, true).ID: return 439;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 20, false).ID: return 440;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 21, true).ID: return 441;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 21, false).ID: return 442;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 22, true).ID: return 443;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 22, false).ID: return 444;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 23, true).ID: return 445;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 23, false).ID: return 446;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 24, true).ID: return 447;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Hat, 24, false).ID: return 448;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 0, true).ID: return 449;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 0, false).ID: return 450;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 1, true).ID: return 451;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 1, false).ID: return 452;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 2, true).ID: return 453;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 2, false).ID: return 454;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 3, true).ID: return 455;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 3, false).ID: return 456;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 4, true).ID: return 457;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 4, false).ID: return 458;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 5, true).ID: return 459;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 5, false).ID: return 460;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 6, true).ID: return 461;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 6, false).ID: return 462;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 7, true).ID: return 463;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 7, false).ID: return 464;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 8, true).ID: return 465;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 8, false).ID: return 466;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 9, true).ID: return 467;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 9, false).ID: return 468;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 10, true).ID: return 469;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 10, false).ID: return 470;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 11, true).ID: return 471;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 11, false).ID: return 472;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 12, true).ID: return 473;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 12, false).ID: return 474;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 13, true).ID: return 475;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 13, false).ID: return 476;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 14, true).ID: return 477;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 14, false).ID: return 478;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 15, true).ID: return 479;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 15, false).ID: return 480;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 16, true).ID: return 481;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 16, false).ID: return 482;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 17, true).ID: return 483;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 17, false).ID: return 484;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 18, true).ID: return 485;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 18, false).ID: return 486;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 19, true).ID: return 487;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 19, false).ID: return 488;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 20, true).ID: return 489;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 20, false).ID: return 490;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 21, true).ID: return 491;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 21, false).ID: return 492;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 22, true).ID: return 493;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 22, false).ID: return 494;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 23, true).ID: return 495;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 23, false).ID: return 496;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 24, true).ID: return 497;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bass, 24, false).ID: return 498;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 0, true).ID: return 499;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 0, false).ID: return 500;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 1, true).ID: return 501;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 1, false).ID: return 502;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 2, true).ID: return 503;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 2, false).ID: return 504;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 3, true).ID: return 505;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 3, false).ID: return 506;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 4, true).ID: return 507;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 4, false).ID: return 508;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 5, true).ID: return 509;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 5, false).ID: return 510;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 6, true).ID: return 511;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 6, false).ID: return 512;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 7, true).ID: return 513;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 7, false).ID: return 514;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 8, true).ID: return 515;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 8, false).ID: return 516;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 9, true).ID: return 517;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 9, false).ID: return 518;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 10, true).ID: return 519;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 10, false).ID: return 520;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 11, true).ID: return 521;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 11, false).ID: return 522;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 12, true).ID: return 523;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 12, false).ID: return 524;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 13, true).ID: return 525;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 13, false).ID: return 526;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 14, true).ID: return 527;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 14, false).ID: return 528;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 15, true).ID: return 529;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 15, false).ID: return 530;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 16, true).ID: return 531;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 16, false).ID: return 532;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 17, true).ID: return 533;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 17, false).ID: return 534;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 18, true).ID: return 535;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 18, false).ID: return 536;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 19, true).ID: return 537;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 19, false).ID: return 538;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 20, true).ID: return 539;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 20, false).ID: return 540;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 21, true).ID: return 541;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 21, false).ID: return 542;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 22, true).ID: return 543;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 22, false).ID: return 544;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 23, true).ID: return 545;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 23, false).ID: return 546;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 24, true).ID: return 547;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Flute, 24, false).ID: return 548;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 0, true).ID: return 549;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 0, false).ID: return 550;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 1, true).ID: return 551;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 1, false).ID: return 552;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 2, true).ID: return 553;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 2, false).ID: return 554;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 3, true).ID: return 555;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 3, false).ID: return 556;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 4, true).ID: return 557;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 4, false).ID: return 558;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 5, true).ID: return 559;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 5, false).ID: return 560;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 6, true).ID: return 561;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 6, false).ID: return 562;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 7, true).ID: return 563;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 7, false).ID: return 564;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 8, true).ID: return 565;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 8, false).ID: return 566;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 9, true).ID: return 567;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 9, false).ID: return 568;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 10, true).ID: return 569;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 10, false).ID: return 570;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 11, true).ID: return 571;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 11, false).ID: return 572;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 12, true).ID: return 573;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 12, false).ID: return 574;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 13, true).ID: return 575;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 13, false).ID: return 576;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 14, true).ID: return 577;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 14, false).ID: return 578;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 15, true).ID: return 579;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 15, false).ID: return 580;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 16, true).ID: return 581;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 16, false).ID: return 582;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 17, true).ID: return 583;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 17, false).ID: return 584;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 18, true).ID: return 585;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 18, false).ID: return 586;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 19, true).ID: return 587;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 19, false).ID: return 588;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 20, true).ID: return 589;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 20, false).ID: return 590;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 21, true).ID: return 591;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 21, false).ID: return 592;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 22, true).ID: return 593;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 22, false).ID: return 594;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 23, true).ID: return 595;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 23, false).ID: return 596;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 24, true).ID: return 597;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bell, 24, false).ID: return 598;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 0, true).ID: return 599;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 0, false).ID: return 600;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 1, true).ID: return 601;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 1, false).ID: return 602;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 2, true).ID: return 603;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 2, false).ID: return 604;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 3, true).ID: return 605;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 3, false).ID: return 606;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 4, true).ID: return 607;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 4, false).ID: return 608;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 5, true).ID: return 609;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 5, false).ID: return 610;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 6, true).ID: return 611;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 6, false).ID: return 612;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 7, true).ID: return 613;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 7, false).ID: return 614;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 8, true).ID: return 615;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 8, false).ID: return 616;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 9, true).ID: return 617;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 9, false).ID: return 618;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 10, true).ID: return 619;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 10, false).ID: return 620;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 11, true).ID: return 621;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 11, false).ID: return 622;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 12, true).ID: return 623;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 12, false).ID: return 624;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 13, true).ID: return 625;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 13, false).ID: return 626;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 14, true).ID: return 627;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 14, false).ID: return 628;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 15, true).ID: return 629;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 15, false).ID: return 630;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 16, true).ID: return 631;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 16, false).ID: return 632;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 17, true).ID: return 633;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 17, false).ID: return 634;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 18, true).ID: return 635;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 18, false).ID: return 636;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 19, true).ID: return 637;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 19, false).ID: return 638;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 20, true).ID: return 639;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 20, false).ID: return 640;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 21, true).ID: return 641;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 21, false).ID: return 642;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 22, true).ID: return 643;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 22, false).ID: return 644;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 23, true).ID: return 645;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 23, false).ID: return 646;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 24, true).ID: return 647;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Guitar, 24, false).ID: return 648;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 0, true).ID: return 649;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 0, false).ID: return 650;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 1, true).ID: return 651;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 1, false).ID: return 652;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 2, true).ID: return 653;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 2, false).ID: return 654;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 3, true).ID: return 655;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 3, false).ID: return 656;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 4, true).ID: return 657;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 4, false).ID: return 658;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 5, true).ID: return 659;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 5, false).ID: return 660;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 6, true).ID: return 661;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 6, false).ID: return 662;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 7, true).ID: return 663;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 7, false).ID: return 664;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 8, true).ID: return 665;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 8, false).ID: return 666;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 9, true).ID: return 667;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 9, false).ID: return 668;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 10, true).ID: return 669;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 10, false).ID: return 670;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 11, true).ID: return 671;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 11, false).ID: return 672;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 12, true).ID: return 673;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 12, false).ID: return 674;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 13, true).ID: return 675;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 13, false).ID: return 676;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 14, true).ID: return 677;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 14, false).ID: return 678;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 15, true).ID: return 679;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 15, false).ID: return 680;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 16, true).ID: return 681;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 16, false).ID: return 682;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 17, true).ID: return 683;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 17, false).ID: return 684;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 18, true).ID: return 685;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 18, false).ID: return 686;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 19, true).ID: return 687;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 19, false).ID: return 688;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 20, true).ID: return 689;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 20, false).ID: return 690;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 21, true).ID: return 691;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 21, false).ID: return 692;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 22, true).ID: return 693;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 22, false).ID: return 694;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 23, true).ID: return 695;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 23, false).ID: return 696;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 24, true).ID: return 697;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Chime, 24, false).ID: return 698;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 0, true).ID: return 699;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 0, false).ID: return 700;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 1, true).ID: return 701;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 1, false).ID: return 702;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 2, true).ID: return 703;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 2, false).ID: return 704;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 3, true).ID: return 705;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 3, false).ID: return 706;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 4, true).ID: return 707;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 4, false).ID: return 708;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 5, true).ID: return 709;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 5, false).ID: return 710;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 6, true).ID: return 711;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 6, false).ID: return 712;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 7, true).ID: return 713;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 7, false).ID: return 714;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 8, true).ID: return 715;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 8, false).ID: return 716;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 9, true).ID: return 717;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 9, false).ID: return 718;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 10, true).ID: return 719;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 10, false).ID: return 720;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 11, true).ID: return 721;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 11, false).ID: return 722;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 12, true).ID: return 723;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 12, false).ID: return 724;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 13, true).ID: return 725;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 13, false).ID: return 726;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 14, true).ID: return 727;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 14, false).ID: return 728;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 15, true).ID: return 729;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 15, false).ID: return 730;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 16, true).ID: return 731;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 16, false).ID: return 732;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 17, true).ID: return 733;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 17, false).ID: return 734;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 18, true).ID: return 735;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 18, false).ID: return 736;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 19, true).ID: return 737;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 19, false).ID: return 738;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 20, true).ID: return 739;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 20, false).ID: return 740;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 21, true).ID: return 741;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 21, false).ID: return 742;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 22, true).ID: return 743;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 22, false).ID: return 744;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 23, true).ID: return 745;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 23, false).ID: return 746;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 24, true).ID: return 747;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Xylophone, 24, false).ID: return 748;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 0, true).ID: return 749;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 0, false).ID: return 750;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 1, true).ID: return 751;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 1, false).ID: return 752;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 2, true).ID: return 753;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 2, false).ID: return 754;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 3, true).ID: return 755;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 3, false).ID: return 756;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 4, true).ID: return 757;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 4, false).ID: return 758;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 5, true).ID: return 759;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 5, false).ID: return 760;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 6, true).ID: return 761;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 6, false).ID: return 762;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 7, true).ID: return 763;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 7, false).ID: return 764;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 8, true).ID: return 765;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 8, false).ID: return 766;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 9, true).ID: return 767;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 9, false).ID: return 768;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 10, true).ID: return 769;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 10, false).ID: return 770;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 11, true).ID: return 771;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 11, false).ID: return 772;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 12, true).ID: return 773;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 12, false).ID: return 774;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 13, true).ID: return 775;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 13, false).ID: return 776;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 14, true).ID: return 777;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 14, false).ID: return 778;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 15, true).ID: return 779;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 15, false).ID: return 780;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 16, true).ID: return 781;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 16, false).ID: return 782;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 17, true).ID: return 783;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 17, false).ID: return 784;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 18, true).ID: return 785;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 18, false).ID: return 786;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 19, true).ID: return 787;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 19, false).ID: return 788;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 20, true).ID: return 789;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 20, false).ID: return 790;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 21, true).ID: return 791;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 21, false).ID: return 792;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 22, true).ID: return 793;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 22, false).ID: return 794;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 23, true).ID: return 795;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 23, false).ID: return 796;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 24, true).ID: return 797;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::IronXylophone, 24, false).ID: return 798;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 0, true).ID: return 799;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 0, false).ID: return 800;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 1, true).ID: return 801;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 1, false).ID: return 802;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 2, true).ID: return 803;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 2, false).ID: return 804;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 3, true).ID: return 805;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 3, false).ID: return 806;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 4, true).ID: return 807;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 4, false).ID: return 808;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 5, true).ID: return 809;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 5, false).ID: return 810;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 6, true).ID: return 811;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 6, false).ID: return 812;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 7, true).ID: return 813;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 7, false).ID: return 814;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 8, true).ID: return 815;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 8, false).ID: return 816;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 9, true).ID: return 817;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 9, false).ID: return 818;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 10, true).ID: return 819;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 10, false).ID: return 820;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 11, true).ID: return 821;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 11, false).ID: return 822;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 12, true).ID: return 823;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 12, false).ID: return 824;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 13, true).ID: return 825;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 13, false).ID: return 826;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 14, true).ID: return 827;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 14, false).ID: return 828;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 15, true).ID: return 829;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 15, false).ID: return 830;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 16, true).ID: return 831;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 16, false).ID: return 832;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 17, true).ID: return 833;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 17, false).ID: return 834;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 18, true).ID: return 835;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 18, false).ID: return 836;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 19, true).ID: return 837;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 19, false).ID: return 838;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 20, true).ID: return 839;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 20, false).ID: return 840;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 21, true).ID: return 841;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 21, false).ID: return 842;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 22, true).ID: return 843;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 22, false).ID: return 844;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 23, true).ID: return 845;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 23, false).ID: return 846;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 24, true).ID: return 847;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::CowBell, 24, false).ID: return 848;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 0, true).ID: return 849;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 0, false).ID: return 850;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 1, true).ID: return 851;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 1, false).ID: return 852;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 2, true).ID: return 853;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 2, false).ID: return 854;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 3, true).ID: return 855;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 3, false).ID: return 856;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 4, true).ID: return 857;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 4, false).ID: return 858;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 5, true).ID: return 859;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 5, false).ID: return 860;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 6, true).ID: return 861;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 6, false).ID: return 862;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 7, true).ID: return 863;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 7, false).ID: return 864;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 8, true).ID: return 865;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 8, false).ID: return 866;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 9, true).ID: return 867;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 9, false).ID: return 868;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 10, true).ID: return 869;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 10, false).ID: return 870;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 11, true).ID: return 871;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 11, false).ID: return 872;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 12, true).ID: return 873;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 12, false).ID: return 874;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 13, true).ID: return 875;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 13, false).ID: return 876;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 14, true).ID: return 877;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 14, false).ID: return 878;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 15, true).ID: return 879;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 15, false).ID: return 880;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 16, true).ID: return 881;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 16, false).ID: return 882;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 17, true).ID: return 883;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 17, false).ID: return 884;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 18, true).ID: return 885;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 18, false).ID: return 886;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 19, true).ID: return 887;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 19, false).ID: return 888;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 20, true).ID: return 889;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 20, false).ID: return 890;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 21, true).ID: return 891;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 21, false).ID: return 892;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 22, true).ID: return 893;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 22, false).ID: return 894;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 23, true).ID: return 895;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 23, false).ID: return 896;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 24, true).ID: return 897;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Didgeridoo, 24, false).ID: return 898;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 0, true).ID: return 899;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 0, false).ID: return 900;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 1, true).ID: return 901;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 1, false).ID: return 902;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 2, true).ID: return 903;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 2, false).ID: return 904;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 3, true).ID: return 905;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 3, false).ID: return 906;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 4, true).ID: return 907;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 4, false).ID: return 908;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 5, true).ID: return 909;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 5, false).ID: return 910;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 6, true).ID: return 911;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 6, false).ID: return 912;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 7, true).ID: return 913;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 7, false).ID: return 914;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 8, true).ID: return 915;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 8, false).ID: return 916;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 9, true).ID: return 917;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 9, false).ID: return 918;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 10, true).ID: return 919;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 10, false).ID: return 920;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 11, true).ID: return 921;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 11, false).ID: return 922;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 12, true).ID: return 923;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 12, false).ID: return 924;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 13, true).ID: return 925;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 13, false).ID: return 926;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 14, true).ID: return 927;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 14, false).ID: return 928;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 15, true).ID: return 929;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 15, false).ID: return 930;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 16, true).ID: return 931;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 16, false).ID: return 932;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 17, true).ID: return 933;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 17, false).ID: return 934;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 18, true).ID: return 935;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 18, false).ID: return 936;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 19, true).ID: return 937;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 19, false).ID: return 938;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 20, true).ID: return 939;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 20, false).ID: return 940;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 21, true).ID: return 941;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 21, false).ID: return 942;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 22, true).ID: return 943;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 22, false).ID: return 944;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 23, true).ID: return 945;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 23, false).ID: return 946;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 24, true).ID: return 947;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Bit, 24, false).ID: return 948;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 0, true).ID: return 949;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 0, false).ID: return 950;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 1, true).ID: return 951;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 1, false).ID: return 952;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 2, true).ID: return 953;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 2, false).ID: return 954;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 3, true).ID: return 955;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 3, false).ID: return 956;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 4, true).ID: return 957;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 4, false).ID: return 958;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 5, true).ID: return 959;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 5, false).ID: return 960;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 6, true).ID: return 961;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 6, false).ID: return 962;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 7, true).ID: return 963;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 7, false).ID: return 964;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 8, true).ID: return 965;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 8, false).ID: return 966;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 9, true).ID: return 967;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 9, false).ID: return 968;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 10, true).ID: return 969;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 10, false).ID: return 970;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 11, true).ID: return 971;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 11, false).ID: return 972;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 12, true).ID: return 973;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 12, false).ID: return 974;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 13, true).ID: return 975;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 13, false).ID: return 976;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 14, true).ID: return 977;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 14, false).ID: return 978;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 15, true).ID: return 979;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 15, false).ID: return 980;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 16, true).ID: return 981;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 16, false).ID: return 982;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 17, true).ID: return 983;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 17, false).ID: return 984;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 18, true).ID: return 985;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 18, false).ID: return 986;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 19, true).ID: return 987;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 19, false).ID: return 988;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 20, true).ID: return 989;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 20, false).ID: return 990;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 21, true).ID: return 991;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 21, false).ID: return 992;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 22, true).ID: return 993;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 22, false).ID: return 994;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 23, true).ID: return 995;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 23, false).ID: return 996;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 24, true).ID: return 997;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Banjo, 24, false).ID: return 998;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 0, true).ID: return 999;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 0, false).ID: return 1000;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 1, true).ID: return 1001;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 1, false).ID: return 1002;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 2, true).ID: return 1003;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 2, false).ID: return 1004;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 3, true).ID: return 1005;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 3, false).ID: return 1006;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 4, true).ID: return 1007;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 4, false).ID: return 1008;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 5, true).ID: return 1009;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 5, false).ID: return 1010;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 6, true).ID: return 1011;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 6, false).ID: return 1012;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 7, true).ID: return 1013;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 7, false).ID: return 1014;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 8, true).ID: return 1015;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 8, false).ID: return 1016;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 9, true).ID: return 1017;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 9, false).ID: return 1018;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 10, true).ID: return 1019;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 10, false).ID: return 1020;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 11, true).ID: return 1021;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 11, false).ID: return 1022;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 12, true).ID: return 1023;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 12, false).ID: return 1024;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 13, true).ID: return 1025;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 13, false).ID: return 1026;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 14, true).ID: return 1027;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 14, false).ID: return 1028;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 15, true).ID: return 1029;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 15, false).ID: return 1030;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 16, true).ID: return 1031;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 16, false).ID: return 1032;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 17, true).ID: return 1033;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 17, false).ID: return 1034;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 18, true).ID: return 1035;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 18, false).ID: return 1036;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 19, true).ID: return 1037;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 19, false).ID: return 1038;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 20, true).ID: return 1039;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 20, false).ID: return 1040;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 21, true).ID: return 1041;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 21, false).ID: return 1042;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 22, true).ID: return 1043;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 22, false).ID: return 1044;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 23, true).ID: return 1045;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 23, false).ID: return 1046;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 24, true).ID: return 1047;
			case NoteBlock::NoteBlock(NoteBlock::Instrument::Pling, 24, false).ID: return 1048;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6346;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6347;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6348;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6349;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 6350;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 6351;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 6352;
			case OakButton::OakButton(OakButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 6353;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6354;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6355;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6356;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6357;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 6358;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 6359;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 6360;
			case OakButton::OakButton(OakButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 6361;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6362;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6363;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6364;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6365;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 6366;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 6367;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 6368;
			case OakButton::OakButton(OakButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 6369;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, true).ID: return 3573;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, false).ID: return 3574;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, true).ID: return 3575;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, false).ID: return 3576;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, true).ID: return 3577;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, false).ID: return 3578;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, true).ID: return 3579;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, false).ID: return 3580;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, true).ID: return 3581;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, false).ID: return 3582;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, true).ID: return 3583;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, false).ID: return 3584;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, true).ID: return 3585;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, false).ID: return 3586;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, true).ID: return 3587;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZM, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, false).ID: return 3588;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, true).ID: return 3589;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, false).ID: return 3590;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, true).ID: return 3591;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, false).ID: return 3592;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, true).ID: return 3593;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, false).ID: return 3594;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, true).ID: return 3595;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, false).ID: return 3596;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, true).ID: return 3597;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, false).ID: return 3598;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, true).ID: return 3599;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, false).ID: return 3600;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, true).ID: return 3601;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, false).ID: return 3602;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, true).ID: return 3603;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_ZP, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, false).ID: return 3604;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, true).ID: return 3605;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, false).ID: return 3606;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, true).ID: return 3607;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, false).ID: return 3608;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, true).ID: return 3609;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, false).ID: return 3610;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, true).ID: return 3611;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, false).ID: return 3612;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, true).ID: return 3613;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, false).ID: return 3614;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, true).ID: return 3615;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, false).ID: return 3616;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, true).ID: return 3617;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, false).ID: return 3618;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, true).ID: return 3619;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XM, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, false).ID: return 3620;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, true).ID: return 3621;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Left, true, false).ID: return 3622;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, true).ID: return 3623;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Left, false, false).ID: return 3624;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, true).ID: return 3625;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Right, true, false).ID: return 3626;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, true).ID: return 3627;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Upper, OakDoor::Hinge::Right, false, false).ID: return 3628;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, true).ID: return 3629;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Left, true, false).ID: return 3630;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, true).ID: return 3631;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Left, false, false).ID: return 3632;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, true).ID: return 3633;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Right, true, false).ID: return 3634;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, true).ID: return 3635;
			case OakDoor::OakDoor(eBlockFace::BLOCK_FACE_XP, OakDoor::Half::Lower, OakDoor::Hinge::Right, false, false).ID: return 3636;
			case OakFence::OakFence(true, true, true, true).ID: return 3968;
			case OakFence::OakFence(true, true, true, false).ID: return 3969;
			case OakFence::OakFence(true, true, false, true).ID: return 3972;
			case OakFence::OakFence(true, true, false, false).ID: return 3973;
			case OakFence::OakFence(true, false, true, true).ID: return 3976;
			case OakFence::OakFence(true, false, true, false).ID: return 3977;
			case OakFence::OakFence(true, false, false, true).ID: return 3980;
			case OakFence::OakFence(true, false, false, false).ID: return 3981;
			case OakFence::OakFence(false, true, true, true).ID: return 3984;
			case OakFence::OakFence(false, true, true, false).ID: return 3985;
			case OakFence::OakFence(false, true, false, true).ID: return 3988;
			case OakFence::OakFence(false, true, false, false).ID: return 3989;
			case OakFence::OakFence(false, false, true, true).ID: return 3992;
			case OakFence::OakFence(false, false, true, false).ID: return 3993;
			case OakFence::OakFence(false, false, false, true).ID: return 3996;
			case OakFence::OakFence(false, false, false, false).ID: return 3997;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 4820;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 4821;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 4822;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 4823;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 4824;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 4825;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 4826;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 4827;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 4828;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 4829;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 4830;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 4831;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 4832;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 4833;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 4834;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 4835;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 4836;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 4837;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 4838;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 4839;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 4840;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 4841;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 4842;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 4843;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 4844;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 4845;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 4846;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 4847;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 4848;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 4849;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 4850;
			case OakFenceGate::OakFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 4851;
			case OakLeaves::OakLeaves(1, true).ID: return 145;
			case OakLeaves::OakLeaves(1, false).ID: return 146;
			case OakLeaves::OakLeaves(2, true).ID: return 147;
			case OakLeaves::OakLeaves(2, false).ID: return 148;
			case OakLeaves::OakLeaves(3, true).ID: return 149;
			case OakLeaves::OakLeaves(3, false).ID: return 150;
			case OakLeaves::OakLeaves(4, true).ID: return 151;
			case OakLeaves::OakLeaves(4, false).ID: return 152;
			case OakLeaves::OakLeaves(5, true).ID: return 153;
			case OakLeaves::OakLeaves(5, false).ID: return 154;
			case OakLeaves::OakLeaves(6, true).ID: return 155;
			case OakLeaves::OakLeaves(6, false).ID: return 156;
			case OakLeaves::OakLeaves(7, true).ID: return 157;
			case OakLeaves::OakLeaves(7, false).ID: return 158;
			case OakLog::OakLog(OakLog::Axis::X).ID: return 73;
			case OakLog::OakLog(OakLog::Axis::Y).ID: return 74;
			case OakLog::OakLog(OakLog::Axis::Z).ID: return 75;
			case OakPlanks::OakPlanks().ID: return 15;
			case OakPressurePlate::OakPressurePlate(true).ID: return 3873;
			case OakPressurePlate::OakPressurePlate(false).ID: return 3874;
			case OakSapling::OakSapling(0).ID: return 21;
			case OakSapling::OakSapling(1).ID: return 22;
			case OakSign::OakSign(0).ID: return 3382;
			case OakSign::OakSign(1).ID: return 3384;
			case OakSign::OakSign(2).ID: return 3386;
			case OakSign::OakSign(3).ID: return 3388;
			case OakSign::OakSign(4).ID: return 3390;
			case OakSign::OakSign(5).ID: return 3392;
			case OakSign::OakSign(6).ID: return 3394;
			case OakSign::OakSign(7).ID: return 3396;
			case OakSign::OakSign(8).ID: return 3398;
			case OakSign::OakSign(9).ID: return 3400;
			case OakSign::OakSign(10).ID: return 3402;
			case OakSign::OakSign(11).ID: return 3404;
			case OakSign::OakSign(12).ID: return 3406;
			case OakSign::OakSign(13).ID: return 3408;
			case OakSign::OakSign(14).ID: return 3410;
			case OakSign::OakSign(15).ID: return 3412;
			case OakSlab::OakSlab(OakSlab::Type::Top).ID: return 8301;
			case OakSlab::OakSlab(OakSlab::Type::Bottom).ID: return 8303;
			case OakSlab::OakSlab(OakSlab::Type::Double).ID: return 8305;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Top, OakStairs::Shape::Straight).ID: return 1955;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Top, OakStairs::Shape::InnerLeft).ID: return 1957;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Top, OakStairs::Shape::InnerRight).ID: return 1959;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Top, OakStairs::Shape::OuterLeft).ID: return 1961;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Top, OakStairs::Shape::OuterRight).ID: return 1963;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Bottom, OakStairs::Shape::Straight).ID: return 1965;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Bottom, OakStairs::Shape::InnerLeft).ID: return 1967;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Bottom, OakStairs::Shape::InnerRight).ID: return 1969;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Bottom, OakStairs::Shape::OuterLeft).ID: return 1971;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZM, OakStairs::Half::Bottom, OakStairs::Shape::OuterRight).ID: return 1973;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Top, OakStairs::Shape::Straight).ID: return 1975;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Top, OakStairs::Shape::InnerLeft).ID: return 1977;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Top, OakStairs::Shape::InnerRight).ID: return 1979;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Top, OakStairs::Shape::OuterLeft).ID: return 1981;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Top, OakStairs::Shape::OuterRight).ID: return 1983;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Bottom, OakStairs::Shape::Straight).ID: return 1985;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Bottom, OakStairs::Shape::InnerLeft).ID: return 1987;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Bottom, OakStairs::Shape::InnerRight).ID: return 1989;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Bottom, OakStairs::Shape::OuterLeft).ID: return 1991;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_ZP, OakStairs::Half::Bottom, OakStairs::Shape::OuterRight).ID: return 1993;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Top, OakStairs::Shape::Straight).ID: return 1995;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Top, OakStairs::Shape::InnerLeft).ID: return 1997;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Top, OakStairs::Shape::InnerRight).ID: return 1999;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Top, OakStairs::Shape::OuterLeft).ID: return 2001;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Top, OakStairs::Shape::OuterRight).ID: return 2003;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Bottom, OakStairs::Shape::Straight).ID: return 2005;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Bottom, OakStairs::Shape::InnerLeft).ID: return 2007;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Bottom, OakStairs::Shape::InnerRight).ID: return 2009;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Bottom, OakStairs::Shape::OuterLeft).ID: return 2011;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XM, OakStairs::Half::Bottom, OakStairs::Shape::OuterRight).ID: return 2013;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Top, OakStairs::Shape::Straight).ID: return 2015;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Top, OakStairs::Shape::InnerLeft).ID: return 2017;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Top, OakStairs::Shape::InnerRight).ID: return 2019;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Top, OakStairs::Shape::OuterLeft).ID: return 2021;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Top, OakStairs::Shape::OuterRight).ID: return 2023;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Bottom, OakStairs::Shape::Straight).ID: return 2025;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Bottom, OakStairs::Shape::InnerLeft).ID: return 2027;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Bottom, OakStairs::Shape::InnerRight).ID: return 2029;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Bottom, OakStairs::Shape::OuterLeft).ID: return 2031;
			case OakStairs::OakStairs(eBlockFace::BLOCK_FACE_XP, OakStairs::Half::Bottom, OakStairs::Shape::OuterRight).ID: return 2033;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Top, true, true).ID: return 4112;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Top, true, false).ID: return 4114;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Top, false, true).ID: return 4116;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Top, false, false).ID: return 4118;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Bottom, true, true).ID: return 4120;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Bottom, true, false).ID: return 4122;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Bottom, false, true).ID: return 4124;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZM, OakTrapdoor::Half::Bottom, false, false).ID: return 4126;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Top, true, true).ID: return 4128;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Top, true, false).ID: return 4130;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Top, false, true).ID: return 4132;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Top, false, false).ID: return 4134;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Bottom, true, true).ID: return 4136;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Bottom, true, false).ID: return 4138;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Bottom, false, true).ID: return 4140;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_ZP, OakTrapdoor::Half::Bottom, false, false).ID: return 4142;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Top, true, true).ID: return 4144;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Top, true, false).ID: return 4146;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Top, false, true).ID: return 4148;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Top, false, false).ID: return 4150;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Bottom, true, true).ID: return 4152;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Bottom, true, false).ID: return 4154;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Bottom, false, true).ID: return 4156;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XM, OakTrapdoor::Half::Bottom, false, false).ID: return 4158;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Top, true, true).ID: return 4160;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Top, true, false).ID: return 4162;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Top, false, true).ID: return 4164;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Top, false, false).ID: return 4166;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Bottom, true, true).ID: return 4168;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Bottom, true, false).ID: return 4170;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Bottom, false, true).ID: return 4172;
			case OakTrapdoor::OakTrapdoor(eBlockFace::BLOCK_FACE_XP, OakTrapdoor::Half::Bottom, false, false).ID: return 4174;
			case OakWallSign::OakWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 3736;
			case OakWallSign::OakWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 3738;
			case OakWallSign::OakWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 3740;
			case OakWallSign::OakWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 3742;
			case OakWood::OakWood(OakWood::Axis::X).ID: return 109;
			case OakWood::OakWood(OakWood::Axis::Y).ID: return 110;
			case OakWood::OakWood(OakWood::Axis::Z).ID: return 111;
			case Observer::Observer(eBlockFace::BLOCK_FACE_ZM, true).ID: return 9260;
			case Observer::Observer(eBlockFace::BLOCK_FACE_ZM, false).ID: return 9261;
			case Observer::Observer(eBlockFace::BLOCK_FACE_XP, true).ID: return 9262;
			case Observer::Observer(eBlockFace::BLOCK_FACE_XP, false).ID: return 9263;
			case Observer::Observer(eBlockFace::BLOCK_FACE_ZP, true).ID: return 9264;
			case Observer::Observer(eBlockFace::BLOCK_FACE_ZP, false).ID: return 9265;
			case Observer::Observer(eBlockFace::BLOCK_FACE_XM, true).ID: return 9266;
			case Observer::Observer(eBlockFace::BLOCK_FACE_XM, false).ID: return 9267;
			case Observer::Observer(eBlockFace::BLOCK_FACE_YP, true).ID: return 9268;
			case Observer::Observer(eBlockFace::BLOCK_FACE_YP, false).ID: return 9269;
			case Observer::Observer(eBlockFace::BLOCK_FACE_YM, true).ID: return 9270;
			case Observer::Observer(eBlockFace::BLOCK_FACE_YM, false).ID: return 9271;
			case Obsidian::Obsidian().ID: return 1434;
			case OrangeBanner::OrangeBanner(0).ID: return 7913;
			case OrangeBanner::OrangeBanner(1).ID: return 7914;
			case OrangeBanner::OrangeBanner(2).ID: return 7915;
			case OrangeBanner::OrangeBanner(3).ID: return 7916;
			case OrangeBanner::OrangeBanner(4).ID: return 7917;
			case OrangeBanner::OrangeBanner(5).ID: return 7918;
			case OrangeBanner::OrangeBanner(6).ID: return 7919;
			case OrangeBanner::OrangeBanner(7).ID: return 7920;
			case OrangeBanner::OrangeBanner(8).ID: return 7921;
			case OrangeBanner::OrangeBanner(9).ID: return 7922;
			case OrangeBanner::OrangeBanner(10).ID: return 7923;
			case OrangeBanner::OrangeBanner(11).ID: return 7924;
			case OrangeBanner::OrangeBanner(12).ID: return 7925;
			case OrangeBanner::OrangeBanner(13).ID: return 7926;
			case OrangeBanner::OrangeBanner(14).ID: return 7927;
			case OrangeBanner::OrangeBanner(15).ID: return 7928;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZM, true, OrangeBed::Part::Head).ID: return 1065;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZM, true, OrangeBed::Part::Foot).ID: return 1066;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZM, false, OrangeBed::Part::Head).ID: return 1067;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZM, false, OrangeBed::Part::Foot).ID: return 1068;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZP, true, OrangeBed::Part::Head).ID: return 1069;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZP, true, OrangeBed::Part::Foot).ID: return 1070;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZP, false, OrangeBed::Part::Head).ID: return 1071;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_ZP, false, OrangeBed::Part::Foot).ID: return 1072;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XM, true, OrangeBed::Part::Head).ID: return 1073;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XM, true, OrangeBed::Part::Foot).ID: return 1074;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XM, false, OrangeBed::Part::Head).ID: return 1075;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XM, false, OrangeBed::Part::Foot).ID: return 1076;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XP, true, OrangeBed::Part::Head).ID: return 1077;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XP, true, OrangeBed::Part::Foot).ID: return 1078;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XP, false, OrangeBed::Part::Head).ID: return 1079;
			case OrangeBed::OrangeBed(eBlockFace::BLOCK_FACE_XP, false, OrangeBed::Part::Foot).ID: return 1080;
			case OrangeCarpet::OrangeCarpet().ID: return 7867;
			case OrangeConcrete::OrangeConcrete().ID: return 9439;
			case OrangeConcretePowder::OrangeConcretePowder().ID: return 9455;
			case OrangeGlazedTerracotta::OrangeGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9378;
			case OrangeGlazedTerracotta::OrangeGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9379;
			case OrangeGlazedTerracotta::OrangeGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9380;
			case OrangeGlazedTerracotta::OrangeGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9381;
			case OrangeShulkerBox::OrangeShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9284;
			case OrangeShulkerBox::OrangeShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9285;
			case OrangeShulkerBox::OrangeShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9286;
			case OrangeShulkerBox::OrangeShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9287;
			case OrangeShulkerBox::OrangeShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9288;
			case OrangeShulkerBox::OrangeShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9289;
			case OrangeStainedGlass::OrangeStainedGlass().ID: return 4096;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, true, true, true).ID: return 6897;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, true, true, false).ID: return 6898;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, true, false, true).ID: return 6901;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, true, false, false).ID: return 6902;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, false, true, true).ID: return 6905;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, false, true, false).ID: return 6906;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, false, false, true).ID: return 6909;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(true, false, false, false).ID: return 6910;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, true, true, true).ID: return 6913;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, true, true, false).ID: return 6914;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, true, false, true).ID: return 6917;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, true, false, false).ID: return 6918;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, false, true, true).ID: return 6921;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, false, true, false).ID: return 6922;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, false, false, true).ID: return 6925;
			case OrangeStainedGlassPane::OrangeStainedGlassPane(false, false, false, false).ID: return 6926;
			case OrangeTerracotta::OrangeTerracotta().ID: return 6848;
			case OrangeTulip::OrangeTulip().ID: return 1418;
			case OrangeWallBanner::OrangeWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8157;
			case OrangeWallBanner::OrangeWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8158;
			case OrangeWallBanner::OrangeWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8159;
			case OrangeWallBanner::OrangeWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8160;
			case OrangeWool::OrangeWool().ID: return 1385;
			case OxeyeDaisy::OxeyeDaisy().ID: return 1421;
			case PackedIce::PackedIce().ID: return 7884;
			case Peony::Peony(Peony::Half::Upper).ID: return 7891;
			case Peony::Peony(Peony::Half::Lower).ID: return 7892;
			case PetrifiedOakSlab::PetrifiedOakSlab(PetrifiedOakSlab::Type::Top).ID: return 8361;
			case PetrifiedOakSlab::PetrifiedOakSlab(PetrifiedOakSlab::Type::Bottom).ID: return 8363;
			case PetrifiedOakSlab::PetrifiedOakSlab(PetrifiedOakSlab::Type::Double).ID: return 8365;
			case PinkBanner::PinkBanner(0).ID: return 7993;
			case PinkBanner::PinkBanner(1).ID: return 7994;
			case PinkBanner::PinkBanner(2).ID: return 7995;
			case PinkBanner::PinkBanner(3).ID: return 7996;
			case PinkBanner::PinkBanner(4).ID: return 7997;
			case PinkBanner::PinkBanner(5).ID: return 7998;
			case PinkBanner::PinkBanner(6).ID: return 7999;
			case PinkBanner::PinkBanner(7).ID: return 8000;
			case PinkBanner::PinkBanner(8).ID: return 8001;
			case PinkBanner::PinkBanner(9).ID: return 8002;
			case PinkBanner::PinkBanner(10).ID: return 8003;
			case PinkBanner::PinkBanner(11).ID: return 8004;
			case PinkBanner::PinkBanner(12).ID: return 8005;
			case PinkBanner::PinkBanner(13).ID: return 8006;
			case PinkBanner::PinkBanner(14).ID: return 8007;
			case PinkBanner::PinkBanner(15).ID: return 8008;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZM, true, PinkBed::Part::Head).ID: return 1145;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZM, true, PinkBed::Part::Foot).ID: return 1146;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZM, false, PinkBed::Part::Head).ID: return 1147;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZM, false, PinkBed::Part::Foot).ID: return 1148;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZP, true, PinkBed::Part::Head).ID: return 1149;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZP, true, PinkBed::Part::Foot).ID: return 1150;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZP, false, PinkBed::Part::Head).ID: return 1151;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_ZP, false, PinkBed::Part::Foot).ID: return 1152;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XM, true, PinkBed::Part::Head).ID: return 1153;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XM, true, PinkBed::Part::Foot).ID: return 1154;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XM, false, PinkBed::Part::Head).ID: return 1155;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XM, false, PinkBed::Part::Foot).ID: return 1156;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XP, true, PinkBed::Part::Head).ID: return 1157;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XP, true, PinkBed::Part::Foot).ID: return 1158;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XP, false, PinkBed::Part::Head).ID: return 1159;
			case PinkBed::PinkBed(eBlockFace::BLOCK_FACE_XP, false, PinkBed::Part::Foot).ID: return 1160;
			case PinkCarpet::PinkCarpet().ID: return 7872;
			case PinkConcrete::PinkConcrete().ID: return 9444;
			case PinkConcretePowder::PinkConcretePowder().ID: return 9460;
			case PinkGlazedTerracotta::PinkGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9398;
			case PinkGlazedTerracotta::PinkGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9399;
			case PinkGlazedTerracotta::PinkGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9400;
			case PinkGlazedTerracotta::PinkGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9401;
			case PinkShulkerBox::PinkShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9314;
			case PinkShulkerBox::PinkShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9315;
			case PinkShulkerBox::PinkShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9316;
			case PinkShulkerBox::PinkShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9317;
			case PinkShulkerBox::PinkShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9318;
			case PinkShulkerBox::PinkShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9319;
			case PinkStainedGlass::PinkStainedGlass().ID: return 4101;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, true, true, true).ID: return 7057;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, true, true, false).ID: return 7058;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, true, false, true).ID: return 7061;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, true, false, false).ID: return 7062;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, false, true, true).ID: return 7065;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, false, true, false).ID: return 7066;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, false, false, true).ID: return 7069;
			case PinkStainedGlassPane::PinkStainedGlassPane(true, false, false, false).ID: return 7070;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, true, true, true).ID: return 7073;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, true, true, false).ID: return 7074;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, true, false, true).ID: return 7077;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, true, false, false).ID: return 7078;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, false, true, true).ID: return 7081;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, false, true, false).ID: return 7082;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, false, false, true).ID: return 7085;
			case PinkStainedGlassPane::PinkStainedGlassPane(false, false, false, false).ID: return 7086;
			case PinkTerracotta::PinkTerracotta().ID: return 6853;
			case PinkTulip::PinkTulip().ID: return 1420;
			case PinkWallBanner::PinkWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8177;
			case PinkWallBanner::PinkWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8178;
			case PinkWallBanner::PinkWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8179;
			case PinkWallBanner::PinkWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8180;
			case PinkWool::PinkWool().ID: return 1390;
			case Piston::Piston(true, eBlockFace::BLOCK_FACE_ZM).ID: return 1348;
			case Piston::Piston(true, eBlockFace::BLOCK_FACE_XP).ID: return 1349;
			case Piston::Piston(true, eBlockFace::BLOCK_FACE_ZP).ID: return 1350;
			case Piston::Piston(true, eBlockFace::BLOCK_FACE_XM).ID: return 1351;
			case Piston::Piston(true, eBlockFace::BLOCK_FACE_YP).ID: return 1352;
			case Piston::Piston(true, eBlockFace::BLOCK_FACE_YM).ID: return 1353;
			case Piston::Piston(false, eBlockFace::BLOCK_FACE_ZM).ID: return 1354;
			case Piston::Piston(false, eBlockFace::BLOCK_FACE_XP).ID: return 1355;
			case Piston::Piston(false, eBlockFace::BLOCK_FACE_ZP).ID: return 1356;
			case Piston::Piston(false, eBlockFace::BLOCK_FACE_XM).ID: return 1357;
			case Piston::Piston(false, eBlockFace::BLOCK_FACE_YP).ID: return 1358;
			case Piston::Piston(false, eBlockFace::BLOCK_FACE_YM).ID: return 1359;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZM, true, PistonHead::Type::Normal).ID: return 1360;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZM, true, PistonHead::Type::Sticky).ID: return 1361;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZM, false, PistonHead::Type::Normal).ID: return 1362;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZM, false, PistonHead::Type::Sticky).ID: return 1363;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XP, true, PistonHead::Type::Normal).ID: return 1364;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XP, true, PistonHead::Type::Sticky).ID: return 1365;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XP, false, PistonHead::Type::Normal).ID: return 1366;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XP, false, PistonHead::Type::Sticky).ID: return 1367;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZP, true, PistonHead::Type::Normal).ID: return 1368;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZP, true, PistonHead::Type::Sticky).ID: return 1369;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZP, false, PistonHead::Type::Normal).ID: return 1370;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_ZP, false, PistonHead::Type::Sticky).ID: return 1371;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XM, true, PistonHead::Type::Normal).ID: return 1372;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XM, true, PistonHead::Type::Sticky).ID: return 1373;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XM, false, PistonHead::Type::Normal).ID: return 1374;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_XM, false, PistonHead::Type::Sticky).ID: return 1375;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YP, true, PistonHead::Type::Normal).ID: return 1376;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YP, true, PistonHead::Type::Sticky).ID: return 1377;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YP, false, PistonHead::Type::Normal).ID: return 1378;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YP, false, PistonHead::Type::Sticky).ID: return 1379;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YM, true, PistonHead::Type::Normal).ID: return 1380;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YM, true, PistonHead::Type::Sticky).ID: return 1381;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YM, false, PistonHead::Type::Normal).ID: return 1382;
			case PistonHead::PistonHead(eBlockFace::BLOCK_FACE_YM, false, PistonHead::Type::Sticky).ID: return 1383;
			case PlayerHead::PlayerHead(0).ID: return 6550;
			case PlayerHead::PlayerHead(1).ID: return 6551;
			case PlayerHead::PlayerHead(2).ID: return 6552;
			case PlayerHead::PlayerHead(3).ID: return 6553;
			case PlayerHead::PlayerHead(4).ID: return 6554;
			case PlayerHead::PlayerHead(5).ID: return 6555;
			case PlayerHead::PlayerHead(6).ID: return 6556;
			case PlayerHead::PlayerHead(7).ID: return 6557;
			case PlayerHead::PlayerHead(8).ID: return 6558;
			case PlayerHead::PlayerHead(9).ID: return 6559;
			case PlayerHead::PlayerHead(10).ID: return 6560;
			case PlayerHead::PlayerHead(11).ID: return 6561;
			case PlayerHead::PlayerHead(12).ID: return 6562;
			case PlayerHead::PlayerHead(13).ID: return 6563;
			case PlayerHead::PlayerHead(14).ID: return 6564;
			case PlayerHead::PlayerHead(15).ID: return 6565;
			case PlayerWallHead::PlayerWallHead(eBlockFace::BLOCK_FACE_ZM).ID: return 6566;
			case PlayerWallHead::PlayerWallHead(eBlockFace::BLOCK_FACE_ZP).ID: return 6567;
			case PlayerWallHead::PlayerWallHead(eBlockFace::BLOCK_FACE_XM).ID: return 6568;
			case PlayerWallHead::PlayerWallHead(eBlockFace::BLOCK_FACE_XP).ID: return 6569;
			case Podzol::Podzol(true).ID: return 12;
			case Podzol::Podzol(false).ID: return 13;
			case PolishedAndesite::PolishedAndesite().ID: return 7;
			case PolishedAndesiteSlab::PolishedAndesiteSlab(PolishedAndesiteSlab::Type::Top).ID: return 10856;
			case PolishedAndesiteSlab::PolishedAndesiteSlab(PolishedAndesiteSlab::Type::Bottom).ID: return 10858;
			case PolishedAndesiteSlab::PolishedAndesiteSlab(PolishedAndesiteSlab::Type::Double).ID: return 10860;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::Straight).ID: return 10630;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10632;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10634;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10636;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10638;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::Straight).ID: return 10640;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10642;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10644;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10646;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10648;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::Straight).ID: return 10650;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10652;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10654;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10656;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10658;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::Straight).ID: return 10660;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10662;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10664;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10666;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10668;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::Straight).ID: return 10670;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10672;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10674;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10676;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10678;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::Straight).ID: return 10680;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10682;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10684;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10686;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XM, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10688;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::Straight).ID: return 10690;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10692;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10694;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10696;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Top, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10698;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::Straight).ID: return 10700;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerLeft).ID: return 10702;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::InnerRight).ID: return 10704;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterLeft).ID: return 10706;
			case PolishedAndesiteStairs::PolishedAndesiteStairs(eBlockFace::BLOCK_FACE_XP, PolishedAndesiteStairs::Half::Bottom, PolishedAndesiteStairs::Shape::OuterRight).ID: return 10708;
			case PolishedBasalt::PolishedBasalt(PolishedBasalt::Axis::X).ID: return 4005;
			case PolishedBasalt::PolishedBasalt(PolishedBasalt::Axis::Y).ID: return 4006;
			case PolishedBasalt::PolishedBasalt(PolishedBasalt::Axis::Z).ID: return 4007;
			case PolishedBlackstone::PolishedBlackstone().ID: return 16250;
			case PolishedBlackstoneBrickSlab::PolishedBlackstoneBrickSlab(PolishedBlackstoneBrickSlab::Type::Top).ID: return 16255;
			case PolishedBlackstoneBrickSlab::PolishedBlackstoneBrickSlab(PolishedBlackstoneBrickSlab::Type::Bottom).ID: return 16257;
			case PolishedBlackstoneBrickSlab::PolishedBlackstoneBrickSlab(PolishedBlackstoneBrickSlab::Type::Double).ID: return 16259;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16261;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16263;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16265;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16267;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16269;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16271;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16273;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16275;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16277;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16279;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16281;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16283;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16285;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16287;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16289;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16291;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16293;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16295;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16297;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16299;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16301;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16303;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16305;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16307;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16309;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16311;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16313;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16315;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16317;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16319;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16321;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16323;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16325;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16327;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Top, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16329;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::Straight).ID: return 16331;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerLeft).ID: return 16333;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::InnerRight).ID: return 16335;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterLeft).ID: return 16337;
			case PolishedBlackstoneBrickStairs::PolishedBlackstoneBrickStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneBrickStairs::Half::Bottom, PolishedBlackstoneBrickStairs::Shape::OuterRight).ID: return 16339;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16343;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16344;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16345;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16349;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16350;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16351;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16355;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16356;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16357;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16361;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16362;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16363;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16367;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16368;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16369;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16373;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16374;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16375;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16379;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16380;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16381;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16385;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16386;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16387;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16391;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16392;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16393;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16397;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16398;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16399;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16403;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16404;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16405;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16409;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16410;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16411;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16415;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16416;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16417;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16421;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16422;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16423;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16427;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16428;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16429;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16433;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16434;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16435;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16439;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16440;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16441;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16445;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16446;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::None, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16447;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16451;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16452;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16453;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16457;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16458;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16459;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16463;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16464;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16465;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16469;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16470;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16471;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16475;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16476;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16477;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16481;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16482;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16483;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16487;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16488;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16489;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16493;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16494;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16495;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16499;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16500;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16501;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16505;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16506;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16507;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16511;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16512;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16513;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16517;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16518;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16519;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16523;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16524;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16525;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16529;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16530;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16531;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16535;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16536;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16537;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16541;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16542;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16543;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16547;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16548;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16549;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16553;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16554;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Low, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16555;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16559;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16560;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16561;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16565;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16566;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16567;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16571;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16572;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16573;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16577;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16578;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16579;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16583;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16584;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16585;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16589;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16590;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::None, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16591;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16595;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16596;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16597;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16601;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16602;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16603;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16607;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16608;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16609;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16613;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16614;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16615;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16619;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16620;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16621;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16625;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16626;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Low, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16627;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::None).ID: return 16631;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16632;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16633;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::None).ID: return 16637;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16638;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::None, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16639;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::None).ID: return 16643;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16644;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16645;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::None).ID: return 16649;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16650;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Low, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16651;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::None).ID: return 16655;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Low).ID: return 16656;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, true, PolishedBlackstoneBrickWall::West::Tall).ID: return 16657;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::None).ID: return 16661;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Low).ID: return 16662;
			case PolishedBlackstoneBrickWall::PolishedBlackstoneBrickWall(PolishedBlackstoneBrickWall::East::Tall, PolishedBlackstoneBrickWall::North::Tall, PolishedBlackstoneBrickWall::South::Tall, false, PolishedBlackstoneBrickWall::West::Tall).ID: return 16663;
			case PolishedBlackstoneBricks::PolishedBlackstoneBricks().ID: return 16251;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 16753;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 16754;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 16755;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 16756;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 16757;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 16758;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 16759;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 16760;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 16761;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 16762;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 16763;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 16764;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 16765;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 16766;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 16767;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 16768;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 16769;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 16770;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 16771;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 16772;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 16773;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 16774;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 16775;
			case PolishedBlackstoneButton::PolishedBlackstoneButton(PolishedBlackstoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 16776;
			case PolishedBlackstonePressurePlate::PolishedBlackstonePressurePlate(true).ID: return 16751;
			case PolishedBlackstonePressurePlate::PolishedBlackstonePressurePlate(false).ID: return 16752;
			case PolishedBlackstoneSlab::PolishedBlackstoneSlab(PolishedBlackstoneSlab::Type::Top).ID: return 16746;
			case PolishedBlackstoneSlab::PolishedBlackstoneSlab(PolishedBlackstoneSlab::Type::Bottom).ID: return 16748;
			case PolishedBlackstoneSlab::PolishedBlackstoneSlab(PolishedBlackstoneSlab::Type::Double).ID: return 16750;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::Straight).ID: return 16666;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16668;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16670;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16672;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16674;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::Straight).ID: return 16676;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16678;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16680;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16682;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16684;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::Straight).ID: return 16686;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16688;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16690;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16692;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16694;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::Straight).ID: return 16696;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16698;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16700;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16702;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_ZP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16704;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::Straight).ID: return 16706;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16708;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16710;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16712;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16714;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::Straight).ID: return 16716;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16718;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16720;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16722;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XM, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16724;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::Straight).ID: return 16726;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16728;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16730;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16732;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Top, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16734;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::Straight).ID: return 16736;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerLeft).ID: return 16738;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::InnerRight).ID: return 16740;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterLeft).ID: return 16742;
			case PolishedBlackstoneStairs::PolishedBlackstoneStairs(eBlockFace::BLOCK_FACE_XP, PolishedBlackstoneStairs::Half::Bottom, PolishedBlackstoneStairs::Shape::OuterRight).ID: return 16744;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16780;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16781;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16782;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 16786;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 16787;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 16788;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 16792;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 16793;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 16794;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 16798;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 16799;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 16800;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 16804;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 16805;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 16806;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 16810;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 16811;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 16812;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16816;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16817;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16818;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 16822;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 16823;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 16824;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 16828;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 16829;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 16830;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 16834;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 16835;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 16836;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 16840;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 16841;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 16842;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 16846;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 16847;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 16848;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16852;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16853;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16854;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 16858;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 16859;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 16860;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 16864;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 16865;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 16866;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 16870;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 16871;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 16872;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 16876;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 16877;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 16878;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 16882;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 16883;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::None, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 16884;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16888;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16889;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16890;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 16894;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 16895;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 16896;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 16900;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 16901;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 16902;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 16906;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 16907;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 16908;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 16912;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 16913;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 16914;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 16918;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 16919;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 16920;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16924;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16925;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16926;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 16930;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 16931;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 16932;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 16936;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 16937;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 16938;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 16942;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 16943;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 16944;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 16948;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 16949;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 16950;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 16954;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 16955;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 16956;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16960;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16961;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16962;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 16966;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 16967;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 16968;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 16972;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 16973;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 16974;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 16978;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 16979;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 16980;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 16984;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 16985;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 16986;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 16990;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 16991;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Low, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 16992;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 16996;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 16997;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 16998;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 17002;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 17003;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 17004;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 17008;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 17009;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 17010;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 17014;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 17015;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 17016;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 17020;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 17021;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 17022;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 17026;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 17027;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::None, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 17028;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 17032;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 17033;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 17034;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 17038;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 17039;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 17040;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 17044;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 17045;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 17046;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 17050;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 17051;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 17052;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 17056;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 17057;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 17058;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 17062;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 17063;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Low, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 17064;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::None).ID: return 17068;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Low).ID: return 17069;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, true, PolishedBlackstoneWall::West::Tall).ID: return 17070;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::None).ID: return 17074;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Low).ID: return 17075;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::None, false, PolishedBlackstoneWall::West::Tall).ID: return 17076;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::None).ID: return 17080;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Low).ID: return 17081;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, true, PolishedBlackstoneWall::West::Tall).ID: return 17082;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::None).ID: return 17086;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Low).ID: return 17087;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Low, false, PolishedBlackstoneWall::West::Tall).ID: return 17088;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::None).ID: return 17092;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Low).ID: return 17093;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, true, PolishedBlackstoneWall::West::Tall).ID: return 17094;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::None).ID: return 17098;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Low).ID: return 17099;
			case PolishedBlackstoneWall::PolishedBlackstoneWall(PolishedBlackstoneWall::East::Tall, PolishedBlackstoneWall::North::Tall, PolishedBlackstoneWall::South::Tall, false, PolishedBlackstoneWall::West::Tall).ID: return 17100;
			case PolishedDiorite::PolishedDiorite().ID: return 5;
			case PolishedDioriteSlab::PolishedDioriteSlab(PolishedDioriteSlab::Type::Top).ID: return 10808;
			case PolishedDioriteSlab::PolishedDioriteSlab(PolishedDioriteSlab::Type::Bottom).ID: return 10810;
			case PolishedDioriteSlab::PolishedDioriteSlab(PolishedDioriteSlab::Type::Double).ID: return 10812;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::Straight).ID: return 9910;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9912;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerRight).ID: return 9914;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9916;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterRight).ID: return 9918;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::Straight).ID: return 9920;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9922;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerRight).ID: return 9924;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9926;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterRight).ID: return 9928;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::Straight).ID: return 9930;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9932;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerRight).ID: return 9934;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9936;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterRight).ID: return 9938;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::Straight).ID: return 9940;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9942;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerRight).ID: return 9944;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9946;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterRight).ID: return 9948;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::Straight).ID: return 9950;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9952;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerRight).ID: return 9954;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9956;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterRight).ID: return 9958;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::Straight).ID: return 9960;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9962;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerRight).ID: return 9964;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9966;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XM, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterRight).ID: return 9968;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::Straight).ID: return 9970;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9972;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::InnerRight).ID: return 9974;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9976;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Top, PolishedDioriteStairs::Shape::OuterRight).ID: return 9978;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::Straight).ID: return 9980;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerLeft).ID: return 9982;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::InnerRight).ID: return 9984;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterLeft).ID: return 9986;
			case PolishedDioriteStairs::PolishedDioriteStairs(eBlockFace::BLOCK_FACE_XP, PolishedDioriteStairs::Half::Bottom, PolishedDioriteStairs::Shape::OuterRight).ID: return 9988;
			case PolishedGranite::PolishedGranite().ID: return 3;
			case PolishedGraniteSlab::PolishedGraniteSlab(PolishedGraniteSlab::Type::Top).ID: return 10790;
			case PolishedGraniteSlab::PolishedGraniteSlab(PolishedGraniteSlab::Type::Bottom).ID: return 10792;
			case PolishedGraniteSlab::PolishedGraniteSlab(PolishedGraniteSlab::Type::Double).ID: return 10794;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::Straight).ID: return 9670;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9672;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerRight).ID: return 9674;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9676;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterRight).ID: return 9678;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::Straight).ID: return 9680;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9682;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerRight).ID: return 9684;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9686;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterRight).ID: return 9688;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::Straight).ID: return 9690;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9692;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerRight).ID: return 9694;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9696;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterRight).ID: return 9698;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::Straight).ID: return 9700;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9702;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerRight).ID: return 9704;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9706;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_ZP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterRight).ID: return 9708;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::Straight).ID: return 9710;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9712;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerRight).ID: return 9714;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9716;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterRight).ID: return 9718;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::Straight).ID: return 9720;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9722;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerRight).ID: return 9724;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9726;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XM, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterRight).ID: return 9728;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::Straight).ID: return 9730;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9732;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::InnerRight).ID: return 9734;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9736;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Top, PolishedGraniteStairs::Shape::OuterRight).ID: return 9738;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::Straight).ID: return 9740;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerLeft).ID: return 9742;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::InnerRight).ID: return 9744;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterLeft).ID: return 9746;
			case PolishedGraniteStairs::PolishedGraniteStairs(eBlockFace::BLOCK_FACE_XP, PolishedGraniteStairs::Half::Bottom, PolishedGraniteStairs::Shape::OuterRight).ID: return 9748;
			case Poppy::Poppy().ID: return 1413;
			case Potatoes::Potatoes(0).ID: return 6338;
			case Potatoes::Potatoes(1).ID: return 6339;
			case Potatoes::Potatoes(2).ID: return 6340;
			case Potatoes::Potatoes(3).ID: return 6341;
			case Potatoes::Potatoes(4).ID: return 6342;
			case Potatoes::Potatoes(5).ID: return 6343;
			case Potatoes::Potatoes(6).ID: return 6344;
			case Potatoes::Potatoes(7).ID: return 6345;
			case PottedAcaciaSapling::PottedAcaciaSapling().ID: return 6310;
			case PottedAllium::PottedAllium().ID: return 6316;
			case PottedAzureBluet::PottedAzureBluet().ID: return 6317;
			case PottedBamboo::PottedBamboo().ID: return 9664;
			case PottedBirchSapling::PottedBirchSapling().ID: return 6308;
			case PottedBlueOrchid::PottedBlueOrchid().ID: return 6315;
			case PottedBrownMushroom::PottedBrownMushroom().ID: return 6327;
			case PottedCactus::PottedCactus().ID: return 6329;
			case PottedCornflower::PottedCornflower().ID: return 6323;
			case PottedCrimsonFungus::PottedCrimsonFungus().ID: return 15834;
			case PottedCrimsonRoots::PottedCrimsonRoots().ID: return 15836;
			case PottedDandelion::PottedDandelion().ID: return 6313;
			case PottedDarkOakSapling::PottedDarkOakSapling().ID: return 6311;
			case PottedDeadBush::PottedDeadBush().ID: return 6328;
			case PottedFern::PottedFern().ID: return 6312;
			case PottedJungleSapling::PottedJungleSapling().ID: return 6309;
			case PottedLilyOfTheValley::PottedLilyOfTheValley().ID: return 6324;
			case PottedOakSapling::PottedOakSapling().ID: return 6306;
			case PottedOrangeTulip::PottedOrangeTulip().ID: return 6319;
			case PottedOxeyeDaisy::PottedOxeyeDaisy().ID: return 6322;
			case PottedPinkTulip::PottedPinkTulip().ID: return 6321;
			case PottedPoppy::PottedPoppy().ID: return 6314;
			case PottedRedMushroom::PottedRedMushroom().ID: return 6326;
			case PottedRedTulip::PottedRedTulip().ID: return 6318;
			case PottedSpruceSapling::PottedSpruceSapling().ID: return 6307;
			case PottedWarpedFungus::PottedWarpedFungus().ID: return 15835;
			case PottedWarpedRoots::PottedWarpedRoots().ID: return 15837;
			case PottedWhiteTulip::PottedWhiteTulip().ID: return 6320;
			case PottedWitherRose::PottedWitherRose().ID: return 6325;
			case PoweredRail::PoweredRail(true, PoweredRail::Shape::NorthSouth).ID: return 1305;
			case PoweredRail::PoweredRail(true, PoweredRail::Shape::EastWest).ID: return 1306;
			case PoweredRail::PoweredRail(true, PoweredRail::Shape::AscendingEast).ID: return 1307;
			case PoweredRail::PoweredRail(true, PoweredRail::Shape::AscendingWest).ID: return 1308;
			case PoweredRail::PoweredRail(true, PoweredRail::Shape::AscendingNorth).ID: return 1309;
			case PoweredRail::PoweredRail(true, PoweredRail::Shape::AscendingSouth).ID: return 1310;
			case PoweredRail::PoweredRail(false, PoweredRail::Shape::NorthSouth).ID: return 1311;
			case PoweredRail::PoweredRail(false, PoweredRail::Shape::EastWest).ID: return 1312;
			case PoweredRail::PoweredRail(false, PoweredRail::Shape::AscendingEast).ID: return 1313;
			case PoweredRail::PoweredRail(false, PoweredRail::Shape::AscendingWest).ID: return 1314;
			case PoweredRail::PoweredRail(false, PoweredRail::Shape::AscendingNorth).ID: return 1315;
			case PoweredRail::PoweredRail(false, PoweredRail::Shape::AscendingSouth).ID: return 1316;
			case Prismarine::Prismarine().ID: return 7601;
			case PrismarineBrickSlab::PrismarineBrickSlab(PrismarineBrickSlab::Type::Top).ID: return 7851;
			case PrismarineBrickSlab::PrismarineBrickSlab(PrismarineBrickSlab::Type::Bottom).ID: return 7853;
			case PrismarineBrickSlab::PrismarineBrickSlab(PrismarineBrickSlab::Type::Double).ID: return 7855;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::Straight).ID: return 7685;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7687;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerRight).ID: return 7689;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7691;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterRight).ID: return 7693;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::Straight).ID: return 7695;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7697;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerRight).ID: return 7699;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7701;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterRight).ID: return 7703;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::Straight).ID: return 7705;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7707;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerRight).ID: return 7709;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7711;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterRight).ID: return 7713;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::Straight).ID: return 7715;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7717;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerRight).ID: return 7719;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7721;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterRight).ID: return 7723;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::Straight).ID: return 7725;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7727;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerRight).ID: return 7729;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7731;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterRight).ID: return 7733;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::Straight).ID: return 7735;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7737;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerRight).ID: return 7739;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7741;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XM, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterRight).ID: return 7743;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::Straight).ID: return 7745;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7747;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::InnerRight).ID: return 7749;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7751;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Top, PrismarineBrickStairs::Shape::OuterRight).ID: return 7753;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::Straight).ID: return 7755;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerLeft).ID: return 7757;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::InnerRight).ID: return 7759;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterLeft).ID: return 7761;
			case PrismarineBrickStairs::PrismarineBrickStairs(eBlockFace::BLOCK_FACE_XP, PrismarineBrickStairs::Half::Bottom, PrismarineBrickStairs::Shape::OuterRight).ID: return 7763;
			case PrismarineBricks::PrismarineBricks().ID: return 7602;
			case PrismarineSlab::PrismarineSlab(PrismarineSlab::Type::Top).ID: return 7845;
			case PrismarineSlab::PrismarineSlab(PrismarineSlab::Type::Bottom).ID: return 7847;
			case PrismarineSlab::PrismarineSlab(PrismarineSlab::Type::Double).ID: return 7849;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::Straight).ID: return 7605;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerLeft).ID: return 7607;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerRight).ID: return 7609;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterLeft).ID: return 7611;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterRight).ID: return 7613;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::Straight).ID: return 7615;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerLeft).ID: return 7617;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerRight).ID: return 7619;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterLeft).ID: return 7621;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterRight).ID: return 7623;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::Straight).ID: return 7625;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerLeft).ID: return 7627;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerRight).ID: return 7629;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterLeft).ID: return 7631;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterRight).ID: return 7633;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::Straight).ID: return 7635;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerLeft).ID: return 7637;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerRight).ID: return 7639;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterLeft).ID: return 7641;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_ZP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterRight).ID: return 7643;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::Straight).ID: return 7645;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerLeft).ID: return 7647;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerRight).ID: return 7649;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterLeft).ID: return 7651;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterRight).ID: return 7653;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::Straight).ID: return 7655;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerLeft).ID: return 7657;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerRight).ID: return 7659;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterLeft).ID: return 7661;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XM, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterRight).ID: return 7663;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::Straight).ID: return 7665;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerLeft).ID: return 7667;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::InnerRight).ID: return 7669;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterLeft).ID: return 7671;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Top, PrismarineStairs::Shape::OuterRight).ID: return 7673;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::Straight).ID: return 7675;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerLeft).ID: return 7677;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::InnerRight).ID: return 7679;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterLeft).ID: return 7681;
			case PrismarineStairs::PrismarineStairs(eBlockFace::BLOCK_FACE_XP, PrismarineStairs::Half::Bottom, PrismarineStairs::Shape::OuterRight).ID: return 7683;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11194;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11195;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11196;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11200;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11201;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11202;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11206;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11207;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11208;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11212;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11213;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11214;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11218;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11219;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11220;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11224;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11225;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11226;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11230;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11231;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11232;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11236;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11237;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11238;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11242;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11243;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11244;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11248;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11249;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11250;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11254;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11255;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11256;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11260;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11261;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11262;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11266;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11267;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11268;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11272;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11273;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11274;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11278;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11279;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11280;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11284;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11285;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11286;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11290;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11291;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11292;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11296;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11297;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::None, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11298;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11302;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11303;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11304;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11308;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11309;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11310;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11314;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11315;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11316;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11320;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11321;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11322;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11326;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11327;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11328;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11332;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11333;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11334;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11338;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11339;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11340;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11344;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11345;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11346;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11350;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11351;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11352;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11356;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11357;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11358;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11362;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11363;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11364;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11368;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11369;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11370;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11374;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11375;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11376;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11380;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11381;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11382;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11386;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11387;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11388;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11392;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11393;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11394;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11398;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11399;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11400;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11404;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11405;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Low, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11406;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11410;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11411;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11412;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11416;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11417;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11418;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11422;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11423;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11424;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11428;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11429;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11430;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11434;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11435;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11436;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11440;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11441;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::None, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11442;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11446;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11447;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11448;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11452;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11453;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11454;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11458;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11459;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11460;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11464;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11465;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11466;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11470;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11471;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11472;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11476;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11477;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Low, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11478;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::None).ID: return 11482;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::Low).ID: return 11483;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::None, true, PrismarineWall::West::Tall).ID: return 11484;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::None).ID: return 11488;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::Low).ID: return 11489;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::None, false, PrismarineWall::West::Tall).ID: return 11490;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::None).ID: return 11494;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::Low).ID: return 11495;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Low, true, PrismarineWall::West::Tall).ID: return 11496;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::None).ID: return 11500;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::Low).ID: return 11501;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Low, false, PrismarineWall::West::Tall).ID: return 11502;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::None).ID: return 11506;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::Low).ID: return 11507;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Tall, true, PrismarineWall::West::Tall).ID: return 11508;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::None).ID: return 11512;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::Low).ID: return 11513;
			case PrismarineWall::PrismarineWall(PrismarineWall::East::Tall, PrismarineWall::North::Tall, PrismarineWall::South::Tall, false, PrismarineWall::West::Tall).ID: return 11514;
			case Pumpkin::Pumpkin().ID: return 3998;
			case PumpkinStem::PumpkinStem(0).ID: return 4772;
			case PumpkinStem::PumpkinStem(1).ID: return 4773;
			case PumpkinStem::PumpkinStem(2).ID: return 4774;
			case PumpkinStem::PumpkinStem(3).ID: return 4775;
			case PumpkinStem::PumpkinStem(4).ID: return 4776;
			case PumpkinStem::PumpkinStem(5).ID: return 4777;
			case PumpkinStem::PumpkinStem(6).ID: return 4778;
			case PumpkinStem::PumpkinStem(7).ID: return 4779;
			case PurpleBanner::PurpleBanner(0).ID: return 8057;
			case PurpleBanner::PurpleBanner(1).ID: return 8058;
			case PurpleBanner::PurpleBanner(2).ID: return 8059;
			case PurpleBanner::PurpleBanner(3).ID: return 8060;
			case PurpleBanner::PurpleBanner(4).ID: return 8061;
			case PurpleBanner::PurpleBanner(5).ID: return 8062;
			case PurpleBanner::PurpleBanner(6).ID: return 8063;
			case PurpleBanner::PurpleBanner(7).ID: return 8064;
			case PurpleBanner::PurpleBanner(8).ID: return 8065;
			case PurpleBanner::PurpleBanner(9).ID: return 8066;
			case PurpleBanner::PurpleBanner(10).ID: return 8067;
			case PurpleBanner::PurpleBanner(11).ID: return 8068;
			case PurpleBanner::PurpleBanner(12).ID: return 8069;
			case PurpleBanner::PurpleBanner(13).ID: return 8070;
			case PurpleBanner::PurpleBanner(14).ID: return 8071;
			case PurpleBanner::PurpleBanner(15).ID: return 8072;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZM, true, PurpleBed::Part::Head).ID: return 1209;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZM, true, PurpleBed::Part::Foot).ID: return 1210;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZM, false, PurpleBed::Part::Head).ID: return 1211;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZM, false, PurpleBed::Part::Foot).ID: return 1212;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZP, true, PurpleBed::Part::Head).ID: return 1213;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZP, true, PurpleBed::Part::Foot).ID: return 1214;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZP, false, PurpleBed::Part::Head).ID: return 1215;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_ZP, false, PurpleBed::Part::Foot).ID: return 1216;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XM, true, PurpleBed::Part::Head).ID: return 1217;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XM, true, PurpleBed::Part::Foot).ID: return 1218;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XM, false, PurpleBed::Part::Head).ID: return 1219;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XM, false, PurpleBed::Part::Foot).ID: return 1220;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XP, true, PurpleBed::Part::Head).ID: return 1221;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XP, true, PurpleBed::Part::Foot).ID: return 1222;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XP, false, PurpleBed::Part::Head).ID: return 1223;
			case PurpleBed::PurpleBed(eBlockFace::BLOCK_FACE_XP, false, PurpleBed::Part::Foot).ID: return 1224;
			case PurpleCarpet::PurpleCarpet().ID: return 7876;
			case PurpleConcrete::PurpleConcrete().ID: return 9448;
			case PurpleConcretePowder::PurpleConcretePowder().ID: return 9464;
			case PurpleGlazedTerracotta::PurpleGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9414;
			case PurpleGlazedTerracotta::PurpleGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9415;
			case PurpleGlazedTerracotta::PurpleGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9416;
			case PurpleGlazedTerracotta::PurpleGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9417;
			case PurpleShulkerBox::PurpleShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9338;
			case PurpleShulkerBox::PurpleShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9339;
			case PurpleShulkerBox::PurpleShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9340;
			case PurpleShulkerBox::PurpleShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9341;
			case PurpleShulkerBox::PurpleShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9342;
			case PurpleShulkerBox::PurpleShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9343;
			case PurpleStainedGlass::PurpleStainedGlass().ID: return 4105;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, true, true, true).ID: return 7185;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, true, true, false).ID: return 7186;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, true, false, true).ID: return 7189;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, true, false, false).ID: return 7190;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, false, true, true).ID: return 7193;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, false, true, false).ID: return 7194;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, false, false, true).ID: return 7197;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(true, false, false, false).ID: return 7198;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, true, true, true).ID: return 7201;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, true, true, false).ID: return 7202;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, true, false, true).ID: return 7205;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, true, false, false).ID: return 7206;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, false, true, true).ID: return 7209;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, false, true, false).ID: return 7210;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, false, false, true).ID: return 7213;
			case PurpleStainedGlassPane::PurpleStainedGlassPane(false, false, false, false).ID: return 7214;
			case PurpleTerracotta::PurpleTerracotta().ID: return 6857;
			case PurpleWallBanner::PurpleWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8193;
			case PurpleWallBanner::PurpleWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8194;
			case PurpleWallBanner::PurpleWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8195;
			case PurpleWallBanner::PurpleWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8196;
			case PurpleWool::PurpleWool().ID: return 1394;
			case PurpurBlock::PurpurBlock().ID: return 9134;
			case PurpurPillar::PurpurPillar(PurpurPillar::Axis::X).ID: return 9135;
			case PurpurPillar::PurpurPillar(PurpurPillar::Axis::Y).ID: return 9136;
			case PurpurPillar::PurpurPillar(PurpurPillar::Axis::Z).ID: return 9137;
			case PurpurSlab::PurpurSlab(PurpurSlab::Type::Top).ID: return 8409;
			case PurpurSlab::PurpurSlab(PurpurSlab::Type::Bottom).ID: return 8411;
			case PurpurSlab::PurpurSlab(PurpurSlab::Type::Double).ID: return 8413;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Top, PurpurStairs::Shape::Straight).ID: return 9139;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerLeft).ID: return 9141;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerRight).ID: return 9143;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterLeft).ID: return 9145;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterRight).ID: return 9147;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::Straight).ID: return 9149;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerLeft).ID: return 9151;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerRight).ID: return 9153;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterLeft).ID: return 9155;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterRight).ID: return 9157;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Top, PurpurStairs::Shape::Straight).ID: return 9159;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerLeft).ID: return 9161;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerRight).ID: return 9163;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterLeft).ID: return 9165;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterRight).ID: return 9167;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::Straight).ID: return 9169;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerLeft).ID: return 9171;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerRight).ID: return 9173;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterLeft).ID: return 9175;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_ZP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterRight).ID: return 9177;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Top, PurpurStairs::Shape::Straight).ID: return 9179;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerLeft).ID: return 9181;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerRight).ID: return 9183;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterLeft).ID: return 9185;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterRight).ID: return 9187;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::Straight).ID: return 9189;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerLeft).ID: return 9191;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerRight).ID: return 9193;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterLeft).ID: return 9195;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XM, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterRight).ID: return 9197;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Top, PurpurStairs::Shape::Straight).ID: return 9199;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerLeft).ID: return 9201;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Top, PurpurStairs::Shape::InnerRight).ID: return 9203;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterLeft).ID: return 9205;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Top, PurpurStairs::Shape::OuterRight).ID: return 9207;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::Straight).ID: return 9209;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerLeft).ID: return 9211;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::InnerRight).ID: return 9213;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterLeft).ID: return 9215;
			case PurpurStairs::PurpurStairs(eBlockFace::BLOCK_FACE_XP, PurpurStairs::Half::Bottom, PurpurStairs::Shape::OuterRight).ID: return 9217;
			case QuartzBlock::QuartzBlock().ID: return 6738;
			case QuartzBricks::QuartzBricks().ID: return 17103;
			case QuartzPillar::QuartzPillar(QuartzPillar::Axis::X).ID: return 6740;
			case QuartzPillar::QuartzPillar(QuartzPillar::Axis::Y).ID: return 6741;
			case QuartzPillar::QuartzPillar(QuartzPillar::Axis::Z).ID: return 6742;
			case QuartzSlab::QuartzSlab(QuartzSlab::Type::Top).ID: return 8391;
			case QuartzSlab::QuartzSlab(QuartzSlab::Type::Bottom).ID: return 8393;
			case QuartzSlab::QuartzSlab(QuartzSlab::Type::Double).ID: return 8395;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Top, QuartzStairs::Shape::Straight).ID: return 6744;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerLeft).ID: return 6746;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerRight).ID: return 6748;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterLeft).ID: return 6750;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterRight).ID: return 6752;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::Straight).ID: return 6754;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerLeft).ID: return 6756;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerRight).ID: return 6758;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterLeft).ID: return 6760;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterRight).ID: return 6762;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Top, QuartzStairs::Shape::Straight).ID: return 6764;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerLeft).ID: return 6766;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerRight).ID: return 6768;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterLeft).ID: return 6770;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterRight).ID: return 6772;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::Straight).ID: return 6774;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerLeft).ID: return 6776;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerRight).ID: return 6778;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterLeft).ID: return 6780;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_ZP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterRight).ID: return 6782;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Top, QuartzStairs::Shape::Straight).ID: return 6784;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerLeft).ID: return 6786;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerRight).ID: return 6788;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterLeft).ID: return 6790;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterRight).ID: return 6792;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::Straight).ID: return 6794;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerLeft).ID: return 6796;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerRight).ID: return 6798;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterLeft).ID: return 6800;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XM, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterRight).ID: return 6802;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Top, QuartzStairs::Shape::Straight).ID: return 6804;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerLeft).ID: return 6806;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Top, QuartzStairs::Shape::InnerRight).ID: return 6808;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterLeft).ID: return 6810;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Top, QuartzStairs::Shape::OuterRight).ID: return 6812;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::Straight).ID: return 6814;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerLeft).ID: return 6816;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::InnerRight).ID: return 6818;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterLeft).ID: return 6820;
			case QuartzStairs::QuartzStairs(eBlockFace::BLOCK_FACE_XP, QuartzStairs::Half::Bottom, QuartzStairs::Shape::OuterRight).ID: return 6822;
			case Rail::Rail(Rail::Shape::NorthSouth).ID: return 3645;
			case Rail::Rail(Rail::Shape::EastWest).ID: return 3646;
			case Rail::Rail(Rail::Shape::AscendingEast).ID: return 3647;
			case Rail::Rail(Rail::Shape::AscendingWest).ID: return 3648;
			case Rail::Rail(Rail::Shape::AscendingNorth).ID: return 3649;
			case Rail::Rail(Rail::Shape::AscendingSouth).ID: return 3650;
			case Rail::Rail(Rail::Shape::SouthEast).ID: return 3651;
			case Rail::Rail(Rail::Shape::SouthWest).ID: return 3652;
			case Rail::Rail(Rail::Shape::NorthWest).ID: return 3653;
			case Rail::Rail(Rail::Shape::NorthEast).ID: return 3654;
			case RedBanner::RedBanner(0).ID: return 8121;
			case RedBanner::RedBanner(1).ID: return 8122;
			case RedBanner::RedBanner(2).ID: return 8123;
			case RedBanner::RedBanner(3).ID: return 8124;
			case RedBanner::RedBanner(4).ID: return 8125;
			case RedBanner::RedBanner(5).ID: return 8126;
			case RedBanner::RedBanner(6).ID: return 8127;
			case RedBanner::RedBanner(7).ID: return 8128;
			case RedBanner::RedBanner(8).ID: return 8129;
			case RedBanner::RedBanner(9).ID: return 8130;
			case RedBanner::RedBanner(10).ID: return 8131;
			case RedBanner::RedBanner(11).ID: return 8132;
			case RedBanner::RedBanner(12).ID: return 8133;
			case RedBanner::RedBanner(13).ID: return 8134;
			case RedBanner::RedBanner(14).ID: return 8135;
			case RedBanner::RedBanner(15).ID: return 8136;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZM, true, RedBed::Part::Head).ID: return 1273;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZM, true, RedBed::Part::Foot).ID: return 1274;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZM, false, RedBed::Part::Head).ID: return 1275;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZM, false, RedBed::Part::Foot).ID: return 1276;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZP, true, RedBed::Part::Head).ID: return 1277;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZP, true, RedBed::Part::Foot).ID: return 1278;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZP, false, RedBed::Part::Head).ID: return 1279;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_ZP, false, RedBed::Part::Foot).ID: return 1280;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XM, true, RedBed::Part::Head).ID: return 1281;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XM, true, RedBed::Part::Foot).ID: return 1282;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XM, false, RedBed::Part::Head).ID: return 1283;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XM, false, RedBed::Part::Foot).ID: return 1284;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XP, true, RedBed::Part::Head).ID: return 1285;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XP, true, RedBed::Part::Foot).ID: return 1286;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XP, false, RedBed::Part::Head).ID: return 1287;
			case RedBed::RedBed(eBlockFace::BLOCK_FACE_XP, false, RedBed::Part::Foot).ID: return 1288;
			case RedCarpet::RedCarpet().ID: return 7880;
			case RedConcrete::RedConcrete().ID: return 9452;
			case RedConcretePowder::RedConcretePowder().ID: return 9468;
			case RedGlazedTerracotta::RedGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9430;
			case RedGlazedTerracotta::RedGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9431;
			case RedGlazedTerracotta::RedGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9432;
			case RedGlazedTerracotta::RedGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9433;
			case RedMushroom::RedMushroom().ID: return 1426;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, true, true, true).ID: return 4569;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, true, true, false).ID: return 4570;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, true, false, true).ID: return 4571;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, true, false, false).ID: return 4572;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, false, true, true).ID: return 4573;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, false, true, false).ID: return 4574;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, false, false, true).ID: return 4575;
			case RedMushroomBlock::RedMushroomBlock(true, true, true, false, false, false).ID: return 4576;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, true, true, true).ID: return 4577;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, true, true, false).ID: return 4578;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, true, false, true).ID: return 4579;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, true, false, false).ID: return 4580;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, false, true, true).ID: return 4581;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, false, true, false).ID: return 4582;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, false, false, true).ID: return 4583;
			case RedMushroomBlock::RedMushroomBlock(true, true, false, false, false, false).ID: return 4584;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, true, true, true).ID: return 4585;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, true, true, false).ID: return 4586;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, true, false, true).ID: return 4587;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, true, false, false).ID: return 4588;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, false, true, true).ID: return 4589;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, false, true, false).ID: return 4590;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, false, false, true).ID: return 4591;
			case RedMushroomBlock::RedMushroomBlock(true, false, true, false, false, false).ID: return 4592;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, true, true, true).ID: return 4593;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, true, true, false).ID: return 4594;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, true, false, true).ID: return 4595;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, true, false, false).ID: return 4596;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, false, true, true).ID: return 4597;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, false, true, false).ID: return 4598;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, false, false, true).ID: return 4599;
			case RedMushroomBlock::RedMushroomBlock(true, false, false, false, false, false).ID: return 4600;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, true, true, true).ID: return 4601;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, true, true, false).ID: return 4602;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, true, false, true).ID: return 4603;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, true, false, false).ID: return 4604;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, false, true, true).ID: return 4605;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, false, true, false).ID: return 4606;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, false, false, true).ID: return 4607;
			case RedMushroomBlock::RedMushroomBlock(false, true, true, false, false, false).ID: return 4608;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, true, true, true).ID: return 4609;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, true, true, false).ID: return 4610;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, true, false, true).ID: return 4611;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, true, false, false).ID: return 4612;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, false, true, true).ID: return 4613;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, false, true, false).ID: return 4614;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, false, false, true).ID: return 4615;
			case RedMushroomBlock::RedMushroomBlock(false, true, false, false, false, false).ID: return 4616;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, true, true, true).ID: return 4617;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, true, true, false).ID: return 4618;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, true, false, true).ID: return 4619;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, true, false, false).ID: return 4620;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, false, true, true).ID: return 4621;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, false, true, false).ID: return 4622;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, false, false, true).ID: return 4623;
			case RedMushroomBlock::RedMushroomBlock(false, false, true, false, false, false).ID: return 4624;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, true, true, true).ID: return 4625;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, true, true, false).ID: return 4626;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, true, false, true).ID: return 4627;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, true, false, false).ID: return 4628;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, false, true, true).ID: return 4629;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, false, true, false).ID: return 4630;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, false, false, true).ID: return 4631;
			case RedMushroomBlock::RedMushroomBlock(false, false, false, false, false, false).ID: return 4632;
			case RedNetherBrickSlab::RedNetherBrickSlab(RedNetherBrickSlab::Type::Top).ID: return 10850;
			case RedNetherBrickSlab::RedNetherBrickSlab(RedNetherBrickSlab::Type::Bottom).ID: return 10852;
			case RedNetherBrickSlab::RedNetherBrickSlab(RedNetherBrickSlab::Type::Double).ID: return 10854;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::Straight).ID: return 10550;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10552;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerRight).ID: return 10554;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10556;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterRight).ID: return 10558;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::Straight).ID: return 10560;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10562;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerRight).ID: return 10564;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10566;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterRight).ID: return 10568;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::Straight).ID: return 10570;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10572;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerRight).ID: return 10574;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10576;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterRight).ID: return 10578;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::Straight).ID: return 10580;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10582;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerRight).ID: return 10584;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10586;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_ZP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterRight).ID: return 10588;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::Straight).ID: return 10590;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10592;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerRight).ID: return 10594;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10596;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterRight).ID: return 10598;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::Straight).ID: return 10600;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10602;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerRight).ID: return 10604;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10606;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XM, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterRight).ID: return 10608;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::Straight).ID: return 10610;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10612;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::InnerRight).ID: return 10614;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10616;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Top, RedNetherBrickStairs::Shape::OuterRight).ID: return 10618;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::Straight).ID: return 10620;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerLeft).ID: return 10622;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::InnerRight).ID: return 10624;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterLeft).ID: return 10626;
			case RedNetherBrickStairs::RedNetherBrickStairs(eBlockFace::BLOCK_FACE_XP, RedNetherBrickStairs::Half::Bottom, RedNetherBrickStairs::Shape::OuterRight).ID: return 10628;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13462;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13463;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13464;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13468;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13469;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13470;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13474;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13475;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13476;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13480;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13481;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13482;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13486;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13487;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13488;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13492;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13493;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13494;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13498;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13499;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13500;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13504;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13505;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13506;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13510;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13511;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13512;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13516;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13517;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13518;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13522;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13523;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13524;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13528;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13529;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13530;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13534;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13535;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13536;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13540;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13541;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13542;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13546;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13547;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13548;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13552;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13553;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13554;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13558;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13559;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13560;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13564;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13565;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::None, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13566;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13570;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13571;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13572;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13576;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13577;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13578;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13582;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13583;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13584;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13588;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13589;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13590;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13594;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13595;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13596;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13600;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13601;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13602;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13606;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13607;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13608;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13612;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13613;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13614;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13618;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13619;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13620;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13624;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13625;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13626;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13630;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13631;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13632;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13636;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13637;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13638;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13642;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13643;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13644;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13648;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13649;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13650;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13654;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13655;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13656;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13660;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13661;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13662;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13666;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13667;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13668;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13672;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13673;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Low, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13674;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13678;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13679;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13680;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13684;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13685;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13686;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13690;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13691;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13692;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13696;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13697;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13698;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13702;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13703;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13704;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13708;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13709;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::None, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13710;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13714;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13715;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13716;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13720;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13721;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13722;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13726;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13727;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13728;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13732;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13733;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13734;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13738;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13739;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13740;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13744;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13745;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Low, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13746;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::None).ID: return 13750;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Low).ID: return 13751;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, true, RedNetherBrickWall::West::Tall).ID: return 13752;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::None).ID: return 13756;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Low).ID: return 13757;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::None, false, RedNetherBrickWall::West::Tall).ID: return 13758;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::None).ID: return 13762;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Low).ID: return 13763;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, true, RedNetherBrickWall::West::Tall).ID: return 13764;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::None).ID: return 13768;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Low).ID: return 13769;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Low, false, RedNetherBrickWall::West::Tall).ID: return 13770;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::None).ID: return 13774;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Low).ID: return 13775;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, true, RedNetherBrickWall::West::Tall).ID: return 13776;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::None).ID: return 13780;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Low).ID: return 13781;
			case RedNetherBrickWall::RedNetherBrickWall(RedNetherBrickWall::East::Tall, RedNetherBrickWall::North::Tall, RedNetherBrickWall::South::Tall, false, RedNetherBrickWall::West::Tall).ID: return 13782;
			case RedNetherBricks::RedNetherBricks().ID: return 9255;
			case RedSand::RedSand().ID: return 67;
			case RedSandstone::RedSandstone().ID: return 8217;
			case RedSandstoneSlab::RedSandstoneSlab(RedSandstoneSlab::Type::Top).ID: return 8397;
			case RedSandstoneSlab::RedSandstoneSlab(RedSandstoneSlab::Type::Bottom).ID: return 8399;
			case RedSandstoneSlab::RedSandstoneSlab(RedSandstoneSlab::Type::Double).ID: return 8401;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::Straight).ID: return 8221;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerLeft).ID: return 8223;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerRight).ID: return 8225;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterLeft).ID: return 8227;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterRight).ID: return 8229;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::Straight).ID: return 8231;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerLeft).ID: return 8233;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerRight).ID: return 8235;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterLeft).ID: return 8237;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterRight).ID: return 8239;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::Straight).ID: return 8241;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerLeft).ID: return 8243;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerRight).ID: return 8245;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterLeft).ID: return 8247;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterRight).ID: return 8249;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::Straight).ID: return 8251;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerLeft).ID: return 8253;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerRight).ID: return 8255;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterLeft).ID: return 8257;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterRight).ID: return 8259;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::Straight).ID: return 8261;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerLeft).ID: return 8263;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerRight).ID: return 8265;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterLeft).ID: return 8267;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterRight).ID: return 8269;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::Straight).ID: return 8271;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerLeft).ID: return 8273;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerRight).ID: return 8275;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterLeft).ID: return 8277;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterRight).ID: return 8279;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::Straight).ID: return 8281;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerLeft).ID: return 8283;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::InnerRight).ID: return 8285;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterLeft).ID: return 8287;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Top, RedSandstoneStairs::Shape::OuterRight).ID: return 8289;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::Straight).ID: return 8291;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerLeft).ID: return 8293;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::InnerRight).ID: return 8295;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterLeft).ID: return 8297;
			case RedSandstoneStairs::RedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, RedSandstoneStairs::Half::Bottom, RedSandstoneStairs::Shape::OuterRight).ID: return 8299;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11518;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11519;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11520;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11524;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11525;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11526;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11530;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11531;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11532;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11536;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11537;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11538;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11542;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11543;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11544;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11548;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11549;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11550;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11554;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11555;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11556;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11560;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11561;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11562;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11566;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11567;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11568;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11572;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11573;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11574;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11578;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11579;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11580;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11584;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11585;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11586;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11590;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11591;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11592;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11596;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11597;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11598;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11602;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11603;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11604;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11608;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11609;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11610;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11614;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11615;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11616;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11620;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11621;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::None, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11622;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11626;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11627;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11628;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11632;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11633;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11634;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11638;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11639;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11640;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11644;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11645;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11646;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11650;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11651;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11652;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11656;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11657;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11658;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11662;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11663;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11664;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11668;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11669;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11670;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11674;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11675;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11676;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11680;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11681;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11682;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11686;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11687;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11688;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11692;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11693;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11694;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11698;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11699;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11700;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11704;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11705;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11706;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11710;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11711;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11712;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11716;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11717;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11718;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11722;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11723;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11724;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11728;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11729;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Low, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11730;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11734;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11735;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11736;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11740;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11741;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11742;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11746;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11747;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11748;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11752;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11753;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11754;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11758;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11759;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11760;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11764;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11765;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::None, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11766;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11770;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11771;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11772;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11776;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11777;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11778;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11782;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11783;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11784;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11788;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11789;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11790;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11794;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11795;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11796;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11800;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11801;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Low, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11802;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::None).ID: return 11806;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Low).ID: return 11807;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, true, RedSandstoneWall::West::Tall).ID: return 11808;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::None).ID: return 11812;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Low).ID: return 11813;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::None, false, RedSandstoneWall::West::Tall).ID: return 11814;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::None).ID: return 11818;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Low).ID: return 11819;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, true, RedSandstoneWall::West::Tall).ID: return 11820;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::None).ID: return 11824;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Low).ID: return 11825;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Low, false, RedSandstoneWall::West::Tall).ID: return 11826;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::None).ID: return 11830;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Low).ID: return 11831;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, true, RedSandstoneWall::West::Tall).ID: return 11832;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::None).ID: return 11836;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Low).ID: return 11837;
			case RedSandstoneWall::RedSandstoneWall(RedSandstoneWall::East::Tall, RedSandstoneWall::North::Tall, RedSandstoneWall::South::Tall, false, RedSandstoneWall::West::Tall).ID: return 11838;
			case RedShulkerBox::RedShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9362;
			case RedShulkerBox::RedShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9363;
			case RedShulkerBox::RedShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9364;
			case RedShulkerBox::RedShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9365;
			case RedShulkerBox::RedShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9366;
			case RedShulkerBox::RedShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9367;
			case RedStainedGlass::RedStainedGlass().ID: return 4109;
			case RedStainedGlassPane::RedStainedGlassPane(true, true, true, true).ID: return 7313;
			case RedStainedGlassPane::RedStainedGlassPane(true, true, true, false).ID: return 7314;
			case RedStainedGlassPane::RedStainedGlassPane(true, true, false, true).ID: return 7317;
			case RedStainedGlassPane::RedStainedGlassPane(true, true, false, false).ID: return 7318;
			case RedStainedGlassPane::RedStainedGlassPane(true, false, true, true).ID: return 7321;
			case RedStainedGlassPane::RedStainedGlassPane(true, false, true, false).ID: return 7322;
			case RedStainedGlassPane::RedStainedGlassPane(true, false, false, true).ID: return 7325;
			case RedStainedGlassPane::RedStainedGlassPane(true, false, false, false).ID: return 7326;
			case RedStainedGlassPane::RedStainedGlassPane(false, true, true, true).ID: return 7329;
			case RedStainedGlassPane::RedStainedGlassPane(false, true, true, false).ID: return 7330;
			case RedStainedGlassPane::RedStainedGlassPane(false, true, false, true).ID: return 7333;
			case RedStainedGlassPane::RedStainedGlassPane(false, true, false, false).ID: return 7334;
			case RedStainedGlassPane::RedStainedGlassPane(false, false, true, true).ID: return 7337;
			case RedStainedGlassPane::RedStainedGlassPane(false, false, true, false).ID: return 7338;
			case RedStainedGlassPane::RedStainedGlassPane(false, false, false, true).ID: return 7341;
			case RedStainedGlassPane::RedStainedGlassPane(false, false, false, false).ID: return 7342;
			case RedTerracotta::RedTerracotta().ID: return 6861;
			case RedTulip::RedTulip().ID: return 1417;
			case RedWallBanner::RedWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8209;
			case RedWallBanner::RedWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8210;
			case RedWallBanner::RedWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8211;
			case RedWallBanner::RedWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8212;
			case RedWool::RedWool().ID: return 1398;
			case RedstoneBlock::RedstoneBlock().ID: return 6726;
			case RedstoneLamp::RedstoneLamp(true).ID: return 5156;
			case RedstoneLamp::RedstoneLamp(false).ID: return 5157;
			case RedstoneOre::RedstoneOre(true).ID: return 3885;
			case RedstoneOre::RedstoneOre(false).ID: return 3886;
			case RedstoneTorch::RedstoneTorch(true).ID: return 3887;
			case RedstoneTorch::RedstoneTorch(false).ID: return 3888;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_ZM, true).ID: return 3889;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_ZM, false).ID: return 3890;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_ZP, true).ID: return 3891;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_ZP, false).ID: return 3892;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_XM, true).ID: return 3893;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_XM, false).ID: return 3894;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_XP, true).ID: return 3895;
			case RedstoneWallTorch::RedstoneWallTorch(eBlockFace::BLOCK_FACE_XP, false).ID: return 3896;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2058;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2059;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2060;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2061;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2062;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2063;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2064;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2065;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2066;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2067;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2068;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2069;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2070;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2071;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2072;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2073;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2074;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2075;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2076;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2077;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2078;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2079;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2080;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2081;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2082;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2083;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2084;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2085;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2086;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2087;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2088;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2089;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2090;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2091;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2092;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2093;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2094;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2095;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2096;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2097;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2098;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2099;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2100;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2101;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2102;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2103;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2104;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2105;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2106;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2107;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2108;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2109;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2110;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2111;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2112;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2113;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2114;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2115;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2116;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2117;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2118;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2119;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2120;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2121;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2122;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2123;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2124;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2125;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2126;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2127;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2128;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2129;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2130;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2131;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2132;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2133;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2134;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2135;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2136;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2137;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2138;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2139;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2140;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2141;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2142;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2143;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2144;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2145;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2146;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2147;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2148;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2149;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2150;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2151;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2152;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2153;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2154;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2155;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2156;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2157;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2158;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2159;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2160;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2161;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2162;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2163;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2164;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2165;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2166;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2167;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2168;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2169;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2170;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2171;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2172;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2173;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2174;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2175;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2176;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2177;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2178;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2179;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2180;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2181;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2182;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2183;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2184;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2185;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2186;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2187;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2188;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2189;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2190;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2191;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2192;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2193;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2194;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2195;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2196;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2197;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2198;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2199;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2200;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2201;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2202;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2203;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2204;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2205;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2206;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2207;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2208;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2209;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2210;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2211;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2212;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2213;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2214;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2215;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2216;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2217;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2218;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2219;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2220;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2221;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2222;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2223;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2224;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2225;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2226;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2227;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2228;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2229;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2230;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2231;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2232;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2233;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2234;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2235;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2236;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2237;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2238;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2239;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2240;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2241;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2242;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2243;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2244;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2245;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2246;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2247;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2248;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2249;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2250;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2251;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2252;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2253;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2254;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2255;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2256;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2257;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2258;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2259;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2260;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2261;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2262;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2263;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2264;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2265;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2266;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2267;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2268;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2269;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2270;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2271;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2272;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2273;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2274;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2275;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2276;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2277;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2278;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2279;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2280;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2281;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2282;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2283;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2284;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2285;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2286;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2287;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2288;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2289;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2290;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2291;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2292;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2293;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2294;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2295;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2296;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2297;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2298;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2299;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2300;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2301;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2302;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2303;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2304;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2305;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2306;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2307;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2308;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2309;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2310;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2311;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2312;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2313;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2314;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2315;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2316;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2317;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2318;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2319;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2320;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2321;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2322;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2323;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2324;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2325;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2326;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2327;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2328;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2329;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2330;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2331;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2332;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2333;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2334;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2335;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2336;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2337;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2338;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2339;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2340;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2341;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2342;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2343;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2344;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2345;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2346;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2347;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2348;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2349;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2350;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2351;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2352;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2353;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2354;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2355;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2356;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2357;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2358;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2359;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2360;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2361;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2362;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2363;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2364;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2365;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2366;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2367;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2368;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2369;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2370;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2371;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2372;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2373;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2374;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2375;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2376;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2377;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2378;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2379;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2380;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2381;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2382;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2383;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2384;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2385;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2386;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2387;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2388;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2389;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2390;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2391;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2392;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2393;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2394;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2395;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2396;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2397;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2398;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2399;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2400;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2401;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2402;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2403;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2404;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2405;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2406;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2407;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2408;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2409;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2410;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2411;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2412;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2413;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2414;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2415;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2416;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2417;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2418;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2419;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2420;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2421;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2422;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2423;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2424;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2425;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2426;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2427;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2428;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2429;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2430;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2431;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2432;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2433;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2434;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2435;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2436;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2437;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2438;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2439;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2440;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2441;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2442;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2443;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2444;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2445;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2446;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2447;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2448;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2449;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2450;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2451;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2452;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2453;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2454;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2455;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2456;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2457;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2458;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2459;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2460;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2461;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2462;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2463;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2464;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2465;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2466;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2467;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2468;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2469;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2470;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2471;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2472;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2473;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2474;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2475;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2476;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2477;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2478;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2479;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2480;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2481;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2482;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2483;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2484;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2485;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2486;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2487;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2488;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Up, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2489;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2490;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2491;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2492;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2493;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2494;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2495;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2496;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2497;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2498;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2499;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2500;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2501;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2502;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2503;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2504;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2505;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2506;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2507;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2508;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2509;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2510;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2511;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2512;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2513;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2514;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2515;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2516;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2517;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2518;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2519;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2520;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2521;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2522;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2523;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2524;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2525;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2526;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2527;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2528;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2529;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2530;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2531;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2532;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2533;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2534;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2535;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2536;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2537;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2538;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2539;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2540;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2541;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2542;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2543;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2544;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2545;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2546;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2547;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2548;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2549;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2550;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2551;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2552;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2553;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2554;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2555;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2556;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2557;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2558;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2559;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2560;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2561;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2562;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2563;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2564;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2565;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2566;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2567;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2568;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2569;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2570;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2571;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2572;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2573;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2574;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2575;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2576;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2577;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2578;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2579;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2580;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2581;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2582;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2583;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2584;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2585;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2586;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2587;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2588;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2589;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2590;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2591;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2592;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2593;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2594;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2595;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2596;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2597;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2598;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2599;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2600;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2601;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2602;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2603;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2604;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2605;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2606;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2607;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2608;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2609;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2610;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2611;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2612;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2613;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2614;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2615;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2616;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2617;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2618;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2619;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2620;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2621;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2622;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2623;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2624;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2625;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2626;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2627;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2628;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2629;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2630;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2631;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2632;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2633;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2634;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2635;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2636;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2637;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2638;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2639;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2640;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2641;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2642;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2643;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2644;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2645;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2646;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2647;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2648;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2649;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2650;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2651;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2652;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2653;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2654;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2655;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2656;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2657;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2658;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2659;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2660;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2661;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2662;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2663;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2664;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2665;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2666;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2667;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2668;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2669;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2670;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2671;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2672;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2673;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2674;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2675;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2676;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2677;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2678;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2679;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2680;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2681;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2682;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2683;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2684;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2685;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2686;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2687;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2688;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2689;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2690;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2691;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2692;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2693;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2694;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2695;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2696;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2697;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2698;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2699;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2700;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2701;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2702;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2703;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2704;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2705;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2706;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2707;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2708;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2709;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2710;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2711;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2712;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2713;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2714;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2715;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2716;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2717;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2718;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2719;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2720;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2721;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2722;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2723;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2724;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2725;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2726;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2727;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2728;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2729;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2730;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2731;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2732;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2733;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2734;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2735;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2736;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2737;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2738;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2739;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2740;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2741;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2742;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2743;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2744;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2745;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2746;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2747;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2748;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2749;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2750;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2751;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2752;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2753;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2754;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2755;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2756;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2757;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2758;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2759;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2760;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2761;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2762;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2763;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2764;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2765;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2766;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2767;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2768;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2769;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2770;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2771;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2772;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2773;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2774;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2775;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2776;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2777;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2778;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2779;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2780;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2781;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2782;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2783;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2784;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2785;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2786;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2787;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2788;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2789;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2790;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2791;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2792;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2793;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2794;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2795;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2796;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2797;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2798;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2799;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2800;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2801;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2802;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2803;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2804;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2805;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2806;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2807;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2808;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2809;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2810;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2811;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2812;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2813;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2814;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2815;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2816;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2817;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2818;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2819;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2820;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2821;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2822;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2823;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2824;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2825;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2826;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2827;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2828;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2829;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2830;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2831;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2832;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2833;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2834;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2835;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2836;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2837;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2838;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2839;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2840;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2841;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2842;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2843;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2844;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2845;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2846;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2847;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2848;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2849;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2850;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2851;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2852;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2853;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2854;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2855;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2856;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2857;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2858;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2859;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2860;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2861;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2862;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2863;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2864;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2865;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2866;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2867;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2868;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2869;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2870;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2871;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2872;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2873;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2874;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2875;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2876;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2877;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2878;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2879;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2880;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2881;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2882;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2883;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2884;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2885;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2886;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2887;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2888;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2889;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2890;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2891;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2892;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2893;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2894;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2895;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2896;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2897;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2898;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2899;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2900;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2901;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2902;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2903;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2904;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2905;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2906;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2907;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2908;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2909;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2910;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2911;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2912;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2913;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2914;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2915;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2916;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2917;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2918;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2919;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2920;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::Side, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2921;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2922;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2923;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2924;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2925;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2926;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2927;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2928;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2929;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2930;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2931;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2932;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2933;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2934;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2935;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2936;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2937;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2938;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2939;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2940;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2941;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2942;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2943;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2944;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2945;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2946;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2947;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2948;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2949;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2950;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2951;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2952;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2953;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2954;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2955;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2956;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2957;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2958;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2959;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2960;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2961;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2962;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2963;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2964;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2965;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2966;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2967;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2968;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2969;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2970;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2971;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2972;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2973;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2974;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2975;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2976;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2977;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2978;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2979;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2980;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2981;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2982;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2983;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2984;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2985;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2986;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2987;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2988;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2989;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2990;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 2991;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 2992;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 2993;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 2994;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 2995;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 2996;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 2997;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 2998;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 2999;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3000;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3001;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3002;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3003;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3004;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3005;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3006;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3007;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3008;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3009;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3010;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3011;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3012;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3013;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3014;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3015;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3016;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3017;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3018;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3019;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3020;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3021;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3022;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3023;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3024;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3025;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3026;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3027;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3028;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3029;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3030;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3031;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3032;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3033;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3034;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3035;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3036;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3037;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3038;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3039;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3040;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3041;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3042;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3043;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3044;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3045;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3046;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3047;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3048;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3049;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3050;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3051;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3052;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3053;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3054;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3055;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3056;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3057;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3058;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3059;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3060;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3061;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3062;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3063;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3064;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Up, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3065;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3066;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3067;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3068;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3069;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3070;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3071;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3072;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3073;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3074;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3075;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3076;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3077;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3078;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3079;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3080;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3081;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3082;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3083;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3084;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3085;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3086;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3087;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3088;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3089;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3090;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3091;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3092;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3093;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3094;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3095;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3096;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3097;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3098;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3099;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3100;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3101;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3102;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3103;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3104;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3105;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3106;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3107;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3108;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3109;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3110;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3111;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3112;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3113;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3114;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3115;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3116;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3117;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3118;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3119;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3120;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3121;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3122;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3123;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3124;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3125;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3126;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3127;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3128;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3129;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3130;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3131;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3132;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3133;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3134;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3135;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3136;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3137;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3138;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3139;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3140;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3141;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3142;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3143;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3144;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3145;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3146;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3147;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3148;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3149;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3150;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3151;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3152;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3153;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3154;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3155;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3156;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3157;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3158;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3159;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3160;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3161;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3162;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3163;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3164;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3165;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3166;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3167;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3168;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3169;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3170;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3171;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3172;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3173;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3174;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3175;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3176;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3177;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3178;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3179;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3180;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3181;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3182;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3183;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3184;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3185;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3186;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3187;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3188;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3189;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3190;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3191;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3192;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3193;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3194;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3195;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3196;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3197;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3198;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3199;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3200;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3201;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3202;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3203;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3204;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3205;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3206;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3207;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3208;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::Side, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3209;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3210;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3211;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3212;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3213;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3214;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3215;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3216;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3217;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 0, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3218;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3219;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3220;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3221;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3222;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3223;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3224;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3225;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3226;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 1, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3227;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3228;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3229;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3230;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3231;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3232;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3233;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3234;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3235;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 2, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3236;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3237;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3238;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3239;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3240;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3241;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3242;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3243;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3244;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 3, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3245;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3246;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3247;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3248;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3249;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3250;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3251;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3252;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3253;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 4, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3254;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3255;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3256;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3257;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3258;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3259;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3260;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3261;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3262;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 5, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3263;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3264;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3265;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3266;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3267;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3268;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3269;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3270;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3271;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 6, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3272;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3273;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3274;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3275;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3276;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3277;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3278;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3279;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3280;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 7, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3281;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3282;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3283;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3284;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3285;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3286;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3287;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3288;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3289;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 8, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3290;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3291;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3292;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3293;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3294;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3295;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3296;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3297;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3298;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 9, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3299;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3300;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3301;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3302;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3303;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3304;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3305;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3306;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3307;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 10, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3308;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3309;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3310;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3311;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3312;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3313;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3314;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3315;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3316;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 11, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3317;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3318;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3319;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3320;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3321;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3322;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3323;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3324;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3325;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 12, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3326;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3327;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3328;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3329;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3330;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3331;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3332;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3333;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3334;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 13, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3335;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3336;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3337;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3338;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3339;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3340;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3341;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3342;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3343;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 14, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3344;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::Up).ID: return 3345;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::Side).ID: return 3346;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::Up, RedstoneWire::West::None).ID: return 3347;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::Up).ID: return 3348;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::Side).ID: return 3349;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::Side, RedstoneWire::West::None).ID: return 3350;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::Up).ID: return 3351;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::Side).ID: return 3352;
			case RedstoneWire::RedstoneWire(RedstoneWire::East::None, RedstoneWire::North::None, 15, RedstoneWire::South::None, RedstoneWire::West::None).ID: return 3353;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 4031;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 4032;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 4033;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 4034;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 4035;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 4036;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 4037;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 4038;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XM, true, true).ID: return 4039;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XM, true, false).ID: return 4040;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XM, false, true).ID: return 4041;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XM, false, false).ID: return 4042;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XP, true, true).ID: return 4043;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XP, true, false).ID: return 4044;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XP, false, true).ID: return 4045;
			case Repeater::Repeater(1, eBlockFace::BLOCK_FACE_XP, false, false).ID: return 4046;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 4047;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 4048;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 4049;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 4050;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 4051;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 4052;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 4053;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 4054;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XM, true, true).ID: return 4055;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XM, true, false).ID: return 4056;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XM, false, true).ID: return 4057;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XM, false, false).ID: return 4058;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XP, true, true).ID: return 4059;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XP, true, false).ID: return 4060;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XP, false, true).ID: return 4061;
			case Repeater::Repeater(2, eBlockFace::BLOCK_FACE_XP, false, false).ID: return 4062;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 4063;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 4064;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 4065;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 4066;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 4067;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 4068;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 4069;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 4070;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XM, true, true).ID: return 4071;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XM, true, false).ID: return 4072;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XM, false, true).ID: return 4073;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XM, false, false).ID: return 4074;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XP, true, true).ID: return 4075;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XP, true, false).ID: return 4076;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XP, false, true).ID: return 4077;
			case Repeater::Repeater(3, eBlockFace::BLOCK_FACE_XP, false, false).ID: return 4078;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 4079;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 4080;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 4081;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 4082;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 4083;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 4084;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 4085;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 4086;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XM, true, true).ID: return 4087;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XM, true, false).ID: return 4088;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XM, false, true).ID: return 4089;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XM, false, false).ID: return 4090;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XP, true, true).ID: return 4091;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XP, true, false).ID: return 4092;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XP, false, true).ID: return 4093;
			case Repeater::Repeater(4, eBlockFace::BLOCK_FACE_XP, false, false).ID: return 4094;
			case RepeatingCommandBlock::RepeatingCommandBlock(true, eBlockFace::BLOCK_FACE_ZM).ID: return 9225;
			case RepeatingCommandBlock::RepeatingCommandBlock(true, eBlockFace::BLOCK_FACE_XP).ID: return 9226;
			case RepeatingCommandBlock::RepeatingCommandBlock(true, eBlockFace::BLOCK_FACE_ZP).ID: return 9227;
			case RepeatingCommandBlock::RepeatingCommandBlock(true, eBlockFace::BLOCK_FACE_XM).ID: return 9228;
			case RepeatingCommandBlock::RepeatingCommandBlock(true, eBlockFace::BLOCK_FACE_YP).ID: return 9229;
			case RepeatingCommandBlock::RepeatingCommandBlock(true, eBlockFace::BLOCK_FACE_YM).ID: return 9230;
			case RepeatingCommandBlock::RepeatingCommandBlock(false, eBlockFace::BLOCK_FACE_ZM).ID: return 9231;
			case RepeatingCommandBlock::RepeatingCommandBlock(false, eBlockFace::BLOCK_FACE_XP).ID: return 9232;
			case RepeatingCommandBlock::RepeatingCommandBlock(false, eBlockFace::BLOCK_FACE_ZP).ID: return 9233;
			case RepeatingCommandBlock::RepeatingCommandBlock(false, eBlockFace::BLOCK_FACE_XM).ID: return 9234;
			case RepeatingCommandBlock::RepeatingCommandBlock(false, eBlockFace::BLOCK_FACE_YP).ID: return 9235;
			case RepeatingCommandBlock::RepeatingCommandBlock(false, eBlockFace::BLOCK_FACE_YM).ID: return 9236;
			case RespawnAnchor::RespawnAnchor(0).ID: return 15829;
			case RespawnAnchor::RespawnAnchor(1).ID: return 15830;
			case RespawnAnchor::RespawnAnchor(2).ID: return 15831;
			case RespawnAnchor::RespawnAnchor(3).ID: return 15832;
			case RespawnAnchor::RespawnAnchor(4).ID: return 15833;
			case RoseBush::RoseBush(RoseBush::Half::Upper).ID: return 7889;
			case RoseBush::RoseBush(RoseBush::Half::Lower).ID: return 7890;
			case Sand::Sand().ID: return 66;
			case Sandstone::Sandstone().ID: return 246;
			case SandstoneSlab::SandstoneSlab(SandstoneSlab::Type::Top).ID: return 8349;
			case SandstoneSlab::SandstoneSlab(SandstoneSlab::Type::Bottom).ID: return 8351;
			case SandstoneSlab::SandstoneSlab(SandstoneSlab::Type::Double).ID: return 8353;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::Straight).ID: return 5171;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerLeft).ID: return 5173;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerRight).ID: return 5175;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterLeft).ID: return 5177;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterRight).ID: return 5179;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::Straight).ID: return 5181;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerLeft).ID: return 5183;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerRight).ID: return 5185;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterLeft).ID: return 5187;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterRight).ID: return 5189;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::Straight).ID: return 5191;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerLeft).ID: return 5193;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerRight).ID: return 5195;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterLeft).ID: return 5197;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterRight).ID: return 5199;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::Straight).ID: return 5201;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerLeft).ID: return 5203;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerRight).ID: return 5205;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterLeft).ID: return 5207;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterRight).ID: return 5209;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::Straight).ID: return 5211;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerLeft).ID: return 5213;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerRight).ID: return 5215;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterLeft).ID: return 5217;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterRight).ID: return 5219;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::Straight).ID: return 5221;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerLeft).ID: return 5223;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerRight).ID: return 5225;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterLeft).ID: return 5227;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XM, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterRight).ID: return 5229;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::Straight).ID: return 5231;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerLeft).ID: return 5233;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::InnerRight).ID: return 5235;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterLeft).ID: return 5237;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Top, SandstoneStairs::Shape::OuterRight).ID: return 5239;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::Straight).ID: return 5241;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerLeft).ID: return 5243;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::InnerRight).ID: return 5245;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterLeft).ID: return 5247;
			case SandstoneStairs::SandstoneStairs(eBlockFace::BLOCK_FACE_XP, SandstoneStairs::Half::Bottom, SandstoneStairs::Shape::OuterRight).ID: return 5249;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 13786;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 13787;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 13788;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 13792;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 13793;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 13794;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 13798;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 13799;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 13800;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 13804;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 13805;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 13806;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 13810;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 13811;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 13812;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 13816;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 13817;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 13818;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 13822;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 13823;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 13824;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 13828;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 13829;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 13830;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 13834;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 13835;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 13836;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 13840;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 13841;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 13842;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 13846;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 13847;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 13848;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 13852;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 13853;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 13854;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 13858;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 13859;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 13860;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 13864;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 13865;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 13866;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 13870;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 13871;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 13872;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 13876;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 13877;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 13878;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 13882;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 13883;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 13884;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 13888;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 13889;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::None, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 13890;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 13894;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 13895;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 13896;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 13900;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 13901;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 13902;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 13906;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 13907;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 13908;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 13912;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 13913;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 13914;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 13918;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 13919;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 13920;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 13924;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 13925;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 13926;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 13930;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 13931;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 13932;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 13936;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 13937;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 13938;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 13942;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 13943;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 13944;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 13948;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 13949;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 13950;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 13954;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 13955;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 13956;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 13960;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 13961;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 13962;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 13966;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 13967;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 13968;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 13972;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 13973;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 13974;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 13978;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 13979;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 13980;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 13984;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 13985;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 13986;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 13990;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 13991;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 13992;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 13996;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 13997;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Low, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 13998;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 14002;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 14003;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 14004;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 14008;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 14009;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 14010;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 14014;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 14015;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 14016;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 14020;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 14021;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 14022;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 14026;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 14027;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 14028;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 14032;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 14033;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::None, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 14034;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 14038;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 14039;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 14040;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 14044;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 14045;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 14046;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 14050;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 14051;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 14052;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 14056;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 14057;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 14058;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 14062;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 14063;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 14064;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 14068;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 14069;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Low, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 14070;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::None).ID: return 14074;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::Low).ID: return 14075;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::None, true, SandstoneWall::West::Tall).ID: return 14076;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::None).ID: return 14080;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::Low).ID: return 14081;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::None, false, SandstoneWall::West::Tall).ID: return 14082;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::None).ID: return 14086;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::Low).ID: return 14087;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Low, true, SandstoneWall::West::Tall).ID: return 14088;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::None).ID: return 14092;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::Low).ID: return 14093;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Low, false, SandstoneWall::West::Tall).ID: return 14094;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::None).ID: return 14098;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::Low).ID: return 14099;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Tall, true, SandstoneWall::West::Tall).ID: return 14100;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::None).ID: return 14104;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::Low).ID: return 14105;
			case SandstoneWall::SandstoneWall(SandstoneWall::East::Tall, SandstoneWall::North::Tall, SandstoneWall::South::Tall, false, SandstoneWall::West::Tall).ID: return 14106;
			case Scaffolding::Scaffolding(true, 0).ID: return 14756;
			case Scaffolding::Scaffolding(true, 1).ID: return 14758;
			case Scaffolding::Scaffolding(true, 2).ID: return 14760;
			case Scaffolding::Scaffolding(true, 3).ID: return 14762;
			case Scaffolding::Scaffolding(true, 4).ID: return 14764;
			case Scaffolding::Scaffolding(true, 5).ID: return 14766;
			case Scaffolding::Scaffolding(true, 6).ID: return 14768;
			case Scaffolding::Scaffolding(true, 7).ID: return 14770;
			case Scaffolding::Scaffolding(false, 0).ID: return 14772;
			case Scaffolding::Scaffolding(false, 1).ID: return 14774;
			case Scaffolding::Scaffolding(false, 2).ID: return 14776;
			case Scaffolding::Scaffolding(false, 3).ID: return 14778;
			case Scaffolding::Scaffolding(false, 4).ID: return 14780;
			case Scaffolding::Scaffolding(false, 5).ID: return 14782;
			case Scaffolding::Scaffolding(false, 6).ID: return 14784;
			case Scaffolding::Scaffolding(false, 7).ID: return 14786;
			case SeaLantern::SeaLantern().ID: return 7862;
			case SeaPickle::SeaPickle(1).ID: return 9641;
			case SeaPickle::SeaPickle(2).ID: return 9643;
			case SeaPickle::SeaPickle(3).ID: return 9645;
			case SeaPickle::SeaPickle(4).ID: return 9647;
			case Seagrass::Seagrass().ID: return 1345;
			case Shroomlight::Shroomlight().ID: return 14989;
			case ShulkerBox::ShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9272;
			case ShulkerBox::ShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9273;
			case ShulkerBox::ShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9274;
			case ShulkerBox::ShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9275;
			case ShulkerBox::ShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9276;
			case ShulkerBox::ShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9277;
			case SkeletonSkull::SkeletonSkull(0).ID: return 6490;
			case SkeletonSkull::SkeletonSkull(1).ID: return 6491;
			case SkeletonSkull::SkeletonSkull(2).ID: return 6492;
			case SkeletonSkull::SkeletonSkull(3).ID: return 6493;
			case SkeletonSkull::SkeletonSkull(4).ID: return 6494;
			case SkeletonSkull::SkeletonSkull(5).ID: return 6495;
			case SkeletonSkull::SkeletonSkull(6).ID: return 6496;
			case SkeletonSkull::SkeletonSkull(7).ID: return 6497;
			case SkeletonSkull::SkeletonSkull(8).ID: return 6498;
			case SkeletonSkull::SkeletonSkull(9).ID: return 6499;
			case SkeletonSkull::SkeletonSkull(10).ID: return 6500;
			case SkeletonSkull::SkeletonSkull(11).ID: return 6501;
			case SkeletonSkull::SkeletonSkull(12).ID: return 6502;
			case SkeletonSkull::SkeletonSkull(13).ID: return 6503;
			case SkeletonSkull::SkeletonSkull(14).ID: return 6504;
			case SkeletonSkull::SkeletonSkull(15).ID: return 6505;
			case SkeletonWallSkull::SkeletonWallSkull(eBlockFace::BLOCK_FACE_ZM).ID: return 6506;
			case SkeletonWallSkull::SkeletonWallSkull(eBlockFace::BLOCK_FACE_ZP).ID: return 6507;
			case SkeletonWallSkull::SkeletonWallSkull(eBlockFace::BLOCK_FACE_XM).ID: return 6508;
			case SkeletonWallSkull::SkeletonWallSkull(eBlockFace::BLOCK_FACE_XP).ID: return 6509;
			case SlimeBlock::SlimeBlock().ID: return 7535;
			case SmithingTable::SmithingTable().ID: return 14849;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_ZM, true).ID: return 14803;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_ZM, false).ID: return 14804;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_ZP, true).ID: return 14805;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_ZP, false).ID: return 14806;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_XM, true).ID: return 14807;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_XM, false).ID: return 14808;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_XP, true).ID: return 14809;
			case Smoker::Smoker(eBlockFace::BLOCK_FACE_XP, false).ID: return 14810;
			case SmoothQuartz::SmoothQuartz().ID: return 8416;
			case SmoothQuartzSlab::SmoothQuartzSlab(SmoothQuartzSlab::Type::Top).ID: return 10832;
			case SmoothQuartzSlab::SmoothQuartzSlab(SmoothQuartzSlab::Type::Bottom).ID: return 10834;
			case SmoothQuartzSlab::SmoothQuartzSlab(SmoothQuartzSlab::Type::Double).ID: return 10836;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::Straight).ID: return 10310;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10312;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerRight).ID: return 10314;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10316;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterRight).ID: return 10318;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::Straight).ID: return 10320;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10322;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerRight).ID: return 10324;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10326;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterRight).ID: return 10328;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::Straight).ID: return 10330;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10332;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerRight).ID: return 10334;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10336;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterRight).ID: return 10338;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::Straight).ID: return 10340;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10342;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerRight).ID: return 10344;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10346;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_ZP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterRight).ID: return 10348;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::Straight).ID: return 10350;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10352;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerRight).ID: return 10354;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10356;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterRight).ID: return 10358;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::Straight).ID: return 10360;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10362;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerRight).ID: return 10364;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10366;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XM, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterRight).ID: return 10368;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::Straight).ID: return 10370;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10372;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::InnerRight).ID: return 10374;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10376;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Top, SmoothQuartzStairs::Shape::OuterRight).ID: return 10378;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::Straight).ID: return 10380;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerLeft).ID: return 10382;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::InnerRight).ID: return 10384;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterLeft).ID: return 10386;
			case SmoothQuartzStairs::SmoothQuartzStairs(eBlockFace::BLOCK_FACE_XP, SmoothQuartzStairs::Half::Bottom, SmoothQuartzStairs::Shape::OuterRight).ID: return 10388;
			case SmoothRedSandstone::SmoothRedSandstone().ID: return 8417;
			case SmoothRedSandstoneSlab::SmoothRedSandstoneSlab(SmoothRedSandstoneSlab::Type::Top).ID: return 10796;
			case SmoothRedSandstoneSlab::SmoothRedSandstoneSlab(SmoothRedSandstoneSlab::Type::Bottom).ID: return 10798;
			case SmoothRedSandstoneSlab::SmoothRedSandstoneSlab(SmoothRedSandstoneSlab::Type::Double).ID: return 10800;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9750;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9752;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9754;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9756;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9758;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9760;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9762;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9764;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9766;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9768;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9770;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9772;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9774;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9776;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9778;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9780;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9782;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9784;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9786;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9788;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9790;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9792;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9794;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9796;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9798;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9800;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9802;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9804;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9806;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9808;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9810;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9812;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9814;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9816;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Top, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9818;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::Straight).ID: return 9820;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerLeft).ID: return 9822;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::InnerRight).ID: return 9824;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterLeft).ID: return 9826;
			case SmoothRedSandstoneStairs::SmoothRedSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothRedSandstoneStairs::Half::Bottom, SmoothRedSandstoneStairs::Shape::OuterRight).ID: return 9828;
			case SmoothSandstone::SmoothSandstone().ID: return 8415;
			case SmoothSandstoneSlab::SmoothSandstoneSlab(SmoothSandstoneSlab::Type::Top).ID: return 10826;
			case SmoothSandstoneSlab::SmoothSandstoneSlab(SmoothSandstoneSlab::Type::Bottom).ID: return 10828;
			case SmoothSandstoneSlab::SmoothSandstoneSlab(SmoothSandstoneSlab::Type::Double).ID: return 10830;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::Straight).ID: return 10230;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10232;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10234;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10236;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10238;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::Straight).ID: return 10240;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10242;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10244;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10246;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10248;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::Straight).ID: return 10250;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10252;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10254;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10256;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10258;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::Straight).ID: return 10260;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10262;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10264;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10266;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_ZP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10268;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::Straight).ID: return 10270;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10272;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10274;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10276;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10278;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::Straight).ID: return 10280;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10282;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10284;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10286;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XM, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10288;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::Straight).ID: return 10290;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10292;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10294;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10296;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Top, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10298;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::Straight).ID: return 10300;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerLeft).ID: return 10302;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::InnerRight).ID: return 10304;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterLeft).ID: return 10306;
			case SmoothSandstoneStairs::SmoothSandstoneStairs(eBlockFace::BLOCK_FACE_XP, SmoothSandstoneStairs::Half::Bottom, SmoothSandstoneStairs::Shape::OuterRight).ID: return 10308;
			case SmoothStone::SmoothStone().ID: return 8414;
			case SmoothStoneSlab::SmoothStoneSlab(SmoothStoneSlab::Type::Top).ID: return 8343;
			case SmoothStoneSlab::SmoothStoneSlab(SmoothStoneSlab::Type::Bottom).ID: return 8345;
			case SmoothStoneSlab::SmoothStoneSlab(SmoothStoneSlab::Type::Double).ID: return 8347;
			case Snow::Snow(1).ID: return 3921;
			case Snow::Snow(2).ID: return 3922;
			case Snow::Snow(3).ID: return 3923;
			case Snow::Snow(4).ID: return 3924;
			case Snow::Snow(5).ID: return 3925;
			case Snow::Snow(6).ID: return 3926;
			case Snow::Snow(7).ID: return 3927;
			case Snow::Snow(8).ID: return 3928;
			case SnowBlock::SnowBlock().ID: return 3930;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZM, true, true).ID: return 14923;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZM, true, false).ID: return 14925;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZM, false, true).ID: return 14927;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZM, false, false).ID: return 14929;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZP, true, true).ID: return 14931;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZP, true, false).ID: return 14933;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZP, false, true).ID: return 14935;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_ZP, false, false).ID: return 14937;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XM, true, true).ID: return 14939;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XM, true, false).ID: return 14941;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XM, false, true).ID: return 14943;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XM, false, false).ID: return 14945;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XP, true, true).ID: return 14947;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XP, true, false).ID: return 14949;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XP, false, true).ID: return 14951;
			case SoulCampfire::SoulCampfire(eBlockFace::BLOCK_FACE_XP, false, false).ID: return 14953;
			case SoulFire::SoulFire().ID: return 1952;
			case SoulLantern::SoulLantern(true).ID: return 14888;
			case SoulLantern::SoulLantern(false).ID: return 14889;
			case SoulSand::SoulSand().ID: return 4000;
			case SoulSoil::SoulSoil().ID: return 4001;
			case SoulTorch::SoulTorch().ID: return 4008;
			case SoulWallTorch::SoulWallTorch(eBlockFace::BLOCK_FACE_ZM).ID: return 4009;
			case SoulWallTorch::SoulWallTorch(eBlockFace::BLOCK_FACE_ZP).ID: return 4010;
			case SoulWallTorch::SoulWallTorch(eBlockFace::BLOCK_FACE_XM).ID: return 4011;
			case SoulWallTorch::SoulWallTorch(eBlockFace::BLOCK_FACE_XP).ID: return 4012;
			case Spawner::Spawner().ID: return 1953;
			case Sponge::Sponge().ID: return 229;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6370;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6371;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6372;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6373;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 6374;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 6375;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 6376;
			case SpruceButton::SpruceButton(SpruceButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 6377;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6378;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6379;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6380;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6381;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 6382;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 6383;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 6384;
			case SpruceButton::SpruceButton(SpruceButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 6385;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 6386;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 6387;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 6388;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 6389;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 6390;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 6391;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 6392;
			case SpruceButton::SpruceButton(SpruceButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 6393;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, true).ID: return 8738;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, false).ID: return 8739;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, true).ID: return 8740;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, false).ID: return 8741;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, true).ID: return 8742;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, false).ID: return 8743;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, true).ID: return 8744;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, false).ID: return 8745;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, true).ID: return 8746;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, false).ID: return 8747;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, true).ID: return 8748;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, false).ID: return 8749;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, true).ID: return 8750;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, false).ID: return 8751;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, true).ID: return 8752;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, false).ID: return 8753;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, true).ID: return 8754;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, false).ID: return 8755;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, true).ID: return 8756;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, false).ID: return 8757;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, true).ID: return 8758;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, false).ID: return 8759;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, true).ID: return 8760;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, false).ID: return 8761;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, true).ID: return 8762;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, false).ID: return 8763;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, true).ID: return 8764;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, false).ID: return 8765;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, true).ID: return 8766;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, false).ID: return 8767;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, true).ID: return 8768;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_ZP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, false).ID: return 8769;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, true).ID: return 8770;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, false).ID: return 8771;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, true).ID: return 8772;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, false).ID: return 8773;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, true).ID: return 8774;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, false).ID: return 8775;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, true).ID: return 8776;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, false).ID: return 8777;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, true).ID: return 8778;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, false).ID: return 8779;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, true).ID: return 8780;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, false).ID: return 8781;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, true).ID: return 8782;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, false).ID: return 8783;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, true).ID: return 8784;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XM, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, false).ID: return 8785;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, true).ID: return 8786;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, true, false).ID: return 8787;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, true).ID: return 8788;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Left, false, false).ID: return 8789;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, true).ID: return 8790;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, true, false).ID: return 8791;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, true).ID: return 8792;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Upper, SpruceDoor::Hinge::Right, false, false).ID: return 8793;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, true).ID: return 8794;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, true, false).ID: return 8795;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, true).ID: return 8796;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Left, false, false).ID: return 8797;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, true).ID: return 8798;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, true, false).ID: return 8799;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, true).ID: return 8800;
			case SpruceDoor::SpruceDoor(eBlockFace::BLOCK_FACE_XP, SpruceDoor::Half::Lower, SpruceDoor::Hinge::Right, false, false).ID: return 8801;
			case SpruceFence::SpruceFence(true, true, true, true).ID: return 8580;
			case SpruceFence::SpruceFence(true, true, true, false).ID: return 8581;
			case SpruceFence::SpruceFence(true, true, false, true).ID: return 8584;
			case SpruceFence::SpruceFence(true, true, false, false).ID: return 8585;
			case SpruceFence::SpruceFence(true, false, true, true).ID: return 8588;
			case SpruceFence::SpruceFence(true, false, true, false).ID: return 8589;
			case SpruceFence::SpruceFence(true, false, false, true).ID: return 8592;
			case SpruceFence::SpruceFence(true, false, false, false).ID: return 8593;
			case SpruceFence::SpruceFence(false, true, true, true).ID: return 8596;
			case SpruceFence::SpruceFence(false, true, true, false).ID: return 8597;
			case SpruceFence::SpruceFence(false, true, false, true).ID: return 8600;
			case SpruceFence::SpruceFence(false, true, false, false).ID: return 8601;
			case SpruceFence::SpruceFence(false, false, true, true).ID: return 8604;
			case SpruceFence::SpruceFence(false, false, true, false).ID: return 8605;
			case SpruceFence::SpruceFence(false, false, false, true).ID: return 8608;
			case SpruceFence::SpruceFence(false, false, false, false).ID: return 8609;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 8418;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 8419;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 8420;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 8421;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 8422;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 8423;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 8424;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 8425;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 8426;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 8427;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 8428;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 8429;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 8430;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 8431;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 8432;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 8433;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 8434;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 8435;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 8436;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 8437;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 8438;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 8439;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 8440;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 8441;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 8442;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 8443;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 8444;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 8445;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 8446;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 8447;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 8448;
			case SpruceFenceGate::SpruceFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 8449;
			case SpruceLeaves::SpruceLeaves(1, true).ID: return 159;
			case SpruceLeaves::SpruceLeaves(1, false).ID: return 160;
			case SpruceLeaves::SpruceLeaves(2, true).ID: return 161;
			case SpruceLeaves::SpruceLeaves(2, false).ID: return 162;
			case SpruceLeaves::SpruceLeaves(3, true).ID: return 163;
			case SpruceLeaves::SpruceLeaves(3, false).ID: return 164;
			case SpruceLeaves::SpruceLeaves(4, true).ID: return 165;
			case SpruceLeaves::SpruceLeaves(4, false).ID: return 166;
			case SpruceLeaves::SpruceLeaves(5, true).ID: return 167;
			case SpruceLeaves::SpruceLeaves(5, false).ID: return 168;
			case SpruceLeaves::SpruceLeaves(6, true).ID: return 169;
			case SpruceLeaves::SpruceLeaves(6, false).ID: return 170;
			case SpruceLeaves::SpruceLeaves(7, true).ID: return 171;
			case SpruceLeaves::SpruceLeaves(7, false).ID: return 172;
			case SpruceLog::SpruceLog(SpruceLog::Axis::X).ID: return 76;
			case SpruceLog::SpruceLog(SpruceLog::Axis::Y).ID: return 77;
			case SpruceLog::SpruceLog(SpruceLog::Axis::Z).ID: return 78;
			case SprucePlanks::SprucePlanks().ID: return 16;
			case SprucePressurePlate::SprucePressurePlate(true).ID: return 3875;
			case SprucePressurePlate::SprucePressurePlate(false).ID: return 3876;
			case SpruceSapling::SpruceSapling(0).ID: return 23;
			case SpruceSapling::SpruceSapling(1).ID: return 24;
			case SpruceSign::SpruceSign(0).ID: return 3414;
			case SpruceSign::SpruceSign(1).ID: return 3416;
			case SpruceSign::SpruceSign(2).ID: return 3418;
			case SpruceSign::SpruceSign(3).ID: return 3420;
			case SpruceSign::SpruceSign(4).ID: return 3422;
			case SpruceSign::SpruceSign(5).ID: return 3424;
			case SpruceSign::SpruceSign(6).ID: return 3426;
			case SpruceSign::SpruceSign(7).ID: return 3428;
			case SpruceSign::SpruceSign(8).ID: return 3430;
			case SpruceSign::SpruceSign(9).ID: return 3432;
			case SpruceSign::SpruceSign(10).ID: return 3434;
			case SpruceSign::SpruceSign(11).ID: return 3436;
			case SpruceSign::SpruceSign(12).ID: return 3438;
			case SpruceSign::SpruceSign(13).ID: return 3440;
			case SpruceSign::SpruceSign(14).ID: return 3442;
			case SpruceSign::SpruceSign(15).ID: return 3444;
			case SpruceSlab::SpruceSlab(SpruceSlab::Type::Top).ID: return 8307;
			case SpruceSlab::SpruceSlab(SpruceSlab::Type::Bottom).ID: return 8309;
			case SpruceSlab::SpruceSlab(SpruceSlab::Type::Double).ID: return 8311;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Top, SpruceStairs::Shape::Straight).ID: return 5405;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerLeft).ID: return 5407;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerRight).ID: return 5409;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterLeft).ID: return 5411;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterRight).ID: return 5413;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::Straight).ID: return 5415;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerLeft).ID: return 5417;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerRight).ID: return 5419;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterLeft).ID: return 5421;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterRight).ID: return 5423;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Top, SpruceStairs::Shape::Straight).ID: return 5425;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerLeft).ID: return 5427;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerRight).ID: return 5429;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterLeft).ID: return 5431;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterRight).ID: return 5433;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::Straight).ID: return 5435;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerLeft).ID: return 5437;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerRight).ID: return 5439;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterLeft).ID: return 5441;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_ZP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterRight).ID: return 5443;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Top, SpruceStairs::Shape::Straight).ID: return 5445;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerLeft).ID: return 5447;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerRight).ID: return 5449;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterLeft).ID: return 5451;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterRight).ID: return 5453;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::Straight).ID: return 5455;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerLeft).ID: return 5457;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerRight).ID: return 5459;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterLeft).ID: return 5461;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XM, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterRight).ID: return 5463;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Top, SpruceStairs::Shape::Straight).ID: return 5465;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerLeft).ID: return 5467;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Top, SpruceStairs::Shape::InnerRight).ID: return 5469;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterLeft).ID: return 5471;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Top, SpruceStairs::Shape::OuterRight).ID: return 5473;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::Straight).ID: return 5475;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerLeft).ID: return 5477;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::InnerRight).ID: return 5479;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterLeft).ID: return 5481;
			case SpruceStairs::SpruceStairs(eBlockFace::BLOCK_FACE_XP, SpruceStairs::Half::Bottom, SpruceStairs::Shape::OuterRight).ID: return 5483;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Top, true, true).ID: return 4176;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Top, true, false).ID: return 4178;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Top, false, true).ID: return 4180;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Top, false, false).ID: return 4182;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Bottom, true, true).ID: return 4184;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Bottom, true, false).ID: return 4186;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Bottom, false, true).ID: return 4188;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZM, SpruceTrapdoor::Half::Bottom, false, false).ID: return 4190;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Top, true, true).ID: return 4192;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Top, true, false).ID: return 4194;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Top, false, true).ID: return 4196;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Top, false, false).ID: return 4198;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Bottom, true, true).ID: return 4200;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Bottom, true, false).ID: return 4202;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Bottom, false, true).ID: return 4204;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_ZP, SpruceTrapdoor::Half::Bottom, false, false).ID: return 4206;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Top, true, true).ID: return 4208;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Top, true, false).ID: return 4210;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Top, false, true).ID: return 4212;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Top, false, false).ID: return 4214;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Bottom, true, true).ID: return 4216;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Bottom, true, false).ID: return 4218;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Bottom, false, true).ID: return 4220;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XM, SpruceTrapdoor::Half::Bottom, false, false).ID: return 4222;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Top, true, true).ID: return 4224;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Top, true, false).ID: return 4226;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Top, false, true).ID: return 4228;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Top, false, false).ID: return 4230;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Bottom, true, true).ID: return 4232;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Bottom, true, false).ID: return 4234;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Bottom, false, true).ID: return 4236;
			case SpruceTrapdoor::SpruceTrapdoor(eBlockFace::BLOCK_FACE_XP, SpruceTrapdoor::Half::Bottom, false, false).ID: return 4238;
			case SpruceWallSign::SpruceWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 3744;
			case SpruceWallSign::SpruceWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 3746;
			case SpruceWallSign::SpruceWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 3748;
			case SpruceWallSign::SpruceWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 3750;
			case SpruceWood::SpruceWood(SpruceWood::Axis::X).ID: return 112;
			case SpruceWood::SpruceWood(SpruceWood::Axis::Y).ID: return 113;
			case SpruceWood::SpruceWood(SpruceWood::Axis::Z).ID: return 114;
			case StickyPiston::StickyPiston(true, eBlockFace::BLOCK_FACE_ZM).ID: return 1329;
			case StickyPiston::StickyPiston(true, eBlockFace::BLOCK_FACE_XP).ID: return 1330;
			case StickyPiston::StickyPiston(true, eBlockFace::BLOCK_FACE_ZP).ID: return 1331;
			case StickyPiston::StickyPiston(true, eBlockFace::BLOCK_FACE_XM).ID: return 1332;
			case StickyPiston::StickyPiston(true, eBlockFace::BLOCK_FACE_YP).ID: return 1333;
			case StickyPiston::StickyPiston(true, eBlockFace::BLOCK_FACE_YM).ID: return 1334;
			case StickyPiston::StickyPiston(false, eBlockFace::BLOCK_FACE_ZM).ID: return 1335;
			case StickyPiston::StickyPiston(false, eBlockFace::BLOCK_FACE_XP).ID: return 1336;
			case StickyPiston::StickyPiston(false, eBlockFace::BLOCK_FACE_ZP).ID: return 1337;
			case StickyPiston::StickyPiston(false, eBlockFace::BLOCK_FACE_XM).ID: return 1338;
			case StickyPiston::StickyPiston(false, eBlockFace::BLOCK_FACE_YP).ID: return 1339;
			case StickyPiston::StickyPiston(false, eBlockFace::BLOCK_FACE_YM).ID: return 1340;
			case Stone::Stone().ID: return 1;
			case StoneBrickSlab::StoneBrickSlab(StoneBrickSlab::Type::Top).ID: return 8379;
			case StoneBrickSlab::StoneBrickSlab(StoneBrickSlab::Type::Bottom).ID: return 8381;
			case StoneBrickSlab::StoneBrickSlab(StoneBrickSlab::Type::Double).ID: return 8383;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::Straight).ID: return 4933;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerLeft).ID: return 4935;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerRight).ID: return 4937;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterLeft).ID: return 4939;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterRight).ID: return 4941;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::Straight).ID: return 4943;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerLeft).ID: return 4945;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerRight).ID: return 4947;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterLeft).ID: return 4949;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterRight).ID: return 4951;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::Straight).ID: return 4953;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerLeft).ID: return 4955;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerRight).ID: return 4957;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterLeft).ID: return 4959;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterRight).ID: return 4961;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::Straight).ID: return 4963;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerLeft).ID: return 4965;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerRight).ID: return 4967;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterLeft).ID: return 4969;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_ZP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterRight).ID: return 4971;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::Straight).ID: return 4973;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerLeft).ID: return 4975;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerRight).ID: return 4977;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterLeft).ID: return 4979;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterRight).ID: return 4981;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::Straight).ID: return 4983;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerLeft).ID: return 4985;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerRight).ID: return 4987;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterLeft).ID: return 4989;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XM, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterRight).ID: return 4991;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::Straight).ID: return 4993;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerLeft).ID: return 4995;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::InnerRight).ID: return 4997;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterLeft).ID: return 4999;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Top, StoneBrickStairs::Shape::OuterRight).ID: return 5001;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::Straight).ID: return 5003;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerLeft).ID: return 5005;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::InnerRight).ID: return 5007;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterLeft).ID: return 5009;
			case StoneBrickStairs::StoneBrickStairs(eBlockFace::BLOCK_FACE_XP, StoneBrickStairs::Half::Bottom, StoneBrickStairs::Shape::OuterRight).ID: return 5011;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12490;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12491;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12492;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12496;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12497;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12498;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12502;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12503;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12504;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12508;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12509;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12510;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12514;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12515;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12516;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12520;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12521;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12522;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12526;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12527;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12528;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12532;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12533;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12534;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12538;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12539;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12540;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12544;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12545;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12546;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12550;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12551;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12552;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12556;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12557;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12558;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12562;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12563;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12564;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12568;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12569;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12570;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12574;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12575;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12576;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12580;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12581;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12582;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12586;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12587;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12588;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12592;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12593;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::None, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12594;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12598;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12599;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12600;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12604;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12605;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12606;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12610;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12611;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12612;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12616;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12617;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12618;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12622;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12623;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12624;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12628;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12629;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12630;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12634;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12635;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12636;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12640;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12641;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12642;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12646;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12647;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12648;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12652;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12653;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12654;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12658;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12659;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12660;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12664;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12665;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12666;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12670;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12671;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12672;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12676;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12677;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12678;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12682;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12683;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12684;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12688;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12689;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12690;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12694;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12695;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12696;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12700;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12701;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Low, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12702;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12706;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12707;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12708;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12712;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12713;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12714;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12718;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12719;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12720;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12724;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12725;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12726;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12730;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12731;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12732;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12736;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12737;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::None, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12738;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12742;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12743;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12744;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12748;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12749;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12750;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12754;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12755;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12756;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12760;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12761;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12762;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12766;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12767;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12768;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12772;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12773;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Low, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12774;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::None).ID: return 12778;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::Low).ID: return 12779;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::None, true, StoneBrickWall::West::Tall).ID: return 12780;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::None).ID: return 12784;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::Low).ID: return 12785;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::None, false, StoneBrickWall::West::Tall).ID: return 12786;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::None).ID: return 12790;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::Low).ID: return 12791;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, true, StoneBrickWall::West::Tall).ID: return 12792;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::None).ID: return 12796;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::Low).ID: return 12797;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Low, false, StoneBrickWall::West::Tall).ID: return 12798;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::None).ID: return 12802;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Low).ID: return 12803;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, true, StoneBrickWall::West::Tall).ID: return 12804;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::None).ID: return 12808;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Low).ID: return 12809;
			case StoneBrickWall::StoneBrickWall(StoneBrickWall::East::Tall, StoneBrickWall::North::Tall, StoneBrickWall::South::Tall, false, StoneBrickWall::West::Tall).ID: return 12810;
			case StoneBricks::StoneBricks().ID: return 4495;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 3897;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 3898;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 3899;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 3900;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 3901;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 3902;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 3903;
			case StoneButton::StoneButton(StoneButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 3904;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 3905;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 3906;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 3907;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 3908;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 3909;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 3910;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 3911;
			case StoneButton::StoneButton(StoneButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 3912;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 3913;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 3914;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 3915;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 3916;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 3917;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 3918;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 3919;
			case StoneButton::StoneButton(StoneButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 3920;
			case StonePressurePlate::StonePressurePlate(true).ID: return 3807;
			case StonePressurePlate::StonePressurePlate(false).ID: return 3808;
			case StoneSlab::StoneSlab(StoneSlab::Type::Top).ID: return 8337;
			case StoneSlab::StoneSlab(StoneSlab::Type::Bottom).ID: return 8339;
			case StoneSlab::StoneSlab(StoneSlab::Type::Double).ID: return 8341;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Top, StoneStairs::Shape::Straight).ID: return 10150;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Top, StoneStairs::Shape::InnerLeft).ID: return 10152;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Top, StoneStairs::Shape::InnerRight).ID: return 10154;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Top, StoneStairs::Shape::OuterLeft).ID: return 10156;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Top, StoneStairs::Shape::OuterRight).ID: return 10158;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Bottom, StoneStairs::Shape::Straight).ID: return 10160;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerLeft).ID: return 10162;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerRight).ID: return 10164;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterLeft).ID: return 10166;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZM, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterRight).ID: return 10168;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Top, StoneStairs::Shape::Straight).ID: return 10170;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Top, StoneStairs::Shape::InnerLeft).ID: return 10172;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Top, StoneStairs::Shape::InnerRight).ID: return 10174;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Top, StoneStairs::Shape::OuterLeft).ID: return 10176;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Top, StoneStairs::Shape::OuterRight).ID: return 10178;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Bottom, StoneStairs::Shape::Straight).ID: return 10180;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerLeft).ID: return 10182;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerRight).ID: return 10184;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterLeft).ID: return 10186;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_ZP, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterRight).ID: return 10188;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Top, StoneStairs::Shape::Straight).ID: return 10190;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Top, StoneStairs::Shape::InnerLeft).ID: return 10192;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Top, StoneStairs::Shape::InnerRight).ID: return 10194;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Top, StoneStairs::Shape::OuterLeft).ID: return 10196;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Top, StoneStairs::Shape::OuterRight).ID: return 10198;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Bottom, StoneStairs::Shape::Straight).ID: return 10200;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerLeft).ID: return 10202;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerRight).ID: return 10204;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterLeft).ID: return 10206;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XM, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterRight).ID: return 10208;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Top, StoneStairs::Shape::Straight).ID: return 10210;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Top, StoneStairs::Shape::InnerLeft).ID: return 10212;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Top, StoneStairs::Shape::InnerRight).ID: return 10214;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Top, StoneStairs::Shape::OuterLeft).ID: return 10216;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Top, StoneStairs::Shape::OuterRight).ID: return 10218;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Bottom, StoneStairs::Shape::Straight).ID: return 10220;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerLeft).ID: return 10222;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Bottom, StoneStairs::Shape::InnerRight).ID: return 10224;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterLeft).ID: return 10226;
			case StoneStairs::StoneStairs(eBlockFace::BLOCK_FACE_XP, StoneStairs::Half::Bottom, StoneStairs::Shape::OuterRight).ID: return 10228;
			case Stonecutter::Stonecutter(eBlockFace::BLOCK_FACE_ZM).ID: return 14850;
			case Stonecutter::Stonecutter(eBlockFace::BLOCK_FACE_ZP).ID: return 14851;
			case Stonecutter::Stonecutter(eBlockFace::BLOCK_FACE_XM).ID: return 14852;
			case Stonecutter::Stonecutter(eBlockFace::BLOCK_FACE_XP).ID: return 14853;
			case StrippedAcaciaLog::StrippedAcaciaLog(StrippedAcaciaLog::Axis::X).ID: return 100;
			case StrippedAcaciaLog::StrippedAcaciaLog(StrippedAcaciaLog::Axis::Y).ID: return 101;
			case StrippedAcaciaLog::StrippedAcaciaLog(StrippedAcaciaLog::Axis::Z).ID: return 102;
			case StrippedAcaciaWood::StrippedAcaciaWood(StrippedAcaciaWood::Axis::X).ID: return 139;
			case StrippedAcaciaWood::StrippedAcaciaWood(StrippedAcaciaWood::Axis::Y).ID: return 140;
			case StrippedAcaciaWood::StrippedAcaciaWood(StrippedAcaciaWood::Axis::Z).ID: return 141;
			case StrippedBirchLog::StrippedBirchLog(StrippedBirchLog::Axis::X).ID: return 94;
			case StrippedBirchLog::StrippedBirchLog(StrippedBirchLog::Axis::Y).ID: return 95;
			case StrippedBirchLog::StrippedBirchLog(StrippedBirchLog::Axis::Z).ID: return 96;
			case StrippedBirchWood::StrippedBirchWood(StrippedBirchWood::Axis::X).ID: return 133;
			case StrippedBirchWood::StrippedBirchWood(StrippedBirchWood::Axis::Y).ID: return 134;
			case StrippedBirchWood::StrippedBirchWood(StrippedBirchWood::Axis::Z).ID: return 135;
			case StrippedCrimsonHyphae::StrippedCrimsonHyphae(StrippedCrimsonHyphae::Axis::X).ID: return 14984;
			case StrippedCrimsonHyphae::StrippedCrimsonHyphae(StrippedCrimsonHyphae::Axis::Y).ID: return 14985;
			case StrippedCrimsonHyphae::StrippedCrimsonHyphae(StrippedCrimsonHyphae::Axis::Z).ID: return 14986;
			case StrippedCrimsonStem::StrippedCrimsonStem(StrippedCrimsonStem::Axis::X).ID: return 14978;
			case StrippedCrimsonStem::StrippedCrimsonStem(StrippedCrimsonStem::Axis::Y).ID: return 14979;
			case StrippedCrimsonStem::StrippedCrimsonStem(StrippedCrimsonStem::Axis::Z).ID: return 14980;
			case StrippedDarkOakLog::StrippedDarkOakLog(StrippedDarkOakLog::Axis::X).ID: return 103;
			case StrippedDarkOakLog::StrippedDarkOakLog(StrippedDarkOakLog::Axis::Y).ID: return 104;
			case StrippedDarkOakLog::StrippedDarkOakLog(StrippedDarkOakLog::Axis::Z).ID: return 105;
			case StrippedDarkOakWood::StrippedDarkOakWood(StrippedDarkOakWood::Axis::X).ID: return 142;
			case StrippedDarkOakWood::StrippedDarkOakWood(StrippedDarkOakWood::Axis::Y).ID: return 143;
			case StrippedDarkOakWood::StrippedDarkOakWood(StrippedDarkOakWood::Axis::Z).ID: return 144;
			case StrippedJungleLog::StrippedJungleLog(StrippedJungleLog::Axis::X).ID: return 97;
			case StrippedJungleLog::StrippedJungleLog(StrippedJungleLog::Axis::Y).ID: return 98;
			case StrippedJungleLog::StrippedJungleLog(StrippedJungleLog::Axis::Z).ID: return 99;
			case StrippedJungleWood::StrippedJungleWood(StrippedJungleWood::Axis::X).ID: return 136;
			case StrippedJungleWood::StrippedJungleWood(StrippedJungleWood::Axis::Y).ID: return 137;
			case StrippedJungleWood::StrippedJungleWood(StrippedJungleWood::Axis::Z).ID: return 138;
			case StrippedOakLog::StrippedOakLog(StrippedOakLog::Axis::X).ID: return 106;
			case StrippedOakLog::StrippedOakLog(StrippedOakLog::Axis::Y).ID: return 107;
			case StrippedOakLog::StrippedOakLog(StrippedOakLog::Axis::Z).ID: return 108;
			case StrippedOakWood::StrippedOakWood(StrippedOakWood::Axis::X).ID: return 127;
			case StrippedOakWood::StrippedOakWood(StrippedOakWood::Axis::Y).ID: return 128;
			case StrippedOakWood::StrippedOakWood(StrippedOakWood::Axis::Z).ID: return 129;
			case StrippedSpruceLog::StrippedSpruceLog(StrippedSpruceLog::Axis::X).ID: return 91;
			case StrippedSpruceLog::StrippedSpruceLog(StrippedSpruceLog::Axis::Y).ID: return 92;
			case StrippedSpruceLog::StrippedSpruceLog(StrippedSpruceLog::Axis::Z).ID: return 93;
			case StrippedSpruceWood::StrippedSpruceWood(StrippedSpruceWood::Axis::X).ID: return 130;
			case StrippedSpruceWood::StrippedSpruceWood(StrippedSpruceWood::Axis::Y).ID: return 131;
			case StrippedSpruceWood::StrippedSpruceWood(StrippedSpruceWood::Axis::Z).ID: return 132;
			case StrippedWarpedHyphae::StrippedWarpedHyphae(StrippedWarpedHyphae::Axis::X).ID: return 14967;
			case StrippedWarpedHyphae::StrippedWarpedHyphae(StrippedWarpedHyphae::Axis::Y).ID: return 14968;
			case StrippedWarpedHyphae::StrippedWarpedHyphae(StrippedWarpedHyphae::Axis::Z).ID: return 14969;
			case StrippedWarpedStem::StrippedWarpedStem(StrippedWarpedStem::Axis::X).ID: return 14961;
			case StrippedWarpedStem::StrippedWarpedStem(StrippedWarpedStem::Axis::Y).ID: return 14962;
			case StrippedWarpedStem::StrippedWarpedStem(StrippedWarpedStem::Axis::Z).ID: return 14963;
			case StructureBlock::StructureBlock(StructureBlock::Mode::Save).ID: return 15735;
			case StructureBlock::StructureBlock(StructureBlock::Mode::Load).ID: return 15736;
			case StructureBlock::StructureBlock(StructureBlock::Mode::Corner).ID: return 15737;
			case StructureBlock::StructureBlock(StructureBlock::Mode::Data).ID: return 15738;
			case StructureVoid::StructureVoid().ID: return 9259;
			case SugarCane::SugarCane(0).ID: return 3948;
			case SugarCane::SugarCane(1).ID: return 3949;
			case SugarCane::SugarCane(2).ID: return 3950;
			case SugarCane::SugarCane(3).ID: return 3951;
			case SugarCane::SugarCane(4).ID: return 3952;
			case SugarCane::SugarCane(5).ID: return 3953;
			case SugarCane::SugarCane(6).ID: return 3954;
			case SugarCane::SugarCane(7).ID: return 3955;
			case SugarCane::SugarCane(8).ID: return 3956;
			case SugarCane::SugarCane(9).ID: return 3957;
			case SugarCane::SugarCane(10).ID: return 3958;
			case SugarCane::SugarCane(11).ID: return 3959;
			case SugarCane::SugarCane(12).ID: return 3960;
			case SugarCane::SugarCane(13).ID: return 3961;
			case SugarCane::SugarCane(14).ID: return 3962;
			case SugarCane::SugarCane(15).ID: return 3963;
			case Sunflower::Sunflower(Sunflower::Half::Upper).ID: return 7885;
			case Sunflower::Sunflower(Sunflower::Half::Lower).ID: return 7886;
			case SweetBerryBush::SweetBerryBush(0).ID: return 14954;
			case SweetBerryBush::SweetBerryBush(1).ID: return 14955;
			case SweetBerryBush::SweetBerryBush(2).ID: return 14956;
			case SweetBerryBush::SweetBerryBush(3).ID: return 14957;
			case TNT::TNT(true).ID: return 1430;
			case TNT::TNT(false).ID: return 1431;
			case TallGrass::TallGrass(TallGrass::Half::Upper).ID: return 7893;
			case TallGrass::TallGrass(TallGrass::Half::Lower).ID: return 7894;
			case TallSeagrass::TallSeagrass(TallSeagrass::Half::Upper).ID: return 1346;
			case TallSeagrass::TallSeagrass(TallSeagrass::Half::Lower).ID: return 1347;
			case Target::Target(0).ID: return 15760;
			case Target::Target(1).ID: return 15761;
			case Target::Target(2).ID: return 15762;
			case Target::Target(3).ID: return 15763;
			case Target::Target(4).ID: return 15764;
			case Target::Target(5).ID: return 15765;
			case Target::Target(6).ID: return 15766;
			case Target::Target(7).ID: return 15767;
			case Target::Target(8).ID: return 15768;
			case Target::Target(9).ID: return 15769;
			case Target::Target(10).ID: return 15770;
			case Target::Target(11).ID: return 15771;
			case Target::Target(12).ID: return 15772;
			case Target::Target(13).ID: return 15773;
			case Target::Target(14).ID: return 15774;
			case Target::Target(15).ID: return 15775;
			case Terracotta::Terracotta().ID: return 7882;
			case Torch::Torch().ID: return 1435;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_ZM, TrappedChest::Type::Single).ID: return 6623;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_ZM, TrappedChest::Type::Left).ID: return 6625;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_ZM, TrappedChest::Type::Right).ID: return 6627;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_ZP, TrappedChest::Type::Single).ID: return 6629;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_ZP, TrappedChest::Type::Left).ID: return 6631;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_ZP, TrappedChest::Type::Right).ID: return 6633;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_XM, TrappedChest::Type::Single).ID: return 6635;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_XM, TrappedChest::Type::Left).ID: return 6637;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_XM, TrappedChest::Type::Right).ID: return 6639;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_XP, TrappedChest::Type::Single).ID: return 6641;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_XP, TrappedChest::Type::Left).ID: return 6643;
			case TrappedChest::TrappedChest(eBlockFace::BLOCK_FACE_XP, TrappedChest::Type::Right).ID: return 6645;
			case Tripwire::Tripwire(true, true, true, true, true, true, true).ID: return 5275;
			case Tripwire::Tripwire(true, true, true, true, true, true, false).ID: return 5276;
			case Tripwire::Tripwire(true, true, true, true, true, false, true).ID: return 5277;
			case Tripwire::Tripwire(true, true, true, true, true, false, false).ID: return 5278;
			case Tripwire::Tripwire(true, true, true, true, false, true, true).ID: return 5279;
			case Tripwire::Tripwire(true, true, true, true, false, true, false).ID: return 5280;
			case Tripwire::Tripwire(true, true, true, true, false, false, true).ID: return 5281;
			case Tripwire::Tripwire(true, true, true, true, false, false, false).ID: return 5282;
			case Tripwire::Tripwire(true, true, true, false, true, true, true).ID: return 5283;
			case Tripwire::Tripwire(true, true, true, false, true, true, false).ID: return 5284;
			case Tripwire::Tripwire(true, true, true, false, true, false, true).ID: return 5285;
			case Tripwire::Tripwire(true, true, true, false, true, false, false).ID: return 5286;
			case Tripwire::Tripwire(true, true, true, false, false, true, true).ID: return 5287;
			case Tripwire::Tripwire(true, true, true, false, false, true, false).ID: return 5288;
			case Tripwire::Tripwire(true, true, true, false, false, false, true).ID: return 5289;
			case Tripwire::Tripwire(true, true, true, false, false, false, false).ID: return 5290;
			case Tripwire::Tripwire(true, true, false, true, true, true, true).ID: return 5291;
			case Tripwire::Tripwire(true, true, false, true, true, true, false).ID: return 5292;
			case Tripwire::Tripwire(true, true, false, true, true, false, true).ID: return 5293;
			case Tripwire::Tripwire(true, true, false, true, true, false, false).ID: return 5294;
			case Tripwire::Tripwire(true, true, false, true, false, true, true).ID: return 5295;
			case Tripwire::Tripwire(true, true, false, true, false, true, false).ID: return 5296;
			case Tripwire::Tripwire(true, true, false, true, false, false, true).ID: return 5297;
			case Tripwire::Tripwire(true, true, false, true, false, false, false).ID: return 5298;
			case Tripwire::Tripwire(true, true, false, false, true, true, true).ID: return 5299;
			case Tripwire::Tripwire(true, true, false, false, true, true, false).ID: return 5300;
			case Tripwire::Tripwire(true, true, false, false, true, false, true).ID: return 5301;
			case Tripwire::Tripwire(true, true, false, false, true, false, false).ID: return 5302;
			case Tripwire::Tripwire(true, true, false, false, false, true, true).ID: return 5303;
			case Tripwire::Tripwire(true, true, false, false, false, true, false).ID: return 5304;
			case Tripwire::Tripwire(true, true, false, false, false, false, true).ID: return 5305;
			case Tripwire::Tripwire(true, true, false, false, false, false, false).ID: return 5306;
			case Tripwire::Tripwire(true, false, true, true, true, true, true).ID: return 5307;
			case Tripwire::Tripwire(true, false, true, true, true, true, false).ID: return 5308;
			case Tripwire::Tripwire(true, false, true, true, true, false, true).ID: return 5309;
			case Tripwire::Tripwire(true, false, true, true, true, false, false).ID: return 5310;
			case Tripwire::Tripwire(true, false, true, true, false, true, true).ID: return 5311;
			case Tripwire::Tripwire(true, false, true, true, false, true, false).ID: return 5312;
			case Tripwire::Tripwire(true, false, true, true, false, false, true).ID: return 5313;
			case Tripwire::Tripwire(true, false, true, true, false, false, false).ID: return 5314;
			case Tripwire::Tripwire(true, false, true, false, true, true, true).ID: return 5315;
			case Tripwire::Tripwire(true, false, true, false, true, true, false).ID: return 5316;
			case Tripwire::Tripwire(true, false, true, false, true, false, true).ID: return 5317;
			case Tripwire::Tripwire(true, false, true, false, true, false, false).ID: return 5318;
			case Tripwire::Tripwire(true, false, true, false, false, true, true).ID: return 5319;
			case Tripwire::Tripwire(true, false, true, false, false, true, false).ID: return 5320;
			case Tripwire::Tripwire(true, false, true, false, false, false, true).ID: return 5321;
			case Tripwire::Tripwire(true, false, true, false, false, false, false).ID: return 5322;
			case Tripwire::Tripwire(true, false, false, true, true, true, true).ID: return 5323;
			case Tripwire::Tripwire(true, false, false, true, true, true, false).ID: return 5324;
			case Tripwire::Tripwire(true, false, false, true, true, false, true).ID: return 5325;
			case Tripwire::Tripwire(true, false, false, true, true, false, false).ID: return 5326;
			case Tripwire::Tripwire(true, false, false, true, false, true, true).ID: return 5327;
			case Tripwire::Tripwire(true, false, false, true, false, true, false).ID: return 5328;
			case Tripwire::Tripwire(true, false, false, true, false, false, true).ID: return 5329;
			case Tripwire::Tripwire(true, false, false, true, false, false, false).ID: return 5330;
			case Tripwire::Tripwire(true, false, false, false, true, true, true).ID: return 5331;
			case Tripwire::Tripwire(true, false, false, false, true, true, false).ID: return 5332;
			case Tripwire::Tripwire(true, false, false, false, true, false, true).ID: return 5333;
			case Tripwire::Tripwire(true, false, false, false, true, false, false).ID: return 5334;
			case Tripwire::Tripwire(true, false, false, false, false, true, true).ID: return 5335;
			case Tripwire::Tripwire(true, false, false, false, false, true, false).ID: return 5336;
			case Tripwire::Tripwire(true, false, false, false, false, false, true).ID: return 5337;
			case Tripwire::Tripwire(true, false, false, false, false, false, false).ID: return 5338;
			case Tripwire::Tripwire(false, true, true, true, true, true, true).ID: return 5339;
			case Tripwire::Tripwire(false, true, true, true, true, true, false).ID: return 5340;
			case Tripwire::Tripwire(false, true, true, true, true, false, true).ID: return 5341;
			case Tripwire::Tripwire(false, true, true, true, true, false, false).ID: return 5342;
			case Tripwire::Tripwire(false, true, true, true, false, true, true).ID: return 5343;
			case Tripwire::Tripwire(false, true, true, true, false, true, false).ID: return 5344;
			case Tripwire::Tripwire(false, true, true, true, false, false, true).ID: return 5345;
			case Tripwire::Tripwire(false, true, true, true, false, false, false).ID: return 5346;
			case Tripwire::Tripwire(false, true, true, false, true, true, true).ID: return 5347;
			case Tripwire::Tripwire(false, true, true, false, true, true, false).ID: return 5348;
			case Tripwire::Tripwire(false, true, true, false, true, false, true).ID: return 5349;
			case Tripwire::Tripwire(false, true, true, false, true, false, false).ID: return 5350;
			case Tripwire::Tripwire(false, true, true, false, false, true, true).ID: return 5351;
			case Tripwire::Tripwire(false, true, true, false, false, true, false).ID: return 5352;
			case Tripwire::Tripwire(false, true, true, false, false, false, true).ID: return 5353;
			case Tripwire::Tripwire(false, true, true, false, false, false, false).ID: return 5354;
			case Tripwire::Tripwire(false, true, false, true, true, true, true).ID: return 5355;
			case Tripwire::Tripwire(false, true, false, true, true, true, false).ID: return 5356;
			case Tripwire::Tripwire(false, true, false, true, true, false, true).ID: return 5357;
			case Tripwire::Tripwire(false, true, false, true, true, false, false).ID: return 5358;
			case Tripwire::Tripwire(false, true, false, true, false, true, true).ID: return 5359;
			case Tripwire::Tripwire(false, true, false, true, false, true, false).ID: return 5360;
			case Tripwire::Tripwire(false, true, false, true, false, false, true).ID: return 5361;
			case Tripwire::Tripwire(false, true, false, true, false, false, false).ID: return 5362;
			case Tripwire::Tripwire(false, true, false, false, true, true, true).ID: return 5363;
			case Tripwire::Tripwire(false, true, false, false, true, true, false).ID: return 5364;
			case Tripwire::Tripwire(false, true, false, false, true, false, true).ID: return 5365;
			case Tripwire::Tripwire(false, true, false, false, true, false, false).ID: return 5366;
			case Tripwire::Tripwire(false, true, false, false, false, true, true).ID: return 5367;
			case Tripwire::Tripwire(false, true, false, false, false, true, false).ID: return 5368;
			case Tripwire::Tripwire(false, true, false, false, false, false, true).ID: return 5369;
			case Tripwire::Tripwire(false, true, false, false, false, false, false).ID: return 5370;
			case Tripwire::Tripwire(false, false, true, true, true, true, true).ID: return 5371;
			case Tripwire::Tripwire(false, false, true, true, true, true, false).ID: return 5372;
			case Tripwire::Tripwire(false, false, true, true, true, false, true).ID: return 5373;
			case Tripwire::Tripwire(false, false, true, true, true, false, false).ID: return 5374;
			case Tripwire::Tripwire(false, false, true, true, false, true, true).ID: return 5375;
			case Tripwire::Tripwire(false, false, true, true, false, true, false).ID: return 5376;
			case Tripwire::Tripwire(false, false, true, true, false, false, true).ID: return 5377;
			case Tripwire::Tripwire(false, false, true, true, false, false, false).ID: return 5378;
			case Tripwire::Tripwire(false, false, true, false, true, true, true).ID: return 5379;
			case Tripwire::Tripwire(false, false, true, false, true, true, false).ID: return 5380;
			case Tripwire::Tripwire(false, false, true, false, true, false, true).ID: return 5381;
			case Tripwire::Tripwire(false, false, true, false, true, false, false).ID: return 5382;
			case Tripwire::Tripwire(false, false, true, false, false, true, true).ID: return 5383;
			case Tripwire::Tripwire(false, false, true, false, false, true, false).ID: return 5384;
			case Tripwire::Tripwire(false, false, true, false, false, false, true).ID: return 5385;
			case Tripwire::Tripwire(false, false, true, false, false, false, false).ID: return 5386;
			case Tripwire::Tripwire(false, false, false, true, true, true, true).ID: return 5387;
			case Tripwire::Tripwire(false, false, false, true, true, true, false).ID: return 5388;
			case Tripwire::Tripwire(false, false, false, true, true, false, true).ID: return 5389;
			case Tripwire::Tripwire(false, false, false, true, true, false, false).ID: return 5390;
			case Tripwire::Tripwire(false, false, false, true, false, true, true).ID: return 5391;
			case Tripwire::Tripwire(false, false, false, true, false, true, false).ID: return 5392;
			case Tripwire::Tripwire(false, false, false, true, false, false, true).ID: return 5393;
			case Tripwire::Tripwire(false, false, false, true, false, false, false).ID: return 5394;
			case Tripwire::Tripwire(false, false, false, false, true, true, true).ID: return 5395;
			case Tripwire::Tripwire(false, false, false, false, true, true, false).ID: return 5396;
			case Tripwire::Tripwire(false, false, false, false, true, false, true).ID: return 5397;
			case Tripwire::Tripwire(false, false, false, false, true, false, false).ID: return 5398;
			case Tripwire::Tripwire(false, false, false, false, false, true, true).ID: return 5399;
			case Tripwire::Tripwire(false, false, false, false, false, true, false).ID: return 5400;
			case Tripwire::Tripwire(false, false, false, false, false, false, true).ID: return 5401;
			case Tripwire::Tripwire(false, false, false, false, false, false, false).ID: return 5402;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_ZM, true).ID: return 5259;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_ZM, false).ID: return 5260;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_ZP, true).ID: return 5261;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_ZP, false).ID: return 5262;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_XM, true).ID: return 5263;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_XM, false).ID: return 5264;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_XP, true).ID: return 5265;
			case TripwireHook::TripwireHook(true, eBlockFace::BLOCK_FACE_XP, false).ID: return 5266;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_ZM, true).ID: return 5267;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_ZM, false).ID: return 5268;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_ZP, true).ID: return 5269;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_ZP, false).ID: return 5270;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_XM, true).ID: return 5271;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_XM, false).ID: return 5272;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_XP, true).ID: return 5273;
			case TripwireHook::TripwireHook(false, eBlockFace::BLOCK_FACE_XP, false).ID: return 5274;
			case TubeCoral::TubeCoral().ID: return 9531;
			case TubeCoralBlock::TubeCoralBlock().ID: return 9515;
			case TubeCoralFan::TubeCoralFan().ID: return 9551;
			case TubeCoralWallFan::TubeCoralWallFan(eBlockFace::BLOCK_FACE_ZM).ID: return 9601;
			case TubeCoralWallFan::TubeCoralWallFan(eBlockFace::BLOCK_FACE_ZP).ID: return 9603;
			case TubeCoralWallFan::TubeCoralWallFan(eBlockFace::BLOCK_FACE_XM).ID: return 9605;
			case TubeCoralWallFan::TubeCoralWallFan(eBlockFace::BLOCK_FACE_XP).ID: return 9607;
			case TurtleEgg::TurtleEgg(1, 0).ID: return 9498;
			case TurtleEgg::TurtleEgg(1, 1).ID: return 9499;
			case TurtleEgg::TurtleEgg(1, 2).ID: return 9500;
			case TurtleEgg::TurtleEgg(2, 0).ID: return 9501;
			case TurtleEgg::TurtleEgg(2, 1).ID: return 9502;
			case TurtleEgg::TurtleEgg(2, 2).ID: return 9503;
			case TurtleEgg::TurtleEgg(3, 0).ID: return 9504;
			case TurtleEgg::TurtleEgg(3, 1).ID: return 9505;
			case TurtleEgg::TurtleEgg(3, 2).ID: return 9506;
			case TurtleEgg::TurtleEgg(4, 0).ID: return 9507;
			case TurtleEgg::TurtleEgg(4, 1).ID: return 9508;
			case TurtleEgg::TurtleEgg(4, 2).ID: return 9509;
			case TwistingVines::TwistingVines(0).ID: return 15017;
			case TwistingVines::TwistingVines(1).ID: return 15018;
			case TwistingVines::TwistingVines(2).ID: return 15019;
			case TwistingVines::TwistingVines(3).ID: return 15020;
			case TwistingVines::TwistingVines(4).ID: return 15021;
			case TwistingVines::TwistingVines(5).ID: return 15022;
			case TwistingVines::TwistingVines(6).ID: return 15023;
			case TwistingVines::TwistingVines(7).ID: return 15024;
			case TwistingVines::TwistingVines(8).ID: return 15025;
			case TwistingVines::TwistingVines(9).ID: return 15026;
			case TwistingVines::TwistingVines(10).ID: return 15027;
			case TwistingVines::TwistingVines(11).ID: return 15028;
			case TwistingVines::TwistingVines(12).ID: return 15029;
			case TwistingVines::TwistingVines(13).ID: return 15030;
			case TwistingVines::TwistingVines(14).ID: return 15031;
			case TwistingVines::TwistingVines(15).ID: return 15032;
			case TwistingVines::TwistingVines(16).ID: return 15033;
			case TwistingVines::TwistingVines(17).ID: return 15034;
			case TwistingVines::TwistingVines(18).ID: return 15035;
			case TwistingVines::TwistingVines(19).ID: return 15036;
			case TwistingVines::TwistingVines(20).ID: return 15037;
			case TwistingVines::TwistingVines(21).ID: return 15038;
			case TwistingVines::TwistingVines(22).ID: return 15039;
			case TwistingVines::TwistingVines(23).ID: return 15040;
			case TwistingVines::TwistingVines(24).ID: return 15041;
			case TwistingVines::TwistingVines(25).ID: return 15042;
			case TwistingVinesPlant::TwistingVinesPlant().ID: return 15043;
			case Vine::Vine(true, true, true, true, true).ID: return 4788;
			case Vine::Vine(true, true, true, true, false).ID: return 4789;
			case Vine::Vine(true, true, true, false, true).ID: return 4790;
			case Vine::Vine(true, true, true, false, false).ID: return 4791;
			case Vine::Vine(true, true, false, true, true).ID: return 4792;
			case Vine::Vine(true, true, false, true, false).ID: return 4793;
			case Vine::Vine(true, true, false, false, true).ID: return 4794;
			case Vine::Vine(true, true, false, false, false).ID: return 4795;
			case Vine::Vine(true, false, true, true, true).ID: return 4796;
			case Vine::Vine(true, false, true, true, false).ID: return 4797;
			case Vine::Vine(true, false, true, false, true).ID: return 4798;
			case Vine::Vine(true, false, true, false, false).ID: return 4799;
			case Vine::Vine(true, false, false, true, true).ID: return 4800;
			case Vine::Vine(true, false, false, true, false).ID: return 4801;
			case Vine::Vine(true, false, false, false, true).ID: return 4802;
			case Vine::Vine(true, false, false, false, false).ID: return 4803;
			case Vine::Vine(false, true, true, true, true).ID: return 4804;
			case Vine::Vine(false, true, true, true, false).ID: return 4805;
			case Vine::Vine(false, true, true, false, true).ID: return 4806;
			case Vine::Vine(false, true, true, false, false).ID: return 4807;
			case Vine::Vine(false, true, false, true, true).ID: return 4808;
			case Vine::Vine(false, true, false, true, false).ID: return 4809;
			case Vine::Vine(false, true, false, false, true).ID: return 4810;
			case Vine::Vine(false, true, false, false, false).ID: return 4811;
			case Vine::Vine(false, false, true, true, true).ID: return 4812;
			case Vine::Vine(false, false, true, true, false).ID: return 4813;
			case Vine::Vine(false, false, true, false, true).ID: return 4814;
			case Vine::Vine(false, false, true, false, false).ID: return 4815;
			case Vine::Vine(false, false, false, true, true).ID: return 4816;
			case Vine::Vine(false, false, false, true, false).ID: return 4817;
			case Vine::Vine(false, false, false, false, true).ID: return 4818;
			case Vine::Vine(false, false, false, false, false).ID: return 4819;
			case VoidAir::VoidAir().ID: return 9665;
			case WallTorch::WallTorch(eBlockFace::BLOCK_FACE_ZM).ID: return 1436;
			case WallTorch::WallTorch(eBlockFace::BLOCK_FACE_ZP).ID: return 1437;
			case WallTorch::WallTorch(eBlockFace::BLOCK_FACE_XM).ID: return 1438;
			case WallTorch::WallTorch(eBlockFace::BLOCK_FACE_XP).ID: return 1439;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, true).ID: return 15503;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_ZM, false).ID: return 15504;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, true).ID: return 15505;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_ZP, false).ID: return 15506;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, true).ID: return 15507;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_XM, false).ID: return 15508;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, true).ID: return 15509;
			case WarpedButton::WarpedButton(WarpedButton::Face::Floor, eBlockFace::BLOCK_FACE_XP, false).ID: return 15510;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, true).ID: return 15511;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_ZM, false).ID: return 15512;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, true).ID: return 15513;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_ZP, false).ID: return 15514;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, true).ID: return 15515;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_XM, false).ID: return 15516;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, true).ID: return 15517;
			case WarpedButton::WarpedButton(WarpedButton::Face::Wall, eBlockFace::BLOCK_FACE_XP, false).ID: return 15518;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, true).ID: return 15519;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZM, false).ID: return 15520;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, true).ID: return 15521;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_ZP, false).ID: return 15522;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, true).ID: return 15523;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XM, false).ID: return 15524;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, true).ID: return 15525;
			case WarpedButton::WarpedButton(WarpedButton::Face::Ceiling, eBlockFace::BLOCK_FACE_XP, false).ID: return 15526;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, true).ID: return 15591;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, false).ID: return 15592;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, true).ID: return 15593;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, false).ID: return 15594;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, true).ID: return 15595;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, false).ID: return 15596;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, true).ID: return 15597;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, false).ID: return 15598;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, true).ID: return 15599;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, false).ID: return 15600;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, true).ID: return 15601;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, false).ID: return 15602;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, true).ID: return 15603;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, false).ID: return 15604;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, true).ID: return 15605;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, false).ID: return 15606;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, true).ID: return 15607;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, false).ID: return 15608;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, true).ID: return 15609;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, false).ID: return 15610;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, true).ID: return 15611;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, false).ID: return 15612;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, true).ID: return 15613;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, false).ID: return 15614;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, true).ID: return 15615;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, false).ID: return 15616;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, true).ID: return 15617;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, false).ID: return 15618;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, true).ID: return 15619;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, false).ID: return 15620;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, true).ID: return 15621;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_ZP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, false).ID: return 15622;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, true).ID: return 15623;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, false).ID: return 15624;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, true).ID: return 15625;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, false).ID: return 15626;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, true).ID: return 15627;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, false).ID: return 15628;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, true).ID: return 15629;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, false).ID: return 15630;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, true).ID: return 15631;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, false).ID: return 15632;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, true).ID: return 15633;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, false).ID: return 15634;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, true).ID: return 15635;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, false).ID: return 15636;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, true).ID: return 15637;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XM, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, false).ID: return 15638;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, true).ID: return 15639;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, true, false).ID: return 15640;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, true).ID: return 15641;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Left, false, false).ID: return 15642;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, true).ID: return 15643;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, true, false).ID: return 15644;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, true).ID: return 15645;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Upper, WarpedDoor::Hinge::Right, false, false).ID: return 15646;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, true).ID: return 15647;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, true, false).ID: return 15648;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, true).ID: return 15649;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Left, false, false).ID: return 15650;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, true).ID: return 15651;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, true, false).ID: return 15652;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, true).ID: return 15653;
			case WarpedDoor::WarpedDoor(eBlockFace::BLOCK_FACE_XP, WarpedDoor::Half::Lower, WarpedDoor::Hinge::Right, false, false).ID: return 15654;
			case WarpedFence::WarpedFence(true, true, true, true).ID: return 15097;
			case WarpedFence::WarpedFence(true, true, true, false).ID: return 15098;
			case WarpedFence::WarpedFence(true, true, false, true).ID: return 15101;
			case WarpedFence::WarpedFence(true, true, false, false).ID: return 15102;
			case WarpedFence::WarpedFence(true, false, true, true).ID: return 15105;
			case WarpedFence::WarpedFence(true, false, true, false).ID: return 15106;
			case WarpedFence::WarpedFence(true, false, false, true).ID: return 15109;
			case WarpedFence::WarpedFence(true, false, false, false).ID: return 15110;
			case WarpedFence::WarpedFence(false, true, true, true).ID: return 15113;
			case WarpedFence::WarpedFence(false, true, true, false).ID: return 15114;
			case WarpedFence::WarpedFence(false, true, false, true).ID: return 15117;
			case WarpedFence::WarpedFence(false, true, false, false).ID: return 15118;
			case WarpedFence::WarpedFence(false, false, true, true).ID: return 15121;
			case WarpedFence::WarpedFence(false, false, true, false).ID: return 15122;
			case WarpedFence::WarpedFence(false, false, false, true).ID: return 15125;
			case WarpedFence::WarpedFence(false, false, false, false).ID: return 15126;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, true).ID: return 15287;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, true, true, false).ID: return 15288;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, true).ID: return 15289;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, true, false, false).ID: return 15290;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, true).ID: return 15291;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, false, true, false).ID: return 15292;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, true).ID: return 15293;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZM, false, false, false).ID: return 15294;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, true).ID: return 15295;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, true, true, false).ID: return 15296;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, true).ID: return 15297;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, true, false, false).ID: return 15298;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, true).ID: return 15299;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, false, true, false).ID: return 15300;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, true).ID: return 15301;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_ZP, false, false, false).ID: return 15302;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, true).ID: return 15303;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, true, true, false).ID: return 15304;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, true).ID: return 15305;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, true, false, false).ID: return 15306;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, true).ID: return 15307;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, false, true, false).ID: return 15308;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, true).ID: return 15309;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XM, false, false, false).ID: return 15310;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, true).ID: return 15311;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, true, true, false).ID: return 15312;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, true).ID: return 15313;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, true, false, false).ID: return 15314;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, true).ID: return 15315;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, false, true, false).ID: return 15316;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, true).ID: return 15317;
			case WarpedFenceGate::WarpedFenceGate(eBlockFace::BLOCK_FACE_XP, false, false, false).ID: return 15318;
			case WarpedFungus::WarpedFungus().ID: return 14971;
			case WarpedHyphae::WarpedHyphae(WarpedHyphae::Axis::X).ID: return 14964;
			case WarpedHyphae::WarpedHyphae(WarpedHyphae::Axis::Y).ID: return 14965;
			case WarpedHyphae::WarpedHyphae(WarpedHyphae::Axis::Z).ID: return 14966;
			case WarpedNylium::WarpedNylium().ID: return 14970;
			case WarpedPlanks::WarpedPlanks().ID: return 15046;
			case WarpedPressurePlate::WarpedPressurePlate(true).ID: return 15061;
			case WarpedPressurePlate::WarpedPressurePlate(false).ID: return 15062;
			case WarpedRoots::WarpedRoots().ID: return 14973;
			case WarpedSign::WarpedSign(0).ID: return 15688;
			case WarpedSign::WarpedSign(1).ID: return 15690;
			case WarpedSign::WarpedSign(2).ID: return 15692;
			case WarpedSign::WarpedSign(3).ID: return 15694;
			case WarpedSign::WarpedSign(4).ID: return 15696;
			case WarpedSign::WarpedSign(5).ID: return 15698;
			case WarpedSign::WarpedSign(6).ID: return 15700;
			case WarpedSign::WarpedSign(7).ID: return 15702;
			case WarpedSign::WarpedSign(8).ID: return 15704;
			case WarpedSign::WarpedSign(9).ID: return 15706;
			case WarpedSign::WarpedSign(10).ID: return 15708;
			case WarpedSign::WarpedSign(11).ID: return 15710;
			case WarpedSign::WarpedSign(12).ID: return 15712;
			case WarpedSign::WarpedSign(13).ID: return 15714;
			case WarpedSign::WarpedSign(14).ID: return 15716;
			case WarpedSign::WarpedSign(15).ID: return 15718;
			case WarpedSlab::WarpedSlab(WarpedSlab::Type::Top).ID: return 15054;
			case WarpedSlab::WarpedSlab(WarpedSlab::Type::Bottom).ID: return 15056;
			case WarpedSlab::WarpedSlab(WarpedSlab::Type::Double).ID: return 15058;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Top, WarpedStairs::Shape::Straight).ID: return 15400;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerLeft).ID: return 15402;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerRight).ID: return 15404;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterLeft).ID: return 15406;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterRight).ID: return 15408;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::Straight).ID: return 15410;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerLeft).ID: return 15412;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerRight).ID: return 15414;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterLeft).ID: return 15416;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterRight).ID: return 15418;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Top, WarpedStairs::Shape::Straight).ID: return 15420;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerLeft).ID: return 15422;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerRight).ID: return 15424;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterLeft).ID: return 15426;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterRight).ID: return 15428;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::Straight).ID: return 15430;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerLeft).ID: return 15432;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerRight).ID: return 15434;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterLeft).ID: return 15436;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_ZP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterRight).ID: return 15438;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Top, WarpedStairs::Shape::Straight).ID: return 15440;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerLeft).ID: return 15442;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerRight).ID: return 15444;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterLeft).ID: return 15446;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterRight).ID: return 15448;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::Straight).ID: return 15450;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerLeft).ID: return 15452;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerRight).ID: return 15454;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterLeft).ID: return 15456;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XM, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterRight).ID: return 15458;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Top, WarpedStairs::Shape::Straight).ID: return 15460;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerLeft).ID: return 15462;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Top, WarpedStairs::Shape::InnerRight).ID: return 15464;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterLeft).ID: return 15466;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Top, WarpedStairs::Shape::OuterRight).ID: return 15468;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::Straight).ID: return 15470;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerLeft).ID: return 15472;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::InnerRight).ID: return 15474;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterLeft).ID: return 15476;
			case WarpedStairs::WarpedStairs(eBlockFace::BLOCK_FACE_XP, WarpedStairs::Half::Bottom, WarpedStairs::Shape::OuterRight).ID: return 15478;
			case WarpedStem::WarpedStem(WarpedStem::Axis::X).ID: return 14958;
			case WarpedStem::WarpedStem(WarpedStem::Axis::Y).ID: return 14959;
			case WarpedStem::WarpedStem(WarpedStem::Axis::Z).ID: return 14960;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Top, true, true).ID: return 15192;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Top, true, false).ID: return 15194;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Top, false, true).ID: return 15196;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Top, false, false).ID: return 15198;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Bottom, true, true).ID: return 15200;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Bottom, true, false).ID: return 15202;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Bottom, false, true).ID: return 15204;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZM, WarpedTrapdoor::Half::Bottom, false, false).ID: return 15206;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Top, true, true).ID: return 15208;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Top, true, false).ID: return 15210;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Top, false, true).ID: return 15212;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Top, false, false).ID: return 15214;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Bottom, true, true).ID: return 15216;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Bottom, true, false).ID: return 15218;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Bottom, false, true).ID: return 15220;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_ZP, WarpedTrapdoor::Half::Bottom, false, false).ID: return 15222;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Top, true, true).ID: return 15224;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Top, true, false).ID: return 15226;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Top, false, true).ID: return 15228;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Top, false, false).ID: return 15230;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Bottom, true, true).ID: return 15232;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Bottom, true, false).ID: return 15234;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Bottom, false, true).ID: return 15236;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XM, WarpedTrapdoor::Half::Bottom, false, false).ID: return 15238;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Top, true, true).ID: return 15240;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Top, true, false).ID: return 15242;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Top, false, true).ID: return 15244;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Top, false, false).ID: return 15246;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Bottom, true, true).ID: return 15248;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Bottom, true, false).ID: return 15250;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Bottom, false, true).ID: return 15252;
			case WarpedTrapdoor::WarpedTrapdoor(eBlockFace::BLOCK_FACE_XP, WarpedTrapdoor::Half::Bottom, false, false).ID: return 15254;
			case WarpedWallSign::WarpedWallSign(eBlockFace::BLOCK_FACE_ZM).ID: return 15728;
			case WarpedWallSign::WarpedWallSign(eBlockFace::BLOCK_FACE_ZP).ID: return 15730;
			case WarpedWallSign::WarpedWallSign(eBlockFace::BLOCK_FACE_XM).ID: return 15732;
			case WarpedWallSign::WarpedWallSign(eBlockFace::BLOCK_FACE_XP).ID: return 15734;
			case WarpedWartBlock::WarpedWartBlock().ID: return 14972;
			case Water::Water(0).ID: return 34;
			case Water::Water(1).ID: return 35;
			case Water::Water(2).ID: return 36;
			case Water::Water(3).ID: return 37;
			case Water::Water(4).ID: return 38;
			case Water::Water(5).ID: return 39;
			case Water::Water(6).ID: return 40;
			case Water::Water(7).ID: return 41;
			case Water::Water(8).ID: return 42;
			case Water::Water(9).ID: return 43;
			case Water::Water(10).ID: return 44;
			case Water::Water(11).ID: return 45;
			case Water::Water(12).ID: return 46;
			case Water::Water(13).ID: return 47;
			case Water::Water(14).ID: return 48;
			case Water::Water(15).ID: return 49;
			case WeepingVines::WeepingVines(0).ID: return 14990;
			case WeepingVines::WeepingVines(1).ID: return 14991;
			case WeepingVines::WeepingVines(2).ID: return 14992;
			case WeepingVines::WeepingVines(3).ID: return 14993;
			case WeepingVines::WeepingVines(4).ID: return 14994;
			case WeepingVines::WeepingVines(5).ID: return 14995;
			case WeepingVines::WeepingVines(6).ID: return 14996;
			case WeepingVines::WeepingVines(7).ID: return 14997;
			case WeepingVines::WeepingVines(8).ID: return 14998;
			case WeepingVines::WeepingVines(9).ID: return 14999;
			case WeepingVines::WeepingVines(10).ID: return 15000;
			case WeepingVines::WeepingVines(11).ID: return 15001;
			case WeepingVines::WeepingVines(12).ID: return 15002;
			case WeepingVines::WeepingVines(13).ID: return 15003;
			case WeepingVines::WeepingVines(14).ID: return 15004;
			case WeepingVines::WeepingVines(15).ID: return 15005;
			case WeepingVines::WeepingVines(16).ID: return 15006;
			case WeepingVines::WeepingVines(17).ID: return 15007;
			case WeepingVines::WeepingVines(18).ID: return 15008;
			case WeepingVines::WeepingVines(19).ID: return 15009;
			case WeepingVines::WeepingVines(20).ID: return 15010;
			case WeepingVines::WeepingVines(21).ID: return 15011;
			case WeepingVines::WeepingVines(22).ID: return 15012;
			case WeepingVines::WeepingVines(23).ID: return 15013;
			case WeepingVines::WeepingVines(24).ID: return 15014;
			case WeepingVines::WeepingVines(25).ID: return 15015;
			case WeepingVinesPlant::WeepingVinesPlant().ID: return 15016;
			case WetSponge::WetSponge().ID: return 230;
			case Wheat::Wheat(0).ID: return 3357;
			case Wheat::Wheat(1).ID: return 3358;
			case Wheat::Wheat(2).ID: return 3359;
			case Wheat::Wheat(3).ID: return 3360;
			case Wheat::Wheat(4).ID: return 3361;
			case Wheat::Wheat(5).ID: return 3362;
			case Wheat::Wheat(6).ID: return 3363;
			case Wheat::Wheat(7).ID: return 3364;
			case WhiteBanner::WhiteBanner(0).ID: return 7897;
			case WhiteBanner::WhiteBanner(1).ID: return 7898;
			case WhiteBanner::WhiteBanner(2).ID: return 7899;
			case WhiteBanner::WhiteBanner(3).ID: return 7900;
			case WhiteBanner::WhiteBanner(4).ID: return 7901;
			case WhiteBanner::WhiteBanner(5).ID: return 7902;
			case WhiteBanner::WhiteBanner(6).ID: return 7903;
			case WhiteBanner::WhiteBanner(7).ID: return 7904;
			case WhiteBanner::WhiteBanner(8).ID: return 7905;
			case WhiteBanner::WhiteBanner(9).ID: return 7906;
			case WhiteBanner::WhiteBanner(10).ID: return 7907;
			case WhiteBanner::WhiteBanner(11).ID: return 7908;
			case WhiteBanner::WhiteBanner(12).ID: return 7909;
			case WhiteBanner::WhiteBanner(13).ID: return 7910;
			case WhiteBanner::WhiteBanner(14).ID: return 7911;
			case WhiteBanner::WhiteBanner(15).ID: return 7912;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZM, true, WhiteBed::Part::Head).ID: return 1049;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZM, true, WhiteBed::Part::Foot).ID: return 1050;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZM, false, WhiteBed::Part::Head).ID: return 1051;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZM, false, WhiteBed::Part::Foot).ID: return 1052;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZP, true, WhiteBed::Part::Head).ID: return 1053;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZP, true, WhiteBed::Part::Foot).ID: return 1054;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZP, false, WhiteBed::Part::Head).ID: return 1055;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_ZP, false, WhiteBed::Part::Foot).ID: return 1056;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XM, true, WhiteBed::Part::Head).ID: return 1057;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XM, true, WhiteBed::Part::Foot).ID: return 1058;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XM, false, WhiteBed::Part::Head).ID: return 1059;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XM, false, WhiteBed::Part::Foot).ID: return 1060;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XP, true, WhiteBed::Part::Head).ID: return 1061;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XP, true, WhiteBed::Part::Foot).ID: return 1062;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XP, false, WhiteBed::Part::Head).ID: return 1063;
			case WhiteBed::WhiteBed(eBlockFace::BLOCK_FACE_XP, false, WhiteBed::Part::Foot).ID: return 1064;
			case WhiteCarpet::WhiteCarpet().ID: return 7866;
			case WhiteConcrete::WhiteConcrete().ID: return 9438;
			case WhiteConcretePowder::WhiteConcretePowder().ID: return 9454;
			case WhiteGlazedTerracotta::WhiteGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9374;
			case WhiteGlazedTerracotta::WhiteGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9375;
			case WhiteGlazedTerracotta::WhiteGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9376;
			case WhiteGlazedTerracotta::WhiteGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9377;
			case WhiteShulkerBox::WhiteShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9278;
			case WhiteShulkerBox::WhiteShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9279;
			case WhiteShulkerBox::WhiteShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9280;
			case WhiteShulkerBox::WhiteShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9281;
			case WhiteShulkerBox::WhiteShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9282;
			case WhiteShulkerBox::WhiteShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9283;
			case WhiteStainedGlass::WhiteStainedGlass().ID: return 4095;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, true, true, true).ID: return 6865;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, true, true, false).ID: return 6866;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, true, false, true).ID: return 6869;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, true, false, false).ID: return 6870;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, false, true, true).ID: return 6873;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, false, true, false).ID: return 6874;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, false, false, true).ID: return 6877;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(true, false, false, false).ID: return 6878;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, true, true, true).ID: return 6881;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, true, true, false).ID: return 6882;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, true, false, true).ID: return 6885;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, true, false, false).ID: return 6886;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, false, true, true).ID: return 6889;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, false, true, false).ID: return 6890;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, false, false, true).ID: return 6893;
			case WhiteStainedGlassPane::WhiteStainedGlassPane(false, false, false, false).ID: return 6894;
			case WhiteTerracotta::WhiteTerracotta().ID: return 6847;
			case WhiteTulip::WhiteTulip().ID: return 1419;
			case WhiteWallBanner::WhiteWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8153;
			case WhiteWallBanner::WhiteWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8154;
			case WhiteWallBanner::WhiteWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8155;
			case WhiteWallBanner::WhiteWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8156;
			case WhiteWool::WhiteWool().ID: return 1384;
			case WitherRose::WitherRose().ID: return 1423;
			case WitherSkeletonSkull::WitherSkeletonSkull(0).ID: return 6510;
			case WitherSkeletonSkull::WitherSkeletonSkull(1).ID: return 6511;
			case WitherSkeletonSkull::WitherSkeletonSkull(2).ID: return 6512;
			case WitherSkeletonSkull::WitherSkeletonSkull(3).ID: return 6513;
			case WitherSkeletonSkull::WitherSkeletonSkull(4).ID: return 6514;
			case WitherSkeletonSkull::WitherSkeletonSkull(5).ID: return 6515;
			case WitherSkeletonSkull::WitherSkeletonSkull(6).ID: return 6516;
			case WitherSkeletonSkull::WitherSkeletonSkull(7).ID: return 6517;
			case WitherSkeletonSkull::WitherSkeletonSkull(8).ID: return 6518;
			case WitherSkeletonSkull::WitherSkeletonSkull(9).ID: return 6519;
			case WitherSkeletonSkull::WitherSkeletonSkull(10).ID: return 6520;
			case WitherSkeletonSkull::WitherSkeletonSkull(11).ID: return 6521;
			case WitherSkeletonSkull::WitherSkeletonSkull(12).ID: return 6522;
			case WitherSkeletonSkull::WitherSkeletonSkull(13).ID: return 6523;
			case WitherSkeletonSkull::WitherSkeletonSkull(14).ID: return 6524;
			case WitherSkeletonSkull::WitherSkeletonSkull(15).ID: return 6525;
			case WitherSkeletonWallSkull::WitherSkeletonWallSkull(eBlockFace::BLOCK_FACE_ZM).ID: return 6526;
			case WitherSkeletonWallSkull::WitherSkeletonWallSkull(eBlockFace::BLOCK_FACE_ZP).ID: return 6527;
			case WitherSkeletonWallSkull::WitherSkeletonWallSkull(eBlockFace::BLOCK_FACE_XM).ID: return 6528;
			case WitherSkeletonWallSkull::WitherSkeletonWallSkull(eBlockFace::BLOCK_FACE_XP).ID: return 6529;
			case YellowBanner::YellowBanner(0).ID: return 7961;
			case YellowBanner::YellowBanner(1).ID: return 7962;
			case YellowBanner::YellowBanner(2).ID: return 7963;
			case YellowBanner::YellowBanner(3).ID: return 7964;
			case YellowBanner::YellowBanner(4).ID: return 7965;
			case YellowBanner::YellowBanner(5).ID: return 7966;
			case YellowBanner::YellowBanner(6).ID: return 7967;
			case YellowBanner::YellowBanner(7).ID: return 7968;
			case YellowBanner::YellowBanner(8).ID: return 7969;
			case YellowBanner::YellowBanner(9).ID: return 7970;
			case YellowBanner::YellowBanner(10).ID: return 7971;
			case YellowBanner::YellowBanner(11).ID: return 7972;
			case YellowBanner::YellowBanner(12).ID: return 7973;
			case YellowBanner::YellowBanner(13).ID: return 7974;
			case YellowBanner::YellowBanner(14).ID: return 7975;
			case YellowBanner::YellowBanner(15).ID: return 7976;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZM, true, YellowBed::Part::Head).ID: return 1113;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZM, true, YellowBed::Part::Foot).ID: return 1114;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZM, false, YellowBed::Part::Head).ID: return 1115;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZM, false, YellowBed::Part::Foot).ID: return 1116;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZP, true, YellowBed::Part::Head).ID: return 1117;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZP, true, YellowBed::Part::Foot).ID: return 1118;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZP, false, YellowBed::Part::Head).ID: return 1119;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_ZP, false, YellowBed::Part::Foot).ID: return 1120;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XM, true, YellowBed::Part::Head).ID: return 1121;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XM, true, YellowBed::Part::Foot).ID: return 1122;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XM, false, YellowBed::Part::Head).ID: return 1123;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XM, false, YellowBed::Part::Foot).ID: return 1124;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XP, true, YellowBed::Part::Head).ID: return 1125;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XP, true, YellowBed::Part::Foot).ID: return 1126;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XP, false, YellowBed::Part::Head).ID: return 1127;
			case YellowBed::YellowBed(eBlockFace::BLOCK_FACE_XP, false, YellowBed::Part::Foot).ID: return 1128;
			case YellowCarpet::YellowCarpet().ID: return 7870;
			case YellowConcrete::YellowConcrete().ID: return 9442;
			case YellowConcretePowder::YellowConcretePowder().ID: return 9458;
			case YellowGlazedTerracotta::YellowGlazedTerracotta(eBlockFace::BLOCK_FACE_ZM).ID: return 9390;
			case YellowGlazedTerracotta::YellowGlazedTerracotta(eBlockFace::BLOCK_FACE_ZP).ID: return 9391;
			case YellowGlazedTerracotta::YellowGlazedTerracotta(eBlockFace::BLOCK_FACE_XM).ID: return 9392;
			case YellowGlazedTerracotta::YellowGlazedTerracotta(eBlockFace::BLOCK_FACE_XP).ID: return 9393;
			case YellowShulkerBox::YellowShulkerBox(eBlockFace::BLOCK_FACE_ZM).ID: return 9302;
			case YellowShulkerBox::YellowShulkerBox(eBlockFace::BLOCK_FACE_XP).ID: return 9303;
			case YellowShulkerBox::YellowShulkerBox(eBlockFace::BLOCK_FACE_ZP).ID: return 9304;
			case YellowShulkerBox::YellowShulkerBox(eBlockFace::BLOCK_FACE_XM).ID: return 9305;
			case YellowShulkerBox::YellowShulkerBox(eBlockFace::BLOCK_FACE_YP).ID: return 9306;
			case YellowShulkerBox::YellowShulkerBox(eBlockFace::BLOCK_FACE_YM).ID: return 9307;
			case YellowStainedGlass::YellowStainedGlass().ID: return 4099;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, true, true, true).ID: return 6993;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, true, true, false).ID: return 6994;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, true, false, true).ID: return 6997;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, true, false, false).ID: return 6998;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, false, true, true).ID: return 7001;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, false, true, false).ID: return 7002;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, false, false, true).ID: return 7005;
			case YellowStainedGlassPane::YellowStainedGlassPane(true, false, false, false).ID: return 7006;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, true, true, true).ID: return 7009;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, true, true, false).ID: return 7010;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, true, false, true).ID: return 7013;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, true, false, false).ID: return 7014;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, false, true, true).ID: return 7017;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, false, true, false).ID: return 7018;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, false, false, true).ID: return 7021;
			case YellowStainedGlassPane::YellowStainedGlassPane(false, false, false, false).ID: return 7022;
			case YellowTerracotta::YellowTerracotta().ID: return 6851;
			case YellowWallBanner::YellowWallBanner(eBlockFace::BLOCK_FACE_ZM).ID: return 8169;
			case YellowWallBanner::YellowWallBanner(eBlockFace::BLOCK_FACE_ZP).ID: return 8170;
			case YellowWallBanner::YellowWallBanner(eBlockFace::BLOCK_FACE_XM).ID: return 8171;
			case YellowWallBanner::YellowWallBanner(eBlockFace::BLOCK_FACE_XP).ID: return 8172;
			case YellowWool::YellowWool().ID: return 1388;
			case ZombieHead::ZombieHead(0).ID: return 6530;
			case ZombieHead::ZombieHead(1).ID: return 6531;
			case ZombieHead::ZombieHead(2).ID: return 6532;
			case ZombieHead::ZombieHead(3).ID: return 6533;
			case ZombieHead::ZombieHead(4).ID: return 6534;
			case ZombieHead::ZombieHead(5).ID: return 6535;
			case ZombieHead::ZombieHead(6).ID: return 6536;
			case ZombieHead::ZombieHead(7).ID: return 6537;
			case ZombieHead::ZombieHead(8).ID: return 6538;
			case ZombieHead::ZombieHead(9).ID: return 6539;
			case ZombieHead::ZombieHead(10).ID: return 6540;
			case ZombieHead::ZombieHead(11).ID: return 6541;
			case ZombieHead::ZombieHead(12).ID: return 6542;
			case ZombieHead::ZombieHead(13).ID: return 6543;
			case ZombieHead::ZombieHead(14).ID: return 6544;
			case ZombieHead::ZombieHead(15).ID: return 6545;
			case ZombieWallHead::ZombieWallHead(eBlockFace::BLOCK_FACE_ZM).ID: return 6546;
			case ZombieWallHead::ZombieWallHead(eBlockFace::BLOCK_FACE_ZP).ID: return 6547;
			case ZombieWallHead::ZombieWallHead(eBlockFace::BLOCK_FACE_XM).ID: return 6548;
			case ZombieWallHead::ZombieWallHead(eBlockFace::BLOCK_FACE_XP).ID: return 6549;
			default: return 0;
		}
	}

	UInt32 From(const Item ID)
	{
		switch (ID)
		{
			case Item::AcaciaBoat: return 901;
			case Item::AcaciaButton: return 309;
			case Item::AcaciaDoor: return 562;
			case Item::AcaciaFence: return 212;
			case Item::AcaciaFenceGate: return 256;
			case Item::AcaciaLeaves: return 73;
			case Item::AcaciaLog: return 41;
			case Item::AcaciaPlanks: return 19;
			case Item::AcaciaPressurePlate: return 195;
			case Item::AcaciaSapling: return 27;
			case Item::AcaciaSign: return 656;
			case Item::AcaciaSlab: return 142;
			case Item::AcaciaStairs: return 369;
			case Item::AcaciaTrapdoor: return 230;
			case Item::AcaciaWood: return 65;
			case Item::ActivatorRail: return 329;
			case Item::Air: return -0;
			case Item::Allium: return 114;
			case Item::AncientDebris: return 959;
			case Item::Andesite: return 6;
			case Item::AndesiteSlab: return 552;
			case Item::AndesiteStairs: return 539;
			case Item::AndesiteWall: return 296;
			case Item::Anvil: return 314;
			case Item::Apple: return 576;
			case Item::ArmorStand: return 859;
			case Item::Arrow: return 578;
			case Item::AzureBluet: return 115;
			case Item::BakedPotato: return 831;
			case Item::Bamboo: return 135;
			case Item::Barrel: return 935;
			case Item::Barrier: return 347;
			case Item::Basalt: return 221;
			case Item::BatSpawnEgg: return 759;
			case Item::Beacon: return 286;
			case Item::Bedrock: return 29;
			case Item::BeeNest: return 952;
			case Item::BeeSpawnEgg: return 760;
			case Item::Beef: return 739;
			case Item::Beehive: return 953;
			case Item::Beetroot: return 888;
			case Item::BeetrootSeeds: return 889;
			case Item::BeetrootSoup: return 890;
			case Item::Bell: return 944;
			case Item::BirchBoat: return 899;
			case Item::BirchButton: return 307;
			case Item::BirchDoor: return 560;
			case Item::BirchFence: return 210;
			case Item::BirchFenceGate: return 254;
			case Item::BirchLeaves: return 71;
			case Item::BirchLog: return 39;
			case Item::BirchPlanks: return 17;
			case Item::BirchPressurePlate: return 193;
			case Item::BirchSapling: return 25;
			case Item::BirchSign: return 654;
			case Item::BirchSlab: return 140;
			case Item::BirchStairs: return 281;
			case Item::BirchTrapdoor: return 228;
			case Item::BirchWood: return 63;
			case Item::BlackBanner: return 884;
			case Item::BlackBed: return 731;
			case Item::BlackCarpet: return 365;
			case Item::BlackConcrete: return 479;
			case Item::BlackConcretePowder: return 495;
			case Item::BlackDye: return 711;
			case Item::BlackGlazedTerracotta: return 463;
			case Item::BlackShulkerBox: return 447;
			case Item::BlackStainedGlass: return 394;
			case Item::BlackStainedGlassPane: return 410;
			case Item::BlackTerracotta: return 346;
			case Item::BlackWool: return 110;
			case Item::Blackstone: return 962;
			case Item::BlackstoneSlab: return 963;
			case Item::BlackstoneStairs: return 964;
			case Item::BlackstoneWall: return 301;
			case Item::BlastFurnace: return 937;
			case Item::BlazePowder: return 753;
			case Item::BlazeRod: return 745;
			case Item::BlazeSpawnEgg: return 761;
			case Item::BlueBanner: return 880;
			case Item::BlueBed: return 727;
			case Item::BlueCarpet: return 361;
			case Item::BlueConcrete: return 475;
			case Item::BlueConcretePowder: return 491;
			case Item::BlueDye: return 709;
			case Item::BlueGlazedTerracotta: return 459;
			case Item::BlueIce: return 527;
			case Item::BlueOrchid: return 113;
			case Item::BlueShulkerBox: return 443;
			case Item::BlueStainedGlass: return 390;
			case Item::BlueStainedGlassPane: return 406;
			case Item::BlueTerracotta: return 342;
			case Item::BlueWool: return 106;
			case Item::Bone: return 713;
			case Item::BoneBlock: return 428;
			case Item::BoneMeal: return 708;
			case Item::Book: return 678;
			case Item::Bookshelf: return 168;
			case Item::Bow: return 577;
			case Item::Bowl: return 600;
			case Item::BrainCoral: return 508;
			case Item::BrainCoralBlock: return 503;
			case Item::BrainCoralFan: return 518;
			case Item::Bread: return 621;
			case Item::BrewingStand: return 755;
			case Item::Brick: return 674;
			case Item::BrickSlab: return 152;
			case Item::BrickStairs: return 260;
			case Item::BrickWall: return 289;
			case Item::Bricks: return 166;
			case Item::BrownBanner: return 881;
			case Item::BrownBed: return 728;
			case Item::BrownCarpet: return 362;
			case Item::BrownConcrete: return 476;
			case Item::BrownConcretePowder: return 492;
			case Item::BrownDye: return 710;
			case Item::BrownGlazedTerracotta: return 460;
			case Item::BrownMushroom: return 124;
			case Item::BrownMushroomBlock: return 244;
			case Item::BrownShulkerBox: return 444;
			case Item::BrownStainedGlass: return 391;
			case Item::BrownStainedGlassPane: return 407;
			case Item::BrownTerracotta: return 343;
			case Item::BrownWool: return 107;
			case Item::BubbleCoral: return 509;
			case Item::BubbleCoralBlock: return 504;
			case Item::BubbleCoralFan: return 519;
			case Item::Bucket: return 660;
			case Item::Cactus: return 205;
			case Item::Cake: return 715;
			case Item::Campfire: return 948;
			case Item::Carrot: return 829;
			case Item::CarrotOnAStick: return 841;
			case Item::CartographyTable: return 938;
			case Item::CarvedPumpkin: return 217;
			case Item::CatSpawnEgg: return 762;
			case Item::Cauldron: return 756;
			case Item::CaveSpiderSpawnEgg: return 763;
			case Item::Chain: return 248;
			case Item::ChainCommandBlock: return 423;
			case Item::ChainmailBoots: return 629;
			case Item::ChainmailChestplate: return 627;
			case Item::ChainmailHelmet: return 626;
			case Item::ChainmailLeggings: return 628;
			case Item::Charcoal: return 580;
			case Item::Chest: return 180;
			case Item::ChestMinecart: return 680;
			case Item::Chicken: return 741;
			case Item::ChickenSpawnEgg: return 764;
			case Item::ChippedAnvil: return 315;
			case Item::ChiseledNetherBricks: return 266;
			case Item::ChiseledPolishedBlackstone: return 969;
			case Item::ChiseledQuartzBlock: return 324;
			case Item::ChiseledRedSandstone: return 419;
			case Item::ChiseledSandstone: return 82;
			case Item::ChiseledStoneBricks: return 243;
			case Item::ChorusFlower: return 174;
			case Item::ChorusFruit: return 886;
			case Item::ChorusPlant: return 173;
			case Item::Clay: return 206;
			case Item::ClayBall: return 675;
			case Item::Clock: return 685;
			case Item::Coal: return 579;
			case Item::CoalBlock: return 367;
			case Item::CoalOre: return 35;
			case Item::CoarseDirt: return 10;
			case Item::Cobblestone: return 14;
			case Item::CobblestoneSlab: return 151;
			case Item::CobblestoneStairs: return 188;
			case Item::CobblestoneWall: return 287;
			case Item::Cobweb: return 88;
			case Item::CocoaBeans: return 696;
			case Item::Cod: return 687;
			case Item::CodBucket: return 672;
			case Item::CodSpawnEgg: return 765;
			case Item::CommandBlock: return 285;
			case Item::CommandBlockMinecart: return 866;
			case Item::Comparator: return 567;
			case Item::Compass: return 683;
			case Item::Composter: return 934;
			case Item::Conduit: return 528;
			case Item::CookedBeef: return 740;
			case Item::CookedChicken: return 742;
			case Item::CookedCod: return 691;
			case Item::CookedMutton: return 868;
			case Item::CookedPorkchop: return 648;
			case Item::CookedRabbit: return 855;
			case Item::CookedSalmon: return 692;
			case Item::Cookie: return 732;
			case Item::Cornflower: return 121;
			case Item::CowSpawnEgg: return 766;
			case Item::CrackedNetherBricks: return 265;
			case Item::CrackedPolishedBlackstoneBricks: return 973;
			case Item::CrackedStoneBricks: return 242;
			case Item::CraftingTable: return 183;
			case Item::CreeperBannerPattern: return 929;
			case Item::CreeperHead: return 839;
			case Item::CreeperSpawnEgg: return 767;
			case Item::CrimsonButton: return 311;
			case Item::CrimsonDoor: return 564;
			case Item::CrimsonFence: return 214;
			case Item::CrimsonFenceGate: return 258;
			case Item::CrimsonFungus: return 126;
			case Item::CrimsonHyphae: return 67;
			case Item::CrimsonNylium: return 12;
			case Item::CrimsonPlanks: return 21;
			case Item::CrimsonPressurePlate: return 197;
			case Item::CrimsonRoots: return 128;
			case Item::CrimsonSign: return 658;
			case Item::CrimsonSlab: return 144;
			case Item::CrimsonStairs: return 283;
			case Item::CrimsonStem: return 43;
			case Item::CrimsonTrapdoor: return 232;
			case Item::Crossbow: return 925;
			case Item::CryingObsidian: return 961;
			case Item::CutRedSandstone: return 420;
			case Item::CutRedSandstoneSlab: return 157;
			case Item::CutSandstone: return 83;
			case Item::CutSandstoneSlab: return 149;
			case Item::CyanBanner: return 878;
			case Item::CyanBed: return 725;
			case Item::CyanCarpet: return 359;
			case Item::CyanConcrete: return 473;
			case Item::CyanConcretePowder: return 489;
			case Item::CyanDye: return 699;
			case Item::CyanGlazedTerracotta: return 457;
			case Item::CyanShulkerBox: return 441;
			case Item::CyanStainedGlass: return 388;
			case Item::CyanStainedGlassPane: return 404;
			case Item::CyanTerracotta: return 340;
			case Item::CyanWool: return 104;
			case Item::DamagedAnvil: return 316;
			case Item::Dandelion: return 111;
			case Item::DarkOakBoat: return 902;
			case Item::DarkOakButton: return 310;
			case Item::DarkOakDoor: return 563;
			case Item::DarkOakFence: return 213;
			case Item::DarkOakFenceGate: return 257;
			case Item::DarkOakLeaves: return 74;
			case Item::DarkOakLog: return 42;
			case Item::DarkOakPlanks: return 20;
			case Item::DarkOakPressurePlate: return 196;
			case Item::DarkOakSapling: return 28;
			case Item::DarkOakSign: return 657;
			case Item::DarkOakSlab: return 143;
			case Item::DarkOakStairs: return 370;
			case Item::DarkOakTrapdoor: return 231;
			case Item::DarkOakWood: return 66;
			case Item::DarkPrismarine: return 413;
			case Item::DarkPrismarineSlab: return 161;
			case Item::DarkPrismarineStairs: return 416;
			case Item::DaylightDetector: return 320;
			case Item::DeadBrainCoral: return 512;
			case Item::DeadBrainCoralBlock: return 498;
			case Item::DeadBrainCoralFan: return 523;
			case Item::DeadBubbleCoral: return 513;
			case Item::DeadBubbleCoralBlock: return 499;
			case Item::DeadBubbleCoralFan: return 524;
			case Item::DeadBush: return 91;
			case Item::DeadFireCoral: return 514;
			case Item::DeadFireCoralBlock: return 500;
			case Item::DeadFireCoralFan: return 525;
			case Item::DeadHornCoral: return 515;
			case Item::DeadHornCoralBlock: return 501;
			case Item::DeadHornCoralFan: return 526;
			case Item::DeadTubeCoral: return 516;
			case Item::DeadTubeCoralBlock: return 497;
			case Item::DeadTubeCoralFan: return 522;
			case Item::DebugStick: return 907;
			case Item::DetectorRail: return 86;
			case Item::Diamond: return 581;
			case Item::DiamondAxe: return 598;
			case Item::DiamondBlock: return 182;
			case Item::DiamondBoots: return 637;
			case Item::DiamondChestplate: return 635;
			case Item::DiamondHelmet: return 634;
			case Item::DiamondHoe: return 616;
			case Item::DiamondHorseArmor: return 862;
			case Item::DiamondLeggings: return 636;
			case Item::DiamondOre: return 181;
			case Item::DiamondPickaxe: return 597;
			case Item::DiamondShovel: return 596;
			case Item::DiamondSword: return 595;
			case Item::Diorite: return 4;
			case Item::DioriteSlab: return 555;
			case Item::DioriteStairs: return 542;
			case Item::DioriteWall: return 300;
			case Item::Dirt: return 9;
			case Item::Dispenser: return 80;
			case Item::DolphinSpawnEgg: return 768;
			case Item::DonkeySpawnEgg: return 769;
			case Item::DragonBreath: return 891;
			case Item::DragonEgg: return 273;
			case Item::DragonHead: return 840;
			case Item::DriedKelp: return 736;
			case Item::DriedKelpBlock: return 676;
			case Item::Dropper: return 330;
			case Item::DrownedSpawnEgg: return 770;
			case Item::Egg: return 682;
			case Item::ElderGuardianSpawnEgg: return 771;
			case Item::Elytra: return 897;
			case Item::Emerald: return 826;
			case Item::EmeraldBlock: return 279;
			case Item::EmeraldOre: return 276;
			case Item::EnchantedBook: return 847;
			case Item::EnchantedGoldenApple: return 651;
			case Item::EnchantingTable: return 269;
			case Item::EndCrystal: return 885;
			case Item::EndPortalFrame: return 270;
			case Item::EndRod: return 172;
			case Item::EndStone: return 271;
			case Item::EndStoneBrickSlab: return 548;
			case Item::EndStoneBrickStairs: return 534;
			case Item::EndStoneBrickWall: return 299;
			case Item::EndStoneBricks: return 272;
			case Item::EnderChest: return 277;
			case Item::EnderEye: return 757;
			case Item::EnderPearl: return 744;
			case Item::EndermanSpawnEgg: return 772;
			case Item::EndermiteSpawnEgg: return 773;
			case Item::EvokerSpawnEgg: return 774;
			case Item::ExperienceBottle: return 822;
			case Item::Farmland: return 184;
			case Item::Feather: return 611;
			case Item::FermentedSpiderEye: return 752;
			case Item::Fern: return 90;
			case Item::FilledMap: return 733;
			case Item::FireCharge: return 823;
			case Item::FireCoral: return 510;
			case Item::FireCoralBlock: return 505;
			case Item::FireCoralFan: return 520;
			case Item::FireworkRocket: return 845;
			case Item::FireworkStar: return 846;
			case Item::FishingRod: return 684;
			case Item::FletchingTable: return 939;
			case Item::Flint: return 646;
			case Item::FlintAndSteel: return 575;
			case Item::FlowerBannerPattern: return 928;
			case Item::FlowerPot: return 828;
			case Item::FoxSpawnEgg: return 775;
			case Item::Furnace: return 185;
			case Item::FurnaceMinecart: return 681;
			case Item::GhastSpawnEgg: return 776;
			case Item::GhastTear: return 746;
			case Item::GildedBlackstone: return 965;
			case Item::Glass: return 77;
			case Item::GlassBottle: return 750;
			case Item::GlassPane: return 249;
			case Item::GlisteringMelonSlice: return 758;
			case Item::GlobeBannerPattern: return 932;
			case Item::Glowstone: return 224;
			case Item::GlowstoneDust: return 686;
			case Item::GoldBlock: return 136;
			case Item::GoldIngot: return 583;
			case Item::GoldNugget: return 747;
			case Item::GoldOre: return 33;
			case Item::GoldenApple: return 650;
			case Item::GoldenAxe: return 605;
			case Item::GoldenBoots: return 641;
			case Item::GoldenCarrot: return 834;
			case Item::GoldenChestplate: return 639;
			case Item::GoldenHelmet: return 638;
			case Item::GoldenHoe: return 617;
			case Item::GoldenHorseArmor: return 861;
			case Item::GoldenLeggings: return 640;
			case Item::GoldenPickaxe: return 604;
			case Item::GoldenShovel: return 603;
			case Item::GoldenSword: return 602;
			case Item::Granite: return 2;
			case Item::GraniteSlab: return 551;
			case Item::GraniteStairs: return 538;
			case Item::GraniteWall: return 293;
			case Item::Grass: return 89;
			case Item::GrassBlock: return 8;
			case Item::GrassPath: return 372;
			case Item::Gravel: return 32;
			case Item::GrayBanner: return 876;
			case Item::GrayBed: return 723;
			case Item::GrayCarpet: return 357;
			case Item::GrayConcrete: return 471;
			case Item::GrayConcretePowder: return 487;
			case Item::GrayDye: return 701;
			case Item::GrayGlazedTerracotta: return 455;
			case Item::GrayShulkerBox: return 439;
			case Item::GrayStainedGlass: return 386;
			case Item::GrayStainedGlassPane: return 402;
			case Item::GrayTerracotta: return 338;
			case Item::GrayWool: return 102;
			case Item::GreenBanner: return 882;
			case Item::GreenBed: return 729;
			case Item::GreenCarpet: return 363;
			case Item::GreenConcrete: return 477;
			case Item::GreenConcretePowder: return 493;
			case Item::GreenDye: return 695;
			case Item::GreenGlazedTerracotta: return 461;
			case Item::GreenShulkerBox: return 445;
			case Item::GreenStainedGlass: return 392;
			case Item::GreenStainedGlassPane: return 408;
			case Item::GreenTerracotta: return 344;
			case Item::GreenWool: return 108;
			case Item::Grindstone: return 940;
			case Item::GuardianSpawnEgg: return 777;
			case Item::Gunpowder: return 612;
			case Item::HayBale: return 349;
			case Item::HeartOfTheSea: return 924;
			case Item::HeavyWeightedPressurePlate: return 319;
			case Item::HoglinSpawnEgg: return 778;
			case Item::HoneyBlock: return 955;
			case Item::HoneyBottle: return 954;
			case Item::Honeycomb: return 951;
			case Item::HoneycombBlock: return 956;
			case Item::Hopper: return 323;
			case Item::HopperMinecart: return 851;
			case Item::HornCoral: return 511;
			case Item::HornCoralBlock: return 506;
			case Item::HornCoralFan: return 521;
			case Item::HorseSpawnEgg: return 779;
			case Item::HuskSpawnEgg: return 780;
			case Item::Ice: return 203;
			case Item::InfestedChiseledStoneBricks: return 239;
			case Item::InfestedCobblestone: return 235;
			case Item::InfestedCrackedStoneBricks: return 238;
			case Item::InfestedMossyStoneBricks: return 237;
			case Item::InfestedStone: return 234;
			case Item::InfestedStoneBricks: return 236;
			case Item::InkSac: return 693;
			case Item::IronAxe: return 574;
			case Item::IronBars: return 247;
			case Item::IronBlock: return 137;
			case Item::IronBoots: return 633;
			case Item::IronChestplate: return 631;
			case Item::IronDoor: return 557;
			case Item::IronHelmet: return 630;
			case Item::IronHoe: return 615;
			case Item::IronHorseArmor: return 860;
			case Item::IronIngot: return 582;
			case Item::IronLeggings: return 632;
			case Item::IronNugget: return 905;
			case Item::IronOre: return 34;
			case Item::IronPickaxe: return 573;
			case Item::IronShovel: return 572;
			case Item::IronSword: return 586;
			case Item::IronTrapdoor: return 348;
			case Item::ItemFrame: return 827;
			case Item::JackOLantern: return 225;
			case Item::Jigsaw: return 569;
			case Item::Jukebox: return 207;
			case Item::JungleBoat: return 900;
			case Item::JungleButton: return 308;
			case Item::JungleDoor: return 561;
			case Item::JungleFence: return 211;
			case Item::JungleFenceGate: return 255;
			case Item::JungleLeaves: return 72;
			case Item::JungleLog: return 40;
			case Item::JunglePlanks: return 18;
			case Item::JunglePressurePlate: return 194;
			case Item::JungleSapling: return 26;
			case Item::JungleSign: return 655;
			case Item::JungleSlab: return 141;
			case Item::JungleStairs: return 282;
			case Item::JungleTrapdoor: return 229;
			case Item::JungleWood: return 64;
			case Item::Kelp: return 134;
			case Item::KnowledgeBook: return 906;
			case Item::Ladder: return 186;
			case Item::Lantern: return 945;
			case Item::LapisBlock: return 79;
			case Item::LapisLazuli: return 697;
			case Item::LapisOre: return 78;
			case Item::LargeFern: return 378;
			case Item::LavaBucket: return 662;
			case Item::Lead: return 864;
			case Item::Leather: return 668;
			case Item::LeatherBoots: return 625;
			case Item::LeatherChestplate: return 623;
			case Item::LeatherHelmet: return 622;
			case Item::LeatherHorseArmor: return 863;
			case Item::LeatherLeggings: return 624;
			case Item::Lectern: return 941;
			case Item::Lever: return 189;
			case Item::LightBlueBanner: return 872;
			case Item::LightBlueBed: return 719;
			case Item::LightBlueCarpet: return 353;
			case Item::LightBlueConcrete: return 467;
			case Item::LightBlueConcretePowder: return 483;
			case Item::LightBlueDye: return 705;
			case Item::LightBlueGlazedTerracotta: return 451;
			case Item::LightBlueShulkerBox: return 435;
			case Item::LightBlueStainedGlass: return 382;
			case Item::LightBlueStainedGlassPane: return 398;
			case Item::LightBlueTerracotta: return 334;
			case Item::LightBlueWool: return 98;
			case Item::LightGrayBanner: return 877;
			case Item::LightGrayBed: return 724;
			case Item::LightGrayCarpet: return 358;
			case Item::LightGrayConcrete: return 472;
			case Item::LightGrayConcretePowder: return 488;
			case Item::LightGrayDye: return 700;
			case Item::LightGrayGlazedTerracotta: return 456;
			case Item::LightGrayShulkerBox: return 440;
			case Item::LightGrayStainedGlass: return 387;
			case Item::LightGrayStainedGlassPane: return 403;
			case Item::LightGrayTerracotta: return 339;
			case Item::LightGrayWool: return 103;
			case Item::LightWeightedPressurePlate: return 318;
			case Item::Lilac: return 374;
			case Item::LilyOfTheValley: return 122;
			case Item::LilyPad: return 263;
			case Item::LimeBanner: return 874;
			case Item::LimeBed: return 721;
			case Item::LimeCarpet: return 355;
			case Item::LimeConcrete: return 469;
			case Item::LimeConcretePowder: return 485;
			case Item::LimeDye: return 703;
			case Item::LimeGlazedTerracotta: return 453;
			case Item::LimeShulkerBox: return 437;
			case Item::LimeStainedGlass: return 384;
			case Item::LimeStainedGlassPane: return 400;
			case Item::LimeTerracotta: return 336;
			case Item::LimeWool: return 100;
			case Item::LingeringPotion: return 895;
			case Item::LlamaSpawnEgg: return 781;
			case Item::Lodestone: return 957;
			case Item::Loom: return 927;
			case Item::MagentaBanner: return 871;
			case Item::MagentaBed: return 718;
			case Item::MagentaCarpet: return 352;
			case Item::MagentaConcrete: return 466;
			case Item::MagentaConcretePowder: return 482;
			case Item::MagentaDye: return 706;
			case Item::MagentaGlazedTerracotta: return 450;
			case Item::MagentaShulkerBox: return 434;
			case Item::MagentaStainedGlass: return 381;
			case Item::MagentaStainedGlassPane: return 397;
			case Item::MagentaTerracotta: return 333;
			case Item::MagentaWool: return 97;
			case Item::MagmaBlock: return 424;
			case Item::MagmaCream: return 754;
			case Item::MagmaCubeSpawnEgg: return 782;
			case Item::Map: return 833;
			case Item::Melon: return 250;
			case Item::MelonSeeds: return 738;
			case Item::MelonSlice: return 735;
			case Item::MilkBucket: return 669;
			case Item::Minecart: return 663;
			case Item::MojangBannerPattern: return 931;
			case Item::MooshroomSpawnEgg: return 783;
			case Item::MossyCobblestone: return 169;
			case Item::MossyCobblestoneSlab: return 547;
			case Item::MossyCobblestoneStairs: return 533;
			case Item::MossyCobblestoneWall: return 288;
			case Item::MossyStoneBrickSlab: return 545;
			case Item::MossyStoneBrickStairs: return 531;
			case Item::MossyStoneBrickWall: return 292;
			case Item::MossyStoneBricks: return 241;
			case Item::MuleSpawnEgg: return 784;
			case Item::MushroomStem: return 246;
			case Item::MushroomStew: return 601;
			case Item::MusicDiscBlocks: return 910;
			case Item::MusicDiscCat: return 909;
			case Item::MusicDiscChirp: return 911;
			case Item::MusicDiscFar: return 912;
			case Item::MusicDiscMall: return 913;
			case Item::MusicDiscMellohi: return 914;
			case Item::MusicDiscPigstep: return 920;
			case Item::MusicDiscStal: return 915;
			case Item::MusicDiscStrad: return 916;
			case Item::MusicDiscWait: return 919;
			case Item::MusicDiscWard: return 917;
			case Item::MusicDisc11: return 918;
			case Item::MusicDisc13: return 908;
			case Item::Mutton: return 867;
			case Item::Mycelium: return 262;
			case Item::NameTag: return 865;
			case Item::NautilusShell: return 923;
			case Item::NetherBrick: return 848;
			case Item::NetherBrickFence: return 267;
			case Item::NetherBrickSlab: return 154;
			case Item::NetherBrickStairs: return 268;
			case Item::NetherBrickWall: return 295;
			case Item::NetherBricks: return 264;
			case Item::NetherGoldOre: return 36;
			case Item::NetherQuartzOre: return 322;
			case Item::NetherSprouts: return 130;
			case Item::NetherStar: return 843;
			case Item::NetherWart: return 748;
			case Item::NetherWartBlock: return 425;
			case Item::NetheriteAxe: return 609;
			case Item::NetheriteBlock: return 958;
			case Item::NetheriteBoots: return 645;
			case Item::NetheriteChestplate: return 643;
			case Item::NetheriteHelmet: return 642;
			case Item::NetheriteHoe: return 618;
			case Item::NetheriteIngot: return 584;
			case Item::NetheriteLeggings: return 644;
			case Item::NetheritePickaxe: return 608;
			case Item::NetheriteScrap: return 585;
			case Item::NetheriteShovel: return 607;
			case Item::NetheriteSword: return 606;
			case Item::Netherrack: return 218;
			case Item::NoteBlock: return 84;
			case Item::OakBoat: return 667;
			case Item::OakButton: return 305;
			case Item::OakDoor: return 558;
			case Item::OakFence: return 208;
			case Item::OakFenceGate: return 252;
			case Item::OakLeaves: return 69;
			case Item::OakLog: return 37;
			case Item::OakPlanks: return 15;
			case Item::OakPressurePlate: return 191;
			case Item::OakSapling: return 23;
			case Item::OakSign: return 652;
			case Item::OakSlab: return 138;
			case Item::OakStairs: return 179;
			case Item::OakTrapdoor: return 226;
			case Item::OakWood: return 61;
			case Item::Observer: return 430;
			case Item::Obsidian: return 170;
			case Item::OcelotSpawnEgg: return 785;
			case Item::OrangeBanner: return 870;
			case Item::OrangeBed: return 717;
			case Item::OrangeCarpet: return 351;
			case Item::OrangeConcrete: return 465;
			case Item::OrangeConcretePowder: return 481;
			case Item::OrangeDye: return 707;
			case Item::OrangeGlazedTerracotta: return 449;
			case Item::OrangeShulkerBox: return 433;
			case Item::OrangeStainedGlass: return 380;
			case Item::OrangeStainedGlassPane: return 396;
			case Item::OrangeTerracotta: return 332;
			case Item::OrangeTulip: return 117;
			case Item::OrangeWool: return 96;
			case Item::OxeyeDaisy: return 120;
			case Item::PackedIce: return 368;
			case Item::Painting: return 649;
			case Item::PandaSpawnEgg: return 786;
			case Item::Paper: return 677;
			case Item::ParrotSpawnEgg: return 787;
			case Item::Peony: return 376;
			case Item::PetrifiedOakSlab: return 150;
			case Item::PhantomMembrane: return 922;
			case Item::PhantomSpawnEgg: return 788;
			case Item::PigSpawnEgg: return 789;
			case Item::PiglinBannerPattern: return 933;
			case Item::PiglinSpawnEgg: return 790;
			case Item::PillagerSpawnEgg: return 791;
			case Item::PinkBanner: return 875;
			case Item::PinkBed: return 722;
			case Item::PinkCarpet: return 356;
			case Item::PinkConcrete: return 470;
			case Item::PinkConcretePowder: return 486;
			case Item::PinkDye: return 702;
			case Item::PinkGlazedTerracotta: return 454;
			case Item::PinkShulkerBox: return 438;
			case Item::PinkStainedGlass: return 385;
			case Item::PinkStainedGlassPane: return 401;
			case Item::PinkTerracotta: return 337;
			case Item::PinkTulip: return 119;
			case Item::PinkWool: return 101;
			case Item::Piston: return 94;
			case Item::PlayerHead: return 837;
			case Item::Podzol: return 11;
			case Item::PoisonousPotato: return 832;
			case Item::PolarBearSpawnEgg: return 792;
			case Item::PolishedAndesite: return 7;
			case Item::PolishedAndesiteSlab: return 554;
			case Item::PolishedAndesiteStairs: return 541;
			case Item::PolishedBasalt: return 222;
			case Item::PolishedBlackstone: return 966;
			case Item::PolishedBlackstoneBrickSlab: return 971;
			case Item::PolishedBlackstoneBrickStairs: return 972;
			case Item::PolishedBlackstoneBrickWall: return 303;
			case Item::PolishedBlackstoneBricks: return 970;
			case Item::PolishedBlackstoneButton: return 313;
			case Item::PolishedBlackstonePressurePlate: return 199;
			case Item::PolishedBlackstoneSlab: return 967;
			case Item::PolishedBlackstoneStairs: return 968;
			case Item::PolishedBlackstoneWall: return 302;
			case Item::PolishedDiorite: return 5;
			case Item::PolishedDioriteSlab: return 546;
			case Item::PolishedDioriteStairs: return 532;
			case Item::PolishedGranite: return 3;
			case Item::PolishedGraniteSlab: return 543;
			case Item::PolishedGraniteStairs: return 529;
			case Item::PoppedChorusFruit: return 887;
			case Item::Poppy: return 112;
			case Item::Porkchop: return 647;
			case Item::Potato: return 830;
			case Item::Potion: return 749;
			case Item::PoweredRail: return 85;
			case Item::Prismarine: return 411;
			case Item::PrismarineBrickSlab: return 160;
			case Item::PrismarineBrickStairs: return 415;
			case Item::PrismarineBricks: return 412;
			case Item::PrismarineCrystals: return 853;
			case Item::PrismarineShard: return 852;
			case Item::PrismarineSlab: return 159;
			case Item::PrismarineStairs: return 414;
			case Item::PrismarineWall: return 290;
			case Item::Pufferfish: return 690;
			case Item::PufferfishBucket: return 670;
			case Item::PufferfishSpawnEgg: return 793;
			case Item::Pumpkin: return 216;
			case Item::PumpkinPie: return 844;
			case Item::PumpkinSeeds: return 737;
			case Item::PurpleBanner: return 879;
			case Item::PurpleBed: return 726;
			case Item::PurpleCarpet: return 360;
			case Item::PurpleConcrete: return 474;
			case Item::PurpleConcretePowder: return 490;
			case Item::PurpleDye: return 698;
			case Item::PurpleGlazedTerracotta: return 458;
			case Item::PurpleShulkerBox: return 442;
			case Item::PurpleStainedGlass: return 389;
			case Item::PurpleStainedGlassPane: return 405;
			case Item::PurpleTerracotta: return 341;
			case Item::PurpleWool: return 105;
			case Item::PurpurBlock: return 175;
			case Item::PurpurPillar: return 176;
			case Item::PurpurSlab: return 158;
			case Item::PurpurStairs: return 177;
			case Item::Quartz: return 849;
			case Item::QuartzBlock: return 325;
			case Item::QuartzBricks: return 326;
			case Item::QuartzPillar: return 327;
			case Item::QuartzSlab: return 155;
			case Item::QuartzStairs: return 328;
			case Item::Rabbit: return 854;
			case Item::RabbitFoot: return 857;
			case Item::RabbitHide: return 858;
			case Item::RabbitSpawnEgg: return 794;
			case Item::RabbitStew: return 856;
			case Item::Rail: return 187;
			case Item::RavagerSpawnEgg: return 795;
			case Item::RedBanner: return 883;
			case Item::RedBed: return 730;
			case Item::RedCarpet: return 364;
			case Item::RedConcrete: return 478;
			case Item::RedConcretePowder: return 494;
			case Item::RedDye: return 694;
			case Item::RedGlazedTerracotta: return 462;
			case Item::RedMushroom: return 125;
			case Item::RedMushroomBlock: return 245;
			case Item::RedNetherBrickSlab: return 553;
			case Item::RedNetherBrickStairs: return 540;
			case Item::RedNetherBrickWall: return 297;
			case Item::RedNetherBricks: return 427;
			case Item::RedSand: return 31;
			case Item::RedSandstone: return 418;
			case Item::RedSandstoneSlab: return 156;
			case Item::RedSandstoneStairs: return 421;
			case Item::RedSandstoneWall: return 291;
			case Item::RedShulkerBox: return 446;
			case Item::RedStainedGlass: return 393;
			case Item::RedStainedGlassPane: return 409;
			case Item::RedTerracotta: return 345;
			case Item::RedTulip: return 116;
			case Item::RedWool: return 109;
			case Item::Redstone: return 665;
			case Item::RedstoneBlock: return 321;
			case Item::RedstoneLamp: return 274;
			case Item::RedstoneOre: return 200;
			case Item::RedstoneTorch: return 201;
			case Item::Repeater: return 566;
			case Item::RepeatingCommandBlock: return 422;
			case Item::RespawnAnchor: return 974;
			case Item::RoseBush: return 375;
			case Item::RottenFlesh: return 743;
			case Item::Saddle: return 664;
			case Item::Salmon: return 688;
			case Item::SalmonBucket: return 671;
			case Item::SalmonSpawnEgg: return 796;
			case Item::Sand: return 30;
			case Item::Sandstone: return 81;
			case Item::SandstoneSlab: return 148;
			case Item::SandstoneStairs: return 275;
			case Item::SandstoneWall: return 298;
			case Item::Scaffolding: return 556;
			case Item::Scute: return 571;
			case Item::SeaLantern: return 417;
			case Item::SeaPickle: return 93;
			case Item::Seagrass: return 92;
			case Item::Shears: return 734;
			case Item::SheepSpawnEgg: return 797;
			case Item::Shield: return 896;
			case Item::Shroomlight: return 950;
			case Item::ShulkerBox: return 431;
			case Item::ShulkerShell: return 904;
			case Item::ShulkerSpawnEgg: return 798;
			case Item::SilverfishSpawnEgg: return 799;
			case Item::SkeletonHorseSpawnEgg: return 801;
			case Item::SkeletonSkull: return 835;
			case Item::SkeletonSpawnEgg: return 800;
			case Item::SkullBannerPattern: return 930;
			case Item::SlimeBall: return 679;
			case Item::SlimeBlock: return 371;
			case Item::SlimeSpawnEgg: return 802;
			case Item::SmithingTable: return 942;
			case Item::Smoker: return 936;
			case Item::SmoothQuartz: return 162;
			case Item::SmoothQuartzSlab: return 550;
			case Item::SmoothQuartzStairs: return 537;
			case Item::SmoothRedSandstone: return 163;
			case Item::SmoothRedSandstoneSlab: return 544;
			case Item::SmoothRedSandstoneStairs: return 530;
			case Item::SmoothSandstone: return 164;
			case Item::SmoothSandstoneSlab: return 549;
			case Item::SmoothSandstoneStairs: return 536;
			case Item::SmoothStone: return 165;
			case Item::SmoothStoneSlab: return 147;
			case Item::Snow: return 202;
			case Item::SnowBlock: return 204;
			case Item::Snowball: return 666;
			case Item::SoulCampfire: return 949;
			case Item::SoulLantern: return 946;
			case Item::SoulSand: return 219;
			case Item::SoulSoil: return 220;
			case Item::SoulTorch: return 223;
			case Item::Spawner: return 178;
			case Item::SpectralArrow: return 893;
			case Item::SpiderEye: return 751;
			case Item::SpiderSpawnEgg: return 803;
			case Item::SplashPotion: return 892;
			case Item::Sponge: return 75;
			case Item::SpruceBoat: return 898;
			case Item::SpruceButton: return 306;
			case Item::SpruceDoor: return 559;
			case Item::SpruceFence: return 209;
			case Item::SpruceFenceGate: return 253;
			case Item::SpruceLeaves: return 70;
			case Item::SpruceLog: return 38;
			case Item::SprucePlanks: return 16;
			case Item::SprucePressurePlate: return 192;
			case Item::SpruceSapling: return 24;
			case Item::SpruceSign: return 653;
			case Item::SpruceSlab: return 139;
			case Item::SpruceStairs: return 280;
			case Item::SpruceTrapdoor: return 227;
			case Item::SpruceWood: return 62;
			case Item::SquidSpawnEgg: return 804;
			case Item::Stick: return 599;
			case Item::StickyPiston: return 87;
			case Item::Stone: return 1;
			case Item::StoneAxe: return 594;
			case Item::StoneBrickSlab: return 153;
			case Item::StoneBrickStairs: return 261;
			case Item::StoneBrickWall: return 294;
			case Item::StoneBricks: return 240;
			case Item::StoneButton: return 304;
			case Item::StoneHoe: return 614;
			case Item::StonePickaxe: return 593;
			case Item::StonePressurePlate: return 190;
			case Item::StoneShovel: return 592;
			case Item::StoneSlab: return 146;
			case Item::StoneStairs: return 535;
			case Item::StoneSword: return 591;
			case Item::Stonecutter: return 943;
			case Item::StraySpawnEgg: return 805;
			case Item::StriderSpawnEgg: return 806;
			case Item::String: return 610;
			case Item::StrippedAcaciaLog: return 49;
			case Item::StrippedAcaciaWood: return 57;
			case Item::StrippedBirchLog: return 47;
			case Item::StrippedBirchWood: return 55;
			case Item::StrippedCrimsonHyphae: return 59;
			case Item::StrippedCrimsonStem: return 51;
			case Item::StrippedDarkOakLog: return 50;
			case Item::StrippedDarkOakWood: return 58;
			case Item::StrippedJungleLog: return 48;
			case Item::StrippedJungleWood: return 56;
			case Item::StrippedOakLog: return 45;
			case Item::StrippedOakWood: return 53;
			case Item::StrippedSpruceLog: return 46;
			case Item::StrippedSpruceWood: return 54;
			case Item::StrippedWarpedHyphae: return 60;
			case Item::StrippedWarpedStem: return 52;
			case Item::StructureBlock: return 568;
			case Item::StructureVoid: return 429;
			case Item::Sugar: return 714;
			case Item::SugarCane: return 133;
			case Item::Sunflower: return 373;
			case Item::SuspiciousStew: return 926;
			case Item::SweetBerries: return 947;
			case Item::TallGrass: return 377;
			case Item::Target: return 960;
			case Item::Terracotta: return 366;
			case Item::TippedArrow: return 894;
			case Item::TNT: return 167;
			case Item::TNTMinecart: return 850;
			case Item::Torch: return 171;
			case Item::TotemOfUndying: return 903;
			case Item::TraderLlamaSpawnEgg: return 807;
			case Item::TrappedChest: return 317;
			case Item::Trident: return 921;
			case Item::TripwireHook: return 278;
			case Item::TropicalFish: return 689;
			case Item::TropicalFishBucket: return 673;
			case Item::TropicalFishSpawnEgg: return 808;
			case Item::TubeCoral: return 507;
			case Item::TubeCoralBlock: return 502;
			case Item::TubeCoralFan: return 517;
			case Item::TurtleEgg: return 496;
			case Item::TurtleHelmet: return 570;
			case Item::TurtleSpawnEgg: return 809;
			case Item::TwistingVines: return 132;
			case Item::VexSpawnEgg: return 810;
			case Item::VillagerSpawnEgg: return 811;
			case Item::VindicatorSpawnEgg: return 812;
			case Item::Vine: return 251;
			case Item::WanderingTraderSpawnEgg: return 813;
			case Item::WarpedButton: return 312;
			case Item::WarpedDoor: return 565;
			case Item::WarpedFence: return 215;
			case Item::WarpedFenceGate: return 259;
			case Item::WarpedFungus: return 127;
			case Item::WarpedFungusOnA_stick: return 842;
			case Item::WarpedHyphae: return 68;
			case Item::WarpedNylium: return 13;
			case Item::WarpedPlanks: return 22;
			case Item::WarpedPressurePlate: return 198;
			case Item::WarpedRoots: return 129;
			case Item::WarpedSign: return 659;
			case Item::WarpedSlab: return 145;
			case Item::WarpedStairs: return 284;
			case Item::WarpedStem: return 44;
			case Item::WarpedTrapdoor: return 233;
			case Item::WarpedWartBlock: return 426;
			case Item::WaterBucket: return 661;
			case Item::WeepingVines: return 131;
			case Item::WetSponge: return 76;
			case Item::Wheat: return 620;
			case Item::WheatSeeds: return 619;
			case Item::WhiteBanner: return 869;
			case Item::WhiteBed: return 716;
			case Item::WhiteCarpet: return 350;
			case Item::WhiteConcrete: return 464;
			case Item::WhiteConcretePowder: return 480;
			case Item::WhiteDye: return 712;
			case Item::WhiteGlazedTerracotta: return 448;
			case Item::WhiteShulkerBox: return 432;
			case Item::WhiteStainedGlass: return 379;
			case Item::WhiteStainedGlassPane: return 395;
			case Item::WhiteTerracotta: return 331;
			case Item::WhiteTulip: return 118;
			case Item::WhiteWool: return 95;
			case Item::WitchSpawnEgg: return 814;
			case Item::WitherRose: return 123;
			case Item::WitherSkeletonSkull: return 836;
			case Item::WitherSkeletonSpawnEgg: return 815;
			case Item::WolfSpawnEgg: return 816;
			case Item::WoodenAxe: return 590;
			case Item::WoodenHoe: return 613;
			case Item::WoodenPickaxe: return 589;
			case Item::WoodenShovel: return 588;
			case Item::WoodenSword: return 587;
			case Item::WritableBook: return 824;
			case Item::WrittenBook: return 825;
			case Item::YellowBanner: return 873;
			case Item::YellowBed: return 720;
			case Item::YellowCarpet: return 354;
			case Item::YellowConcrete: return 468;
			case Item::YellowConcretePowder: return 484;
			case Item::YellowDye: return 704;
			case Item::YellowGlazedTerracotta: return 452;
			case Item::YellowShulkerBox: return 436;
			case Item::YellowStainedGlass: return 383;
			case Item::YellowStainedGlassPane: return 399;
			case Item::YellowTerracotta: return 335;
			case Item::YellowWool: return 99;
			case Item::ZoglinSpawnEgg: return 817;
			case Item::ZombieHead: return 838;
			case Item::ZombieHorseSpawnEgg: return 819;
			case Item::ZombieSpawnEgg: return 818;
			case Item::ZombieVillagerSpawnEgg: return 820;
			case Item::ZombiePigmanSpawnEgg: return 821;
		}
		UNREACHABLE("Invalid item");
	}

	UInt32 From(const CustomStatistic ID)
	{
		switch (ID)
		{
			case CustomStatistic::AnimalsBred: return 31;
			case CustomStatistic::AviateOneCm: return 17;
			case CustomStatistic::BellRing: return 67;
			case CustomStatistic::BoatOneCm: return 14;
			case CustomStatistic::CleanArmor: return 39;
			case CustomStatistic::CleanBanner: return 40;
			case CustomStatistic::CleanShulkerBox: return 41;
			case CustomStatistic::ClimbOneCm: return 10;
			case CustomStatistic::CrouchOneCm: return 6;
			case CustomStatistic::DamageAbsorbed: return 27;
			case CustomStatistic::DamageBlockedByShield: return 26;
			case CustomStatistic::DamageDealt: return 22;
			case CustomStatistic::DamageDealtAbsorbed: return 23;
			case CustomStatistic::DamageDealtResisted: return 24;
			case CustomStatistic::DamageResisted: return 28;
			case CustomStatistic::DamageTaken: return 25;
			case CustomStatistic::Deaths: return 29;
			case CustomStatistic::Drop: return 21;
			case CustomStatistic::EatCakeSlice: return 36;
			case CustomStatistic::EnchantItem: return 52;
			case CustomStatistic::FallOneCm: return 9;
			case CustomStatistic::FillCauldron: return 37;
			case CustomStatistic::FishCaught: return 33;
			case CustomStatistic::FlyOneCm: return 11;
			case CustomStatistic::HorseOneCm: return 16;
			case CustomStatistic::InspectDispenser: return 46;
			case CustomStatistic::InspectDropper: return 44;
			case CustomStatistic::InspectHopper: return 45;
			case CustomStatistic::InteractWithAnvil: return 70;
			case CustomStatistic::InteractWithBeacon: return 43;
			case CustomStatistic::InteractWithBlastFurnace: return 60;
			case CustomStatistic::InteractWithBrewingstand: return 42;
			case CustomStatistic::InteractWithCampfire: return 63;
			case CustomStatistic::InteractWithCartographyTable: return 64;
			case CustomStatistic::InteractWithCraftingTable: return 55;
			case CustomStatistic::InteractWithFurnace: return 54;
			case CustomStatistic::InteractWithGrindstone: return 71;
			case CustomStatistic::InteractWithLectern: return 62;
			case CustomStatistic::InteractWithLoom: return 65;
			case CustomStatistic::InteractWithSmithingTable: return 73;
			case CustomStatistic::InteractWithSmoker: return 61;
			case CustomStatistic::InteractWithStonecutter: return 66;
			case CustomStatistic::Jump: return 20;
			case CustomStatistic::LeaveGame: return -0;
			case CustomStatistic::MinecartOneCm: return 13;
			case CustomStatistic::MobKills: return 30;
			case CustomStatistic::OpenBarrel: return 59;
			case CustomStatistic::OpenChest: return 56;
			case CustomStatistic::OpenEnderchest: return 51;
			case CustomStatistic::OpenShulkerBox: return 58;
			case CustomStatistic::PigOneCm: return 15;
			case CustomStatistic::PlayNoteblock: return 47;
			case CustomStatistic::PlayOneMinute: return 1;
			case CustomStatistic::PlayRecord: return 53;
			case CustomStatistic::PlayerKills: return 32;
			case CustomStatistic::PotFlower: return 49;
			case CustomStatistic::RaidTrigger: return 68;
			case CustomStatistic::RaidWin: return 69;
			case CustomStatistic::SleepInBed: return 57;
			case CustomStatistic::SneakTime: return 4;
			case CustomStatistic::SprintOneCm: return 7;
			case CustomStatistic::StriderOneCm: return 19;
			case CustomStatistic::SwimOneCm: return 18;
			case CustomStatistic::TalkedToVillager: return 34;
			case CustomStatistic::TargetHit: return 72;
			case CustomStatistic::TimeSinceDeath: return 2;
			case CustomStatistic::TimeSinceRest: return 3;
			case CustomStatistic::TradedWithVillager: return 35;
			case CustomStatistic::TriggerTrappedChest: return 50;
			case CustomStatistic::TuneNoteblock: return 48;
			case CustomStatistic::UseCauldron: return 38;
			case CustomStatistic::WalkOnWaterOneCm: return 8;
			case CustomStatistic::WalkOneCm: return 5;
			case CustomStatistic::WalkUnderWaterOneCm: return 12;
			default: return UInt32(-1);
		}
	}

	Item ToItem(const UInt32 ID)
	{
		switch (ID)
		{
			case 901: return Item::AcaciaBoat;
			case 309: return Item::AcaciaButton;
			case 562: return Item::AcaciaDoor;
			case 212: return Item::AcaciaFence;
			case 256: return Item::AcaciaFenceGate;
			case 73: return Item::AcaciaLeaves;
			case 41: return Item::AcaciaLog;
			case 19: return Item::AcaciaPlanks;
			case 195: return Item::AcaciaPressurePlate;
			case 27: return Item::AcaciaSapling;
			case 656: return Item::AcaciaSign;
			case 142: return Item::AcaciaSlab;
			case 369: return Item::AcaciaStairs;
			case 230: return Item::AcaciaTrapdoor;
			case 65: return Item::AcaciaWood;
			case 329: return Item::ActivatorRail;
			case -0: return Item::Air;
			case 114: return Item::Allium;
			case 959: return Item::AncientDebris;
			case 6: return Item::Andesite;
			case 552: return Item::AndesiteSlab;
			case 539: return Item::AndesiteStairs;
			case 296: return Item::AndesiteWall;
			case 314: return Item::Anvil;
			case 576: return Item::Apple;
			case 859: return Item::ArmorStand;
			case 578: return Item::Arrow;
			case 115: return Item::AzureBluet;
			case 831: return Item::BakedPotato;
			case 135: return Item::Bamboo;
			case 935: return Item::Barrel;
			case 347: return Item::Barrier;
			case 221: return Item::Basalt;
			case 759: return Item::BatSpawnEgg;
			case 286: return Item::Beacon;
			case 29: return Item::Bedrock;
			case 952: return Item::BeeNest;
			case 760: return Item::BeeSpawnEgg;
			case 739: return Item::Beef;
			case 953: return Item::Beehive;
			case 888: return Item::Beetroot;
			case 889: return Item::BeetrootSeeds;
			case 890: return Item::BeetrootSoup;
			case 944: return Item::Bell;
			case 899: return Item::BirchBoat;
			case 307: return Item::BirchButton;
			case 560: return Item::BirchDoor;
			case 210: return Item::BirchFence;
			case 254: return Item::BirchFenceGate;
			case 71: return Item::BirchLeaves;
			case 39: return Item::BirchLog;
			case 17: return Item::BirchPlanks;
			case 193: return Item::BirchPressurePlate;
			case 25: return Item::BirchSapling;
			case 654: return Item::BirchSign;
			case 140: return Item::BirchSlab;
			case 281: return Item::BirchStairs;
			case 228: return Item::BirchTrapdoor;
			case 63: return Item::BirchWood;
			case 884: return Item::BlackBanner;
			case 731: return Item::BlackBed;
			case 365: return Item::BlackCarpet;
			case 479: return Item::BlackConcrete;
			case 495: return Item::BlackConcretePowder;
			case 711: return Item::BlackDye;
			case 463: return Item::BlackGlazedTerracotta;
			case 447: return Item::BlackShulkerBox;
			case 394: return Item::BlackStainedGlass;
			case 410: return Item::BlackStainedGlassPane;
			case 346: return Item::BlackTerracotta;
			case 110: return Item::BlackWool;
			case 962: return Item::Blackstone;
			case 963: return Item::BlackstoneSlab;
			case 964: return Item::BlackstoneStairs;
			case 301: return Item::BlackstoneWall;
			case 937: return Item::BlastFurnace;
			case 753: return Item::BlazePowder;
			case 745: return Item::BlazeRod;
			case 761: return Item::BlazeSpawnEgg;
			case 880: return Item::BlueBanner;
			case 727: return Item::BlueBed;
			case 361: return Item::BlueCarpet;
			case 475: return Item::BlueConcrete;
			case 491: return Item::BlueConcretePowder;
			case 709: return Item::BlueDye;
			case 459: return Item::BlueGlazedTerracotta;
			case 527: return Item::BlueIce;
			case 113: return Item::BlueOrchid;
			case 443: return Item::BlueShulkerBox;
			case 390: return Item::BlueStainedGlass;
			case 406: return Item::BlueStainedGlassPane;
			case 342: return Item::BlueTerracotta;
			case 106: return Item::BlueWool;
			case 713: return Item::Bone;
			case 428: return Item::BoneBlock;
			case 708: return Item::BoneMeal;
			case 678: return Item::Book;
			case 168: return Item::Bookshelf;
			case 577: return Item::Bow;
			case 600: return Item::Bowl;
			case 508: return Item::BrainCoral;
			case 503: return Item::BrainCoralBlock;
			case 518: return Item::BrainCoralFan;
			case 621: return Item::Bread;
			case 755: return Item::BrewingStand;
			case 674: return Item::Brick;
			case 152: return Item::BrickSlab;
			case 260: return Item::BrickStairs;
			case 289: return Item::BrickWall;
			case 166: return Item::Bricks;
			case 881: return Item::BrownBanner;
			case 728: return Item::BrownBed;
			case 362: return Item::BrownCarpet;
			case 476: return Item::BrownConcrete;
			case 492: return Item::BrownConcretePowder;
			case 710: return Item::BrownDye;
			case 460: return Item::BrownGlazedTerracotta;
			case 124: return Item::BrownMushroom;
			case 244: return Item::BrownMushroomBlock;
			case 444: return Item::BrownShulkerBox;
			case 391: return Item::BrownStainedGlass;
			case 407: return Item::BrownStainedGlassPane;
			case 343: return Item::BrownTerracotta;
			case 107: return Item::BrownWool;
			case 509: return Item::BubbleCoral;
			case 504: return Item::BubbleCoralBlock;
			case 519: return Item::BubbleCoralFan;
			case 660: return Item::Bucket;
			case 205: return Item::Cactus;
			case 715: return Item::Cake;
			case 948: return Item::Campfire;
			case 829: return Item::Carrot;
			case 841: return Item::CarrotOnAStick;
			case 938: return Item::CartographyTable;
			case 217: return Item::CarvedPumpkin;
			case 762: return Item::CatSpawnEgg;
			case 756: return Item::Cauldron;
			case 763: return Item::CaveSpiderSpawnEgg;
			case 248: return Item::Chain;
			case 423: return Item::ChainCommandBlock;
			case 629: return Item::ChainmailBoots;
			case 627: return Item::ChainmailChestplate;
			case 626: return Item::ChainmailHelmet;
			case 628: return Item::ChainmailLeggings;
			case 580: return Item::Charcoal;
			case 180: return Item::Chest;
			case 680: return Item::ChestMinecart;
			case 741: return Item::Chicken;
			case 764: return Item::ChickenSpawnEgg;
			case 315: return Item::ChippedAnvil;
			case 266: return Item::ChiseledNetherBricks;
			case 969: return Item::ChiseledPolishedBlackstone;
			case 324: return Item::ChiseledQuartzBlock;
			case 419: return Item::ChiseledRedSandstone;
			case 82: return Item::ChiseledSandstone;
			case 243: return Item::ChiseledStoneBricks;
			case 174: return Item::ChorusFlower;
			case 886: return Item::ChorusFruit;
			case 173: return Item::ChorusPlant;
			case 206: return Item::Clay;
			case 675: return Item::ClayBall;
			case 685: return Item::Clock;
			case 579: return Item::Coal;
			case 367: return Item::CoalBlock;
			case 35: return Item::CoalOre;
			case 10: return Item::CoarseDirt;
			case 14: return Item::Cobblestone;
			case 151: return Item::CobblestoneSlab;
			case 188: return Item::CobblestoneStairs;
			case 287: return Item::CobblestoneWall;
			case 88: return Item::Cobweb;
			case 696: return Item::CocoaBeans;
			case 687: return Item::Cod;
			case 672: return Item::CodBucket;
			case 765: return Item::CodSpawnEgg;
			case 285: return Item::CommandBlock;
			case 866: return Item::CommandBlockMinecart;
			case 567: return Item::Comparator;
			case 683: return Item::Compass;
			case 934: return Item::Composter;
			case 528: return Item::Conduit;
			case 740: return Item::CookedBeef;
			case 742: return Item::CookedChicken;
			case 691: return Item::CookedCod;
			case 868: return Item::CookedMutton;
			case 648: return Item::CookedPorkchop;
			case 855: return Item::CookedRabbit;
			case 692: return Item::CookedSalmon;
			case 732: return Item::Cookie;
			case 121: return Item::Cornflower;
			case 766: return Item::CowSpawnEgg;
			case 265: return Item::CrackedNetherBricks;
			case 973: return Item::CrackedPolishedBlackstoneBricks;
			case 242: return Item::CrackedStoneBricks;
			case 183: return Item::CraftingTable;
			case 929: return Item::CreeperBannerPattern;
			case 839: return Item::CreeperHead;
			case 767: return Item::CreeperSpawnEgg;
			case 311: return Item::CrimsonButton;
			case 564: return Item::CrimsonDoor;
			case 214: return Item::CrimsonFence;
			case 258: return Item::CrimsonFenceGate;
			case 126: return Item::CrimsonFungus;
			case 67: return Item::CrimsonHyphae;
			case 12: return Item::CrimsonNylium;
			case 21: return Item::CrimsonPlanks;
			case 197: return Item::CrimsonPressurePlate;
			case 128: return Item::CrimsonRoots;
			case 658: return Item::CrimsonSign;
			case 144: return Item::CrimsonSlab;
			case 283: return Item::CrimsonStairs;
			case 43: return Item::CrimsonStem;
			case 232: return Item::CrimsonTrapdoor;
			case 925: return Item::Crossbow;
			case 961: return Item::CryingObsidian;
			case 420: return Item::CutRedSandstone;
			case 157: return Item::CutRedSandstoneSlab;
			case 83: return Item::CutSandstone;
			case 149: return Item::CutSandstoneSlab;
			case 878: return Item::CyanBanner;
			case 725: return Item::CyanBed;
			case 359: return Item::CyanCarpet;
			case 473: return Item::CyanConcrete;
			case 489: return Item::CyanConcretePowder;
			case 699: return Item::CyanDye;
			case 457: return Item::CyanGlazedTerracotta;
			case 441: return Item::CyanShulkerBox;
			case 388: return Item::CyanStainedGlass;
			case 404: return Item::CyanStainedGlassPane;
			case 340: return Item::CyanTerracotta;
			case 104: return Item::CyanWool;
			case 316: return Item::DamagedAnvil;
			case 111: return Item::Dandelion;
			case 902: return Item::DarkOakBoat;
			case 310: return Item::DarkOakButton;
			case 563: return Item::DarkOakDoor;
			case 213: return Item::DarkOakFence;
			case 257: return Item::DarkOakFenceGate;
			case 74: return Item::DarkOakLeaves;
			case 42: return Item::DarkOakLog;
			case 20: return Item::DarkOakPlanks;
			case 196: return Item::DarkOakPressurePlate;
			case 28: return Item::DarkOakSapling;
			case 657: return Item::DarkOakSign;
			case 143: return Item::DarkOakSlab;
			case 370: return Item::DarkOakStairs;
			case 231: return Item::DarkOakTrapdoor;
			case 66: return Item::DarkOakWood;
			case 413: return Item::DarkPrismarine;
			case 161: return Item::DarkPrismarineSlab;
			case 416: return Item::DarkPrismarineStairs;
			case 320: return Item::DaylightDetector;
			case 512: return Item::DeadBrainCoral;
			case 498: return Item::DeadBrainCoralBlock;
			case 523: return Item::DeadBrainCoralFan;
			case 513: return Item::DeadBubbleCoral;
			case 499: return Item::DeadBubbleCoralBlock;
			case 524: return Item::DeadBubbleCoralFan;
			case 91: return Item::DeadBush;
			case 514: return Item::DeadFireCoral;
			case 500: return Item::DeadFireCoralBlock;
			case 525: return Item::DeadFireCoralFan;
			case 515: return Item::DeadHornCoral;
			case 501: return Item::DeadHornCoralBlock;
			case 526: return Item::DeadHornCoralFan;
			case 516: return Item::DeadTubeCoral;
			case 497: return Item::DeadTubeCoralBlock;
			case 522: return Item::DeadTubeCoralFan;
			case 907: return Item::DebugStick;
			case 86: return Item::DetectorRail;
			case 581: return Item::Diamond;
			case 598: return Item::DiamondAxe;
			case 182: return Item::DiamondBlock;
			case 637: return Item::DiamondBoots;
			case 635: return Item::DiamondChestplate;
			case 634: return Item::DiamondHelmet;
			case 616: return Item::DiamondHoe;
			case 862: return Item::DiamondHorseArmor;
			case 636: return Item::DiamondLeggings;
			case 181: return Item::DiamondOre;
			case 597: return Item::DiamondPickaxe;
			case 596: return Item::DiamondShovel;
			case 595: return Item::DiamondSword;
			case 4: return Item::Diorite;
			case 555: return Item::DioriteSlab;
			case 542: return Item::DioriteStairs;
			case 300: return Item::DioriteWall;
			case 9: return Item::Dirt;
			case 80: return Item::Dispenser;
			case 768: return Item::DolphinSpawnEgg;
			case 769: return Item::DonkeySpawnEgg;
			case 891: return Item::DragonBreath;
			case 273: return Item::DragonEgg;
			case 840: return Item::DragonHead;
			case 736: return Item::DriedKelp;
			case 676: return Item::DriedKelpBlock;
			case 330: return Item::Dropper;
			case 770: return Item::DrownedSpawnEgg;
			case 682: return Item::Egg;
			case 771: return Item::ElderGuardianSpawnEgg;
			case 897: return Item::Elytra;
			case 826: return Item::Emerald;
			case 279: return Item::EmeraldBlock;
			case 276: return Item::EmeraldOre;
			case 847: return Item::EnchantedBook;
			case 651: return Item::EnchantedGoldenApple;
			case 269: return Item::EnchantingTable;
			case 885: return Item::EndCrystal;
			case 270: return Item::EndPortalFrame;
			case 172: return Item::EndRod;
			case 271: return Item::EndStone;
			case 548: return Item::EndStoneBrickSlab;
			case 534: return Item::EndStoneBrickStairs;
			case 299: return Item::EndStoneBrickWall;
			case 272: return Item::EndStoneBricks;
			case 277: return Item::EnderChest;
			case 757: return Item::EnderEye;
			case 744: return Item::EnderPearl;
			case 772: return Item::EndermanSpawnEgg;
			case 773: return Item::EndermiteSpawnEgg;
			case 774: return Item::EvokerSpawnEgg;
			case 822: return Item::ExperienceBottle;
			case 184: return Item::Farmland;
			case 611: return Item::Feather;
			case 752: return Item::FermentedSpiderEye;
			case 90: return Item::Fern;
			case 733: return Item::FilledMap;
			case 823: return Item::FireCharge;
			case 510: return Item::FireCoral;
			case 505: return Item::FireCoralBlock;
			case 520: return Item::FireCoralFan;
			case 845: return Item::FireworkRocket;
			case 846: return Item::FireworkStar;
			case 684: return Item::FishingRod;
			case 939: return Item::FletchingTable;
			case 646: return Item::Flint;
			case 575: return Item::FlintAndSteel;
			case 928: return Item::FlowerBannerPattern;
			case 828: return Item::FlowerPot;
			case 775: return Item::FoxSpawnEgg;
			case 185: return Item::Furnace;
			case 681: return Item::FurnaceMinecart;
			case 776: return Item::GhastSpawnEgg;
			case 746: return Item::GhastTear;
			case 965: return Item::GildedBlackstone;
			case 77: return Item::Glass;
			case 750: return Item::GlassBottle;
			case 249: return Item::GlassPane;
			case 758: return Item::GlisteringMelonSlice;
			case 932: return Item::GlobeBannerPattern;
			case 224: return Item::Glowstone;
			case 686: return Item::GlowstoneDust;
			case 136: return Item::GoldBlock;
			case 583: return Item::GoldIngot;
			case 747: return Item::GoldNugget;
			case 33: return Item::GoldOre;
			case 650: return Item::GoldenApple;
			case 605: return Item::GoldenAxe;
			case 641: return Item::GoldenBoots;
			case 834: return Item::GoldenCarrot;
			case 639: return Item::GoldenChestplate;
			case 638: return Item::GoldenHelmet;
			case 617: return Item::GoldenHoe;
			case 861: return Item::GoldenHorseArmor;
			case 640: return Item::GoldenLeggings;
			case 604: return Item::GoldenPickaxe;
			case 603: return Item::GoldenShovel;
			case 602: return Item::GoldenSword;
			case 2: return Item::Granite;
			case 551: return Item::GraniteSlab;
			case 538: return Item::GraniteStairs;
			case 293: return Item::GraniteWall;
			case 89: return Item::Grass;
			case 8: return Item::GrassBlock;
			case 372: return Item::GrassPath;
			case 32: return Item::Gravel;
			case 876: return Item::GrayBanner;
			case 723: return Item::GrayBed;
			case 357: return Item::GrayCarpet;
			case 471: return Item::GrayConcrete;
			case 487: return Item::GrayConcretePowder;
			case 701: return Item::GrayDye;
			case 455: return Item::GrayGlazedTerracotta;
			case 439: return Item::GrayShulkerBox;
			case 386: return Item::GrayStainedGlass;
			case 402: return Item::GrayStainedGlassPane;
			case 338: return Item::GrayTerracotta;
			case 102: return Item::GrayWool;
			case 882: return Item::GreenBanner;
			case 729: return Item::GreenBed;
			case 363: return Item::GreenCarpet;
			case 477: return Item::GreenConcrete;
			case 493: return Item::GreenConcretePowder;
			case 695: return Item::GreenDye;
			case 461: return Item::GreenGlazedTerracotta;
			case 445: return Item::GreenShulkerBox;
			case 392: return Item::GreenStainedGlass;
			case 408: return Item::GreenStainedGlassPane;
			case 344: return Item::GreenTerracotta;
			case 108: return Item::GreenWool;
			case 940: return Item::Grindstone;
			case 777: return Item::GuardianSpawnEgg;
			case 612: return Item::Gunpowder;
			case 349: return Item::HayBale;
			case 924: return Item::HeartOfTheSea;
			case 319: return Item::HeavyWeightedPressurePlate;
			case 778: return Item::HoglinSpawnEgg;
			case 955: return Item::HoneyBlock;
			case 954: return Item::HoneyBottle;
			case 951: return Item::Honeycomb;
			case 956: return Item::HoneycombBlock;
			case 323: return Item::Hopper;
			case 851: return Item::HopperMinecart;
			case 511: return Item::HornCoral;
			case 506: return Item::HornCoralBlock;
			case 521: return Item::HornCoralFan;
			case 779: return Item::HorseSpawnEgg;
			case 780: return Item::HuskSpawnEgg;
			case 203: return Item::Ice;
			case 239: return Item::InfestedChiseledStoneBricks;
			case 235: return Item::InfestedCobblestone;
			case 238: return Item::InfestedCrackedStoneBricks;
			case 237: return Item::InfestedMossyStoneBricks;
			case 234: return Item::InfestedStone;
			case 236: return Item::InfestedStoneBricks;
			case 693: return Item::InkSac;
			case 574: return Item::IronAxe;
			case 247: return Item::IronBars;
			case 137: return Item::IronBlock;
			case 633: return Item::IronBoots;
			case 631: return Item::IronChestplate;
			case 557: return Item::IronDoor;
			case 630: return Item::IronHelmet;
			case 615: return Item::IronHoe;
			case 860: return Item::IronHorseArmor;
			case 582: return Item::IronIngot;
			case 632: return Item::IronLeggings;
			case 905: return Item::IronNugget;
			case 34: return Item::IronOre;
			case 573: return Item::IronPickaxe;
			case 572: return Item::IronShovel;
			case 586: return Item::IronSword;
			case 348: return Item::IronTrapdoor;
			case 827: return Item::ItemFrame;
			case 225: return Item::JackOLantern;
			case 569: return Item::Jigsaw;
			case 207: return Item::Jukebox;
			case 900: return Item::JungleBoat;
			case 308: return Item::JungleButton;
			case 561: return Item::JungleDoor;
			case 211: return Item::JungleFence;
			case 255: return Item::JungleFenceGate;
			case 72: return Item::JungleLeaves;
			case 40: return Item::JungleLog;
			case 18: return Item::JunglePlanks;
			case 194: return Item::JunglePressurePlate;
			case 26: return Item::JungleSapling;
			case 655: return Item::JungleSign;
			case 141: return Item::JungleSlab;
			case 282: return Item::JungleStairs;
			case 229: return Item::JungleTrapdoor;
			case 64: return Item::JungleWood;
			case 134: return Item::Kelp;
			case 906: return Item::KnowledgeBook;
			case 186: return Item::Ladder;
			case 945: return Item::Lantern;
			case 79: return Item::LapisBlock;
			case 697: return Item::LapisLazuli;
			case 78: return Item::LapisOre;
			case 378: return Item::LargeFern;
			case 662: return Item::LavaBucket;
			case 864: return Item::Lead;
			case 668: return Item::Leather;
			case 625: return Item::LeatherBoots;
			case 623: return Item::LeatherChestplate;
			case 622: return Item::LeatherHelmet;
			case 863: return Item::LeatherHorseArmor;
			case 624: return Item::LeatherLeggings;
			case 941: return Item::Lectern;
			case 189: return Item::Lever;
			case 872: return Item::LightBlueBanner;
			case 719: return Item::LightBlueBed;
			case 353: return Item::LightBlueCarpet;
			case 467: return Item::LightBlueConcrete;
			case 483: return Item::LightBlueConcretePowder;
			case 705: return Item::LightBlueDye;
			case 451: return Item::LightBlueGlazedTerracotta;
			case 435: return Item::LightBlueShulkerBox;
			case 382: return Item::LightBlueStainedGlass;
			case 398: return Item::LightBlueStainedGlassPane;
			case 334: return Item::LightBlueTerracotta;
			case 98: return Item::LightBlueWool;
			case 877: return Item::LightGrayBanner;
			case 724: return Item::LightGrayBed;
			case 358: return Item::LightGrayCarpet;
			case 472: return Item::LightGrayConcrete;
			case 488: return Item::LightGrayConcretePowder;
			case 700: return Item::LightGrayDye;
			case 456: return Item::LightGrayGlazedTerracotta;
			case 440: return Item::LightGrayShulkerBox;
			case 387: return Item::LightGrayStainedGlass;
			case 403: return Item::LightGrayStainedGlassPane;
			case 339: return Item::LightGrayTerracotta;
			case 103: return Item::LightGrayWool;
			case 318: return Item::LightWeightedPressurePlate;
			case 374: return Item::Lilac;
			case 122: return Item::LilyOfTheValley;
			case 263: return Item::LilyPad;
			case 874: return Item::LimeBanner;
			case 721: return Item::LimeBed;
			case 355: return Item::LimeCarpet;
			case 469: return Item::LimeConcrete;
			case 485: return Item::LimeConcretePowder;
			case 703: return Item::LimeDye;
			case 453: return Item::LimeGlazedTerracotta;
			case 437: return Item::LimeShulkerBox;
			case 384: return Item::LimeStainedGlass;
			case 400: return Item::LimeStainedGlassPane;
			case 336: return Item::LimeTerracotta;
			case 100: return Item::LimeWool;
			case 895: return Item::LingeringPotion;
			case 781: return Item::LlamaSpawnEgg;
			case 957: return Item::Lodestone;
			case 927: return Item::Loom;
			case 871: return Item::MagentaBanner;
			case 718: return Item::MagentaBed;
			case 352: return Item::MagentaCarpet;
			case 466: return Item::MagentaConcrete;
			case 482: return Item::MagentaConcretePowder;
			case 706: return Item::MagentaDye;
			case 450: return Item::MagentaGlazedTerracotta;
			case 434: return Item::MagentaShulkerBox;
			case 381: return Item::MagentaStainedGlass;
			case 397: return Item::MagentaStainedGlassPane;
			case 333: return Item::MagentaTerracotta;
			case 97: return Item::MagentaWool;
			case 424: return Item::MagmaBlock;
			case 754: return Item::MagmaCream;
			case 782: return Item::MagmaCubeSpawnEgg;
			case 833: return Item::Map;
			case 250: return Item::Melon;
			case 738: return Item::MelonSeeds;
			case 735: return Item::MelonSlice;
			case 669: return Item::MilkBucket;
			case 663: return Item::Minecart;
			case 931: return Item::MojangBannerPattern;
			case 783: return Item::MooshroomSpawnEgg;
			case 169: return Item::MossyCobblestone;
			case 547: return Item::MossyCobblestoneSlab;
			case 533: return Item::MossyCobblestoneStairs;
			case 288: return Item::MossyCobblestoneWall;
			case 545: return Item::MossyStoneBrickSlab;
			case 531: return Item::MossyStoneBrickStairs;
			case 292: return Item::MossyStoneBrickWall;
			case 241: return Item::MossyStoneBricks;
			case 784: return Item::MuleSpawnEgg;
			case 246: return Item::MushroomStem;
			case 601: return Item::MushroomStew;
			case 910: return Item::MusicDiscBlocks;
			case 909: return Item::MusicDiscCat;
			case 911: return Item::MusicDiscChirp;
			case 912: return Item::MusicDiscFar;
			case 913: return Item::MusicDiscMall;
			case 914: return Item::MusicDiscMellohi;
			case 920: return Item::MusicDiscPigstep;
			case 915: return Item::MusicDiscStal;
			case 916: return Item::MusicDiscStrad;
			case 919: return Item::MusicDiscWait;
			case 917: return Item::MusicDiscWard;
			case 918: return Item::MusicDisc11;
			case 908: return Item::MusicDisc13;
			case 867: return Item::Mutton;
			case 262: return Item::Mycelium;
			case 865: return Item::NameTag;
			case 923: return Item::NautilusShell;
			case 848: return Item::NetherBrick;
			case 267: return Item::NetherBrickFence;
			case 154: return Item::NetherBrickSlab;
			case 268: return Item::NetherBrickStairs;
			case 295: return Item::NetherBrickWall;
			case 264: return Item::NetherBricks;
			case 36: return Item::NetherGoldOre;
			case 322: return Item::NetherQuartzOre;
			case 130: return Item::NetherSprouts;
			case 843: return Item::NetherStar;
			case 748: return Item::NetherWart;
			case 425: return Item::NetherWartBlock;
			case 609: return Item::NetheriteAxe;
			case 958: return Item::NetheriteBlock;
			case 645: return Item::NetheriteBoots;
			case 643: return Item::NetheriteChestplate;
			case 642: return Item::NetheriteHelmet;
			case 618: return Item::NetheriteHoe;
			case 584: return Item::NetheriteIngot;
			case 644: return Item::NetheriteLeggings;
			case 608: return Item::NetheritePickaxe;
			case 585: return Item::NetheriteScrap;
			case 607: return Item::NetheriteShovel;
			case 606: return Item::NetheriteSword;
			case 218: return Item::Netherrack;
			case 84: return Item::NoteBlock;
			case 667: return Item::OakBoat;
			case 305: return Item::OakButton;
			case 558: return Item::OakDoor;
			case 208: return Item::OakFence;
			case 252: return Item::OakFenceGate;
			case 69: return Item::OakLeaves;
			case 37: return Item::OakLog;
			case 15: return Item::OakPlanks;
			case 191: return Item::OakPressurePlate;
			case 23: return Item::OakSapling;
			case 652: return Item::OakSign;
			case 138: return Item::OakSlab;
			case 179: return Item::OakStairs;
			case 226: return Item::OakTrapdoor;
			case 61: return Item::OakWood;
			case 430: return Item::Observer;
			case 170: return Item::Obsidian;
			case 785: return Item::OcelotSpawnEgg;
			case 870: return Item::OrangeBanner;
			case 717: return Item::OrangeBed;
			case 351: return Item::OrangeCarpet;
			case 465: return Item::OrangeConcrete;
			case 481: return Item::OrangeConcretePowder;
			case 707: return Item::OrangeDye;
			case 449: return Item::OrangeGlazedTerracotta;
			case 433: return Item::OrangeShulkerBox;
			case 380: return Item::OrangeStainedGlass;
			case 396: return Item::OrangeStainedGlassPane;
			case 332: return Item::OrangeTerracotta;
			case 117: return Item::OrangeTulip;
			case 96: return Item::OrangeWool;
			case 120: return Item::OxeyeDaisy;
			case 368: return Item::PackedIce;
			case 649: return Item::Painting;
			case 786: return Item::PandaSpawnEgg;
			case 677: return Item::Paper;
			case 787: return Item::ParrotSpawnEgg;
			case 376: return Item::Peony;
			case 150: return Item::PetrifiedOakSlab;
			case 922: return Item::PhantomMembrane;
			case 788: return Item::PhantomSpawnEgg;
			case 789: return Item::PigSpawnEgg;
			case 933: return Item::PiglinBannerPattern;
			case 790: return Item::PiglinSpawnEgg;
			case 791: return Item::PillagerSpawnEgg;
			case 875: return Item::PinkBanner;
			case 722: return Item::PinkBed;
			case 356: return Item::PinkCarpet;
			case 470: return Item::PinkConcrete;
			case 486: return Item::PinkConcretePowder;
			case 702: return Item::PinkDye;
			case 454: return Item::PinkGlazedTerracotta;
			case 438: return Item::PinkShulkerBox;
			case 385: return Item::PinkStainedGlass;
			case 401: return Item::PinkStainedGlassPane;
			case 337: return Item::PinkTerracotta;
			case 119: return Item::PinkTulip;
			case 101: return Item::PinkWool;
			case 94: return Item::Piston;
			case 837: return Item::PlayerHead;
			case 11: return Item::Podzol;
			case 832: return Item::PoisonousPotato;
			case 792: return Item::PolarBearSpawnEgg;
			case 7: return Item::PolishedAndesite;
			case 554: return Item::PolishedAndesiteSlab;
			case 541: return Item::PolishedAndesiteStairs;
			case 222: return Item::PolishedBasalt;
			case 966: return Item::PolishedBlackstone;
			case 971: return Item::PolishedBlackstoneBrickSlab;
			case 972: return Item::PolishedBlackstoneBrickStairs;
			case 303: return Item::PolishedBlackstoneBrickWall;
			case 970: return Item::PolishedBlackstoneBricks;
			case 313: return Item::PolishedBlackstoneButton;
			case 199: return Item::PolishedBlackstonePressurePlate;
			case 967: return Item::PolishedBlackstoneSlab;
			case 968: return Item::PolishedBlackstoneStairs;
			case 302: return Item::PolishedBlackstoneWall;
			case 5: return Item::PolishedDiorite;
			case 546: return Item::PolishedDioriteSlab;
			case 532: return Item::PolishedDioriteStairs;
			case 3: return Item::PolishedGranite;
			case 543: return Item::PolishedGraniteSlab;
			case 529: return Item::PolishedGraniteStairs;
			case 887: return Item::PoppedChorusFruit;
			case 112: return Item::Poppy;
			case 647: return Item::Porkchop;
			case 830: return Item::Potato;
			case 749: return Item::Potion;
			case 85: return Item::PoweredRail;
			case 411: return Item::Prismarine;
			case 160: return Item::PrismarineBrickSlab;
			case 415: return Item::PrismarineBrickStairs;
			case 412: return Item::PrismarineBricks;
			case 853: return Item::PrismarineCrystals;
			case 852: return Item::PrismarineShard;
			case 159: return Item::PrismarineSlab;
			case 414: return Item::PrismarineStairs;
			case 290: return Item::PrismarineWall;
			case 690: return Item::Pufferfish;
			case 670: return Item::PufferfishBucket;
			case 793: return Item::PufferfishSpawnEgg;
			case 216: return Item::Pumpkin;
			case 844: return Item::PumpkinPie;
			case 737: return Item::PumpkinSeeds;
			case 879: return Item::PurpleBanner;
			case 726: return Item::PurpleBed;
			case 360: return Item::PurpleCarpet;
			case 474: return Item::PurpleConcrete;
			case 490: return Item::PurpleConcretePowder;
			case 698: return Item::PurpleDye;
			case 458: return Item::PurpleGlazedTerracotta;
			case 442: return Item::PurpleShulkerBox;
			case 389: return Item::PurpleStainedGlass;
			case 405: return Item::PurpleStainedGlassPane;
			case 341: return Item::PurpleTerracotta;
			case 105: return Item::PurpleWool;
			case 175: return Item::PurpurBlock;
			case 176: return Item::PurpurPillar;
			case 158: return Item::PurpurSlab;
			case 177: return Item::PurpurStairs;
			case 849: return Item::Quartz;
			case 325: return Item::QuartzBlock;
			case 326: return Item::QuartzBricks;
			case 327: return Item::QuartzPillar;
			case 155: return Item::QuartzSlab;
			case 328: return Item::QuartzStairs;
			case 854: return Item::Rabbit;
			case 857: return Item::RabbitFoot;
			case 858: return Item::RabbitHide;
			case 794: return Item::RabbitSpawnEgg;
			case 856: return Item::RabbitStew;
			case 187: return Item::Rail;
			case 795: return Item::RavagerSpawnEgg;
			case 883: return Item::RedBanner;
			case 730: return Item::RedBed;
			case 364: return Item::RedCarpet;
			case 478: return Item::RedConcrete;
			case 494: return Item::RedConcretePowder;
			case 694: return Item::RedDye;
			case 462: return Item::RedGlazedTerracotta;
			case 125: return Item::RedMushroom;
			case 245: return Item::RedMushroomBlock;
			case 553: return Item::RedNetherBrickSlab;
			case 540: return Item::RedNetherBrickStairs;
			case 297: return Item::RedNetherBrickWall;
			case 427: return Item::RedNetherBricks;
			case 31: return Item::RedSand;
			case 418: return Item::RedSandstone;
			case 156: return Item::RedSandstoneSlab;
			case 421: return Item::RedSandstoneStairs;
			case 291: return Item::RedSandstoneWall;
			case 446: return Item::RedShulkerBox;
			case 393: return Item::RedStainedGlass;
			case 409: return Item::RedStainedGlassPane;
			case 345: return Item::RedTerracotta;
			case 116: return Item::RedTulip;
			case 109: return Item::RedWool;
			case 665: return Item::Redstone;
			case 321: return Item::RedstoneBlock;
			case 274: return Item::RedstoneLamp;
			case 200: return Item::RedstoneOre;
			case 201: return Item::RedstoneTorch;
			case 566: return Item::Repeater;
			case 422: return Item::RepeatingCommandBlock;
			case 974: return Item::RespawnAnchor;
			case 375: return Item::RoseBush;
			case 743: return Item::RottenFlesh;
			case 664: return Item::Saddle;
			case 688: return Item::Salmon;
			case 671: return Item::SalmonBucket;
			case 796: return Item::SalmonSpawnEgg;
			case 30: return Item::Sand;
			case 81: return Item::Sandstone;
			case 148: return Item::SandstoneSlab;
			case 275: return Item::SandstoneStairs;
			case 298: return Item::SandstoneWall;
			case 556: return Item::Scaffolding;
			case 571: return Item::Scute;
			case 417: return Item::SeaLantern;
			case 93: return Item::SeaPickle;
			case 92: return Item::Seagrass;
			case 734: return Item::Shears;
			case 797: return Item::SheepSpawnEgg;
			case 896: return Item::Shield;
			case 950: return Item::Shroomlight;
			case 431: return Item::ShulkerBox;
			case 904: return Item::ShulkerShell;
			case 798: return Item::ShulkerSpawnEgg;
			case 799: return Item::SilverfishSpawnEgg;
			case 801: return Item::SkeletonHorseSpawnEgg;
			case 835: return Item::SkeletonSkull;
			case 800: return Item::SkeletonSpawnEgg;
			case 930: return Item::SkullBannerPattern;
			case 679: return Item::SlimeBall;
			case 371: return Item::SlimeBlock;
			case 802: return Item::SlimeSpawnEgg;
			case 942: return Item::SmithingTable;
			case 936: return Item::Smoker;
			case 162: return Item::SmoothQuartz;
			case 550: return Item::SmoothQuartzSlab;
			case 537: return Item::SmoothQuartzStairs;
			case 163: return Item::SmoothRedSandstone;
			case 544: return Item::SmoothRedSandstoneSlab;
			case 530: return Item::SmoothRedSandstoneStairs;
			case 164: return Item::SmoothSandstone;
			case 549: return Item::SmoothSandstoneSlab;
			case 536: return Item::SmoothSandstoneStairs;
			case 165: return Item::SmoothStone;
			case 147: return Item::SmoothStoneSlab;
			case 202: return Item::Snow;
			case 204: return Item::SnowBlock;
			case 666: return Item::Snowball;
			case 949: return Item::SoulCampfire;
			case 946: return Item::SoulLantern;
			case 219: return Item::SoulSand;
			case 220: return Item::SoulSoil;
			case 223: return Item::SoulTorch;
			case 178: return Item::Spawner;
			case 893: return Item::SpectralArrow;
			case 751: return Item::SpiderEye;
			case 803: return Item::SpiderSpawnEgg;
			case 892: return Item::SplashPotion;
			case 75: return Item::Sponge;
			case 898: return Item::SpruceBoat;
			case 306: return Item::SpruceButton;
			case 559: return Item::SpruceDoor;
			case 209: return Item::SpruceFence;
			case 253: return Item::SpruceFenceGate;
			case 70: return Item::SpruceLeaves;
			case 38: return Item::SpruceLog;
			case 16: return Item::SprucePlanks;
			case 192: return Item::SprucePressurePlate;
			case 24: return Item::SpruceSapling;
			case 653: return Item::SpruceSign;
			case 139: return Item::SpruceSlab;
			case 280: return Item::SpruceStairs;
			case 227: return Item::SpruceTrapdoor;
			case 62: return Item::SpruceWood;
			case 804: return Item::SquidSpawnEgg;
			case 599: return Item::Stick;
			case 87: return Item::StickyPiston;
			case 1: return Item::Stone;
			case 594: return Item::StoneAxe;
			case 153: return Item::StoneBrickSlab;
			case 261: return Item::StoneBrickStairs;
			case 294: return Item::StoneBrickWall;
			case 240: return Item::StoneBricks;
			case 304: return Item::StoneButton;
			case 614: return Item::StoneHoe;
			case 593: return Item::StonePickaxe;
			case 190: return Item::StonePressurePlate;
			case 592: return Item::StoneShovel;
			case 146: return Item::StoneSlab;
			case 535: return Item::StoneStairs;
			case 591: return Item::StoneSword;
			case 943: return Item::Stonecutter;
			case 805: return Item::StraySpawnEgg;
			case 806: return Item::StriderSpawnEgg;
			case 610: return Item::String;
			case 49: return Item::StrippedAcaciaLog;
			case 57: return Item::StrippedAcaciaWood;
			case 47: return Item::StrippedBirchLog;
			case 55: return Item::StrippedBirchWood;
			case 59: return Item::StrippedCrimsonHyphae;
			case 51: return Item::StrippedCrimsonStem;
			case 50: return Item::StrippedDarkOakLog;
			case 58: return Item::StrippedDarkOakWood;
			case 48: return Item::StrippedJungleLog;
			case 56: return Item::StrippedJungleWood;
			case 45: return Item::StrippedOakLog;
			case 53: return Item::StrippedOakWood;
			case 46: return Item::StrippedSpruceLog;
			case 54: return Item::StrippedSpruceWood;
			case 60: return Item::StrippedWarpedHyphae;
			case 52: return Item::StrippedWarpedStem;
			case 568: return Item::StructureBlock;
			case 429: return Item::StructureVoid;
			case 714: return Item::Sugar;
			case 133: return Item::SugarCane;
			case 373: return Item::Sunflower;
			case 926: return Item::SuspiciousStew;
			case 947: return Item::SweetBerries;
			case 377: return Item::TallGrass;
			case 960: return Item::Target;
			case 366: return Item::Terracotta;
			case 894: return Item::TippedArrow;
			case 167: return Item::TNT;
			case 850: return Item::TNTMinecart;
			case 171: return Item::Torch;
			case 903: return Item::TotemOfUndying;
			case 807: return Item::TraderLlamaSpawnEgg;
			case 317: return Item::TrappedChest;
			case 921: return Item::Trident;
			case 278: return Item::TripwireHook;
			case 689: return Item::TropicalFish;
			case 673: return Item::TropicalFishBucket;
			case 808: return Item::TropicalFishSpawnEgg;
			case 507: return Item::TubeCoral;
			case 502: return Item::TubeCoralBlock;
			case 517: return Item::TubeCoralFan;
			case 496: return Item::TurtleEgg;
			case 570: return Item::TurtleHelmet;
			case 809: return Item::TurtleSpawnEgg;
			case 132: return Item::TwistingVines;
			case 810: return Item::VexSpawnEgg;
			case 811: return Item::VillagerSpawnEgg;
			case 812: return Item::VindicatorSpawnEgg;
			case 251: return Item::Vine;
			case 813: return Item::WanderingTraderSpawnEgg;
			case 312: return Item::WarpedButton;
			case 565: return Item::WarpedDoor;
			case 215: return Item::WarpedFence;
			case 259: return Item::WarpedFenceGate;
			case 127: return Item::WarpedFungus;
			case 842: return Item::WarpedFungusOnA_stick;
			case 68: return Item::WarpedHyphae;
			case 13: return Item::WarpedNylium;
			case 22: return Item::WarpedPlanks;
			case 198: return Item::WarpedPressurePlate;
			case 129: return Item::WarpedRoots;
			case 659: return Item::WarpedSign;
			case 145: return Item::WarpedSlab;
			case 284: return Item::WarpedStairs;
			case 44: return Item::WarpedStem;
			case 233: return Item::WarpedTrapdoor;
			case 426: return Item::WarpedWartBlock;
			case 661: return Item::WaterBucket;
			case 131: return Item::WeepingVines;
			case 76: return Item::WetSponge;
			case 620: return Item::Wheat;
			case 619: return Item::WheatSeeds;
			case 869: return Item::WhiteBanner;
			case 716: return Item::WhiteBed;
			case 350: return Item::WhiteCarpet;
			case 464: return Item::WhiteConcrete;
			case 480: return Item::WhiteConcretePowder;
			case 712: return Item::WhiteDye;
			case 448: return Item::WhiteGlazedTerracotta;
			case 432: return Item::WhiteShulkerBox;
			case 379: return Item::WhiteStainedGlass;
			case 395: return Item::WhiteStainedGlassPane;
			case 331: return Item::WhiteTerracotta;
			case 118: return Item::WhiteTulip;
			case 95: return Item::WhiteWool;
			case 814: return Item::WitchSpawnEgg;
			case 123: return Item::WitherRose;
			case 836: return Item::WitherSkeletonSkull;
			case 815: return Item::WitherSkeletonSpawnEgg;
			case 816: return Item::WolfSpawnEgg;
			case 590: return Item::WoodenAxe;
			case 613: return Item::WoodenHoe;
			case 589: return Item::WoodenPickaxe;
			case 588: return Item::WoodenShovel;
			case 587: return Item::WoodenSword;
			case 824: return Item::WritableBook;
			case 825: return Item::WrittenBook;
			case 873: return Item::YellowBanner;
			case 720: return Item::YellowBed;
			case 354: return Item::YellowCarpet;
			case 468: return Item::YellowConcrete;
			case 484: return Item::YellowConcretePowder;
			case 704: return Item::YellowDye;
			case 452: return Item::YellowGlazedTerracotta;
			case 436: return Item::YellowShulkerBox;
			case 383: return Item::YellowStainedGlass;
			case 399: return Item::YellowStainedGlassPane;
			case 335: return Item::YellowTerracotta;
			case 99: return Item::YellowWool;
			case 817: return Item::ZoglinSpawnEgg;
			case 838: return Item::ZombieHead;
			case 819: return Item::ZombieHorseSpawnEgg;
			case 818: return Item::ZombieSpawnEgg;
			case 820: return Item::ZombieVillagerSpawnEgg;
			case 821: return Item::ZombiePigmanSpawnEgg;
			default: return Item::Air;
		}
	}
}
